//
// Generated by PVRCarbon v0.8 (21.2@6135481)
//
#include <unordered_map>
#include <cassert>
#include "EGL/egl.h"
#include "EGL/eglext.h"
#include "platform/native_library.h"
#include "platform/log.h"

#if defined(ASSERT_ON_EGL_ERROR)
#define CHECK_EGL_ERROR_ASSERT(func)                        \
	do                                                      \
	{                                                       \
		auto err = eglGetError();                           \
		if (err != EGL_SUCCESS)                             \
		{                                                   \
			LOG(func " generated EGL error 0x%04X", err);   \
			assert(false && func "Generated an EGL error"); \
		}                                                   \
	} while (0)
#else
#define CHECK_EGL_ERROR_ASSERT(func)
#endif

namespace egl {
namespace internal {

static NativeLibrary& library()
{
#if defined(_WIN32)
	static NativeLibrary instance("libEGL.dll");
#else
	static NativeLibrary instance("libEGL.so");
#endif
	return instance;
}
#if defined(REF_COUNT_EGL_INIT)
std::unordered_map<EGLDisplay, uint32_t> g_initializeRefCount;
#endif
}
}

// EGL_VERSION_1_0
EGLBoolean EGLAPIENTRY eglChooseConfig(EGLDisplay dpy, const EGLint* attrib_list, EGLConfig* configs, EGLint config_size, EGLint* num_config)
{
	using PFN_eglChooseConfig = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, const EGLint* attrib_list, EGLConfig* configs, EGLint config_size, EGLint* num_config);
	static PFN_eglChooseConfig chooseConfigPtr = egl::internal::library().getProcAddress<PFN_eglChooseConfig>("eglChooseConfig");
	auto result = chooseConfigPtr(dpy, attrib_list, configs, config_size, num_config);
	CHECK_EGL_ERROR_ASSERT("eglChooseConfig");
	return result;
}

EGLBoolean EGLAPIENTRY eglCopyBuffers(EGLDisplay dpy, EGLSurface surface, EGLNativePixmapType target)
{
	using PFN_eglCopyBuffers = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSurface surface, EGLNativePixmapType target);
	static PFN_eglCopyBuffers copyBuffersPtr = egl::internal::library().getProcAddress<PFN_eglCopyBuffers>("eglCopyBuffers");
	auto result = copyBuffersPtr(dpy, surface, target);
	CHECK_EGL_ERROR_ASSERT("eglCopyBuffers");
	return result;
}

EGLContext EGLAPIENTRY eglCreateContext(EGLDisplay dpy, EGLConfig config, EGLContext share_context, const EGLint* attrib_list)
{
	using PFN_eglCreateContext = EGLContext(EGLAPIENTRY*)(EGLDisplay dpy, EGLConfig config, EGLContext share_context, const EGLint* attrib_list);
	static PFN_eglCreateContext createContextPtr = egl::internal::library().getProcAddress<PFN_eglCreateContext>("eglCreateContext");
	auto result = createContextPtr(dpy, config, share_context, attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglCreateContext");
	return result;
}

EGLSurface EGLAPIENTRY eglCreatePbufferSurface(EGLDisplay dpy, EGLConfig config, const EGLint* attrib_list)
{
	using PFN_eglCreatePbufferSurface = EGLSurface(EGLAPIENTRY*)(EGLDisplay dpy, EGLConfig config, const EGLint* attrib_list);
	static PFN_eglCreatePbufferSurface createPbufferSurfacePtr = egl::internal::library().getProcAddress<PFN_eglCreatePbufferSurface>("eglCreatePbufferSurface");
	auto result = createPbufferSurfacePtr(dpy, config, attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglCreatePbufferSurface");
	return result;
}

EGLSurface EGLAPIENTRY eglCreatePixmapSurface(EGLDisplay dpy, EGLConfig config, EGLNativePixmapType pixmap, const EGLint* attrib_list)
{
	using PFN_eglCreatePixmapSurface = EGLSurface(EGLAPIENTRY*)(EGLDisplay dpy, EGLConfig config, EGLNativePixmapType pixmap, const EGLint* attrib_list);
	static PFN_eglCreatePixmapSurface createPixmapSurfacePtr = egl::internal::library().getProcAddress<PFN_eglCreatePixmapSurface>("eglCreatePixmapSurface");
	auto result = createPixmapSurfacePtr(dpy, config, pixmap, attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglCreatePixmapSurface");
	return result;
}

EGLSurface EGLAPIENTRY eglCreateWindowSurface(EGLDisplay dpy, EGLConfig config, EGLNativeWindowType win, const EGLint* attrib_list)
{
	using PFN_eglCreateWindowSurface = EGLSurface(EGLAPIENTRY*)(EGLDisplay dpy, EGLConfig config, EGLNativeWindowType win, const EGLint* attrib_list);
	static PFN_eglCreateWindowSurface createWindowSurfacePtr = egl::internal::library().getProcAddress<PFN_eglCreateWindowSurface>("eglCreateWindowSurface");
	auto result = createWindowSurfacePtr(dpy, config, win, attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglCreateWindowSurface");
	return result;
}

EGLBoolean EGLAPIENTRY eglDestroyContext(EGLDisplay dpy, EGLContext ctx)
{
	using PFN_eglDestroyContext = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLContext ctx);
	static PFN_eglDestroyContext destroyContextPtr = egl::internal::library().getProcAddress<PFN_eglDestroyContext>("eglDestroyContext");
	auto result = destroyContextPtr(dpy, ctx);
	CHECK_EGL_ERROR_ASSERT("eglDestroyContext");
	return result;
}

EGLBoolean EGLAPIENTRY eglDestroySurface(EGLDisplay dpy, EGLSurface surface)
{
	using PFN_eglDestroySurface = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSurface surface);
	static PFN_eglDestroySurface destroySurfacePtr = egl::internal::library().getProcAddress<PFN_eglDestroySurface>("eglDestroySurface");
	auto result = destroySurfacePtr(dpy, surface);
	CHECK_EGL_ERROR_ASSERT("eglDestroySurface");
	return result;
}

EGLBoolean EGLAPIENTRY eglGetConfigAttrib(EGLDisplay dpy, EGLConfig config, EGLint attribute, EGLint* value)
{
	using PFN_eglGetConfigAttrib = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLConfig config, EGLint attribute, EGLint * value);
	static PFN_eglGetConfigAttrib getConfigAttribPtr = egl::internal::library().getProcAddress<PFN_eglGetConfigAttrib>("eglGetConfigAttrib");
	auto result = getConfigAttribPtr(dpy, config, attribute, value);
	CHECK_EGL_ERROR_ASSERT("eglGetConfigAttrib");
	return result;
}

EGLBoolean EGLAPIENTRY eglGetConfigs(EGLDisplay dpy, EGLConfig* configs, EGLint config_size, EGLint* num_config)
{
	using PFN_eglGetConfigs = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLConfig * configs, EGLint config_size, EGLint * num_config);
	static PFN_eglGetConfigs getConfigsPtr = egl::internal::library().getProcAddress<PFN_eglGetConfigs>("eglGetConfigs");
	auto result = getConfigsPtr(dpy, configs, config_size, num_config);
	CHECK_EGL_ERROR_ASSERT("eglGetConfigs");
	return result;
}

EGLDisplay EGLAPIENTRY eglGetCurrentDisplay()
{
	using PFN_eglGetCurrentDisplay = EGLDisplay(EGLAPIENTRY*)();
	static PFN_eglGetCurrentDisplay getCurrentDisplayPtr = egl::internal::library().getProcAddress<PFN_eglGetCurrentDisplay>("eglGetCurrentDisplay");
	auto result = getCurrentDisplayPtr();
	CHECK_EGL_ERROR_ASSERT("eglGetCurrentDisplay");
	return result;
}

EGLSurface EGLAPIENTRY eglGetCurrentSurface(EGLint readdraw)
{
	using PFN_eglGetCurrentSurface = EGLSurface(EGLAPIENTRY*)(EGLint readdraw);
	static PFN_eglGetCurrentSurface getCurrentSurfacePtr = egl::internal::library().getProcAddress<PFN_eglGetCurrentSurface>("eglGetCurrentSurface");
	auto result = getCurrentSurfacePtr(readdraw);
	CHECK_EGL_ERROR_ASSERT("eglGetCurrentSurface");
	return result;
}

EGLDisplay EGLAPIENTRY eglGetDisplay(EGLNativeDisplayType display_id)
{
	using PFN_eglGetDisplay = EGLDisplay(EGLAPIENTRY*)(EGLNativeDisplayType display_id);
	static PFN_eglGetDisplay getDisplayPtr = egl::internal::library().getProcAddress<PFN_eglGetDisplay>("eglGetDisplay");
	auto result = getDisplayPtr(display_id);
	return result;
}

EGLint EGLAPIENTRY eglGetError()
{
	using PFN_eglGetError = EGLint(EGLAPIENTRY*)();
	static PFN_eglGetError getErrorPtr = egl::internal::library().getProcAddress<PFN_eglGetError>("eglGetError");
	auto result = getErrorPtr();
	return result;
}

__eglMustCastToProperFunctionPointerType EGLAPIENTRY eglGetProcAddress(const char* procname)
{
	using PFN_eglGetProcAddress = __eglMustCastToProperFunctionPointerType(EGLAPIENTRY*)(const char* procname);
	static PFN_eglGetProcAddress getProcAddressPtr = egl::internal::library().getProcAddress<PFN_eglGetProcAddress>("eglGetProcAddress");
	auto result = getProcAddressPtr(procname);
	CHECK_EGL_ERROR_ASSERT("eglGetProcAddress");
	return result;
}

EGLBoolean EGLAPIENTRY eglInitialize(EGLDisplay dpy, EGLint* major, EGLint* minor)
{
	using PFN_eglInitialize = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLint * major, EGLint * minor);
	static PFN_eglInitialize initializePtr = egl::internal::library().getProcAddress<PFN_eglInitialize>("eglInitialize");
	if (initializePtr(dpy, major, minor) == EGL_FALSE)
	{
		CHECK_EGL_ERROR_ASSERT("eglInitialize");
		return EGL_FALSE;
	}

#if defined(REF_COUNT_EGL_INIT)
	egl::internal::g_initializeRefCount[dpy]++;
#endif
	return EGL_TRUE;
}

EGLBoolean EGLAPIENTRY eglMakeCurrent(EGLDisplay dpy, EGLSurface draw, EGLSurface read, EGLContext ctx)
{
	using PFN_eglMakeCurrent = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSurface draw, EGLSurface read, EGLContext ctx);
	static PFN_eglMakeCurrent makeCurrentPtr = egl::internal::library().getProcAddress<PFN_eglMakeCurrent>("eglMakeCurrent");
	auto result = makeCurrentPtr(dpy, draw, read, ctx);
	CHECK_EGL_ERROR_ASSERT("eglMakeCurrent");
	return result;
}

EGLBoolean EGLAPIENTRY eglQueryContext(EGLDisplay dpy, EGLContext ctx, EGLint attribute, EGLint* value)
{
	using PFN_eglQueryContext = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLContext ctx, EGLint attribute, EGLint * value);
	static PFN_eglQueryContext queryContextPtr = egl::internal::library().getProcAddress<PFN_eglQueryContext>("eglQueryContext");
	auto result = queryContextPtr(dpy, ctx, attribute, value);
	CHECK_EGL_ERROR_ASSERT("eglQueryContext");
	return result;
}

const char* EGLAPIENTRY eglQueryString(EGLDisplay dpy, EGLint name)
{
	using PFN_eglQueryString = const char*(EGLAPIENTRY*) (EGLDisplay dpy, EGLint name);
	static PFN_eglQueryString queryStringPtr = egl::internal::library().getProcAddress<PFN_eglQueryString>("eglQueryString");
	auto result = queryStringPtr(dpy, name);
	CHECK_EGL_ERROR_ASSERT("eglQueryString");
	return result;
}

EGLBoolean EGLAPIENTRY eglQuerySurface(EGLDisplay dpy, EGLSurface surface, EGLint attribute, EGLint* value)
{
	using PFN_eglQuerySurface = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSurface surface, EGLint attribute, EGLint * value);
	static PFN_eglQuerySurface querySurfacePtr = egl::internal::library().getProcAddress<PFN_eglQuerySurface>("eglQuerySurface");
	auto result = querySurfacePtr(dpy, surface, attribute, value);
	CHECK_EGL_ERROR_ASSERT("eglQuerySurface");
	return result;
}

EGLBoolean EGLAPIENTRY eglSwapBuffers(EGLDisplay dpy, EGLSurface surface)
{
	using PFN_eglSwapBuffers = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSurface surface);
	static PFN_eglSwapBuffers swapBuffersPtr = egl::internal::library().getProcAddress<PFN_eglSwapBuffers>("eglSwapBuffers");
	auto result = swapBuffersPtr(dpy, surface);
	CHECK_EGL_ERROR_ASSERT("eglSwapBuffers");
	return result;
}

EGLBoolean EGLAPIENTRY eglTerminate(EGLDisplay dpy)
{
#if defined(REF_COUNT_EGL_INIT)
	if (egl::internal::g_initializeRefCount[dpy] > 0)
	{
		egl::internal::g_initializeRefCount[dpy]--;

		if (egl::internal::g_initializeRefCount[dpy] != 0)
		{
			return EGL_TRUE;
		}
	}
#endif
	using PFN_eglTerminate = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy);
	static PFN_eglTerminate terminatePtr = egl::internal::library().getProcAddress<PFN_eglTerminate>("eglTerminate");
	auto result = terminatePtr(dpy);
	CHECK_EGL_ERROR_ASSERT("eglTerminate");
	return result;
}

EGLBoolean EGLAPIENTRY eglWaitGL()
{
	using PFN_eglWaitGL = EGLBoolean(EGLAPIENTRY*)();
	static PFN_eglWaitGL waitGLPtr = egl::internal::library().getProcAddress<PFN_eglWaitGL>("eglWaitGL");
	auto result = waitGLPtr();
	CHECK_EGL_ERROR_ASSERT("eglWaitGL");
	return result;
}

EGLBoolean EGLAPIENTRY eglWaitNative(EGLint engine)
{
	using PFN_eglWaitNative = EGLBoolean(EGLAPIENTRY*)(EGLint engine);
	static PFN_eglWaitNative waitNativePtr = egl::internal::library().getProcAddress<PFN_eglWaitNative>("eglWaitNative");
	auto result = waitNativePtr(engine);
	CHECK_EGL_ERROR_ASSERT("eglWaitNative");
	return result;
}

// EGL_VERSION_1_1
EGLBoolean EGLAPIENTRY eglBindTexImage(EGLDisplay dpy, EGLSurface surface, EGLint buffer)
{
	using PFN_eglBindTexImage = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSurface surface, EGLint buffer);
	static PFN_eglBindTexImage bindTexImagePtr = egl::internal::library().getProcAddress<PFN_eglBindTexImage>("eglBindTexImage");
	auto result = bindTexImagePtr(dpy, surface, buffer);
	CHECK_EGL_ERROR_ASSERT("eglBindTexImage");
	return result;
}

EGLBoolean EGLAPIENTRY eglReleaseTexImage(EGLDisplay dpy, EGLSurface surface, EGLint buffer)
{
	using PFN_eglReleaseTexImage = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSurface surface, EGLint buffer);
	static PFN_eglReleaseTexImage releaseTexImagePtr = egl::internal::library().getProcAddress<PFN_eglReleaseTexImage>("eglReleaseTexImage");
	auto result = releaseTexImagePtr(dpy, surface, buffer);
	CHECK_EGL_ERROR_ASSERT("eglReleaseTexImage");
	return result;
}

EGLBoolean EGLAPIENTRY eglSurfaceAttrib(EGLDisplay dpy, EGLSurface surface, EGLint attribute, EGLint value)
{
	using PFN_eglSurfaceAttrib = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSurface surface, EGLint attribute, EGLint value);
	static PFN_eglSurfaceAttrib surfaceAttribPtr = egl::internal::library().getProcAddress<PFN_eglSurfaceAttrib>("eglSurfaceAttrib");
	auto result = surfaceAttribPtr(dpy, surface, attribute, value);
	CHECK_EGL_ERROR_ASSERT("eglSurfaceAttrib");
	return result;
}

EGLBoolean EGLAPIENTRY eglSwapInterval(EGLDisplay dpy, EGLint interval)
{
	using PFN_eglSwapInterval = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLint interval);
	static PFN_eglSwapInterval swapIntervalPtr = egl::internal::library().getProcAddress<PFN_eglSwapInterval>("eglSwapInterval");
	auto result = swapIntervalPtr(dpy, interval);
	CHECK_EGL_ERROR_ASSERT("eglSwapInterval");
	return result;
}

// EGL_VERSION_1_2
EGLBoolean EGLAPIENTRY eglBindAPI(EGLenum api)
{
	using PFN_eglBindAPI = EGLBoolean(EGLAPIENTRY*)(EGLenum api);
	static PFN_eglBindAPI bindAPIPtr = egl::internal::library().getProcAddress<PFN_eglBindAPI>("eglBindAPI");
	auto result = bindAPIPtr(api);
	CHECK_EGL_ERROR_ASSERT("eglBindAPI");
	return result;
}

EGLSurface EGLAPIENTRY eglCreatePbufferFromClientBuffer(EGLDisplay dpy, EGLenum buftype, EGLClientBuffer buffer, EGLConfig config, const EGLint* attrib_list)
{
	using PFN_eglCreatePbufferFromClientBuffer = EGLSurface(EGLAPIENTRY*)(EGLDisplay dpy, EGLenum buftype, EGLClientBuffer buffer, EGLConfig config, const EGLint* attrib_list);
	static PFN_eglCreatePbufferFromClientBuffer createPbufferFromClientBufferPtr = egl::internal::library().getProcAddress<PFN_eglCreatePbufferFromClientBuffer>("eglCreatePbufferFromClientBuffer");
	auto result = createPbufferFromClientBufferPtr(dpy, buftype, buffer, config, attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglCreatePbufferFromClientBuffer");
	return result;
}

EGLenum EGLAPIENTRY eglQueryAPI()
{
	using PFN_eglQueryAPI = EGLenum(EGLAPIENTRY*)();
	static PFN_eglQueryAPI queryAPIPtr = egl::internal::library().getProcAddress<PFN_eglQueryAPI>("eglQueryAPI");
	auto result = queryAPIPtr();
	CHECK_EGL_ERROR_ASSERT("eglQueryAPI");
	return result;
}

EGLBoolean EGLAPIENTRY eglReleaseThread()
{
	using PFN_eglReleaseThread = EGLBoolean(EGLAPIENTRY*)();
	static PFN_eglReleaseThread releaseThreadPtr = egl::internal::library().getProcAddress<PFN_eglReleaseThread>("eglReleaseThread");
	auto result = releaseThreadPtr();
	CHECK_EGL_ERROR_ASSERT("eglReleaseThread");
	return result;
}

EGLBoolean EGLAPIENTRY eglWaitClient()
{
	using PFN_eglWaitClient = EGLBoolean(EGLAPIENTRY*)();
	static PFN_eglWaitClient waitClientPtr = egl::internal::library().getProcAddress<PFN_eglWaitClient>("eglWaitClient");
	auto result = waitClientPtr();
	CHECK_EGL_ERROR_ASSERT("eglWaitClient");
	return result;
}

// EGL_VERSION_1_4
EGLContext EGLAPIENTRY eglGetCurrentContext()
{
	using PFN_eglGetCurrentContext = EGLContext(EGLAPIENTRY*)();
	static PFN_eglGetCurrentContext getCurrentContextPtr = egl::internal::library().getProcAddress<PFN_eglGetCurrentContext>("eglGetCurrentContext");
	auto result = getCurrentContextPtr();
	CHECK_EGL_ERROR_ASSERT("eglGetCurrentContext");
	return result;
}

// EGL_VERSION_1_5
EGLint EGLAPIENTRY eglClientWaitSync(EGLDisplay dpy, EGLSync sync, EGLint flags, EGLTime timeout)
{
	using PFN_eglClientWaitSync = EGLint(EGLAPIENTRY*)(EGLDisplay dpy, EGLSync sync, EGLint flags, EGLTime timeout);
	static PFN_eglClientWaitSync clientWaitSyncPtr = egl::internal::library().getProcAddress<PFN_eglClientWaitSync>("eglClientWaitSync");
	auto result = clientWaitSyncPtr(dpy, sync, flags, timeout);
	CHECK_EGL_ERROR_ASSERT("eglClientWaitSync");
	return result;
}

EGLImage EGLAPIENTRY eglCreateImage(EGLDisplay dpy, EGLContext ctx, EGLenum target, EGLClientBuffer buffer, const EGLAttrib* attrib_list)
{
	using PFN_eglCreateImage = EGLImage(EGLAPIENTRY*)(EGLDisplay dpy, EGLContext ctx, EGLenum target, EGLClientBuffer buffer, const EGLAttrib* attrib_list);
	static PFN_eglCreateImage createImagePtr = egl::internal::library().getProcAddress<PFN_eglCreateImage>("eglCreateImage");
	auto result = createImagePtr(dpy, ctx, target, buffer, attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglCreateImage");
	return result;
}

EGLSurface EGLAPIENTRY eglCreatePlatformPixmapSurface(EGLDisplay dpy, EGLConfig config, void* native_pixmap, const EGLAttrib* attrib_list)
{
	using PFN_eglCreatePlatformPixmapSurface = EGLSurface(EGLAPIENTRY*)(EGLDisplay dpy, EGLConfig config, void* native_pixmap, const EGLAttrib* attrib_list);
	static PFN_eglCreatePlatformPixmapSurface createPlatformPixmapSurfacePtr = egl::internal::library().getProcAddress<PFN_eglCreatePlatformPixmapSurface>("eglCreatePlatformPixmapSurface");
	auto result = createPlatformPixmapSurfacePtr(dpy, config, native_pixmap, attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglCreatePlatformPixmapSurface");
	return result;
}

EGLSurface EGLAPIENTRY eglCreatePlatformWindowSurface(EGLDisplay dpy, EGLConfig config, void* native_window, const EGLAttrib* attrib_list)
{
	using PFN_eglCreatePlatformWindowSurface = EGLSurface(EGLAPIENTRY*)(EGLDisplay dpy, EGLConfig config, void* native_window, const EGLAttrib* attrib_list);
	static PFN_eglCreatePlatformWindowSurface createPlatformWindowSurfacePtr = egl::internal::library().getProcAddress<PFN_eglCreatePlatformWindowSurface>("eglCreatePlatformWindowSurface");
	auto result = createPlatformWindowSurfacePtr(dpy, config, native_window, attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglCreatePlatformWindowSurface");
	return result;
}

EGLSync EGLAPIENTRY eglCreateSync(EGLDisplay dpy, EGLenum type, const EGLAttrib* attrib_list)
{
	using PFN_eglCreateSync = EGLSync(EGLAPIENTRY*)(EGLDisplay dpy, EGLenum type, const EGLAttrib* attrib_list);
	static PFN_eglCreateSync createSyncPtr = egl::internal::library().getProcAddress<PFN_eglCreateSync>("eglCreateSync");
	auto result = createSyncPtr(dpy, type, attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglCreateSync");
	return result;
}

EGLBoolean EGLAPIENTRY eglDestroyImage(EGLDisplay dpy, EGLImage image)
{
	using PFN_eglDestroyImage = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLImage image);
	static PFN_eglDestroyImage destroyImagePtr = egl::internal::library().getProcAddress<PFN_eglDestroyImage>("eglDestroyImage");
	auto result = destroyImagePtr(dpy, image);
	CHECK_EGL_ERROR_ASSERT("eglDestroyImage");
	return result;
}

EGLBoolean EGLAPIENTRY eglDestroySync(EGLDisplay dpy, EGLSync sync)
{
	using PFN_eglDestroySync = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSync sync);
	static PFN_eglDestroySync destroySyncPtr = egl::internal::library().getProcAddress<PFN_eglDestroySync>("eglDestroySync");
	auto result = destroySyncPtr(dpy, sync);
	CHECK_EGL_ERROR_ASSERT("eglDestroySync");
	return result;
}

EGLDisplay EGLAPIENTRY eglGetPlatformDisplay(EGLenum platform, void* native_display, const EGLAttrib* attrib_list)
{
	using PFN_eglGetPlatformDisplay = EGLDisplay(EGLAPIENTRY*)(EGLenum platform, void* native_display, const EGLAttrib* attrib_list);
	static PFN_eglGetPlatformDisplay getPlatformDisplayPtr = egl::internal::library().getProcAddress<PFN_eglGetPlatformDisplay>("eglGetPlatformDisplay");
	auto result = getPlatformDisplayPtr(platform, native_display, attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglGetPlatformDisplay");
	return result;
}

EGLBoolean EGLAPIENTRY eglGetSyncAttrib(EGLDisplay dpy, EGLSync sync, EGLint attribute, EGLAttrib* value)
{
	using PFN_eglGetSyncAttrib = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSync sync, EGLint attribute, EGLAttrib * value);
	static PFN_eglGetSyncAttrib getSyncAttribPtr = egl::internal::library().getProcAddress<PFN_eglGetSyncAttrib>("eglGetSyncAttrib");
	auto result = getSyncAttribPtr(dpy, sync, attribute, value);
	CHECK_EGL_ERROR_ASSERT("eglGetSyncAttrib");
	return result;
}

EGLBoolean EGLAPIENTRY eglWaitSync(EGLDisplay dpy, EGLSync sync, EGLint flags)
{
	using PFN_eglWaitSync = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSync sync, EGLint flags);
	static PFN_eglWaitSync waitSyncPtr = egl::internal::library().getProcAddress<PFN_eglWaitSync>("eglWaitSync");
	auto result = waitSyncPtr(dpy, sync, flags);
	CHECK_EGL_ERROR_ASSERT("eglWaitSync");
	return result;
}

// EGL_ANDROID_blob_cache
void EGLAPIENTRY eglSetBlobCacheFuncsANDROID(EGLDisplay dpy, EGLSetBlobFuncANDROID set, EGLGetBlobFuncANDROID get)
{
	using PFN_eglSetBlobCacheFuncsANDROID = void(EGLAPIENTRY*)(EGLDisplay dpy, EGLSetBlobFuncANDROID set, EGLGetBlobFuncANDROID get);
	static PFN_eglSetBlobCacheFuncsANDROID setBlobCacheFuncsANDROIDPtr = reinterpret_cast<PFN_eglSetBlobCacheFuncsANDROID>(eglGetProcAddress("eglSetBlobCacheFuncsANDROID"));
	setBlobCacheFuncsANDROIDPtr(dpy, set, get);
	CHECK_EGL_ERROR_ASSERT("eglSetBlobCacheFuncsANDROID");
}

// EGL_ANDROID_create_native_client_buffer
EGLClientBuffer EGLAPIENTRY eglCreateNativeClientBufferANDROID(const EGLint* attrib_list)
{
	using PFN_eglCreateNativeClientBufferANDROID = EGLClientBuffer(EGLAPIENTRY*)(const EGLint* attrib_list);
	static PFN_eglCreateNativeClientBufferANDROID createNativeClientBufferANDROIDPtr = reinterpret_cast<PFN_eglCreateNativeClientBufferANDROID>(eglGetProcAddress("eglCreateNativeClientBufferANDROID"));
	auto result = createNativeClientBufferANDROIDPtr(attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglCreateNativeClientBufferANDROID");
	return result;
}

// EGL_ANDROID_get_frame_timestamps
EGLBoolean EGLAPIENTRY eglGetCompositorTimingANDROID(EGLDisplay dpy, EGLSurface surface, EGLint numTimestamps, const EGLint* names, EGLnsecsANDROID* values)
{
	using PFN_eglGetCompositorTimingANDROID = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSurface surface, EGLint numTimestamps, const EGLint* names, EGLnsecsANDROID* values);
	static PFN_eglGetCompositorTimingANDROID getCompositorTimingANDROIDPtr = reinterpret_cast<PFN_eglGetCompositorTimingANDROID>(eglGetProcAddress("eglGetCompositorTimingANDROID"));
	auto result = getCompositorTimingANDROIDPtr(dpy, surface, numTimestamps, names, values);
	CHECK_EGL_ERROR_ASSERT("eglGetCompositorTimingANDROID");
	return result;
}

EGLBoolean EGLAPIENTRY eglGetCompositorTimingSupportedANDROID(EGLDisplay dpy, EGLSurface surface, EGLint name)
{
	using PFN_eglGetCompositorTimingSupportedANDROID = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSurface surface, EGLint name);
	static PFN_eglGetCompositorTimingSupportedANDROID getCompositorTimingSupportedANDROIDPtr = reinterpret_cast<PFN_eglGetCompositorTimingSupportedANDROID>(eglGetProcAddress("eglGetCompositorTimingSupportedANDROID"));
	auto result = getCompositorTimingSupportedANDROIDPtr(dpy, surface, name);
	CHECK_EGL_ERROR_ASSERT("eglGetCompositorTimingSupportedANDROID");
	return result;
}

EGLBoolean EGLAPIENTRY eglGetFrameTimestampSupportedANDROID(EGLDisplay dpy, EGLSurface surface, EGLint timestamp)
{
	using PFN_eglGetFrameTimestampSupportedANDROID = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSurface surface, EGLint timestamp);
	static PFN_eglGetFrameTimestampSupportedANDROID getFrameTimestampSupportedANDROIDPtr = reinterpret_cast<PFN_eglGetFrameTimestampSupportedANDROID>(eglGetProcAddress("eglGetFrameTimestampSupportedANDROID"));
	auto result = getFrameTimestampSupportedANDROIDPtr(dpy, surface, timestamp);
	CHECK_EGL_ERROR_ASSERT("eglGetFrameTimestampSupportedANDROID");
	return result;
}

EGLBoolean EGLAPIENTRY eglGetFrameTimestampsANDROID(EGLDisplay dpy, EGLSurface surface, EGLuint64KHR frameId, EGLint numTimestamps, const EGLint* timestamps, EGLnsecsANDROID* values)
{
	using PFN_eglGetFrameTimestampsANDROID = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSurface surface, EGLuint64KHR frameId, EGLint numTimestamps, const EGLint* timestamps, EGLnsecsANDROID* values);
	static PFN_eglGetFrameTimestampsANDROID getFrameTimestampsANDROIDPtr = reinterpret_cast<PFN_eglGetFrameTimestampsANDROID>(eglGetProcAddress("eglGetFrameTimestampsANDROID"));
	auto result = getFrameTimestampsANDROIDPtr(dpy, surface, frameId, numTimestamps, timestamps, values);
	CHECK_EGL_ERROR_ASSERT("eglGetFrameTimestampsANDROID");
	return result;
}

EGLBoolean EGLAPIENTRY eglGetNextFrameIdANDROID(EGLDisplay dpy, EGLSurface surface, EGLuint64KHR* frameId)
{
	using PFN_eglGetNextFrameIdANDROID = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSurface surface, EGLuint64KHR * frameId);
	static PFN_eglGetNextFrameIdANDROID getNextFrameIdANDROIDPtr = reinterpret_cast<PFN_eglGetNextFrameIdANDROID>(eglGetProcAddress("eglGetNextFrameIdANDROID"));
	auto result = getNextFrameIdANDROIDPtr(dpy, surface, frameId);
	CHECK_EGL_ERROR_ASSERT("eglGetNextFrameIdANDROID");
	return result;
}

// EGL_ANDROID_get_native_client_buffer
EGLClientBuffer EGLAPIENTRY eglGetNativeClientBufferANDROID(const struct AHardwareBuffer* buffer)
{
	using PFN_eglGetNativeClientBufferANDROID = EGLClientBuffer(EGLAPIENTRY*)(const struct AHardwareBuffer* buffer);
	static PFN_eglGetNativeClientBufferANDROID getNativeClientBufferANDROIDPtr = reinterpret_cast<PFN_eglGetNativeClientBufferANDROID>(eglGetProcAddress("eglGetNativeClientBufferANDROID"));
	auto result = getNativeClientBufferANDROIDPtr(buffer);
	CHECK_EGL_ERROR_ASSERT("eglGetNativeClientBufferANDROID");
	return result;
}

// EGL_ANDROID_native_fence_sync
EGLint EGLAPIENTRY eglDupNativeFenceFDANDROID(EGLDisplay dpy, EGLSyncKHR sync)
{
	using PFN_eglDupNativeFenceFDANDROID = EGLint(EGLAPIENTRY*)(EGLDisplay dpy, EGLSyncKHR sync);
	static PFN_eglDupNativeFenceFDANDROID dupNativeFenceFDANDROIDPtr = reinterpret_cast<PFN_eglDupNativeFenceFDANDROID>(eglGetProcAddress("eglDupNativeFenceFDANDROID"));
	auto result = dupNativeFenceFDANDROIDPtr(dpy, sync);
	CHECK_EGL_ERROR_ASSERT("eglDupNativeFenceFDANDROID");
	return result;
}

// EGL_ANDROID_presentation_time
EGLBoolean EGLAPIENTRY eglPresentationTimeANDROID(EGLDisplay dpy, EGLSurface surface, EGLnsecsANDROID time)
{
	using PFN_eglPresentationTimeANDROID = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSurface surface, EGLnsecsANDROID time);
	static PFN_eglPresentationTimeANDROID presentationTimeANDROIDPtr = reinterpret_cast<PFN_eglPresentationTimeANDROID>(eglGetProcAddress("eglPresentationTimeANDROID"));
	auto result = presentationTimeANDROIDPtr(dpy, surface, time);
	CHECK_EGL_ERROR_ASSERT("eglPresentationTimeANDROID");
	return result;
}

// EGL_ANGLE_query_surface_pointer
EGLBoolean EGLAPIENTRY eglQuerySurfacePointerANGLE(EGLDisplay dpy, EGLSurface surface, EGLint attribute, void** value)
{
	using PFN_eglQuerySurfacePointerANGLE = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSurface surface, EGLint attribute, void** value);
	static PFN_eglQuerySurfacePointerANGLE querySurfacePointerANGLEPtr = reinterpret_cast<PFN_eglQuerySurfacePointerANGLE>(eglGetProcAddress("eglQuerySurfacePointerANGLE"));
	auto result = querySurfacePointerANGLEPtr(dpy, surface, attribute, value);
	CHECK_EGL_ERROR_ASSERT("eglQuerySurfacePointerANGLE");
	return result;
}

// EGL_EXT_compositor
EGLBoolean EGLAPIENTRY eglCompositorBindTexWindowEXT(EGLint external_win_id)
{
	using PFN_eglCompositorBindTexWindowEXT = EGLBoolean(EGLAPIENTRY*)(EGLint external_win_id);
	static PFN_eglCompositorBindTexWindowEXT compositorBindTexWindowEXTPtr = reinterpret_cast<PFN_eglCompositorBindTexWindowEXT>(eglGetProcAddress("eglCompositorBindTexWindowEXT"));
	auto result = compositorBindTexWindowEXTPtr(external_win_id);
	CHECK_EGL_ERROR_ASSERT("eglCompositorBindTexWindowEXT");
	return result;
}

EGLBoolean EGLAPIENTRY eglCompositorSetContextAttributesEXT(EGLint external_ref_id, const EGLint* context_attributes, EGLint num_entries)
{
	using PFN_eglCompositorSetContextAttributesEXT = EGLBoolean(EGLAPIENTRY*)(EGLint external_ref_id, const EGLint* context_attributes, EGLint num_entries);
	static PFN_eglCompositorSetContextAttributesEXT compositorSetContextAttributesEXTPtr = reinterpret_cast<PFN_eglCompositorSetContextAttributesEXT>(eglGetProcAddress("eglCompositorSetContextAttributesEXT"));
	auto result = compositorSetContextAttributesEXTPtr(external_ref_id, context_attributes, num_entries);
	CHECK_EGL_ERROR_ASSERT("eglCompositorSetContextAttributesEXT");
	return result;
}

EGLBoolean EGLAPIENTRY eglCompositorSetContextListEXT(const EGLint* external_ref_ids, EGLint num_entries)
{
	using PFN_eglCompositorSetContextListEXT = EGLBoolean(EGLAPIENTRY*)(const EGLint* external_ref_ids, EGLint num_entries);
	static PFN_eglCompositorSetContextListEXT compositorSetContextListEXTPtr = reinterpret_cast<PFN_eglCompositorSetContextListEXT>(eglGetProcAddress("eglCompositorSetContextListEXT"));
	auto result = compositorSetContextListEXTPtr(external_ref_ids, num_entries);
	CHECK_EGL_ERROR_ASSERT("eglCompositorSetContextListEXT");
	return result;
}

EGLBoolean EGLAPIENTRY eglCompositorSetSizeEXT(EGLint external_win_id, EGLint width, EGLint height)
{
	using PFN_eglCompositorSetSizeEXT = EGLBoolean(EGLAPIENTRY*)(EGLint external_win_id, EGLint width, EGLint height);
	static PFN_eglCompositorSetSizeEXT compositorSetSizeEXTPtr = reinterpret_cast<PFN_eglCompositorSetSizeEXT>(eglGetProcAddress("eglCompositorSetSizeEXT"));
	auto result = compositorSetSizeEXTPtr(external_win_id, width, height);
	CHECK_EGL_ERROR_ASSERT("eglCompositorSetSizeEXT");
	return result;
}

EGLBoolean EGLAPIENTRY eglCompositorSetWindowAttributesEXT(EGLint external_win_id, const EGLint* window_attributes, EGLint num_entries)
{
	using PFN_eglCompositorSetWindowAttributesEXT = EGLBoolean(EGLAPIENTRY*)(EGLint external_win_id, const EGLint* window_attributes, EGLint num_entries);
	static PFN_eglCompositorSetWindowAttributesEXT compositorSetWindowAttributesEXTPtr = reinterpret_cast<PFN_eglCompositorSetWindowAttributesEXT>(eglGetProcAddress("eglCompositorSetWindowAttributesEXT"));
	auto result = compositorSetWindowAttributesEXTPtr(external_win_id, window_attributes, num_entries);
	CHECK_EGL_ERROR_ASSERT("eglCompositorSetWindowAttributesEXT");
	return result;
}

EGLBoolean EGLAPIENTRY eglCompositorSetWindowListEXT(EGLint external_ref_id, const EGLint* external_win_ids, EGLint num_entries)
{
	using PFN_eglCompositorSetWindowListEXT = EGLBoolean(EGLAPIENTRY*)(EGLint external_ref_id, const EGLint* external_win_ids, EGLint num_entries);
	static PFN_eglCompositorSetWindowListEXT compositorSetWindowListEXTPtr = reinterpret_cast<PFN_eglCompositorSetWindowListEXT>(eglGetProcAddress("eglCompositorSetWindowListEXT"));
	auto result = compositorSetWindowListEXTPtr(external_ref_id, external_win_ids, num_entries);
	CHECK_EGL_ERROR_ASSERT("eglCompositorSetWindowListEXT");
	return result;
}

EGLBoolean EGLAPIENTRY eglCompositorSwapPolicyEXT(EGLint external_win_id, EGLint policy)
{
	using PFN_eglCompositorSwapPolicyEXT = EGLBoolean(EGLAPIENTRY*)(EGLint external_win_id, EGLint policy);
	static PFN_eglCompositorSwapPolicyEXT compositorSwapPolicyEXTPtr = reinterpret_cast<PFN_eglCompositorSwapPolicyEXT>(eglGetProcAddress("eglCompositorSwapPolicyEXT"));
	auto result = compositorSwapPolicyEXTPtr(external_win_id, policy);
	CHECK_EGL_ERROR_ASSERT("eglCompositorSwapPolicyEXT");
	return result;
}

// EGL_EXT_device_base, EGL_EXT_device_enumeration
EGLBoolean EGLAPIENTRY eglQueryDevicesEXT(EGLint max_devices, EGLDeviceEXT* devices, EGLint* num_devices)
{
	using PFN_eglQueryDevicesEXT = EGLBoolean(EGLAPIENTRY*)(EGLint max_devices, EGLDeviceEXT * devices, EGLint * num_devices);
	static PFN_eglQueryDevicesEXT queryDevicesEXTPtr = reinterpret_cast<PFN_eglQueryDevicesEXT>(eglGetProcAddress("eglQueryDevicesEXT"));
	auto result = queryDevicesEXTPtr(max_devices, devices, num_devices);
	CHECK_EGL_ERROR_ASSERT("eglQueryDevicesEXT");
	return result;
}

// EGL_EXT_device_base, EGL_EXT_device_query
EGLBoolean EGLAPIENTRY eglQueryDeviceAttribEXT(EGLDeviceEXT device, EGLint attribute, EGLAttrib* value)
{
	using PFN_eglQueryDeviceAttribEXT = EGLBoolean(EGLAPIENTRY*)(EGLDeviceEXT device, EGLint attribute, EGLAttrib * value);
	static PFN_eglQueryDeviceAttribEXT queryDeviceAttribEXTPtr = reinterpret_cast<PFN_eglQueryDeviceAttribEXT>(eglGetProcAddress("eglQueryDeviceAttribEXT"));
	auto result = queryDeviceAttribEXTPtr(device, attribute, value);
	CHECK_EGL_ERROR_ASSERT("eglQueryDeviceAttribEXT");
	return result;
}

const char* EGLAPIENTRY eglQueryDeviceStringEXT(EGLDeviceEXT device, EGLint name)
{
	using PFN_eglQueryDeviceStringEXT = const char*(EGLAPIENTRY*) (EGLDeviceEXT device, EGLint name);
	static PFN_eglQueryDeviceStringEXT queryDeviceStringEXTPtr = reinterpret_cast<PFN_eglQueryDeviceStringEXT>(eglGetProcAddress("eglQueryDeviceStringEXT"));
	auto result = queryDeviceStringEXTPtr(device, name);
	CHECK_EGL_ERROR_ASSERT("eglQueryDeviceStringEXT");
	return result;
}

EGLBoolean EGLAPIENTRY eglQueryDisplayAttribEXT(EGLDisplay dpy, EGLint attribute, EGLAttrib* value)
{
	using PFN_eglQueryDisplayAttribEXT = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLint attribute, EGLAttrib * value);
	static PFN_eglQueryDisplayAttribEXT queryDisplayAttribEXTPtr = reinterpret_cast<PFN_eglQueryDisplayAttribEXT>(eglGetProcAddress("eglQueryDisplayAttribEXT"));
	auto result = queryDisplayAttribEXTPtr(dpy, attribute, value);
	CHECK_EGL_ERROR_ASSERT("eglQueryDisplayAttribEXT");
	return result;
}

// EGL_EXT_image_dma_buf_import_modifiers
EGLBoolean EGLAPIENTRY eglQueryDmaBufFormatsEXT(EGLDisplay dpy, EGLint max_formats, EGLint* formats, EGLint* num_formats)
{
	using PFN_eglQueryDmaBufFormatsEXT = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLint max_formats, EGLint * formats, EGLint * num_formats);
	static PFN_eglQueryDmaBufFormatsEXT queryDmaBufFormatsEXTPtr = reinterpret_cast<PFN_eglQueryDmaBufFormatsEXT>(eglGetProcAddress("eglQueryDmaBufFormatsEXT"));
	auto result = queryDmaBufFormatsEXTPtr(dpy, max_formats, formats, num_formats);
	CHECK_EGL_ERROR_ASSERT("eglQueryDmaBufFormatsEXT");
	return result;
}

EGLBoolean EGLAPIENTRY eglQueryDmaBufModifiersEXT(EGLDisplay dpy, EGLint format, EGLint max_modifiers, EGLuint64KHR* modifiers, EGLBoolean* external_only, EGLint* num_modifiers)
{
	using PFN_eglQueryDmaBufModifiersEXT = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLint format, EGLint max_modifiers, EGLuint64KHR * modifiers, EGLBoolean * external_only, EGLint * num_modifiers);
	static PFN_eglQueryDmaBufModifiersEXT queryDmaBufModifiersEXTPtr = reinterpret_cast<PFN_eglQueryDmaBufModifiersEXT>(eglGetProcAddress("eglQueryDmaBufModifiersEXT"));
	auto result = queryDmaBufModifiersEXTPtr(dpy, format, max_modifiers, modifiers, external_only, num_modifiers);
	CHECK_EGL_ERROR_ASSERT("eglQueryDmaBufModifiersEXT");
	return result;
}

// EGL_EXT_output_base
EGLBoolean EGLAPIENTRY eglGetOutputLayersEXT(EGLDisplay dpy, const EGLAttrib* attrib_list, EGLOutputLayerEXT* layers, EGLint max_layers, EGLint* num_layers)
{
	using PFN_eglGetOutputLayersEXT = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, const EGLAttrib* attrib_list, EGLOutputLayerEXT* layers, EGLint max_layers, EGLint* num_layers);
	static PFN_eglGetOutputLayersEXT getOutputLayersEXTPtr = reinterpret_cast<PFN_eglGetOutputLayersEXT>(eglGetProcAddress("eglGetOutputLayersEXT"));
	auto result = getOutputLayersEXTPtr(dpy, attrib_list, layers, max_layers, num_layers);
	CHECK_EGL_ERROR_ASSERT("eglGetOutputLayersEXT");
	return result;
}

EGLBoolean EGLAPIENTRY eglGetOutputPortsEXT(EGLDisplay dpy, const EGLAttrib* attrib_list, EGLOutputPortEXT* ports, EGLint max_ports, EGLint* num_ports)
{
	using PFN_eglGetOutputPortsEXT = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, const EGLAttrib* attrib_list, EGLOutputPortEXT* ports, EGLint max_ports, EGLint* num_ports);
	static PFN_eglGetOutputPortsEXT getOutputPortsEXTPtr = reinterpret_cast<PFN_eglGetOutputPortsEXT>(eglGetProcAddress("eglGetOutputPortsEXT"));
	auto result = getOutputPortsEXTPtr(dpy, attrib_list, ports, max_ports, num_ports);
	CHECK_EGL_ERROR_ASSERT("eglGetOutputPortsEXT");
	return result;
}

EGLBoolean EGLAPIENTRY eglOutputLayerAttribEXT(EGLDisplay dpy, EGLOutputLayerEXT layer, EGLint attribute, EGLAttrib value)
{
	using PFN_eglOutputLayerAttribEXT = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLOutputLayerEXT layer, EGLint attribute, EGLAttrib value);
	static PFN_eglOutputLayerAttribEXT outputLayerAttribEXTPtr = reinterpret_cast<PFN_eglOutputLayerAttribEXT>(eglGetProcAddress("eglOutputLayerAttribEXT"));
	auto result = outputLayerAttribEXTPtr(dpy, layer, attribute, value);
	CHECK_EGL_ERROR_ASSERT("eglOutputLayerAttribEXT");
	return result;
}

EGLBoolean EGLAPIENTRY eglOutputPortAttribEXT(EGLDisplay dpy, EGLOutputPortEXT port, EGLint attribute, EGLAttrib value)
{
	using PFN_eglOutputPortAttribEXT = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLOutputPortEXT port, EGLint attribute, EGLAttrib value);
	static PFN_eglOutputPortAttribEXT outputPortAttribEXTPtr = reinterpret_cast<PFN_eglOutputPortAttribEXT>(eglGetProcAddress("eglOutputPortAttribEXT"));
	auto result = outputPortAttribEXTPtr(dpy, port, attribute, value);
	CHECK_EGL_ERROR_ASSERT("eglOutputPortAttribEXT");
	return result;
}

EGLBoolean EGLAPIENTRY eglQueryOutputLayerAttribEXT(EGLDisplay dpy, EGLOutputLayerEXT layer, EGLint attribute, EGLAttrib* value)
{
	using PFN_eglQueryOutputLayerAttribEXT = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLOutputLayerEXT layer, EGLint attribute, EGLAttrib * value);
	static PFN_eglQueryOutputLayerAttribEXT queryOutputLayerAttribEXTPtr = reinterpret_cast<PFN_eglQueryOutputLayerAttribEXT>(eglGetProcAddress("eglQueryOutputLayerAttribEXT"));
	auto result = queryOutputLayerAttribEXTPtr(dpy, layer, attribute, value);
	CHECK_EGL_ERROR_ASSERT("eglQueryOutputLayerAttribEXT");
	return result;
}

const char* EGLAPIENTRY eglQueryOutputLayerStringEXT(EGLDisplay dpy, EGLOutputLayerEXT layer, EGLint name)
{
	using PFN_eglQueryOutputLayerStringEXT = const char*(EGLAPIENTRY*) (EGLDisplay dpy, EGLOutputLayerEXT layer, EGLint name);
	static PFN_eglQueryOutputLayerStringEXT queryOutputLayerStringEXTPtr = reinterpret_cast<PFN_eglQueryOutputLayerStringEXT>(eglGetProcAddress("eglQueryOutputLayerStringEXT"));
	auto result = queryOutputLayerStringEXTPtr(dpy, layer, name);
	CHECK_EGL_ERROR_ASSERT("eglQueryOutputLayerStringEXT");
	return result;
}

EGLBoolean EGLAPIENTRY eglQueryOutputPortAttribEXT(EGLDisplay dpy, EGLOutputPortEXT port, EGLint attribute, EGLAttrib* value)
{
	using PFN_eglQueryOutputPortAttribEXT = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLOutputPortEXT port, EGLint attribute, EGLAttrib * value);
	static PFN_eglQueryOutputPortAttribEXT queryOutputPortAttribEXTPtr = reinterpret_cast<PFN_eglQueryOutputPortAttribEXT>(eglGetProcAddress("eglQueryOutputPortAttribEXT"));
	auto result = queryOutputPortAttribEXTPtr(dpy, port, attribute, value);
	CHECK_EGL_ERROR_ASSERT("eglQueryOutputPortAttribEXT");
	return result;
}

const char* EGLAPIENTRY eglQueryOutputPortStringEXT(EGLDisplay dpy, EGLOutputPortEXT port, EGLint name)
{
	using PFN_eglQueryOutputPortStringEXT = const char*(EGLAPIENTRY*) (EGLDisplay dpy, EGLOutputPortEXT port, EGLint name);
	static PFN_eglQueryOutputPortStringEXT queryOutputPortStringEXTPtr = reinterpret_cast<PFN_eglQueryOutputPortStringEXT>(eglGetProcAddress("eglQueryOutputPortStringEXT"));
	auto result = queryOutputPortStringEXTPtr(dpy, port, name);
	CHECK_EGL_ERROR_ASSERT("eglQueryOutputPortStringEXT");
	return result;
}

// EGL_EXT_platform_base
EGLSurface EGLAPIENTRY eglCreatePlatformPixmapSurfaceEXT(EGLDisplay dpy, EGLConfig config, void* native_pixmap, const EGLint* attrib_list)
{
	using PFN_eglCreatePlatformPixmapSurfaceEXT = EGLSurface(EGLAPIENTRY*)(EGLDisplay dpy, EGLConfig config, void* native_pixmap, const EGLint* attrib_list);
	static PFN_eglCreatePlatformPixmapSurfaceEXT createPlatformPixmapSurfaceEXTPtr = reinterpret_cast<PFN_eglCreatePlatformPixmapSurfaceEXT>(eglGetProcAddress("eglCreatePlatformPixmapSurfaceEXT"));
	auto result = createPlatformPixmapSurfaceEXTPtr(dpy, config, native_pixmap, attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglCreatePlatformPixmapSurfaceEXT");
	return result;
}

EGLSurface EGLAPIENTRY eglCreatePlatformWindowSurfaceEXT(EGLDisplay dpy, EGLConfig config, void* native_window, const EGLint* attrib_list)
{
	using PFN_eglCreatePlatformWindowSurfaceEXT = EGLSurface(EGLAPIENTRY*)(EGLDisplay dpy, EGLConfig config, void* native_window, const EGLint* attrib_list);
	static PFN_eglCreatePlatformWindowSurfaceEXT createPlatformWindowSurfaceEXTPtr = reinterpret_cast<PFN_eglCreatePlatformWindowSurfaceEXT>(eglGetProcAddress("eglCreatePlatformWindowSurfaceEXT"));
	auto result = createPlatformWindowSurfaceEXTPtr(dpy, config, native_window, attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglCreatePlatformWindowSurfaceEXT");
	return result;
}

EGLDisplay EGLAPIENTRY eglGetPlatformDisplayEXT(EGLenum platform, void* native_display, const EGLint* attrib_list)
{
	using PFN_eglGetPlatformDisplayEXT = EGLDisplay(EGLAPIENTRY*)(EGLenum platform, void* native_display, const EGLint* attrib_list);
	static PFN_eglGetPlatformDisplayEXT getPlatformDisplayEXTPtr = reinterpret_cast<PFN_eglGetPlatformDisplayEXT>(eglGetProcAddress("eglGetPlatformDisplayEXT"));
	auto result = getPlatformDisplayEXTPtr(platform, native_display, attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglGetPlatformDisplayEXT");
	return result;
}

// EGL_EXT_stream_consumer_egloutput
EGLBoolean EGLAPIENTRY eglStreamConsumerOutputEXT(EGLDisplay dpy, EGLStreamKHR stream, EGLOutputLayerEXT layer)
{
	using PFN_eglStreamConsumerOutputEXT = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLStreamKHR stream, EGLOutputLayerEXT layer);
	static PFN_eglStreamConsumerOutputEXT streamConsumerOutputEXTPtr = reinterpret_cast<PFN_eglStreamConsumerOutputEXT>(eglGetProcAddress("eglStreamConsumerOutputEXT"));
	auto result = streamConsumerOutputEXTPtr(dpy, stream, layer);
	CHECK_EGL_ERROR_ASSERT("eglStreamConsumerOutputEXT");
	return result;
}

// EGL_EXT_swap_buffers_with_damage
EGLBoolean EGLAPIENTRY eglSwapBuffersWithDamageEXT(EGLDisplay dpy, EGLSurface surface, EGLint* rects, EGLint n_rects)
{
	using PFN_eglSwapBuffersWithDamageEXT = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSurface surface, EGLint * rects, EGLint n_rects);
	static PFN_eglSwapBuffersWithDamageEXT swapBuffersWithDamageEXTPtr = reinterpret_cast<PFN_eglSwapBuffersWithDamageEXT>(eglGetProcAddress("eglSwapBuffersWithDamageEXT"));
	auto result = swapBuffersWithDamageEXTPtr(dpy, surface, rects, n_rects);
	CHECK_EGL_ERROR_ASSERT("eglSwapBuffersWithDamageEXT");
	return result;
}

// EGL_HI_clientpixmap
EGLSurface EGLAPIENTRY eglCreatePixmapSurfaceHI(EGLDisplay dpy, EGLConfig config, struct EGLClientPixmapHI* pixmap)
{
	using PFN_eglCreatePixmapSurfaceHI = EGLSurface(EGLAPIENTRY*)(EGLDisplay dpy, EGLConfig config, struct EGLClientPixmapHI * pixmap);
	static PFN_eglCreatePixmapSurfaceHI createPixmapSurfaceHIPtr = reinterpret_cast<PFN_eglCreatePixmapSurfaceHI>(eglGetProcAddress("eglCreatePixmapSurfaceHI"));
	auto result = createPixmapSurfaceHIPtr(dpy, config, pixmap);
	CHECK_EGL_ERROR_ASSERT("eglCreatePixmapSurfaceHI");
	return result;
}

// EGL_KHR_cl_event2
EGLSyncKHR EGLAPIENTRY eglCreateSync64KHR(EGLDisplay dpy, EGLenum type, const EGLAttribKHR* attrib_list)
{
	using PFN_eglCreateSync64KHR = EGLSyncKHR(EGLAPIENTRY*)(EGLDisplay dpy, EGLenum type, const EGLAttribKHR* attrib_list);
	static PFN_eglCreateSync64KHR createSync64KHRPtr = reinterpret_cast<PFN_eglCreateSync64KHR>(eglGetProcAddress("eglCreateSync64KHR"));
	auto result = createSync64KHRPtr(dpy, type, attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglCreateSync64KHR");
	return result;
}

// EGL_KHR_debug
EGLint EGLAPIENTRY eglDebugMessageControlKHR(EGLDEBUGPROCKHR callback, const EGLAttrib* attrib_list)
{
	using PFN_eglDebugMessageControlKHR = EGLint(EGLAPIENTRY*)(EGLDEBUGPROCKHR callback, const EGLAttrib* attrib_list);
	static PFN_eglDebugMessageControlKHR debugMessageControlKHRPtr = reinterpret_cast<PFN_eglDebugMessageControlKHR>(eglGetProcAddress("eglDebugMessageControlKHR"));
	auto result = debugMessageControlKHRPtr(callback, attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglDebugMessageControlKHR");
	return result;
}

EGLint EGLAPIENTRY eglLabelObjectKHR(EGLDisplay display, EGLenum objectType, EGLObjectKHR object, EGLLabelKHR label)
{
	using PFN_eglLabelObjectKHR = EGLint(EGLAPIENTRY*)(EGLDisplay display, EGLenum objectType, EGLObjectKHR object, EGLLabelKHR label);
	static PFN_eglLabelObjectKHR labelObjectKHRPtr = reinterpret_cast<PFN_eglLabelObjectKHR>(eglGetProcAddress("eglLabelObjectKHR"));
	auto result = labelObjectKHRPtr(display, objectType, object, label);
	CHECK_EGL_ERROR_ASSERT("eglLabelObjectKHR");
	return result;
}

EGLBoolean EGLAPIENTRY eglQueryDebugKHR(EGLint attribute, EGLAttrib* value)
{
	using PFN_eglQueryDebugKHR = EGLBoolean(EGLAPIENTRY*)(EGLint attribute, EGLAttrib * value);
	static PFN_eglQueryDebugKHR queryDebugKHRPtr = reinterpret_cast<PFN_eglQueryDebugKHR>(eglGetProcAddress("eglQueryDebugKHR"));
	auto result = queryDebugKHRPtr(attribute, value);
	CHECK_EGL_ERROR_ASSERT("eglQueryDebugKHR");
	return result;
}

// EGL_KHR_display_reference
EGLBoolean EGLAPIENTRY eglQueryDisplayAttribKHR(EGLDisplay dpy, EGLint name, EGLAttrib* value)
{
	using PFN_eglQueryDisplayAttribKHR = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLint name, EGLAttrib * value);
	static PFN_eglQueryDisplayAttribKHR queryDisplayAttribKHRPtr = reinterpret_cast<PFN_eglQueryDisplayAttribKHR>(eglGetProcAddress("eglQueryDisplayAttribKHR"));
	auto result = queryDisplayAttribKHRPtr(dpy, name, value);
	CHECK_EGL_ERROR_ASSERT("eglQueryDisplayAttribKHR");
	return result;
}

// EGL_KHR_image, EGL_KHR_image_base
EGLImageKHR EGLAPIENTRY eglCreateImageKHR(EGLDisplay dpy, EGLContext ctx, EGLenum target, EGLClientBuffer buffer, const EGLint* attrib_list)
{
	using PFN_eglCreateImageKHR = EGLImageKHR(EGLAPIENTRY*)(EGLDisplay dpy, EGLContext ctx, EGLenum target, EGLClientBuffer buffer, const EGLint* attrib_list);
	static PFN_eglCreateImageKHR createImageKHRPtr = reinterpret_cast<PFN_eglCreateImageKHR>(eglGetProcAddress("eglCreateImageKHR"));
	auto result = createImageKHRPtr(dpy, ctx, target, buffer, attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglCreateImageKHR");
	return result;
}

EGLBoolean EGLAPIENTRY eglDestroyImageKHR(EGLDisplay dpy, EGLImageKHR image)
{
	using PFN_eglDestroyImageKHR = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLImageKHR image);
	static PFN_eglDestroyImageKHR destroyImageKHRPtr = reinterpret_cast<PFN_eglDestroyImageKHR>(eglGetProcAddress("eglDestroyImageKHR"));
	auto result = destroyImageKHRPtr(dpy, image);
	CHECK_EGL_ERROR_ASSERT("eglDestroyImageKHR");
	return result;
}

// EGL_KHR_lock_surface3, EGL_KHR_lock_surface
EGLBoolean EGLAPIENTRY eglLockSurfaceKHR(EGLDisplay dpy, EGLSurface surface, const EGLint* attrib_list)
{
	using PFN_eglLockSurfaceKHR = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSurface surface, const EGLint* attrib_list);
	static PFN_eglLockSurfaceKHR lockSurfaceKHRPtr = reinterpret_cast<PFN_eglLockSurfaceKHR>(eglGetProcAddress("eglLockSurfaceKHR"));
	auto result = lockSurfaceKHRPtr(dpy, surface, attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglLockSurfaceKHR");
	return result;
}

EGLBoolean EGLAPIENTRY eglUnlockSurfaceKHR(EGLDisplay dpy, EGLSurface surface)
{
	using PFN_eglUnlockSurfaceKHR = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSurface surface);
	static PFN_eglUnlockSurfaceKHR unlockSurfaceKHRPtr = reinterpret_cast<PFN_eglUnlockSurfaceKHR>(eglGetProcAddress("eglUnlockSurfaceKHR"));
	auto result = unlockSurfaceKHRPtr(dpy, surface);
	CHECK_EGL_ERROR_ASSERT("eglUnlockSurfaceKHR");
	return result;
}

// EGL_KHR_lock_surface3
EGLBoolean EGLAPIENTRY eglQuerySurface64KHR(EGLDisplay dpy, EGLSurface surface, EGLint attribute, EGLAttribKHR* value)
{
	using PFN_eglQuerySurface64KHR = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSurface surface, EGLint attribute, EGLAttribKHR * value);
	static PFN_eglQuerySurface64KHR querySurface64KHRPtr = reinterpret_cast<PFN_eglQuerySurface64KHR>(eglGetProcAddress("eglQuerySurface64KHR"));
	auto result = querySurface64KHRPtr(dpy, surface, attribute, value);
	CHECK_EGL_ERROR_ASSERT("eglQuerySurface64KHR");
	return result;
}

// EGL_KHR_partial_update
EGLBoolean EGLAPIENTRY eglSetDamageRegionKHR(EGLDisplay dpy, EGLSurface surface, EGLint* rects, EGLint n_rects)
{
	using PFN_eglSetDamageRegionKHR = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSurface surface, EGLint * rects, EGLint n_rects);
	static PFN_eglSetDamageRegionKHR setDamageRegionKHRPtr = reinterpret_cast<PFN_eglSetDamageRegionKHR>(eglGetProcAddress("eglSetDamageRegionKHR"));
	auto result = setDamageRegionKHRPtr(dpy, surface, rects, n_rects);
	CHECK_EGL_ERROR_ASSERT("eglSetDamageRegionKHR");
	return result;
}

#if defined(KHRONOS_SUPPORT_INT64)
// EGL_KHR_reusable_sync, EGL_KHR_fence_sync
EGLint EGLAPIENTRY eglClientWaitSyncKHR(EGLDisplay dpy, EGLSyncKHR sync, EGLint flags, EGLTimeKHR timeout)
{
	using PFN_eglClientWaitSyncKHR = EGLint(EGLAPIENTRY*)(EGLDisplay dpy, EGLSyncKHR sync, EGLint flags, EGLTimeKHR timeout);
	static PFN_eglClientWaitSyncKHR clientWaitSyncKHRPtr = reinterpret_cast<PFN_eglClientWaitSyncKHR>(eglGetProcAddress("eglClientWaitSyncKHR"));
	auto result = clientWaitSyncKHRPtr(dpy, sync, flags, timeout);
	CHECK_EGL_ERROR_ASSERT("eglClientWaitSyncKHR");
	return result;
}

EGLSyncKHR EGLAPIENTRY eglCreateSyncKHR(EGLDisplay dpy, EGLenum type, const EGLint* attrib_list)
{
	using PFN_eglCreateSyncKHR = EGLSyncKHR(EGLAPIENTRY*)(EGLDisplay dpy, EGLenum type, const EGLint* attrib_list);
	static PFN_eglCreateSyncKHR createSyncKHRPtr = reinterpret_cast<PFN_eglCreateSyncKHR>(eglGetProcAddress("eglCreateSyncKHR"));
	auto result = createSyncKHRPtr(dpy, type, attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglCreateSyncKHR");
	return result;
}

EGLBoolean EGLAPIENTRY eglDestroySyncKHR(EGLDisplay dpy, EGLSyncKHR sync)
{
	using PFN_eglDestroySyncKHR = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSyncKHR sync);
	static PFN_eglDestroySyncKHR destroySyncKHRPtr = reinterpret_cast<PFN_eglDestroySyncKHR>(eglGetProcAddress("eglDestroySyncKHR"));
	auto result = destroySyncKHRPtr(dpy, sync);
	CHECK_EGL_ERROR_ASSERT("eglDestroySyncKHR");
	return result;
}

EGLBoolean EGLAPIENTRY eglGetSyncAttribKHR(EGLDisplay dpy, EGLSyncKHR sync, EGLint attribute, EGLint* value)
{
	using PFN_eglGetSyncAttribKHR = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSyncKHR sync, EGLint attribute, EGLint * value);
	static PFN_eglGetSyncAttribKHR getSyncAttribKHRPtr = reinterpret_cast<PFN_eglGetSyncAttribKHR>(eglGetProcAddress("eglGetSyncAttribKHR"));
	auto result = getSyncAttribKHRPtr(dpy, sync, attribute, value);
	CHECK_EGL_ERROR_ASSERT("eglGetSyncAttribKHR");
	return result;
}

#endif
#if defined(KHRONOS_SUPPORT_INT64)
// EGL_KHR_reusable_sync
EGLBoolean EGLAPIENTRY eglSignalSyncKHR(EGLDisplay dpy, EGLSyncKHR sync, EGLenum mode)
{
	using PFN_eglSignalSyncKHR = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSyncKHR sync, EGLenum mode);
	static PFN_eglSignalSyncKHR signalSyncKHRPtr = reinterpret_cast<PFN_eglSignalSyncKHR>(eglGetProcAddress("eglSignalSyncKHR"));
	auto result = signalSyncKHRPtr(dpy, sync, mode);
	CHECK_EGL_ERROR_ASSERT("eglSignalSyncKHR");
	return result;
}

#endif
#if defined(KHRONOS_SUPPORT_INT64)
// EGL_KHR_stream
EGLStreamKHR EGLAPIENTRY eglCreateStreamKHR(EGLDisplay dpy, const EGLint* attrib_list)
{
	using PFN_eglCreateStreamKHR = EGLStreamKHR(EGLAPIENTRY*)(EGLDisplay dpy, const EGLint* attrib_list);
	static PFN_eglCreateStreamKHR createStreamKHRPtr = reinterpret_cast<PFN_eglCreateStreamKHR>(eglGetProcAddress("eglCreateStreamKHR"));
	auto result = createStreamKHRPtr(dpy, attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglCreateStreamKHR");
	return result;
}

EGLBoolean EGLAPIENTRY eglDestroyStreamKHR(EGLDisplay dpy, EGLStreamKHR stream)
{
	using PFN_eglDestroyStreamKHR = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLStreamKHR stream);
	static PFN_eglDestroyStreamKHR destroyStreamKHRPtr = reinterpret_cast<PFN_eglDestroyStreamKHR>(eglGetProcAddress("eglDestroyStreamKHR"));
	auto result = destroyStreamKHRPtr(dpy, stream);
	CHECK_EGL_ERROR_ASSERT("eglDestroyStreamKHR");
	return result;
}

EGLBoolean EGLAPIENTRY eglQueryStreamKHR(EGLDisplay dpy, EGLStreamKHR stream, EGLenum attribute, EGLint* value)
{
	using PFN_eglQueryStreamKHR = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLStreamKHR stream, EGLenum attribute, EGLint * value);
	static PFN_eglQueryStreamKHR queryStreamKHRPtr = reinterpret_cast<PFN_eglQueryStreamKHR>(eglGetProcAddress("eglQueryStreamKHR"));
	auto result = queryStreamKHRPtr(dpy, stream, attribute, value);
	CHECK_EGL_ERROR_ASSERT("eglQueryStreamKHR");
	return result;
}

EGLBoolean EGLAPIENTRY eglQueryStreamu64KHR(EGLDisplay dpy, EGLStreamKHR stream, EGLenum attribute, EGLuint64KHR* value)
{
	using PFN_eglQueryStreamu64KHR = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLStreamKHR stream, EGLenum attribute, EGLuint64KHR * value);
	static PFN_eglQueryStreamu64KHR queryStreamu64KHRPtr = reinterpret_cast<PFN_eglQueryStreamu64KHR>(eglGetProcAddress("eglQueryStreamu64KHR"));
	auto result = queryStreamu64KHRPtr(dpy, stream, attribute, value);
	CHECK_EGL_ERROR_ASSERT("eglQueryStreamu64KHR");
	return result;
}

EGLBoolean EGLAPIENTRY eglStreamAttribKHR(EGLDisplay dpy, EGLStreamKHR stream, EGLenum attribute, EGLint value)
{
	using PFN_eglStreamAttribKHR = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLStreamKHR stream, EGLenum attribute, EGLint value);
	static PFN_eglStreamAttribKHR streamAttribKHRPtr = reinterpret_cast<PFN_eglStreamAttribKHR>(eglGetProcAddress("eglStreamAttribKHR"));
	auto result = streamAttribKHRPtr(dpy, stream, attribute, value);
	CHECK_EGL_ERROR_ASSERT("eglStreamAttribKHR");
	return result;
}

#endif
#if defined(KHRONOS_SUPPORT_INT64)
// EGL_KHR_stream_attrib
EGLStreamKHR EGLAPIENTRY eglCreateStreamAttribKHR(EGLDisplay dpy, const EGLAttrib* attrib_list)
{
	using PFN_eglCreateStreamAttribKHR = EGLStreamKHR(EGLAPIENTRY*)(EGLDisplay dpy, const EGLAttrib* attrib_list);
	static PFN_eglCreateStreamAttribKHR createStreamAttribKHRPtr = reinterpret_cast<PFN_eglCreateStreamAttribKHR>(eglGetProcAddress("eglCreateStreamAttribKHR"));
	auto result = createStreamAttribKHRPtr(dpy, attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglCreateStreamAttribKHR");
	return result;
}

EGLBoolean EGLAPIENTRY eglQueryStreamAttribKHR(EGLDisplay dpy, EGLStreamKHR stream, EGLenum attribute, EGLAttrib* value)
{
	using PFN_eglQueryStreamAttribKHR = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLStreamKHR stream, EGLenum attribute, EGLAttrib * value);
	static PFN_eglQueryStreamAttribKHR queryStreamAttribKHRPtr = reinterpret_cast<PFN_eglQueryStreamAttribKHR>(eglGetProcAddress("eglQueryStreamAttribKHR"));
	auto result = queryStreamAttribKHRPtr(dpy, stream, attribute, value);
	CHECK_EGL_ERROR_ASSERT("eglQueryStreamAttribKHR");
	return result;
}

EGLBoolean EGLAPIENTRY eglSetStreamAttribKHR(EGLDisplay dpy, EGLStreamKHR stream, EGLenum attribute, EGLAttrib value)
{
	using PFN_eglSetStreamAttribKHR = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLStreamKHR stream, EGLenum attribute, EGLAttrib value);
	static PFN_eglSetStreamAttribKHR setStreamAttribKHRPtr = reinterpret_cast<PFN_eglSetStreamAttribKHR>(eglGetProcAddress("eglSetStreamAttribKHR"));
	auto result = setStreamAttribKHRPtr(dpy, stream, attribute, value);
	CHECK_EGL_ERROR_ASSERT("eglSetStreamAttribKHR");
	return result;
}

EGLBoolean EGLAPIENTRY eglStreamConsumerAcquireAttribKHR(EGLDisplay dpy, EGLStreamKHR stream, const EGLAttrib* attrib_list)
{
	using PFN_eglStreamConsumerAcquireAttribKHR = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLStreamKHR stream, const EGLAttrib* attrib_list);
	static PFN_eglStreamConsumerAcquireAttribKHR streamConsumerAcquireAttribKHRPtr = reinterpret_cast<PFN_eglStreamConsumerAcquireAttribKHR>(eglGetProcAddress("eglStreamConsumerAcquireAttribKHR"));
	auto result = streamConsumerAcquireAttribKHRPtr(dpy, stream, attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglStreamConsumerAcquireAttribKHR");
	return result;
}

EGLBoolean EGLAPIENTRY eglStreamConsumerReleaseAttribKHR(EGLDisplay dpy, EGLStreamKHR stream, const EGLAttrib* attrib_list)
{
	using PFN_eglStreamConsumerReleaseAttribKHR = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLStreamKHR stream, const EGLAttrib* attrib_list);
	static PFN_eglStreamConsumerReleaseAttribKHR streamConsumerReleaseAttribKHRPtr = reinterpret_cast<PFN_eglStreamConsumerReleaseAttribKHR>(eglGetProcAddress("eglStreamConsumerReleaseAttribKHR"));
	auto result = streamConsumerReleaseAttribKHRPtr(dpy, stream, attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglStreamConsumerReleaseAttribKHR");
	return result;
}

#endif
#if defined(EGL_KHR_stream)
// EGL_KHR_stream_consumer_gltexture
EGLBoolean EGLAPIENTRY eglStreamConsumerAcquireKHR(EGLDisplay dpy, EGLStreamKHR stream)
{
	using PFN_eglStreamConsumerAcquireKHR = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLStreamKHR stream);
	static PFN_eglStreamConsumerAcquireKHR streamConsumerAcquireKHRPtr = reinterpret_cast<PFN_eglStreamConsumerAcquireKHR>(eglGetProcAddress("eglStreamConsumerAcquireKHR"));
	auto result = streamConsumerAcquireKHRPtr(dpy, stream);
	CHECK_EGL_ERROR_ASSERT("eglStreamConsumerAcquireKHR");
	return result;
}

EGLBoolean EGLAPIENTRY eglStreamConsumerGLTextureExternalKHR(EGLDisplay dpy, EGLStreamKHR stream)
{
	using PFN_eglStreamConsumerGLTextureExternalKHR = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLStreamKHR stream);
	static PFN_eglStreamConsumerGLTextureExternalKHR streamConsumerGLTextureExternalKHRPtr = reinterpret_cast<PFN_eglStreamConsumerGLTextureExternalKHR>(eglGetProcAddress("eglStreamConsumerGLTextureExternalKHR"));
	auto result = streamConsumerGLTextureExternalKHRPtr(dpy, stream);
	CHECK_EGL_ERROR_ASSERT("eglStreamConsumerGLTextureExternalKHR");
	return result;
}

EGLBoolean EGLAPIENTRY eglStreamConsumerReleaseKHR(EGLDisplay dpy, EGLStreamKHR stream)
{
	using PFN_eglStreamConsumerReleaseKHR = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLStreamKHR stream);
	static PFN_eglStreamConsumerReleaseKHR streamConsumerReleaseKHRPtr = reinterpret_cast<PFN_eglStreamConsumerReleaseKHR>(eglGetProcAddress("eglStreamConsumerReleaseKHR"));
	auto result = streamConsumerReleaseKHRPtr(dpy, stream);
	CHECK_EGL_ERROR_ASSERT("eglStreamConsumerReleaseKHR");
	return result;
}

#endif
#if defined(EGL_KHR_stream)
// EGL_KHR_stream_cross_process_fd
EGLStreamKHR EGLAPIENTRY eglCreateStreamFromFileDescriptorKHR(EGLDisplay dpy, EGLNativeFileDescriptorKHR file_descriptor)
{
	using PFN_eglCreateStreamFromFileDescriptorKHR = EGLStreamKHR(EGLAPIENTRY*)(EGLDisplay dpy, EGLNativeFileDescriptorKHR file_descriptor);
	static PFN_eglCreateStreamFromFileDescriptorKHR createStreamFromFileDescriptorKHRPtr = reinterpret_cast<PFN_eglCreateStreamFromFileDescriptorKHR>(eglGetProcAddress("eglCreateStreamFromFileDescriptorKHR"));
	auto result = createStreamFromFileDescriptorKHRPtr(dpy, file_descriptor);
	CHECK_EGL_ERROR_ASSERT("eglCreateStreamFromFileDescriptorKHR");
	return result;
}

EGLNativeFileDescriptorKHR EGLAPIENTRY eglGetStreamFileDescriptorKHR(EGLDisplay dpy, EGLStreamKHR stream)
{
	using PFN_eglGetStreamFileDescriptorKHR = EGLNativeFileDescriptorKHR(EGLAPIENTRY*)(EGLDisplay dpy, EGLStreamKHR stream);
	static PFN_eglGetStreamFileDescriptorKHR getStreamFileDescriptorKHRPtr = reinterpret_cast<PFN_eglGetStreamFileDescriptorKHR>(eglGetProcAddress("eglGetStreamFileDescriptorKHR"));
	auto result = getStreamFileDescriptorKHRPtr(dpy, stream);
	CHECK_EGL_ERROR_ASSERT("eglGetStreamFileDescriptorKHR");
	return result;
}

#endif
#if defined(EGL_KHR_stream)
// EGL_KHR_stream_fifo
EGLBoolean EGLAPIENTRY eglQueryStreamTimeKHR(EGLDisplay dpy, EGLStreamKHR stream, EGLenum attribute, EGLTimeKHR* value)
{
	using PFN_eglQueryStreamTimeKHR = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLStreamKHR stream, EGLenum attribute, EGLTimeKHR * value);
	static PFN_eglQueryStreamTimeKHR queryStreamTimeKHRPtr = reinterpret_cast<PFN_eglQueryStreamTimeKHR>(eglGetProcAddress("eglQueryStreamTimeKHR"));
	auto result = queryStreamTimeKHRPtr(dpy, stream, attribute, value);
	CHECK_EGL_ERROR_ASSERT("eglQueryStreamTimeKHR");
	return result;
}

#endif
#if defined(EGL_KHR_stream)
// EGL_KHR_stream_producer_eglsurface
EGLSurface EGLAPIENTRY eglCreateStreamProducerSurfaceKHR(EGLDisplay dpy, EGLConfig config, EGLStreamKHR stream, const EGLint* attrib_list)
{
	using PFN_eglCreateStreamProducerSurfaceKHR = EGLSurface(EGLAPIENTRY*)(EGLDisplay dpy, EGLConfig config, EGLStreamKHR stream, const EGLint* attrib_list);
	static PFN_eglCreateStreamProducerSurfaceKHR createStreamProducerSurfaceKHRPtr = reinterpret_cast<PFN_eglCreateStreamProducerSurfaceKHR>(eglGetProcAddress("eglCreateStreamProducerSurfaceKHR"));
	auto result = createStreamProducerSurfaceKHRPtr(dpy, config, stream, attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglCreateStreamProducerSurfaceKHR");
	return result;
}

#endif
// EGL_KHR_swap_buffers_with_damage
EGLBoolean EGLAPIENTRY eglSwapBuffersWithDamageKHR(EGLDisplay dpy, EGLSurface surface, EGLint* rects, EGLint n_rects)
{
	using PFN_eglSwapBuffersWithDamageKHR = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSurface surface, EGLint * rects, EGLint n_rects);
	static PFN_eglSwapBuffersWithDamageKHR swapBuffersWithDamageKHRPtr = reinterpret_cast<PFN_eglSwapBuffersWithDamageKHR>(eglGetProcAddress("eglSwapBuffersWithDamageKHR"));
	auto result = swapBuffersWithDamageKHRPtr(dpy, surface, rects, n_rects);
	CHECK_EGL_ERROR_ASSERT("eglSwapBuffersWithDamageKHR");
	return result;
}

// EGL_KHR_wait_sync
EGLint EGLAPIENTRY eglWaitSyncKHR(EGLDisplay dpy, EGLSyncKHR sync, EGLint flags)
{
	using PFN_eglWaitSyncKHR = EGLint(EGLAPIENTRY*)(EGLDisplay dpy, EGLSyncKHR sync, EGLint flags);
	static PFN_eglWaitSyncKHR waitSyncKHRPtr = reinterpret_cast<PFN_eglWaitSyncKHR>(eglGetProcAddress("eglWaitSyncKHR"));
	auto result = waitSyncKHRPtr(dpy, sync, flags);
	CHECK_EGL_ERROR_ASSERT("eglWaitSyncKHR");
	return result;
}

// EGL_MESA_drm_image
EGLImageKHR EGLAPIENTRY eglCreateDRMImageMESA(EGLDisplay dpy, const EGLint* attrib_list)
{
	using PFN_eglCreateDRMImageMESA = EGLImageKHR(EGLAPIENTRY*)(EGLDisplay dpy, const EGLint* attrib_list);
	static PFN_eglCreateDRMImageMESA createDRMImageMESAPtr = reinterpret_cast<PFN_eglCreateDRMImageMESA>(eglGetProcAddress("eglCreateDRMImageMESA"));
	auto result = createDRMImageMESAPtr(dpy, attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglCreateDRMImageMESA");
	return result;
}

EGLBoolean EGLAPIENTRY eglExportDRMImageMESA(EGLDisplay dpy, EGLImageKHR image, EGLint* name, EGLint* handle, EGLint* stride)
{
	using PFN_eglExportDRMImageMESA = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLImageKHR image, EGLint * name, EGLint * handle, EGLint * stride);
	static PFN_eglExportDRMImageMESA exportDRMImageMESAPtr = reinterpret_cast<PFN_eglExportDRMImageMESA>(eglGetProcAddress("eglExportDRMImageMESA"));
	auto result = exportDRMImageMESAPtr(dpy, image, name, handle, stride);
	CHECK_EGL_ERROR_ASSERT("eglExportDRMImageMESA");
	return result;
}

// EGL_MESA_image_dma_buf_export
EGLBoolean EGLAPIENTRY eglExportDMABUFImageMESA(EGLDisplay dpy, EGLImageKHR image, int* fds, EGLint* strides, EGLint* offsets)
{
	using PFN_eglExportDMABUFImageMESA = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLImageKHR image, int* fds, EGLint* strides, EGLint* offsets);
	static PFN_eglExportDMABUFImageMESA exportDMABUFImageMESAPtr = reinterpret_cast<PFN_eglExportDMABUFImageMESA>(eglGetProcAddress("eglExportDMABUFImageMESA"));
	auto result = exportDMABUFImageMESAPtr(dpy, image, fds, strides, offsets);
	CHECK_EGL_ERROR_ASSERT("eglExportDMABUFImageMESA");
	return result;
}

EGLBoolean EGLAPIENTRY eglExportDMABUFImageQueryMESA(EGLDisplay dpy, EGLImageKHR image, int* fourcc, int* num_planes, EGLuint64KHR* modifiers)
{
	using PFN_eglExportDMABUFImageQueryMESA = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLImageKHR image, int* fourcc, int* num_planes, EGLuint64KHR* modifiers);
	static PFN_eglExportDMABUFImageQueryMESA exportDMABUFImageQueryMESAPtr = reinterpret_cast<PFN_eglExportDMABUFImageQueryMESA>(eglGetProcAddress("eglExportDMABUFImageQueryMESA"));
	auto result = exportDMABUFImageQueryMESAPtr(dpy, image, fourcc, num_planes, modifiers);
	CHECK_EGL_ERROR_ASSERT("eglExportDMABUFImageQueryMESA");
	return result;
}

// EGL_NOK_swap_region
EGLBoolean EGLAPIENTRY eglSwapBuffersRegionNOK(EGLDisplay dpy, EGLSurface surface, EGLint numRects, const EGLint* rects)
{
	using PFN_eglSwapBuffersRegionNOK = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSurface surface, EGLint numRects, const EGLint* rects);
	static PFN_eglSwapBuffersRegionNOK swapBuffersRegionNOKPtr = reinterpret_cast<PFN_eglSwapBuffersRegionNOK>(eglGetProcAddress("eglSwapBuffersRegionNOK"));
	auto result = swapBuffersRegionNOKPtr(dpy, surface, numRects, rects);
	CHECK_EGL_ERROR_ASSERT("eglSwapBuffersRegionNOK");
	return result;
}

// EGL_NOK_swap_region2
EGLBoolean EGLAPIENTRY eglSwapBuffersRegion2NOK(EGLDisplay dpy, EGLSurface surface, EGLint numRects, const EGLint* rects)
{
	using PFN_eglSwapBuffersRegion2NOK = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSurface surface, EGLint numRects, const EGLint* rects);
	static PFN_eglSwapBuffersRegion2NOK swapBuffersRegion2NOKPtr = reinterpret_cast<PFN_eglSwapBuffersRegion2NOK>(eglGetProcAddress("eglSwapBuffersRegion2NOK"));
	auto result = swapBuffersRegion2NOKPtr(dpy, surface, numRects, rects);
	CHECK_EGL_ERROR_ASSERT("eglSwapBuffersRegion2NOK");
	return result;
}

// EGL_NV_native_query
EGLBoolean EGLAPIENTRY eglQueryNativeDisplayNV(EGLDisplay dpy, EGLNativeDisplayType* display_id)
{
	using PFN_eglQueryNativeDisplayNV = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLNativeDisplayType * display_id);
	static PFN_eglQueryNativeDisplayNV queryNativeDisplayNVPtr = reinterpret_cast<PFN_eglQueryNativeDisplayNV>(eglGetProcAddress("eglQueryNativeDisplayNV"));
	auto result = queryNativeDisplayNVPtr(dpy, display_id);
	CHECK_EGL_ERROR_ASSERT("eglQueryNativeDisplayNV");
	return result;
}

EGLBoolean EGLAPIENTRY eglQueryNativePixmapNV(EGLDisplay dpy, EGLSurface surf, EGLNativePixmapType* pixmap)
{
	using PFN_eglQueryNativePixmapNV = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSurface surf, EGLNativePixmapType * pixmap);
	static PFN_eglQueryNativePixmapNV queryNativePixmapNVPtr = reinterpret_cast<PFN_eglQueryNativePixmapNV>(eglGetProcAddress("eglQueryNativePixmapNV"));
	auto result = queryNativePixmapNVPtr(dpy, surf, pixmap);
	CHECK_EGL_ERROR_ASSERT("eglQueryNativePixmapNV");
	return result;
}

EGLBoolean EGLAPIENTRY eglQueryNativeWindowNV(EGLDisplay dpy, EGLSurface surf, EGLNativeWindowType* window)
{
	using PFN_eglQueryNativeWindowNV = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSurface surf, EGLNativeWindowType * window);
	static PFN_eglQueryNativeWindowNV queryNativeWindowNVPtr = reinterpret_cast<PFN_eglQueryNativeWindowNV>(eglGetProcAddress("eglQueryNativeWindowNV"));
	auto result = queryNativeWindowNVPtr(dpy, surf, window);
	CHECK_EGL_ERROR_ASSERT("eglQueryNativeWindowNV");
	return result;
}

// EGL_NV_post_sub_buffer
EGLBoolean EGLAPIENTRY eglPostSubBufferNV(EGLDisplay dpy, EGLSurface surface, EGLint x, EGLint y, EGLint width, EGLint height)
{
	using PFN_eglPostSubBufferNV = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLSurface surface, EGLint x, EGLint y, EGLint width, EGLint height);
	static PFN_eglPostSubBufferNV postSubBufferNVPtr = reinterpret_cast<PFN_eglPostSubBufferNV>(eglGetProcAddress("eglPostSubBufferNV"));
	auto result = postSubBufferNVPtr(dpy, surface, x, y, width, height);
	CHECK_EGL_ERROR_ASSERT("eglPostSubBufferNV");
	return result;
}

// EGL_NV_stream_consumer_gltexture_yuv
EGLBoolean EGLAPIENTRY eglStreamConsumerGLTextureExternalAttribsNV(EGLDisplay dpy, EGLStreamKHR stream, const EGLAttrib* attrib_list)
{
	using PFN_eglStreamConsumerGLTextureExternalAttribsNV = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLStreamKHR stream, const EGLAttrib* attrib_list);
	static PFN_eglStreamConsumerGLTextureExternalAttribsNV streamConsumerGLTextureExternalAttribsNVPtr = reinterpret_cast<PFN_eglStreamConsumerGLTextureExternalAttribsNV>(eglGetProcAddress("eglStreamConsumerGLTextureExternalAttribsNV"));
	auto result = streamConsumerGLTextureExternalAttribsNVPtr(dpy, stream, attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglStreamConsumerGLTextureExternalAttribsNV");
	return result;
}

// EGL_NV_stream_metadata
EGLBoolean EGLAPIENTRY eglQueryDisplayAttribNV(EGLDisplay dpy, EGLint attribute, EGLAttrib* value)
{
	using PFN_eglQueryDisplayAttribNV = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLint attribute, EGLAttrib * value);
	static PFN_eglQueryDisplayAttribNV queryDisplayAttribNVPtr = reinterpret_cast<PFN_eglQueryDisplayAttribNV>(eglGetProcAddress("eglQueryDisplayAttribNV"));
	auto result = queryDisplayAttribNVPtr(dpy, attribute, value);
	CHECK_EGL_ERROR_ASSERT("eglQueryDisplayAttribNV");
	return result;
}

EGLBoolean EGLAPIENTRY eglQueryStreamMetadataNV(EGLDisplay dpy, EGLStreamKHR stream, EGLenum name, EGLint n, EGLint offset, EGLint size, void* data)
{
	using PFN_eglQueryStreamMetadataNV = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLStreamKHR stream, EGLenum name, EGLint n, EGLint offset, EGLint size, void* data);
	static PFN_eglQueryStreamMetadataNV queryStreamMetadataNVPtr = reinterpret_cast<PFN_eglQueryStreamMetadataNV>(eglGetProcAddress("eglQueryStreamMetadataNV"));
	auto result = queryStreamMetadataNVPtr(dpy, stream, name, n, offset, size, data);
	CHECK_EGL_ERROR_ASSERT("eglQueryStreamMetadataNV");
	return result;
}

EGLBoolean EGLAPIENTRY eglSetStreamMetadataNV(EGLDisplay dpy, EGLStreamKHR stream, EGLint n, EGLint offset, EGLint size, const void* data)
{
	using PFN_eglSetStreamMetadataNV = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLStreamKHR stream, EGLint n, EGLint offset, EGLint size, const void* data);
	static PFN_eglSetStreamMetadataNV setStreamMetadataNVPtr = reinterpret_cast<PFN_eglSetStreamMetadataNV>(eglGetProcAddress("eglSetStreamMetadataNV"));
	auto result = setStreamMetadataNVPtr(dpy, stream, n, offset, size, data);
	CHECK_EGL_ERROR_ASSERT("eglSetStreamMetadataNV");
	return result;
}

// EGL_NV_stream_reset
EGLBoolean EGLAPIENTRY eglResetStreamNV(EGLDisplay dpy, EGLStreamKHR stream)
{
	using PFN_eglResetStreamNV = EGLBoolean(EGLAPIENTRY*)(EGLDisplay dpy, EGLStreamKHR stream);
	static PFN_eglResetStreamNV resetStreamNVPtr = reinterpret_cast<PFN_eglResetStreamNV>(eglGetProcAddress("eglResetStreamNV"));
	auto result = resetStreamNVPtr(dpy, stream);
	CHECK_EGL_ERROR_ASSERT("eglResetStreamNV");
	return result;
}

// EGL_NV_stream_sync
EGLSyncKHR EGLAPIENTRY eglCreateStreamSyncNV(EGLDisplay dpy, EGLStreamKHR stream, EGLenum type, const EGLint* attrib_list)
{
	using PFN_eglCreateStreamSyncNV = EGLSyncKHR(EGLAPIENTRY*)(EGLDisplay dpy, EGLStreamKHR stream, EGLenum type, const EGLint* attrib_list);
	static PFN_eglCreateStreamSyncNV createStreamSyncNVPtr = reinterpret_cast<PFN_eglCreateStreamSyncNV>(eglGetProcAddress("eglCreateStreamSyncNV"));
	auto result = createStreamSyncNVPtr(dpy, stream, type, attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglCreateStreamSyncNV");
	return result;
}

#if defined(KHRONOS_SUPPORT_INT64)
// EGL_NV_sync
EGLint EGLAPIENTRY eglClientWaitSyncNV(EGLSyncNV sync, EGLint flags, EGLTimeNV timeout)
{
	using PFN_eglClientWaitSyncNV = EGLint(EGLAPIENTRY*)(EGLSyncNV sync, EGLint flags, EGLTimeNV timeout);
	static PFN_eglClientWaitSyncNV clientWaitSyncNVPtr = reinterpret_cast<PFN_eglClientWaitSyncNV>(eglGetProcAddress("eglClientWaitSyncNV"));
	auto result = clientWaitSyncNVPtr(sync, flags, timeout);
	CHECK_EGL_ERROR_ASSERT("eglClientWaitSyncNV");
	return result;
}

EGLSyncNV EGLAPIENTRY eglCreateFenceSyncNV(EGLDisplay dpy, EGLenum condition, const EGLint* attrib_list)
{
	using PFN_eglCreateFenceSyncNV = EGLSyncNV(EGLAPIENTRY*)(EGLDisplay dpy, EGLenum condition, const EGLint* attrib_list);
	static PFN_eglCreateFenceSyncNV createFenceSyncNVPtr = reinterpret_cast<PFN_eglCreateFenceSyncNV>(eglGetProcAddress("eglCreateFenceSyncNV"));
	auto result = createFenceSyncNVPtr(dpy, condition, attrib_list);
	CHECK_EGL_ERROR_ASSERT("eglCreateFenceSyncNV");
	return result;
}

EGLBoolean EGLAPIENTRY eglDestroySyncNV(EGLSyncNV sync)
{
	using PFN_eglDestroySyncNV = EGLBoolean(EGLAPIENTRY*)(EGLSyncNV sync);
	static PFN_eglDestroySyncNV destroySyncNVPtr = reinterpret_cast<PFN_eglDestroySyncNV>(eglGetProcAddress("eglDestroySyncNV"));
	auto result = destroySyncNVPtr(sync);
	CHECK_EGL_ERROR_ASSERT("eglDestroySyncNV");
	return result;
}

EGLBoolean EGLAPIENTRY eglFenceNV(EGLSyncNV sync)
{
	using PFN_eglFenceNV = EGLBoolean(EGLAPIENTRY*)(EGLSyncNV sync);
	static PFN_eglFenceNV fenceNVPtr = reinterpret_cast<PFN_eglFenceNV>(eglGetProcAddress("eglFenceNV"));
	auto result = fenceNVPtr(sync);
	CHECK_EGL_ERROR_ASSERT("eglFenceNV");
	return result;
}

EGLBoolean EGLAPIENTRY eglGetSyncAttribNV(EGLSyncNV sync, EGLint attribute, EGLint* value)
{
	using PFN_eglGetSyncAttribNV = EGLBoolean(EGLAPIENTRY*)(EGLSyncNV sync, EGLint attribute, EGLint * value);
	static PFN_eglGetSyncAttribNV getSyncAttribNVPtr = reinterpret_cast<PFN_eglGetSyncAttribNV>(eglGetProcAddress("eglGetSyncAttribNV"));
	auto result = getSyncAttribNVPtr(sync, attribute, value);
	CHECK_EGL_ERROR_ASSERT("eglGetSyncAttribNV");
	return result;
}

EGLBoolean EGLAPIENTRY eglSignalSyncNV(EGLSyncNV sync, EGLenum mode)
{
	using PFN_eglSignalSyncNV = EGLBoolean(EGLAPIENTRY*)(EGLSyncNV sync, EGLenum mode);
	static PFN_eglSignalSyncNV signalSyncNVPtr = reinterpret_cast<PFN_eglSignalSyncNV>(eglGetProcAddress("eglSignalSyncNV"));
	auto result = signalSyncNVPtr(sync, mode);
	CHECK_EGL_ERROR_ASSERT("eglSignalSyncNV");
	return result;
}

#endif
#if defined(KHRONOS_SUPPORT_INT64)
// EGL_NV_system_time
EGLuint64NV EGLAPIENTRY eglGetSystemTimeFrequencyNV()
{
	using PFN_eglGetSystemTimeFrequencyNV = EGLuint64NV(EGLAPIENTRY*)();
	static PFN_eglGetSystemTimeFrequencyNV getSystemTimeFrequencyNVPtr = reinterpret_cast<PFN_eglGetSystemTimeFrequencyNV>(eglGetProcAddress("eglGetSystemTimeFrequencyNV"));
	auto result = getSystemTimeFrequencyNVPtr();
	CHECK_EGL_ERROR_ASSERT("eglGetSystemTimeFrequencyNV");
	return result;
}

EGLuint64NV EGLAPIENTRY eglGetSystemTimeNV()
{
	using PFN_eglGetSystemTimeNV = EGLuint64NV(EGLAPIENTRY*)();
	static PFN_eglGetSystemTimeNV getSystemTimeNVPtr = reinterpret_cast<PFN_eglGetSystemTimeNV>(eglGetProcAddress("eglGetSystemTimeNV"));
	auto result = getSystemTimeNVPtr();
	CHECK_EGL_ERROR_ASSERT("eglGetSystemTimeNV");
	return result;
}

#endif
