//
// Generated by PVRCarbon v0.8 (21.2@6135481)
//
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <signal.h>
#include <mutex>
#include <cstring>

bool isDebuggerPresent()
{
	// Detect if debugger is attached. Reference implementation: https://stackoverflow.com/questions/3596781/how-to-detect-if-the-current-process-is-being-run-by-gdb

	// Only check once for whether the debugger is present as this may not be efficient to determine
	static bool isUsingDebugger = false;
	static bool haveCheckedForDebugger = false;

	if (!haveCheckedForDebugger)
	{
		static std::mutex debuggerCheckMutex;
		std::lock_guard<std::mutex> lock(debuggerCheckMutex);

		char buffer[4096];

		const int status_fd = ::open("/proc/self/status", O_RDONLY);
		if (status_fd == -1)
		{
			isUsingDebugger = false;
			return isUsingDebugger;
		}

		const ssize_t num_read = ::read(status_fd, buffer, sizeof(buffer) - 1);
		if (num_read <= 0)
		{
			isUsingDebugger = false;
			return isUsingDebugger;
		}

		buffer[num_read] = '\0';
		constexpr char tracerPidString[] = "TracerPid:";
		const auto tracer_pid_ptr = ::strstr(buffer, tracerPidString);
		if (!tracer_pid_ptr)
		{
			isUsingDebugger = false;
			return isUsingDebugger;
		}

		for (const char* characterPtr = tracer_pid_ptr + sizeof(tracerPidString) - 1; characterPtr <= buffer + num_read; ++characterPtr)
		{
			if (::isspace(*characterPtr))
			{
				continue;
			}
			else
			{
				isUsingDebugger = ::isdigit(*characterPtr) != 0 && *characterPtr != '0';
				break;
			}
		}

		haveCheckedForDebugger = true;
	}

	return isUsingDebugger;
}

void debuggerBreak()
{
#if defined(USE_DEBUG_BREAK)
	if (isDebuggerPresent())
	{
		raise(SIGTRAP);
	}
#endif
}
