//
// Generated by PVRCarbon v0.8 (21.2@6135481)
//
#include <unordered_map>
#include <unistd.h>
#include <limits.h>
#include <string.h>
#include <stdexcept>
#include "platform/errors.h"
#include "platform/platform.h"

struct Platform::Impl
{
#if defined(SUPPORT_X11)
	Display* xlibDisplay = nullptr;
	std::unordered_map<uint64_t, Window> xlibWindows;
#endif
};

Platform::Platform()
	: m_impl(std::make_unique<Platform::Impl>())
{
}

Platform::~Platform()
{
#if defined(SUPPORT_X11)
	if (m_impl->xlibDisplay != nullptr)
	{
		XCloseDisplay(m_impl->xlibDisplay);
	}
#endif
}

void Platform::close()
{
#if defined(SUPPORT_X11)
	if (m_impl->xlibDisplay != nullptr)
	{
		XCloseDisplay(m_impl->xlibDisplay);
		m_impl->xlibDisplay = nullptr;
	}
#endif
}

std::string Platform::getProcessPath()
{
	char path[_POSIX_PATH_MAX] = {'\0'};
	ssize_t size = readlink("/proc/self/exe", path, sizeof(path));
	(void) size; // Unused

	std::string value = path;
	const size_t last_slash_idx = value.find_last_of("\\/");

	if (std::string::npos != last_slash_idx)
	{
		value.erase(last_slash_idx + 1);
	}

	return value;
}

void Platform::processEvents()
{
#if defined(SUPPORT_X11)
	if (m_impl->xlibDisplay != nullptr)
	{
		XEvent event;
		int32_t numMessages = XPending(m_impl->xlibDisplay);

		for (int32_t i = 0; i < numMessages; ++i)
		{
			XNextEvent(m_impl->xlibDisplay, &event);
		}
	}
#endif
}

#if defined(SUPPORT_X11)
template <>
Display* Platform::get(uint64_t uid)
{
	(void) uid;

	if (m_impl->xlibDisplay == nullptr)
	{
		m_impl->xlibDisplay = XOpenDisplay(nullptr);

		if (m_impl->xlibDisplay == nullptr)
		{
			throw ApplicationError("Failed to open a connection to the X server");
		}
	}

	return m_impl->xlibDisplay;
}

template <>
Window Platform::get(uint64_t instanceUid, uint64_t uid, uint32_t width, uint32_t height)
{
	auto result = m_impl->xlibWindows.find(uid);

	if (result != m_impl->xlibWindows.end())
	{
		return result->second;
	}

	XSetWindowAttributes attributes = {};
	attributes.background_pixel = 0x7FFFFFFF;
	attributes.border_pixel = 0;
	attributes.event_mask = StructureNotifyMask | ExposureMask | ButtonPressMask | ButtonReleaseMask | KeyPressMask | KeyReleaseMask;

	Display* display = get<Display*>(instanceUid);
	Window window = XCreateWindow(display, XRootWindow(display, 0), 0, 0, width, height, 5, CopyFromParent, InputOutput, CopyFromParent, CWBackPixel, &attributes);

	XMapWindow(display, window);
	XFlush(display);

	m_impl->xlibWindows.emplace(uid, window);
	return window;
}
#endif