//
// Generated by PVRCarbon v0.8 (21.2@6135481)
//
#pragma once
#include <string.h>

#if defined(_WIN32)
#include <Windows.h>
#else
#include <dlfcn.h>
#endif

class NativeLibrary
{
public:
	NativeLibrary(const char* name)
		: m_library(nullptr)
	{
		load(name);
	}

	NativeLibrary()
		: m_library(nullptr)
	{
	}

	~NativeLibrary()
	{
		close();
	}

	bool load(const char* name)
	{
#if defined(_WIN32)
		m_library = LoadLibraryA(name);
#else
		m_library = dlopen(name, RTLD_LAZY | RTLD_GLOBAL);
#endif
		return isLoaded();
	}

	bool isLoaded() const
	{
		return m_library != nullptr;
	}

	void close()
	{
		if (m_library)
		{
#if defined(_WIN32)
			FreeLibrary(static_cast<HMODULE>(m_library));
#else
			dlclose(m_library);
#endif
			m_library = nullptr;
		}
	}

	void* getProcAddress(const char* name)
	{
		if (!isLoaded())
		{
			return nullptr;
		}

#if defined(_WIN32)
		void* ptr = reinterpret_cast<void*>(GetProcAddress(static_cast<HMODULE>(m_library), name));
#else
		void* ptr = dlsym(m_library, name);
#endif
		return ptr;
	}

	template <typename T>
	T getProcAddress(const char* name)
	{
		if (m_library == nullptr)
		{
			return nullptr;
		}

		/*
			Use memcpy to avoid
			warning: ISO C++ forbids casting between pointer-to-function and pointer-to-object [-Wpedantic]
		*/
		T addr;
		void* ptr = getProcAddress(name);
		memcpy(&addr, &ptr, sizeof(void*));
		return addr;
	}

protected:
	void* m_library;
};
