//
// Generated by PVRCarbon v0.8 (21.2@6135481)
//
#include "threads/shared.h"
#include <cstring>

static inline bool isExtensionSupported(const unsigned char* const extensionString, const char* const extension)
{
	if (!extensionString) { return false; }

	// The recommended technique for querying OpenGL extensions;
	// from http://opengl.org/resources/features/OGLextensions/
	const char* start = (const char*)extensionString;
	char *position, *terminator;

	// Extension names should not have spaces.
	position = (char*)strchr(extension, ' ');

	if (position || *extension == '\0') { return 0; }

	/* It takes a bit of care to be fool-proof about parsing the
	OpenGL extensions string. Don't be fooled by sub-strings, etc. */
	for (;;)
	{
		position = (char*)strstr((char*)start, extension);

		if (!position) { break; }

		terminator = position + strlen(extension);

		if (position == start || *(position - 1) == ' ')
		{
			if (*terminator == ' ' || *terminator == '\0') { return true; }
		}

		start = terminator;
	}

	return false;
}

inline bool isGlExtensionSupported(const char* extensionName)
{
	const unsigned char* extensionString = glGetString(GL_EXTENSIONS);
	return isExtensionSupported(extensionString, extensionName);
}

void run_thread0()
{
	EGLNativeDisplayType nativeDisplay; // Recorded value 0x0
	Platform platformManager;
	EGLDisplay display;
	nativeDisplay = platformManager.get<EGLNativeDisplayType>(0x0);
	
	display = eglGetDisplay(nativeDisplay);
	
	if (display == EGL_NO_DISPLAY)
	{
		throw ApplicationError("Failed to get a display");
	}
	
	if (eglInitialize(display, nullptr, nullptr) == EGL_FALSE)
	{
		throw ApplicationError("Failed to initialise our display");
	}
	
	EGLConfig config;
	{
		std::vector<EGLint> attributes =
		{
			EGL_RENDERABLE_TYPE, EGL_OPENGL_ES3_BIT | EGL_OPENGL_ES2_BIT,
			EGL_SURFACE_TYPE, EGL_WINDOW_BIT,
			EGL_NONE
		};
		
		EGLint num = 0;
		
		if (eglChooseConfig(display, attributes.data(), &config, 1, &num) == EGL_FALSE || num == 0)
		{
			throw ApplicationError("Failed to choose a config");
		}
	}

	std::vector<EGLint> attribs;
	
	EGLNativeWindowType nativeWindow; // Recorded value 0x7d9db6ef90
	EGLSurface surface;

	attribs.assign({ EGL_NONE });

	nativeWindow = platformManager.get<EGLNativeWindowType>(0x0, 0x7d9db6ef90, 3360, 1440);
	
	surface = eglCreateWindowSurface(display, config, nativeWindow, attribs.data());
	
	if (surface == EGL_NO_SURFACE)
	{
		throw ApplicationError("Failed to create egl window surface");
	}
	
	attribs.assign({ EGL_CONTEXT_CLIENT_VERSION, 3, EGL_NONE });
	
	EGLContext context;
	context = eglCreateContext(display, config, EGL_NO_CONTEXT, attribs.data());

	if (context == EGL_NO_CONTEXT)
	{
		throw ApplicationError("Failed to create egl context");
	}

	eglMakeCurrent(display, surface, surface, context);

	GLuint texture;
	glGenTextures(1, &texture);
	glBindTexture(GL_TEXTURE_2D, texture);
	glTexStorage2D(GL_TEXTURE_2D, 1, GL_RGBA8, 256, 256);

	auto e = glGetError();

	if (e != GL_NO_ERROR)
	{
		throw ApplicationError("Failed to create texture");
	}

	GLuint framebuffer;
	glGenFramebuffers(1, &framebuffer);
	glBindFramebuffer(GL_FRAMEBUFFER, framebuffer);

	GLint samples;
	glGetIntegerv(GL_MAX_SAMPLES_EXT, &samples);

	if(!isGlExtensionSupported("GL_EXT_multisampled_render_to_texture"))
	{
		throw ApplicationError("Unsupported extension");
	}

	glFramebufferTexture2DMultisampleEXT(GL_FRAMEBUFFER, GL_COLOR_ATTACHMENT0, GL_TEXTURE_2D, texture, 0, 1);
	e = glGetError();

	if (e != GL_NO_ERROR)
	{
		throw ApplicationError("Failed to glFramebufferTexture2DMultisampleEXT");
	}

	if (glCheckFramebufferStatus(GL_FRAMEBUFFER) != GL_FRAMEBUFFER_COMPLETE)
	{
		throw ApplicationError("Failed to create framebuffer");
	}

	// glDeleteFramebuffers(1, &framebuffer);

	eglMakeCurrent(display, EGL_NO_SURFACE, EGL_NO_SURFACE, EGL_NO_CONTEXT);

	eglTerminate(display);
	eglReleaseThread();

	platformManager.close();
}
