//
// Generated by PVRCarbon v0.8 (21.2@6135481)
//
#include <cassert>
#include "EGL/egl.h"
#include "GLES3/gl32.h"
#include "GLES2/gl2ext.h"
#include "platform/native_library.h"
#include "platform/log.h"

#if defined(ASSERT_ON_GL_ERROR)
#define CHECK_GL_ERROR_ASSERT(func)                       \
	do                                                    \
	{                                                     \
		GLenum err;                                       \
		while ((err = glGetError()) != GL_NO_ERROR)       \
		{                                                 \
			LOG(func " generated GL error 0x%04X", err);  \
			assert(false && func "Generated a GL error"); \
		}                                                 \
	} while (0)
#else
#define CHECK_GL_ERROR_ASSERT(func)
#endif

namespace gl {
namespace internal {

static NativeLibrary& library()
{
#if defined(_WIN32)
	static NativeLibrary instance("libGLESv2.dll");
#else
	static NativeLibrary instance("libGLESv2.so");
#endif
	return instance;
}

}
}

// GL_ES_VERSION_2_0
void GL_APIENTRY glActiveTexture(GLenum texture)
{
	using PFN_glActiveTexture = void(GL_APIENTRY*)(GLenum texture);
	static PFN_glActiveTexture activeTexturePtr = gl::internal::library().getProcAddress<PFN_glActiveTexture>("glActiveTexture");
	activeTexturePtr(texture);
	CHECK_GL_ERROR_ASSERT("glActiveTexture");
}

void GL_APIENTRY glAttachShader(GLuint program, GLuint shader)
{
	using PFN_glAttachShader = void(GL_APIENTRY*)(GLuint program, GLuint shader);
	static PFN_glAttachShader attachShaderPtr = gl::internal::library().getProcAddress<PFN_glAttachShader>("glAttachShader");
	attachShaderPtr(program, shader);
	CHECK_GL_ERROR_ASSERT("glAttachShader");
}

void GL_APIENTRY glBindAttribLocation(GLuint program, GLuint index, const GLchar* name)
{
	using PFN_glBindAttribLocation = void(GL_APIENTRY*)(GLuint program, GLuint index, const GLchar* name);
	static PFN_glBindAttribLocation bindAttribLocationPtr = gl::internal::library().getProcAddress<PFN_glBindAttribLocation>("glBindAttribLocation");
	bindAttribLocationPtr(program, index, name);
	CHECK_GL_ERROR_ASSERT("glBindAttribLocation");
}

void GL_APIENTRY glBindBuffer(GLenum target, GLuint buffer)
{
	using PFN_glBindBuffer = void(GL_APIENTRY*)(GLenum target, GLuint buffer);
	static PFN_glBindBuffer bindBufferPtr = gl::internal::library().getProcAddress<PFN_glBindBuffer>("glBindBuffer");
	bindBufferPtr(target, buffer);
	CHECK_GL_ERROR_ASSERT("glBindBuffer");
}

void GL_APIENTRY glBindFramebuffer(GLenum target, GLuint framebuffer)
{
	using PFN_glBindFramebuffer = void(GL_APIENTRY*)(GLenum target, GLuint framebuffer);
	static PFN_glBindFramebuffer bindFramebufferPtr = gl::internal::library().getProcAddress<PFN_glBindFramebuffer>("glBindFramebuffer");
	bindFramebufferPtr(target, framebuffer);
	CHECK_GL_ERROR_ASSERT("glBindFramebuffer");
}

void GL_APIENTRY glBindRenderbuffer(GLenum target, GLuint renderbuffer)
{
	using PFN_glBindRenderbuffer = void(GL_APIENTRY*)(GLenum target, GLuint renderbuffer);
	static PFN_glBindRenderbuffer bindRenderbufferPtr = gl::internal::library().getProcAddress<PFN_glBindRenderbuffer>("glBindRenderbuffer");
	bindRenderbufferPtr(target, renderbuffer);
	CHECK_GL_ERROR_ASSERT("glBindRenderbuffer");
}

void GL_APIENTRY glBindTexture(GLenum target, GLuint texture)
{
	using PFN_glBindTexture = void(GL_APIENTRY*)(GLenum target, GLuint texture);
	static PFN_glBindTexture bindTexturePtr = gl::internal::library().getProcAddress<PFN_glBindTexture>("glBindTexture");
	bindTexturePtr(target, texture);
	CHECK_GL_ERROR_ASSERT("glBindTexture");
}

void GL_APIENTRY glBlendColor(GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha)
{
	using PFN_glBlendColor = void(GL_APIENTRY*)(GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha);
	static PFN_glBlendColor blendColorPtr = gl::internal::library().getProcAddress<PFN_glBlendColor>("glBlendColor");
	blendColorPtr(red, green, blue, alpha);
	CHECK_GL_ERROR_ASSERT("glBlendColor");
}

void GL_APIENTRY glBlendEquation(GLenum mode)
{
	using PFN_glBlendEquation = void(GL_APIENTRY*)(GLenum mode);
	static PFN_glBlendEquation blendEquationPtr = gl::internal::library().getProcAddress<PFN_glBlendEquation>("glBlendEquation");
	blendEquationPtr(mode);
	CHECK_GL_ERROR_ASSERT("glBlendEquation");
}

void GL_APIENTRY glBlendEquationSeparate(GLenum modeRGB, GLenum modeAlpha)
{
	using PFN_glBlendEquationSeparate = void(GL_APIENTRY*)(GLenum modeRGB, GLenum modeAlpha);
	static PFN_glBlendEquationSeparate blendEquationSeparatePtr = gl::internal::library().getProcAddress<PFN_glBlendEquationSeparate>("glBlendEquationSeparate");
	blendEquationSeparatePtr(modeRGB, modeAlpha);
	CHECK_GL_ERROR_ASSERT("glBlendEquationSeparate");
}

void GL_APIENTRY glBlendFunc(GLenum sfactor, GLenum dfactor)
{
	using PFN_glBlendFunc = void(GL_APIENTRY*)(GLenum sfactor, GLenum dfactor);
	static PFN_glBlendFunc blendFuncPtr = gl::internal::library().getProcAddress<PFN_glBlendFunc>("glBlendFunc");
	blendFuncPtr(sfactor, dfactor);
	CHECK_GL_ERROR_ASSERT("glBlendFunc");
}

void GL_APIENTRY glBlendFuncSeparate(GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha)
{
	using PFN_glBlendFuncSeparate = void(GL_APIENTRY*)(GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha);
	static PFN_glBlendFuncSeparate blendFuncSeparatePtr = gl::internal::library().getProcAddress<PFN_glBlendFuncSeparate>("glBlendFuncSeparate");
	blendFuncSeparatePtr(sfactorRGB, dfactorRGB, sfactorAlpha, dfactorAlpha);
	CHECK_GL_ERROR_ASSERT("glBlendFuncSeparate");
}

void GL_APIENTRY glBufferData(GLenum target, GLsizeiptr size, const void* data, GLenum usage)
{
	using PFN_glBufferData = void(GL_APIENTRY*)(GLenum target, GLsizeiptr size, const void* data, GLenum usage);
	static PFN_glBufferData bufferDataPtr = gl::internal::library().getProcAddress<PFN_glBufferData>("glBufferData");
	bufferDataPtr(target, size, data, usage);
	CHECK_GL_ERROR_ASSERT("glBufferData");
}

void GL_APIENTRY glBufferSubData(GLenum target, GLintptr offset, GLsizeiptr size, const void* data)
{
	using PFN_glBufferSubData = void(GL_APIENTRY*)(GLenum target, GLintptr offset, GLsizeiptr size, const void* data);
	static PFN_glBufferSubData bufferSubDataPtr = gl::internal::library().getProcAddress<PFN_glBufferSubData>("glBufferSubData");
	bufferSubDataPtr(target, offset, size, data);
	CHECK_GL_ERROR_ASSERT("glBufferSubData");
}

GLenum GL_APIENTRY glCheckFramebufferStatus(GLenum target)
{
	using PFN_glCheckFramebufferStatus = GLenum(GL_APIENTRY*)(GLenum target);
	static PFN_glCheckFramebufferStatus checkFramebufferStatusPtr = gl::internal::library().getProcAddress<PFN_glCheckFramebufferStatus>("glCheckFramebufferStatus");
	auto result = checkFramebufferStatusPtr(target);
	CHECK_GL_ERROR_ASSERT("glCheckFramebufferStatus");
	return result;
}

void GL_APIENTRY glClear(GLbitfield mask)
{
	using PFN_glClear = void(GL_APIENTRY*)(GLbitfield mask);
	static PFN_glClear clearPtr = gl::internal::library().getProcAddress<PFN_glClear>("glClear");
	clearPtr(mask);
	CHECK_GL_ERROR_ASSERT("glClear");
}

void GL_APIENTRY glClearColor(GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha)
{
	using PFN_glClearColor = void(GL_APIENTRY*)(GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha);
	static PFN_glClearColor clearColorPtr = gl::internal::library().getProcAddress<PFN_glClearColor>("glClearColor");
	clearColorPtr(red, green, blue, alpha);
	CHECK_GL_ERROR_ASSERT("glClearColor");
}

void GL_APIENTRY glClearDepthf(GLfloat d)
{
	using PFN_glClearDepthf = void(GL_APIENTRY*)(GLfloat d);
	static PFN_glClearDepthf clearDepthfPtr = gl::internal::library().getProcAddress<PFN_glClearDepthf>("glClearDepthf");
	clearDepthfPtr(d);
	CHECK_GL_ERROR_ASSERT("glClearDepthf");
}

void GL_APIENTRY glClearStencil(GLint s)
{
	using PFN_glClearStencil = void(GL_APIENTRY*)(GLint s);
	static PFN_glClearStencil clearStencilPtr = gl::internal::library().getProcAddress<PFN_glClearStencil>("glClearStencil");
	clearStencilPtr(s);
	CHECK_GL_ERROR_ASSERT("glClearStencil");
}

void GL_APIENTRY glColorMask(GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha)
{
	using PFN_glColorMask = void(GL_APIENTRY*)(GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha);
	static PFN_glColorMask colorMaskPtr = gl::internal::library().getProcAddress<PFN_glColorMask>("glColorMask");
	colorMaskPtr(red, green, blue, alpha);
	CHECK_GL_ERROR_ASSERT("glColorMask");
}

void GL_APIENTRY glCompileShader(GLuint shader)
{
	using PFN_glCompileShader = void(GL_APIENTRY*)(GLuint shader);
	static PFN_glCompileShader compileShaderPtr = gl::internal::library().getProcAddress<PFN_glCompileShader>("glCompileShader");
	compileShaderPtr(shader);
	CHECK_GL_ERROR_ASSERT("glCompileShader");
}

void GL_APIENTRY glCompressedTexImage2D(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, const void* data)
{
	using PFN_glCompressedTexImage2D = void(GL_APIENTRY*)(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, const void* data);
	static PFN_glCompressedTexImage2D compressedTexImage2DPtr = gl::internal::library().getProcAddress<PFN_glCompressedTexImage2D>("glCompressedTexImage2D");
	compressedTexImage2DPtr(target, level, internalformat, width, height, border, imageSize, data);
	CHECK_GL_ERROR_ASSERT("glCompressedTexImage2D");
}

void GL_APIENTRY glCompressedTexSubImage2D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, const void* data)
{
	using PFN_glCompressedTexSubImage2D = void(GL_APIENTRY*)(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, const void* data);
	static PFN_glCompressedTexSubImage2D compressedTexSubImage2DPtr = gl::internal::library().getProcAddress<PFN_glCompressedTexSubImage2D>("glCompressedTexSubImage2D");
	compressedTexSubImage2DPtr(target, level, xoffset, yoffset, width, height, format, imageSize, data);
	CHECK_GL_ERROR_ASSERT("glCompressedTexSubImage2D");
}

void GL_APIENTRY glCopyTexImage2D(GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border)
{
	using PFN_glCopyTexImage2D = void(GL_APIENTRY*)(GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border);
	static PFN_glCopyTexImage2D copyTexImage2DPtr = gl::internal::library().getProcAddress<PFN_glCopyTexImage2D>("glCopyTexImage2D");
	copyTexImage2DPtr(target, level, internalformat, x, y, width, height, border);
	CHECK_GL_ERROR_ASSERT("glCopyTexImage2D");
}

void GL_APIENTRY glCopyTexSubImage2D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height)
{
	using PFN_glCopyTexSubImage2D = void(GL_APIENTRY*)(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height);
	static PFN_glCopyTexSubImage2D copyTexSubImage2DPtr = gl::internal::library().getProcAddress<PFN_glCopyTexSubImage2D>("glCopyTexSubImage2D");
	copyTexSubImage2DPtr(target, level, xoffset, yoffset, x, y, width, height);
	CHECK_GL_ERROR_ASSERT("glCopyTexSubImage2D");
}

GLuint GL_APIENTRY glCreateProgram()
{
	using PFN_glCreateProgram = GLuint(GL_APIENTRY*)();
	static PFN_glCreateProgram createProgramPtr = gl::internal::library().getProcAddress<PFN_glCreateProgram>("glCreateProgram");
	auto result = createProgramPtr();
	CHECK_GL_ERROR_ASSERT("glCreateProgram");
	return result;
}

GLuint GL_APIENTRY glCreateShader(GLenum type)
{
	using PFN_glCreateShader = GLuint(GL_APIENTRY*)(GLenum type);
	static PFN_glCreateShader createShaderPtr = gl::internal::library().getProcAddress<PFN_glCreateShader>("glCreateShader");
	auto result = createShaderPtr(type);
	CHECK_GL_ERROR_ASSERT("glCreateShader");
	return result;
}

void GL_APIENTRY glCullFace(GLenum mode)
{
	using PFN_glCullFace = void(GL_APIENTRY*)(GLenum mode);
	static PFN_glCullFace cullFacePtr = gl::internal::library().getProcAddress<PFN_glCullFace>("glCullFace");
	cullFacePtr(mode);
	CHECK_GL_ERROR_ASSERT("glCullFace");
}

void GL_APIENTRY glDeleteBuffers(GLsizei n, const GLuint* buffers)
{
	using PFN_glDeleteBuffers = void(GL_APIENTRY*)(GLsizei n, const GLuint* buffers);
	static PFN_glDeleteBuffers deleteBuffersPtr = gl::internal::library().getProcAddress<PFN_glDeleteBuffers>("glDeleteBuffers");
	deleteBuffersPtr(n, buffers);
	CHECK_GL_ERROR_ASSERT("glDeleteBuffers");
}

void GL_APIENTRY glDeleteFramebuffers(GLsizei n, const GLuint* framebuffers)
{
	using PFN_glDeleteFramebuffers = void(GL_APIENTRY*)(GLsizei n, const GLuint* framebuffers);
	static PFN_glDeleteFramebuffers deleteFramebuffersPtr = gl::internal::library().getProcAddress<PFN_glDeleteFramebuffers>("glDeleteFramebuffers");
	deleteFramebuffersPtr(n, framebuffers);
	CHECK_GL_ERROR_ASSERT("glDeleteFramebuffers");
}

void GL_APIENTRY glDeleteProgram(GLuint program)
{
	using PFN_glDeleteProgram = void(GL_APIENTRY*)(GLuint program);
	static PFN_glDeleteProgram deleteProgramPtr = gl::internal::library().getProcAddress<PFN_glDeleteProgram>("glDeleteProgram");
	deleteProgramPtr(program);
	CHECK_GL_ERROR_ASSERT("glDeleteProgram");
}

void GL_APIENTRY glDeleteRenderbuffers(GLsizei n, const GLuint* renderbuffers)
{
	using PFN_glDeleteRenderbuffers = void(GL_APIENTRY*)(GLsizei n, const GLuint* renderbuffers);
	static PFN_glDeleteRenderbuffers deleteRenderbuffersPtr = gl::internal::library().getProcAddress<PFN_glDeleteRenderbuffers>("glDeleteRenderbuffers");
	deleteRenderbuffersPtr(n, renderbuffers);
	CHECK_GL_ERROR_ASSERT("glDeleteRenderbuffers");
}

void GL_APIENTRY glDeleteShader(GLuint shader)
{
	using PFN_glDeleteShader = void(GL_APIENTRY*)(GLuint shader);
	static PFN_glDeleteShader deleteShaderPtr = gl::internal::library().getProcAddress<PFN_glDeleteShader>("glDeleteShader");
	deleteShaderPtr(shader);
	CHECK_GL_ERROR_ASSERT("glDeleteShader");
}

void GL_APIENTRY glDeleteTextures(GLsizei n, const GLuint* textures)
{
	using PFN_glDeleteTextures = void(GL_APIENTRY*)(GLsizei n, const GLuint* textures);
	static PFN_glDeleteTextures deleteTexturesPtr = gl::internal::library().getProcAddress<PFN_glDeleteTextures>("glDeleteTextures");
	deleteTexturesPtr(n, textures);
	CHECK_GL_ERROR_ASSERT("glDeleteTextures");
}

void GL_APIENTRY glDepthFunc(GLenum func)
{
	using PFN_glDepthFunc = void(GL_APIENTRY*)(GLenum func);
	static PFN_glDepthFunc depthFuncPtr = gl::internal::library().getProcAddress<PFN_glDepthFunc>("glDepthFunc");
	depthFuncPtr(func);
	CHECK_GL_ERROR_ASSERT("glDepthFunc");
}

void GL_APIENTRY glDepthMask(GLboolean flag)
{
	using PFN_glDepthMask = void(GL_APIENTRY*)(GLboolean flag);
	static PFN_glDepthMask depthMaskPtr = gl::internal::library().getProcAddress<PFN_glDepthMask>("glDepthMask");
	depthMaskPtr(flag);
	CHECK_GL_ERROR_ASSERT("glDepthMask");
}

void GL_APIENTRY glDepthRangef(GLfloat n, GLfloat f)
{
	using PFN_glDepthRangef = void(GL_APIENTRY*)(GLfloat n, GLfloat f);
	static PFN_glDepthRangef depthRangefPtr = gl::internal::library().getProcAddress<PFN_glDepthRangef>("glDepthRangef");
	depthRangefPtr(n, f);
	CHECK_GL_ERROR_ASSERT("glDepthRangef");
}

void GL_APIENTRY glDetachShader(GLuint program, GLuint shader)
{
	using PFN_glDetachShader = void(GL_APIENTRY*)(GLuint program, GLuint shader);
	static PFN_glDetachShader detachShaderPtr = gl::internal::library().getProcAddress<PFN_glDetachShader>("glDetachShader");
	detachShaderPtr(program, shader);
	CHECK_GL_ERROR_ASSERT("glDetachShader");
}

void GL_APIENTRY glDisable(GLenum cap)
{
	using PFN_glDisable = void(GL_APIENTRY*)(GLenum cap);
	static PFN_glDisable disablePtr = gl::internal::library().getProcAddress<PFN_glDisable>("glDisable");
	disablePtr(cap);
	CHECK_GL_ERROR_ASSERT("glDisable");
}

void GL_APIENTRY glDisableVertexAttribArray(GLuint index)
{
	using PFN_glDisableVertexAttribArray = void(GL_APIENTRY*)(GLuint index);
	static PFN_glDisableVertexAttribArray disableVertexAttribArrayPtr = gl::internal::library().getProcAddress<PFN_glDisableVertexAttribArray>("glDisableVertexAttribArray");
	disableVertexAttribArrayPtr(index);
	CHECK_GL_ERROR_ASSERT("glDisableVertexAttribArray");
}

void GL_APIENTRY glDrawArrays(GLenum mode, GLint first, GLsizei count)
{
	using PFN_glDrawArrays = void(GL_APIENTRY*)(GLenum mode, GLint first, GLsizei count);
	static PFN_glDrawArrays drawArraysPtr = gl::internal::library().getProcAddress<PFN_glDrawArrays>("glDrawArrays");
	drawArraysPtr(mode, first, count);
	CHECK_GL_ERROR_ASSERT("glDrawArrays");
}

void GL_APIENTRY glDrawElements(GLenum mode, GLsizei count, GLenum type, const void* indices)
{
	using PFN_glDrawElements = void(GL_APIENTRY*)(GLenum mode, GLsizei count, GLenum type, const void* indices);
	static PFN_glDrawElements drawElementsPtr = gl::internal::library().getProcAddress<PFN_glDrawElements>("glDrawElements");
	drawElementsPtr(mode, count, type, indices);
	CHECK_GL_ERROR_ASSERT("glDrawElements");
}

void GL_APIENTRY glEnable(GLenum cap)
{
	using PFN_glEnable = void(GL_APIENTRY*)(GLenum cap);
	static PFN_glEnable enablePtr = gl::internal::library().getProcAddress<PFN_glEnable>("glEnable");
	enablePtr(cap);
	CHECK_GL_ERROR_ASSERT("glEnable");
}

void GL_APIENTRY glEnableVertexAttribArray(GLuint index)
{
	using PFN_glEnableVertexAttribArray = void(GL_APIENTRY*)(GLuint index);
	static PFN_glEnableVertexAttribArray enableVertexAttribArrayPtr = gl::internal::library().getProcAddress<PFN_glEnableVertexAttribArray>("glEnableVertexAttribArray");
	enableVertexAttribArrayPtr(index);
	CHECK_GL_ERROR_ASSERT("glEnableVertexAttribArray");
}

void GL_APIENTRY glFinish()
{
	using PFN_glFinish = void(GL_APIENTRY*)();
	static PFN_glFinish finishPtr = gl::internal::library().getProcAddress<PFN_glFinish>("glFinish");
	finishPtr();
	CHECK_GL_ERROR_ASSERT("glFinish");
}

void GL_APIENTRY glFlush()
{
	using PFN_glFlush = void(GL_APIENTRY*)();
	static PFN_glFlush flushPtr = gl::internal::library().getProcAddress<PFN_glFlush>("glFlush");
	flushPtr();
	CHECK_GL_ERROR_ASSERT("glFlush");
}

void GL_APIENTRY glFramebufferRenderbuffer(GLenum target, GLenum attachment, GLenum renderbuffertarget, GLuint renderbuffer)
{
	using PFN_glFramebufferRenderbuffer = void(GL_APIENTRY*)(GLenum target, GLenum attachment, GLenum renderbuffertarget, GLuint renderbuffer);
	static PFN_glFramebufferRenderbuffer framebufferRenderbufferPtr = gl::internal::library().getProcAddress<PFN_glFramebufferRenderbuffer>("glFramebufferRenderbuffer");
	framebufferRenderbufferPtr(target, attachment, renderbuffertarget, renderbuffer);
	CHECK_GL_ERROR_ASSERT("glFramebufferRenderbuffer");
}

void GL_APIENTRY glFramebufferTexture2D(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level)
{
	using PFN_glFramebufferTexture2D = void(GL_APIENTRY*)(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level);
	static PFN_glFramebufferTexture2D framebufferTexture2DPtr = gl::internal::library().getProcAddress<PFN_glFramebufferTexture2D>("glFramebufferTexture2D");
	framebufferTexture2DPtr(target, attachment, textarget, texture, level);
	CHECK_GL_ERROR_ASSERT("glFramebufferTexture2D");
}

void GL_APIENTRY glFrontFace(GLenum mode)
{
	using PFN_glFrontFace = void(GL_APIENTRY*)(GLenum mode);
	static PFN_glFrontFace frontFacePtr = gl::internal::library().getProcAddress<PFN_glFrontFace>("glFrontFace");
	frontFacePtr(mode);
	CHECK_GL_ERROR_ASSERT("glFrontFace");
}

void GL_APIENTRY glGenBuffers(GLsizei n, GLuint* buffers)
{
	using PFN_glGenBuffers = void(GL_APIENTRY*)(GLsizei n, GLuint * buffers);
	static PFN_glGenBuffers genBuffersPtr = gl::internal::library().getProcAddress<PFN_glGenBuffers>("glGenBuffers");
	genBuffersPtr(n, buffers);
	CHECK_GL_ERROR_ASSERT("glGenBuffers");
}

void GL_APIENTRY glGenFramebuffers(GLsizei n, GLuint* framebuffers)
{
	using PFN_glGenFramebuffers = void(GL_APIENTRY*)(GLsizei n, GLuint * framebuffers);
	static PFN_glGenFramebuffers genFramebuffersPtr = gl::internal::library().getProcAddress<PFN_glGenFramebuffers>("glGenFramebuffers");
	genFramebuffersPtr(n, framebuffers);
	CHECK_GL_ERROR_ASSERT("glGenFramebuffers");
}

void GL_APIENTRY glGenRenderbuffers(GLsizei n, GLuint* renderbuffers)
{
	using PFN_glGenRenderbuffers = void(GL_APIENTRY*)(GLsizei n, GLuint * renderbuffers);
	static PFN_glGenRenderbuffers genRenderbuffersPtr = gl::internal::library().getProcAddress<PFN_glGenRenderbuffers>("glGenRenderbuffers");
	genRenderbuffersPtr(n, renderbuffers);
	CHECK_GL_ERROR_ASSERT("glGenRenderbuffers");
}

void GL_APIENTRY glGenTextures(GLsizei n, GLuint* textures)
{
	using PFN_glGenTextures = void(GL_APIENTRY*)(GLsizei n, GLuint * textures);
	static PFN_glGenTextures genTexturesPtr = gl::internal::library().getProcAddress<PFN_glGenTextures>("glGenTextures");
	genTexturesPtr(n, textures);
	CHECK_GL_ERROR_ASSERT("glGenTextures");
}

void GL_APIENTRY glGenerateMipmap(GLenum target)
{
	using PFN_glGenerateMipmap = void(GL_APIENTRY*)(GLenum target);
	static PFN_glGenerateMipmap generateMipmapPtr = gl::internal::library().getProcAddress<PFN_glGenerateMipmap>("glGenerateMipmap");
	generateMipmapPtr(target);
	CHECK_GL_ERROR_ASSERT("glGenerateMipmap");
}

void GL_APIENTRY glGetActiveAttrib(GLuint program, GLuint index, GLsizei bufSize, GLsizei* length, GLint* size, GLenum* type, GLchar* name)
{
	using PFN_glGetActiveAttrib = void(GL_APIENTRY*)(GLuint program, GLuint index, GLsizei bufSize, GLsizei * length, GLint * size, GLenum * type, GLchar * name);
	static PFN_glGetActiveAttrib getActiveAttribPtr = gl::internal::library().getProcAddress<PFN_glGetActiveAttrib>("glGetActiveAttrib");
	getActiveAttribPtr(program, index, bufSize, length, size, type, name);
	CHECK_GL_ERROR_ASSERT("glGetActiveAttrib");
}

void GL_APIENTRY glGetActiveUniform(GLuint program, GLuint index, GLsizei bufSize, GLsizei* length, GLint* size, GLenum* type, GLchar* name)
{
	using PFN_glGetActiveUniform = void(GL_APIENTRY*)(GLuint program, GLuint index, GLsizei bufSize, GLsizei * length, GLint * size, GLenum * type, GLchar * name);
	static PFN_glGetActiveUniform getActiveUniformPtr = gl::internal::library().getProcAddress<PFN_glGetActiveUniform>("glGetActiveUniform");
	getActiveUniformPtr(program, index, bufSize, length, size, type, name);
	CHECK_GL_ERROR_ASSERT("glGetActiveUniform");
}

void GL_APIENTRY glGetAttachedShaders(GLuint program, GLsizei maxCount, GLsizei* count, GLuint* shaders)
{
	using PFN_glGetAttachedShaders = void(GL_APIENTRY*)(GLuint program, GLsizei maxCount, GLsizei * count, GLuint * shaders);
	static PFN_glGetAttachedShaders getAttachedShadersPtr = gl::internal::library().getProcAddress<PFN_glGetAttachedShaders>("glGetAttachedShaders");
	getAttachedShadersPtr(program, maxCount, count, shaders);
	CHECK_GL_ERROR_ASSERT("glGetAttachedShaders");
}

GLint GL_APIENTRY glGetAttribLocation(GLuint program, const GLchar* name)
{
	using PFN_glGetAttribLocation = GLint(GL_APIENTRY*)(GLuint program, const GLchar* name);
	static PFN_glGetAttribLocation getAttribLocationPtr = gl::internal::library().getProcAddress<PFN_glGetAttribLocation>("glGetAttribLocation");
	auto result = getAttribLocationPtr(program, name);
	CHECK_GL_ERROR_ASSERT("glGetAttribLocation");
	return result;
}

void GL_APIENTRY glGetBooleanv(GLenum pname, GLboolean* data)
{
	using PFN_glGetBooleanv = void(GL_APIENTRY*)(GLenum pname, GLboolean * data);
	static PFN_glGetBooleanv getBooleanvPtr = gl::internal::library().getProcAddress<PFN_glGetBooleanv>("glGetBooleanv");
	getBooleanvPtr(pname, data);
	CHECK_GL_ERROR_ASSERT("glGetBooleanv");
}

void GL_APIENTRY glGetBufferParameteriv(GLenum target, GLenum pname, GLint* params)
{
	using PFN_glGetBufferParameteriv = void(GL_APIENTRY*)(GLenum target, GLenum pname, GLint * params);
	static PFN_glGetBufferParameteriv getBufferParameterivPtr = gl::internal::library().getProcAddress<PFN_glGetBufferParameteriv>("glGetBufferParameteriv");
	getBufferParameterivPtr(target, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetBufferParameteriv");
}

GLenum GL_APIENTRY glGetError()
{
	using PFN_glGetError = GLenum(GL_APIENTRY*)();
	static PFN_glGetError getErrorPtr = gl::internal::library().getProcAddress<PFN_glGetError>("glGetError");
	auto result = getErrorPtr();
	return result;
}

void GL_APIENTRY glGetFloatv(GLenum pname, GLfloat* data)
{
	using PFN_glGetFloatv = void(GL_APIENTRY*)(GLenum pname, GLfloat * data);
	static PFN_glGetFloatv getFloatvPtr = gl::internal::library().getProcAddress<PFN_glGetFloatv>("glGetFloatv");
	getFloatvPtr(pname, data);
	CHECK_GL_ERROR_ASSERT("glGetFloatv");
}

void GL_APIENTRY glGetFramebufferAttachmentParameteriv(GLenum target, GLenum attachment, GLenum pname, GLint* params)
{
	using PFN_glGetFramebufferAttachmentParameteriv = void(GL_APIENTRY*)(GLenum target, GLenum attachment, GLenum pname, GLint * params);
	static PFN_glGetFramebufferAttachmentParameteriv getFramebufferAttachmentParameterivPtr = gl::internal::library().getProcAddress<PFN_glGetFramebufferAttachmentParameteriv>("glGetFramebufferAttachmentParameteriv");
	getFramebufferAttachmentParameterivPtr(target, attachment, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetFramebufferAttachmentParameteriv");
}

void GL_APIENTRY glGetIntegerv(GLenum pname, GLint* data)
{
	using PFN_glGetIntegerv = void(GL_APIENTRY*)(GLenum pname, GLint * data);
	static PFN_glGetIntegerv getIntegervPtr = gl::internal::library().getProcAddress<PFN_glGetIntegerv>("glGetIntegerv");
	getIntegervPtr(pname, data);
	CHECK_GL_ERROR_ASSERT("glGetIntegerv");
}

void GL_APIENTRY glGetProgramInfoLog(GLuint program, GLsizei bufSize, GLsizei* length, GLchar* infoLog)
{
	using PFN_glGetProgramInfoLog = void(GL_APIENTRY*)(GLuint program, GLsizei bufSize, GLsizei * length, GLchar * infoLog);
	static PFN_glGetProgramInfoLog getProgramInfoLogPtr = gl::internal::library().getProcAddress<PFN_glGetProgramInfoLog>("glGetProgramInfoLog");
	getProgramInfoLogPtr(program, bufSize, length, infoLog);
	CHECK_GL_ERROR_ASSERT("glGetProgramInfoLog");
}

void GL_APIENTRY glGetProgramiv(GLuint program, GLenum pname, GLint* params)
{
	using PFN_glGetProgramiv = void(GL_APIENTRY*)(GLuint program, GLenum pname, GLint * params);
	static PFN_glGetProgramiv getProgramivPtr = gl::internal::library().getProcAddress<PFN_glGetProgramiv>("glGetProgramiv");
	getProgramivPtr(program, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetProgramiv");
}

void GL_APIENTRY glGetRenderbufferParameteriv(GLenum target, GLenum pname, GLint* params)
{
	using PFN_glGetRenderbufferParameteriv = void(GL_APIENTRY*)(GLenum target, GLenum pname, GLint * params);
	static PFN_glGetRenderbufferParameteriv getRenderbufferParameterivPtr = gl::internal::library().getProcAddress<PFN_glGetRenderbufferParameteriv>("glGetRenderbufferParameteriv");
	getRenderbufferParameterivPtr(target, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetRenderbufferParameteriv");
}

void GL_APIENTRY glGetShaderInfoLog(GLuint shader, GLsizei bufSize, GLsizei* length, GLchar* infoLog)
{
	using PFN_glGetShaderInfoLog = void(GL_APIENTRY*)(GLuint shader, GLsizei bufSize, GLsizei * length, GLchar * infoLog);
	static PFN_glGetShaderInfoLog getShaderInfoLogPtr = gl::internal::library().getProcAddress<PFN_glGetShaderInfoLog>("glGetShaderInfoLog");
	getShaderInfoLogPtr(shader, bufSize, length, infoLog);
	CHECK_GL_ERROR_ASSERT("glGetShaderInfoLog");
}

void GL_APIENTRY glGetShaderPrecisionFormat(GLenum shadertype, GLenum precisiontype, GLint* range, GLint* precision)
{
	using PFN_glGetShaderPrecisionFormat = void(GL_APIENTRY*)(GLenum shadertype, GLenum precisiontype, GLint * range, GLint * precision);
	static PFN_glGetShaderPrecisionFormat getShaderPrecisionFormatPtr = gl::internal::library().getProcAddress<PFN_glGetShaderPrecisionFormat>("glGetShaderPrecisionFormat");
	getShaderPrecisionFormatPtr(shadertype, precisiontype, range, precision);
	CHECK_GL_ERROR_ASSERT("glGetShaderPrecisionFormat");
}

void GL_APIENTRY glGetShaderSource(GLuint shader, GLsizei bufSize, GLsizei* length, GLchar* source)
{
	using PFN_glGetShaderSource = void(GL_APIENTRY*)(GLuint shader, GLsizei bufSize, GLsizei * length, GLchar * source);
	static PFN_glGetShaderSource getShaderSourcePtr = gl::internal::library().getProcAddress<PFN_glGetShaderSource>("glGetShaderSource");
	getShaderSourcePtr(shader, bufSize, length, source);
	CHECK_GL_ERROR_ASSERT("glGetShaderSource");
}

void GL_APIENTRY glGetShaderiv(GLuint shader, GLenum pname, GLint* params)
{
	using PFN_glGetShaderiv = void(GL_APIENTRY*)(GLuint shader, GLenum pname, GLint * params);
	static PFN_glGetShaderiv getShaderivPtr = gl::internal::library().getProcAddress<PFN_glGetShaderiv>("glGetShaderiv");
	getShaderivPtr(shader, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetShaderiv");
}

const GLubyte* GL_APIENTRY glGetString(GLenum name)
{
	using PFN_glGetString = const GLubyte*(GL_APIENTRY*) (GLenum name);
	static PFN_glGetString getStringPtr = gl::internal::library().getProcAddress<PFN_glGetString>("glGetString");
	auto result = getStringPtr(name);
	CHECK_GL_ERROR_ASSERT("glGetString");
	return result;
}

void GL_APIENTRY glGetTexParameterfv(GLenum target, GLenum pname, GLfloat* params)
{
	using PFN_glGetTexParameterfv = void(GL_APIENTRY*)(GLenum target, GLenum pname, GLfloat * params);
	static PFN_glGetTexParameterfv getTexParameterfvPtr = gl::internal::library().getProcAddress<PFN_glGetTexParameterfv>("glGetTexParameterfv");
	getTexParameterfvPtr(target, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetTexParameterfv");
}

void GL_APIENTRY glGetTexParameteriv(GLenum target, GLenum pname, GLint* params)
{
	using PFN_glGetTexParameteriv = void(GL_APIENTRY*)(GLenum target, GLenum pname, GLint * params);
	static PFN_glGetTexParameteriv getTexParameterivPtr = gl::internal::library().getProcAddress<PFN_glGetTexParameteriv>("glGetTexParameteriv");
	getTexParameterivPtr(target, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetTexParameteriv");
}

GLint GL_APIENTRY glGetUniformLocation(GLuint program, const GLchar* name)
{
	using PFN_glGetUniformLocation = GLint(GL_APIENTRY*)(GLuint program, const GLchar* name);
	static PFN_glGetUniformLocation getUniformLocationPtr = gl::internal::library().getProcAddress<PFN_glGetUniformLocation>("glGetUniformLocation");
	auto result = getUniformLocationPtr(program, name);
	CHECK_GL_ERROR_ASSERT("glGetUniformLocation");
	return result;
}

void GL_APIENTRY glGetUniformfv(GLuint program, GLint location, GLfloat* params)
{
	using PFN_glGetUniformfv = void(GL_APIENTRY*)(GLuint program, GLint location, GLfloat * params);
	static PFN_glGetUniformfv getUniformfvPtr = gl::internal::library().getProcAddress<PFN_glGetUniformfv>("glGetUniformfv");
	getUniformfvPtr(program, location, params);
	CHECK_GL_ERROR_ASSERT("glGetUniformfv");
}

void GL_APIENTRY glGetUniformiv(GLuint program, GLint location, GLint* params)
{
	using PFN_glGetUniformiv = void(GL_APIENTRY*)(GLuint program, GLint location, GLint * params);
	static PFN_glGetUniformiv getUniformivPtr = gl::internal::library().getProcAddress<PFN_glGetUniformiv>("glGetUniformiv");
	getUniformivPtr(program, location, params);
	CHECK_GL_ERROR_ASSERT("glGetUniformiv");
}

void GL_APIENTRY glGetVertexAttribPointerv(GLuint index, GLenum pname, void** pointer)
{
	using PFN_glGetVertexAttribPointerv = void(GL_APIENTRY*)(GLuint index, GLenum pname, void** pointer);
	static PFN_glGetVertexAttribPointerv getVertexAttribPointervPtr = gl::internal::library().getProcAddress<PFN_glGetVertexAttribPointerv>("glGetVertexAttribPointerv");
	getVertexAttribPointervPtr(index, pname, pointer);
	CHECK_GL_ERROR_ASSERT("glGetVertexAttribPointerv");
}

void GL_APIENTRY glGetVertexAttribfv(GLuint index, GLenum pname, GLfloat* params)
{
	using PFN_glGetVertexAttribfv = void(GL_APIENTRY*)(GLuint index, GLenum pname, GLfloat * params);
	static PFN_glGetVertexAttribfv getVertexAttribfvPtr = gl::internal::library().getProcAddress<PFN_glGetVertexAttribfv>("glGetVertexAttribfv");
	getVertexAttribfvPtr(index, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetVertexAttribfv");
}

void GL_APIENTRY glGetVertexAttribiv(GLuint index, GLenum pname, GLint* params)
{
	using PFN_glGetVertexAttribiv = void(GL_APIENTRY*)(GLuint index, GLenum pname, GLint * params);
	static PFN_glGetVertexAttribiv getVertexAttribivPtr = gl::internal::library().getProcAddress<PFN_glGetVertexAttribiv>("glGetVertexAttribiv");
	getVertexAttribivPtr(index, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetVertexAttribiv");
}

void GL_APIENTRY glHint(GLenum target, GLenum mode)
{
	using PFN_glHint = void(GL_APIENTRY*)(GLenum target, GLenum mode);
	static PFN_glHint hintPtr = gl::internal::library().getProcAddress<PFN_glHint>("glHint");
	hintPtr(target, mode);
	CHECK_GL_ERROR_ASSERT("glHint");
}

GLboolean GL_APIENTRY glIsBuffer(GLuint buffer)
{
	using PFN_glIsBuffer = GLboolean(GL_APIENTRY*)(GLuint buffer);
	static PFN_glIsBuffer isBufferPtr = gl::internal::library().getProcAddress<PFN_glIsBuffer>("glIsBuffer");
	auto result = isBufferPtr(buffer);
	CHECK_GL_ERROR_ASSERT("glIsBuffer");
	return result;
}

GLboolean GL_APIENTRY glIsEnabled(GLenum cap)
{
	using PFN_glIsEnabled = GLboolean(GL_APIENTRY*)(GLenum cap);
	static PFN_glIsEnabled isEnabledPtr = gl::internal::library().getProcAddress<PFN_glIsEnabled>("glIsEnabled");
	auto result = isEnabledPtr(cap);
	CHECK_GL_ERROR_ASSERT("glIsEnabled");
	return result;
}

GLboolean GL_APIENTRY glIsFramebuffer(GLuint framebuffer)
{
	using PFN_glIsFramebuffer = GLboolean(GL_APIENTRY*)(GLuint framebuffer);
	static PFN_glIsFramebuffer isFramebufferPtr = gl::internal::library().getProcAddress<PFN_glIsFramebuffer>("glIsFramebuffer");
	auto result = isFramebufferPtr(framebuffer);
	CHECK_GL_ERROR_ASSERT("glIsFramebuffer");
	return result;
}

GLboolean GL_APIENTRY glIsProgram(GLuint program)
{
	using PFN_glIsProgram = GLboolean(GL_APIENTRY*)(GLuint program);
	static PFN_glIsProgram isProgramPtr = gl::internal::library().getProcAddress<PFN_glIsProgram>("glIsProgram");
	auto result = isProgramPtr(program);
	CHECK_GL_ERROR_ASSERT("glIsProgram");
	return result;
}

GLboolean GL_APIENTRY glIsRenderbuffer(GLuint renderbuffer)
{
	using PFN_glIsRenderbuffer = GLboolean(GL_APIENTRY*)(GLuint renderbuffer);
	static PFN_glIsRenderbuffer isRenderbufferPtr = gl::internal::library().getProcAddress<PFN_glIsRenderbuffer>("glIsRenderbuffer");
	auto result = isRenderbufferPtr(renderbuffer);
	CHECK_GL_ERROR_ASSERT("glIsRenderbuffer");
	return result;
}

GLboolean GL_APIENTRY glIsShader(GLuint shader)
{
	using PFN_glIsShader = GLboolean(GL_APIENTRY*)(GLuint shader);
	static PFN_glIsShader isShaderPtr = gl::internal::library().getProcAddress<PFN_glIsShader>("glIsShader");
	auto result = isShaderPtr(shader);
	CHECK_GL_ERROR_ASSERT("glIsShader");
	return result;
}

GLboolean GL_APIENTRY glIsTexture(GLuint texture)
{
	using PFN_glIsTexture = GLboolean(GL_APIENTRY*)(GLuint texture);
	static PFN_glIsTexture isTexturePtr = gl::internal::library().getProcAddress<PFN_glIsTexture>("glIsTexture");
	auto result = isTexturePtr(texture);
	CHECK_GL_ERROR_ASSERT("glIsTexture");
	return result;
}

void GL_APIENTRY glLineWidth(GLfloat width)
{
	using PFN_glLineWidth = void(GL_APIENTRY*)(GLfloat width);
	static PFN_glLineWidth lineWidthPtr = gl::internal::library().getProcAddress<PFN_glLineWidth>("glLineWidth");
	lineWidthPtr(width);
	CHECK_GL_ERROR_ASSERT("glLineWidth");
}

void GL_APIENTRY glLinkProgram(GLuint program)
{
	using PFN_glLinkProgram = void(GL_APIENTRY*)(GLuint program);
	static PFN_glLinkProgram linkProgramPtr = gl::internal::library().getProcAddress<PFN_glLinkProgram>("glLinkProgram");
	linkProgramPtr(program);
	CHECK_GL_ERROR_ASSERT("glLinkProgram");
}

void GL_APIENTRY glPixelStorei(GLenum pname, GLint param)
{
	using PFN_glPixelStorei = void(GL_APIENTRY*)(GLenum pname, GLint param);
	static PFN_glPixelStorei pixelStoreiPtr = gl::internal::library().getProcAddress<PFN_glPixelStorei>("glPixelStorei");
	pixelStoreiPtr(pname, param);
	CHECK_GL_ERROR_ASSERT("glPixelStorei");
}

void GL_APIENTRY glPolygonOffset(GLfloat factor, GLfloat units)
{
	using PFN_glPolygonOffset = void(GL_APIENTRY*)(GLfloat factor, GLfloat units);
	static PFN_glPolygonOffset polygonOffsetPtr = gl::internal::library().getProcAddress<PFN_glPolygonOffset>("glPolygonOffset");
	polygonOffsetPtr(factor, units);
	CHECK_GL_ERROR_ASSERT("glPolygonOffset");
}

void GL_APIENTRY glReadPixels(GLint x, GLint y, GLsizei width, GLsizei height, GLenum format, GLenum type, void* pixels)
{
	using PFN_glReadPixels = void(GL_APIENTRY*)(GLint x, GLint y, GLsizei width, GLsizei height, GLenum format, GLenum type, void* pixels);
	static PFN_glReadPixels readPixelsPtr = gl::internal::library().getProcAddress<PFN_glReadPixels>("glReadPixels");
	readPixelsPtr(x, y, width, height, format, type, pixels);
	CHECK_GL_ERROR_ASSERT("glReadPixels");
}

void GL_APIENTRY glReleaseShaderCompiler()
{
	using PFN_glReleaseShaderCompiler = void(GL_APIENTRY*)();
	static PFN_glReleaseShaderCompiler releaseShaderCompilerPtr = gl::internal::library().getProcAddress<PFN_glReleaseShaderCompiler>("glReleaseShaderCompiler");
	releaseShaderCompilerPtr();
	CHECK_GL_ERROR_ASSERT("glReleaseShaderCompiler");
}

void GL_APIENTRY glRenderbufferStorage(GLenum target, GLenum internalformat, GLsizei width, GLsizei height)
{
	using PFN_glRenderbufferStorage = void(GL_APIENTRY*)(GLenum target, GLenum internalformat, GLsizei width, GLsizei height);
	static PFN_glRenderbufferStorage renderbufferStoragePtr = gl::internal::library().getProcAddress<PFN_glRenderbufferStorage>("glRenderbufferStorage");
	renderbufferStoragePtr(target, internalformat, width, height);
	CHECK_GL_ERROR_ASSERT("glRenderbufferStorage");
}

void GL_APIENTRY glSampleCoverage(GLfloat value, GLboolean invert)
{
	using PFN_glSampleCoverage = void(GL_APIENTRY*)(GLfloat value, GLboolean invert);
	static PFN_glSampleCoverage sampleCoveragePtr = gl::internal::library().getProcAddress<PFN_glSampleCoverage>("glSampleCoverage");
	sampleCoveragePtr(value, invert);
	CHECK_GL_ERROR_ASSERT("glSampleCoverage");
}

void GL_APIENTRY glScissor(GLint x, GLint y, GLsizei width, GLsizei height)
{
	using PFN_glScissor = void(GL_APIENTRY*)(GLint x, GLint y, GLsizei width, GLsizei height);
	static PFN_glScissor scissorPtr = gl::internal::library().getProcAddress<PFN_glScissor>("glScissor");
	scissorPtr(x, y, width, height);
	CHECK_GL_ERROR_ASSERT("glScissor");
}

void GL_APIENTRY glShaderBinary(GLsizei count, const GLuint* shaders, GLenum binaryformat, const void* binary, GLsizei length)
{
	using PFN_glShaderBinary = void(GL_APIENTRY*)(GLsizei count, const GLuint* shaders, GLenum binaryformat, const void* binary, GLsizei length);
	static PFN_glShaderBinary shaderBinaryPtr = gl::internal::library().getProcAddress<PFN_glShaderBinary>("glShaderBinary");
	shaderBinaryPtr(count, shaders, binaryformat, binary, length);
	CHECK_GL_ERROR_ASSERT("glShaderBinary");
}

void GL_APIENTRY glShaderSource(GLuint shader, GLsizei count, const GLchar* const* string, const GLint* length)
{
	using PFN_glShaderSource = void(GL_APIENTRY*)(GLuint shader, GLsizei count, const GLchar* const* string, const GLint* length);
	static PFN_glShaderSource shaderSourcePtr = gl::internal::library().getProcAddress<PFN_glShaderSource>("glShaderSource");
	shaderSourcePtr(shader, count, string, length);
	CHECK_GL_ERROR_ASSERT("glShaderSource");
}

void GL_APIENTRY glStencilFunc(GLenum func, GLint ref, GLuint mask)
{
	using PFN_glStencilFunc = void(GL_APIENTRY*)(GLenum func, GLint ref, GLuint mask);
	static PFN_glStencilFunc stencilFuncPtr = gl::internal::library().getProcAddress<PFN_glStencilFunc>("glStencilFunc");
	stencilFuncPtr(func, ref, mask);
	CHECK_GL_ERROR_ASSERT("glStencilFunc");
}

void GL_APIENTRY glStencilFuncSeparate(GLenum face, GLenum func, GLint ref, GLuint mask)
{
	using PFN_glStencilFuncSeparate = void(GL_APIENTRY*)(GLenum face, GLenum func, GLint ref, GLuint mask);
	static PFN_glStencilFuncSeparate stencilFuncSeparatePtr = gl::internal::library().getProcAddress<PFN_glStencilFuncSeparate>("glStencilFuncSeparate");
	stencilFuncSeparatePtr(face, func, ref, mask);
	CHECK_GL_ERROR_ASSERT("glStencilFuncSeparate");
}

void GL_APIENTRY glStencilMask(GLuint mask)
{
	using PFN_glStencilMask = void(GL_APIENTRY*)(GLuint mask);
	static PFN_glStencilMask stencilMaskPtr = gl::internal::library().getProcAddress<PFN_glStencilMask>("glStencilMask");
	stencilMaskPtr(mask);
	CHECK_GL_ERROR_ASSERT("glStencilMask");
}

void GL_APIENTRY glStencilMaskSeparate(GLenum face, GLuint mask)
{
	using PFN_glStencilMaskSeparate = void(GL_APIENTRY*)(GLenum face, GLuint mask);
	static PFN_glStencilMaskSeparate stencilMaskSeparatePtr = gl::internal::library().getProcAddress<PFN_glStencilMaskSeparate>("glStencilMaskSeparate");
	stencilMaskSeparatePtr(face, mask);
	CHECK_GL_ERROR_ASSERT("glStencilMaskSeparate");
}

void GL_APIENTRY glStencilOp(GLenum fail, GLenum zfail, GLenum zpass)
{
	using PFN_glStencilOp = void(GL_APIENTRY*)(GLenum fail, GLenum zfail, GLenum zpass);
	static PFN_glStencilOp stencilOpPtr = gl::internal::library().getProcAddress<PFN_glStencilOp>("glStencilOp");
	stencilOpPtr(fail, zfail, zpass);
	CHECK_GL_ERROR_ASSERT("glStencilOp");
}

void GL_APIENTRY glStencilOpSeparate(GLenum face, GLenum sfail, GLenum dpfail, GLenum dppass)
{
	using PFN_glStencilOpSeparate = void(GL_APIENTRY*)(GLenum face, GLenum sfail, GLenum dpfail, GLenum dppass);
	static PFN_glStencilOpSeparate stencilOpSeparatePtr = gl::internal::library().getProcAddress<PFN_glStencilOpSeparate>("glStencilOpSeparate");
	stencilOpSeparatePtr(face, sfail, dpfail, dppass);
	CHECK_GL_ERROR_ASSERT("glStencilOpSeparate");
}

void GL_APIENTRY glTexImage2D(GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLint border, GLenum format, GLenum type, const void* pixels)
{
	using PFN_glTexImage2D = void(GL_APIENTRY*)(GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLint border, GLenum format, GLenum type, const void* pixels);
	static PFN_glTexImage2D texImage2DPtr = gl::internal::library().getProcAddress<PFN_glTexImage2D>("glTexImage2D");
	texImage2DPtr(target, level, internalformat, width, height, border, format, type, pixels);
	CHECK_GL_ERROR_ASSERT("glTexImage2D");
}

void GL_APIENTRY glTexParameterf(GLenum target, GLenum pname, GLfloat param)
{
	using PFN_glTexParameterf = void(GL_APIENTRY*)(GLenum target, GLenum pname, GLfloat param);
	static PFN_glTexParameterf texParameterfPtr = gl::internal::library().getProcAddress<PFN_glTexParameterf>("glTexParameterf");
	texParameterfPtr(target, pname, param);
	CHECK_GL_ERROR_ASSERT("glTexParameterf");
}

void GL_APIENTRY glTexParameterfv(GLenum target, GLenum pname, const GLfloat* params)
{
	using PFN_glTexParameterfv = void(GL_APIENTRY*)(GLenum target, GLenum pname, const GLfloat* params);
	static PFN_glTexParameterfv texParameterfvPtr = gl::internal::library().getProcAddress<PFN_glTexParameterfv>("glTexParameterfv");
	texParameterfvPtr(target, pname, params);
	CHECK_GL_ERROR_ASSERT("glTexParameterfv");
}

void GL_APIENTRY glTexParameteri(GLenum target, GLenum pname, GLint param)
{
	using PFN_glTexParameteri = void(GL_APIENTRY*)(GLenum target, GLenum pname, GLint param);
	static PFN_glTexParameteri texParameteriPtr = gl::internal::library().getProcAddress<PFN_glTexParameteri>("glTexParameteri");
	texParameteriPtr(target, pname, param);
	CHECK_GL_ERROR_ASSERT("glTexParameteri");
}

void GL_APIENTRY glTexParameteriv(GLenum target, GLenum pname, const GLint* params)
{
	using PFN_glTexParameteriv = void(GL_APIENTRY*)(GLenum target, GLenum pname, const GLint* params);
	static PFN_glTexParameteriv texParameterivPtr = gl::internal::library().getProcAddress<PFN_glTexParameteriv>("glTexParameteriv");
	texParameterivPtr(target, pname, params);
	CHECK_GL_ERROR_ASSERT("glTexParameteriv");
}

void GL_APIENTRY glTexSubImage2D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLenum type, const void* pixels)
{
	using PFN_glTexSubImage2D = void(GL_APIENTRY*)(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLenum type, const void* pixels);
	static PFN_glTexSubImage2D texSubImage2DPtr = gl::internal::library().getProcAddress<PFN_glTexSubImage2D>("glTexSubImage2D");
	texSubImage2DPtr(target, level, xoffset, yoffset, width, height, format, type, pixels);
	CHECK_GL_ERROR_ASSERT("glTexSubImage2D");
}

void GL_APIENTRY glUniform1f(GLint location, GLfloat v0)
{
	using PFN_glUniform1f = void(GL_APIENTRY*)(GLint location, GLfloat v0);
	static PFN_glUniform1f uniform1fPtr = gl::internal::library().getProcAddress<PFN_glUniform1f>("glUniform1f");
	uniform1fPtr(location, v0);
	CHECK_GL_ERROR_ASSERT("glUniform1f");
}

void GL_APIENTRY glUniform1fv(GLint location, GLsizei count, const GLfloat* value)
{
	using PFN_glUniform1fv = void(GL_APIENTRY*)(GLint location, GLsizei count, const GLfloat* value);
	static PFN_glUniform1fv uniform1fvPtr = gl::internal::library().getProcAddress<PFN_glUniform1fv>("glUniform1fv");
	uniform1fvPtr(location, count, value);
	CHECK_GL_ERROR_ASSERT("glUniform1fv");
}

void GL_APIENTRY glUniform1i(GLint location, GLint v0)
{
	using PFN_glUniform1i = void(GL_APIENTRY*)(GLint location, GLint v0);
	static PFN_glUniform1i uniform1iPtr = gl::internal::library().getProcAddress<PFN_glUniform1i>("glUniform1i");
	uniform1iPtr(location, v0);
	CHECK_GL_ERROR_ASSERT("glUniform1i");
}

void GL_APIENTRY glUniform1iv(GLint location, GLsizei count, const GLint* value)
{
	using PFN_glUniform1iv = void(GL_APIENTRY*)(GLint location, GLsizei count, const GLint* value);
	static PFN_glUniform1iv uniform1ivPtr = gl::internal::library().getProcAddress<PFN_glUniform1iv>("glUniform1iv");
	uniform1ivPtr(location, count, value);
	CHECK_GL_ERROR_ASSERT("glUniform1iv");
}

void GL_APIENTRY glUniform2f(GLint location, GLfloat v0, GLfloat v1)
{
	using PFN_glUniform2f = void(GL_APIENTRY*)(GLint location, GLfloat v0, GLfloat v1);
	static PFN_glUniform2f uniform2fPtr = gl::internal::library().getProcAddress<PFN_glUniform2f>("glUniform2f");
	uniform2fPtr(location, v0, v1);
	CHECK_GL_ERROR_ASSERT("glUniform2f");
}

void GL_APIENTRY glUniform2fv(GLint location, GLsizei count, const GLfloat* value)
{
	using PFN_glUniform2fv = void(GL_APIENTRY*)(GLint location, GLsizei count, const GLfloat* value);
	static PFN_glUniform2fv uniform2fvPtr = gl::internal::library().getProcAddress<PFN_glUniform2fv>("glUniform2fv");
	uniform2fvPtr(location, count, value);
	CHECK_GL_ERROR_ASSERT("glUniform2fv");
}

void GL_APIENTRY glUniform2i(GLint location, GLint v0, GLint v1)
{
	using PFN_glUniform2i = void(GL_APIENTRY*)(GLint location, GLint v0, GLint v1);
	static PFN_glUniform2i uniform2iPtr = gl::internal::library().getProcAddress<PFN_glUniform2i>("glUniform2i");
	uniform2iPtr(location, v0, v1);
	CHECK_GL_ERROR_ASSERT("glUniform2i");
}

void GL_APIENTRY glUniform2iv(GLint location, GLsizei count, const GLint* value)
{
	using PFN_glUniform2iv = void(GL_APIENTRY*)(GLint location, GLsizei count, const GLint* value);
	static PFN_glUniform2iv uniform2ivPtr = gl::internal::library().getProcAddress<PFN_glUniform2iv>("glUniform2iv");
	uniform2ivPtr(location, count, value);
	CHECK_GL_ERROR_ASSERT("glUniform2iv");
}

void GL_APIENTRY glUniform3f(GLint location, GLfloat v0, GLfloat v1, GLfloat v2)
{
	using PFN_glUniform3f = void(GL_APIENTRY*)(GLint location, GLfloat v0, GLfloat v1, GLfloat v2);
	static PFN_glUniform3f uniform3fPtr = gl::internal::library().getProcAddress<PFN_glUniform3f>("glUniform3f");
	uniform3fPtr(location, v0, v1, v2);
	CHECK_GL_ERROR_ASSERT("glUniform3f");
}

void GL_APIENTRY glUniform3fv(GLint location, GLsizei count, const GLfloat* value)
{
	using PFN_glUniform3fv = void(GL_APIENTRY*)(GLint location, GLsizei count, const GLfloat* value);
	static PFN_glUniform3fv uniform3fvPtr = gl::internal::library().getProcAddress<PFN_glUniform3fv>("glUniform3fv");
	uniform3fvPtr(location, count, value);
	CHECK_GL_ERROR_ASSERT("glUniform3fv");
}

void GL_APIENTRY glUniform3i(GLint location, GLint v0, GLint v1, GLint v2)
{
	using PFN_glUniform3i = void(GL_APIENTRY*)(GLint location, GLint v0, GLint v1, GLint v2);
	static PFN_glUniform3i uniform3iPtr = gl::internal::library().getProcAddress<PFN_glUniform3i>("glUniform3i");
	uniform3iPtr(location, v0, v1, v2);
	CHECK_GL_ERROR_ASSERT("glUniform3i");
}

void GL_APIENTRY glUniform3iv(GLint location, GLsizei count, const GLint* value)
{
	using PFN_glUniform3iv = void(GL_APIENTRY*)(GLint location, GLsizei count, const GLint* value);
	static PFN_glUniform3iv uniform3ivPtr = gl::internal::library().getProcAddress<PFN_glUniform3iv>("glUniform3iv");
	uniform3ivPtr(location, count, value);
	CHECK_GL_ERROR_ASSERT("glUniform3iv");
}

void GL_APIENTRY glUniform4f(GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3)
{
	using PFN_glUniform4f = void(GL_APIENTRY*)(GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3);
	static PFN_glUniform4f uniform4fPtr = gl::internal::library().getProcAddress<PFN_glUniform4f>("glUniform4f");
	uniform4fPtr(location, v0, v1, v2, v3);
	CHECK_GL_ERROR_ASSERT("glUniform4f");
}

void GL_APIENTRY glUniform4fv(GLint location, GLsizei count, const GLfloat* value)
{
	using PFN_glUniform4fv = void(GL_APIENTRY*)(GLint location, GLsizei count, const GLfloat* value);
	static PFN_glUniform4fv uniform4fvPtr = gl::internal::library().getProcAddress<PFN_glUniform4fv>("glUniform4fv");
	uniform4fvPtr(location, count, value);
	CHECK_GL_ERROR_ASSERT("glUniform4fv");
}

void GL_APIENTRY glUniform4i(GLint location, GLint v0, GLint v1, GLint v2, GLint v3)
{
	using PFN_glUniform4i = void(GL_APIENTRY*)(GLint location, GLint v0, GLint v1, GLint v2, GLint v3);
	static PFN_glUniform4i uniform4iPtr = gl::internal::library().getProcAddress<PFN_glUniform4i>("glUniform4i");
	uniform4iPtr(location, v0, v1, v2, v3);
	CHECK_GL_ERROR_ASSERT("glUniform4i");
}

void GL_APIENTRY glUniform4iv(GLint location, GLsizei count, const GLint* value)
{
	using PFN_glUniform4iv = void(GL_APIENTRY*)(GLint location, GLsizei count, const GLint* value);
	static PFN_glUniform4iv uniform4ivPtr = gl::internal::library().getProcAddress<PFN_glUniform4iv>("glUniform4iv");
	uniform4ivPtr(location, count, value);
	CHECK_GL_ERROR_ASSERT("glUniform4iv");
}

void GL_APIENTRY glUniformMatrix2fv(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glUniformMatrix2fv = void(GL_APIENTRY*)(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glUniformMatrix2fv uniformMatrix2fvPtr = gl::internal::library().getProcAddress<PFN_glUniformMatrix2fv>("glUniformMatrix2fv");
	uniformMatrix2fvPtr(location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glUniformMatrix2fv");
}

void GL_APIENTRY glUniformMatrix3fv(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glUniformMatrix3fv = void(GL_APIENTRY*)(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glUniformMatrix3fv uniformMatrix3fvPtr = gl::internal::library().getProcAddress<PFN_glUniformMatrix3fv>("glUniformMatrix3fv");
	uniformMatrix3fvPtr(location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glUniformMatrix3fv");
}

void GL_APIENTRY glUniformMatrix4fv(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glUniformMatrix4fv = void(GL_APIENTRY*)(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glUniformMatrix4fv uniformMatrix4fvPtr = gl::internal::library().getProcAddress<PFN_glUniformMatrix4fv>("glUniformMatrix4fv");
	uniformMatrix4fvPtr(location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glUniformMatrix4fv");
}

void GL_APIENTRY glUseProgram(GLuint program)
{
	using PFN_glUseProgram = void(GL_APIENTRY*)(GLuint program);
	static PFN_glUseProgram useProgramPtr = gl::internal::library().getProcAddress<PFN_glUseProgram>("glUseProgram");
	useProgramPtr(program);
	CHECK_GL_ERROR_ASSERT("glUseProgram");
}

void GL_APIENTRY glValidateProgram(GLuint program)
{
	using PFN_glValidateProgram = void(GL_APIENTRY*)(GLuint program);
	static PFN_glValidateProgram validateProgramPtr = gl::internal::library().getProcAddress<PFN_glValidateProgram>("glValidateProgram");
	validateProgramPtr(program);
	CHECK_GL_ERROR_ASSERT("glValidateProgram");
}

void GL_APIENTRY glVertexAttrib1f(GLuint index, GLfloat x)
{
	using PFN_glVertexAttrib1f = void(GL_APIENTRY*)(GLuint index, GLfloat x);
	static PFN_glVertexAttrib1f vertexAttrib1fPtr = gl::internal::library().getProcAddress<PFN_glVertexAttrib1f>("glVertexAttrib1f");
	vertexAttrib1fPtr(index, x);
	CHECK_GL_ERROR_ASSERT("glVertexAttrib1f");
}

void GL_APIENTRY glVertexAttrib1fv(GLuint index, const GLfloat* v)
{
	using PFN_glVertexAttrib1fv = void(GL_APIENTRY*)(GLuint index, const GLfloat* v);
	static PFN_glVertexAttrib1fv vertexAttrib1fvPtr = gl::internal::library().getProcAddress<PFN_glVertexAttrib1fv>("glVertexAttrib1fv");
	vertexAttrib1fvPtr(index, v);
	CHECK_GL_ERROR_ASSERT("glVertexAttrib1fv");
}

void GL_APIENTRY glVertexAttrib2f(GLuint index, GLfloat x, GLfloat y)
{
	using PFN_glVertexAttrib2f = void(GL_APIENTRY*)(GLuint index, GLfloat x, GLfloat y);
	static PFN_glVertexAttrib2f vertexAttrib2fPtr = gl::internal::library().getProcAddress<PFN_glVertexAttrib2f>("glVertexAttrib2f");
	vertexAttrib2fPtr(index, x, y);
	CHECK_GL_ERROR_ASSERT("glVertexAttrib2f");
}

void GL_APIENTRY glVertexAttrib2fv(GLuint index, const GLfloat* v)
{
	using PFN_glVertexAttrib2fv = void(GL_APIENTRY*)(GLuint index, const GLfloat* v);
	static PFN_glVertexAttrib2fv vertexAttrib2fvPtr = gl::internal::library().getProcAddress<PFN_glVertexAttrib2fv>("glVertexAttrib2fv");
	vertexAttrib2fvPtr(index, v);
	CHECK_GL_ERROR_ASSERT("glVertexAttrib2fv");
}

void GL_APIENTRY glVertexAttrib3f(GLuint index, GLfloat x, GLfloat y, GLfloat z)
{
	using PFN_glVertexAttrib3f = void(GL_APIENTRY*)(GLuint index, GLfloat x, GLfloat y, GLfloat z);
	static PFN_glVertexAttrib3f vertexAttrib3fPtr = gl::internal::library().getProcAddress<PFN_glVertexAttrib3f>("glVertexAttrib3f");
	vertexAttrib3fPtr(index, x, y, z);
	CHECK_GL_ERROR_ASSERT("glVertexAttrib3f");
}

void GL_APIENTRY glVertexAttrib3fv(GLuint index, const GLfloat* v)
{
	using PFN_glVertexAttrib3fv = void(GL_APIENTRY*)(GLuint index, const GLfloat* v);
	static PFN_glVertexAttrib3fv vertexAttrib3fvPtr = gl::internal::library().getProcAddress<PFN_glVertexAttrib3fv>("glVertexAttrib3fv");
	vertexAttrib3fvPtr(index, v);
	CHECK_GL_ERROR_ASSERT("glVertexAttrib3fv");
}

void GL_APIENTRY glVertexAttrib4f(GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
	using PFN_glVertexAttrib4f = void(GL_APIENTRY*)(GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
	static PFN_glVertexAttrib4f vertexAttrib4fPtr = gl::internal::library().getProcAddress<PFN_glVertexAttrib4f>("glVertexAttrib4f");
	vertexAttrib4fPtr(index, x, y, z, w);
	CHECK_GL_ERROR_ASSERT("glVertexAttrib4f");
}

void GL_APIENTRY glVertexAttrib4fv(GLuint index, const GLfloat* v)
{
	using PFN_glVertexAttrib4fv = void(GL_APIENTRY*)(GLuint index, const GLfloat* v);
	static PFN_glVertexAttrib4fv vertexAttrib4fvPtr = gl::internal::library().getProcAddress<PFN_glVertexAttrib4fv>("glVertexAttrib4fv");
	vertexAttrib4fvPtr(index, v);
	CHECK_GL_ERROR_ASSERT("glVertexAttrib4fv");
}

void GL_APIENTRY glVertexAttribPointer(GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, const void* pointer)
{
	using PFN_glVertexAttribPointer = void(GL_APIENTRY*)(GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, const void* pointer);
	static PFN_glVertexAttribPointer vertexAttribPointerPtr = gl::internal::library().getProcAddress<PFN_glVertexAttribPointer>("glVertexAttribPointer");
	vertexAttribPointerPtr(index, size, type, normalized, stride, pointer);
	CHECK_GL_ERROR_ASSERT("glVertexAttribPointer");
}

void GL_APIENTRY glViewport(GLint x, GLint y, GLsizei width, GLsizei height)
{
	using PFN_glViewport = void(GL_APIENTRY*)(GLint x, GLint y, GLsizei width, GLsizei height);
	static PFN_glViewport viewportPtr = gl::internal::library().getProcAddress<PFN_glViewport>("glViewport");
	viewportPtr(x, y, width, height);
	CHECK_GL_ERROR_ASSERT("glViewport");
}

// GL_ES_VERSION_3_0
void GL_APIENTRY glBeginQuery(GLenum target, GLuint id)
{
	using PFN_glBeginQuery = void(GL_APIENTRY*)(GLenum target, GLuint id);
	static PFN_glBeginQuery beginQueryPtr = gl::internal::library().getProcAddress<PFN_glBeginQuery>("glBeginQuery");
	beginQueryPtr(target, id);
	CHECK_GL_ERROR_ASSERT("glBeginQuery");
}

void GL_APIENTRY glBeginTransformFeedback(GLenum primitiveMode)
{
	using PFN_glBeginTransformFeedback = void(GL_APIENTRY*)(GLenum primitiveMode);
	static PFN_glBeginTransformFeedback beginTransformFeedbackPtr = gl::internal::library().getProcAddress<PFN_glBeginTransformFeedback>("glBeginTransformFeedback");
	beginTransformFeedbackPtr(primitiveMode);
	CHECK_GL_ERROR_ASSERT("glBeginTransformFeedback");
}

void GL_APIENTRY glBindBufferBase(GLenum target, GLuint index, GLuint buffer)
{
	using PFN_glBindBufferBase = void(GL_APIENTRY*)(GLenum target, GLuint index, GLuint buffer);
	static PFN_glBindBufferBase bindBufferBasePtr = gl::internal::library().getProcAddress<PFN_glBindBufferBase>("glBindBufferBase");
	bindBufferBasePtr(target, index, buffer);
	CHECK_GL_ERROR_ASSERT("glBindBufferBase");
}

void GL_APIENTRY glBindBufferRange(GLenum target, GLuint index, GLuint buffer, GLintptr offset, GLsizeiptr size)
{
	using PFN_glBindBufferRange = void(GL_APIENTRY*)(GLenum target, GLuint index, GLuint buffer, GLintptr offset, GLsizeiptr size);
	static PFN_glBindBufferRange bindBufferRangePtr = gl::internal::library().getProcAddress<PFN_glBindBufferRange>("glBindBufferRange");
	bindBufferRangePtr(target, index, buffer, offset, size);
	CHECK_GL_ERROR_ASSERT("glBindBufferRange");
}

void GL_APIENTRY glBindSampler(GLuint unit, GLuint sampler)
{
	using PFN_glBindSampler = void(GL_APIENTRY*)(GLuint unit, GLuint sampler);
	static PFN_glBindSampler bindSamplerPtr = gl::internal::library().getProcAddress<PFN_glBindSampler>("glBindSampler");
	bindSamplerPtr(unit, sampler);
	CHECK_GL_ERROR_ASSERT("glBindSampler");
}

void GL_APIENTRY glBindTransformFeedback(GLenum target, GLuint id)
{
	using PFN_glBindTransformFeedback = void(GL_APIENTRY*)(GLenum target, GLuint id);
	static PFN_glBindTransformFeedback bindTransformFeedbackPtr = gl::internal::library().getProcAddress<PFN_glBindTransformFeedback>("glBindTransformFeedback");
	bindTransformFeedbackPtr(target, id);
	CHECK_GL_ERROR_ASSERT("glBindTransformFeedback");
}

void GL_APIENTRY glBindVertexArray(GLuint array)
{
	using PFN_glBindVertexArray = void(GL_APIENTRY*)(GLuint array);
	static PFN_glBindVertexArray bindVertexArrayPtr = gl::internal::library().getProcAddress<PFN_glBindVertexArray>("glBindVertexArray");
	bindVertexArrayPtr(array);
	CHECK_GL_ERROR_ASSERT("glBindVertexArray");
}

void GL_APIENTRY glBlitFramebuffer(GLint srcX0, GLint srcY0, GLint srcX1, GLint srcY1, GLint dstX0, GLint dstY0, GLint dstX1, GLint dstY1, GLbitfield mask, GLenum filter)
{
	using PFN_glBlitFramebuffer = void(GL_APIENTRY*)(GLint srcX0, GLint srcY0, GLint srcX1, GLint srcY1, GLint dstX0, GLint dstY0, GLint dstX1, GLint dstY1, GLbitfield mask, GLenum filter);
	static PFN_glBlitFramebuffer blitFramebufferPtr = gl::internal::library().getProcAddress<PFN_glBlitFramebuffer>("glBlitFramebuffer");
	blitFramebufferPtr(srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
	CHECK_GL_ERROR_ASSERT("glBlitFramebuffer");
}

void GL_APIENTRY glClearBufferfi(GLenum buffer, GLint drawbuffer, GLfloat depth, GLint stencil)
{
	using PFN_glClearBufferfi = void(GL_APIENTRY*)(GLenum buffer, GLint drawbuffer, GLfloat depth, GLint stencil);
	static PFN_glClearBufferfi clearBufferfiPtr = gl::internal::library().getProcAddress<PFN_glClearBufferfi>("glClearBufferfi");
	clearBufferfiPtr(buffer, drawbuffer, depth, stencil);
	CHECK_GL_ERROR_ASSERT("glClearBufferfi");
}

void GL_APIENTRY glClearBufferfv(GLenum buffer, GLint drawbuffer, const GLfloat* value)
{
	using PFN_glClearBufferfv = void(GL_APIENTRY*)(GLenum buffer, GLint drawbuffer, const GLfloat* value);
	static PFN_glClearBufferfv clearBufferfvPtr = gl::internal::library().getProcAddress<PFN_glClearBufferfv>("glClearBufferfv");
	clearBufferfvPtr(buffer, drawbuffer, value);
	CHECK_GL_ERROR_ASSERT("glClearBufferfv");
}

void GL_APIENTRY glClearBufferiv(GLenum buffer, GLint drawbuffer, const GLint* value)
{
	using PFN_glClearBufferiv = void(GL_APIENTRY*)(GLenum buffer, GLint drawbuffer, const GLint* value);
	static PFN_glClearBufferiv clearBufferivPtr = gl::internal::library().getProcAddress<PFN_glClearBufferiv>("glClearBufferiv");
	clearBufferivPtr(buffer, drawbuffer, value);
	CHECK_GL_ERROR_ASSERT("glClearBufferiv");
}

void GL_APIENTRY glClearBufferuiv(GLenum buffer, GLint drawbuffer, const GLuint* value)
{
	using PFN_glClearBufferuiv = void(GL_APIENTRY*)(GLenum buffer, GLint drawbuffer, const GLuint* value);
	static PFN_glClearBufferuiv clearBufferuivPtr = gl::internal::library().getProcAddress<PFN_glClearBufferuiv>("glClearBufferuiv");
	clearBufferuivPtr(buffer, drawbuffer, value);
	CHECK_GL_ERROR_ASSERT("glClearBufferuiv");
}

GLenum GL_APIENTRY glClientWaitSync(GLsync sync, GLbitfield flags, GLuint64 timeout)
{
	using PFN_glClientWaitSync = GLenum(GL_APIENTRY*)(GLsync sync, GLbitfield flags, GLuint64 timeout);
	static PFN_glClientWaitSync clientWaitSyncPtr = gl::internal::library().getProcAddress<PFN_glClientWaitSync>("glClientWaitSync");
	auto result = clientWaitSyncPtr(sync, flags, timeout);
	CHECK_GL_ERROR_ASSERT("glClientWaitSync");
	return result;
}

void GL_APIENTRY glCompressedTexImage3D(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, const void* data)
{
	using PFN_glCompressedTexImage3D = void(GL_APIENTRY*)(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, const void* data);
	static PFN_glCompressedTexImage3D compressedTexImage3DPtr = gl::internal::library().getProcAddress<PFN_glCompressedTexImage3D>("glCompressedTexImage3D");
	compressedTexImage3DPtr(target, level, internalformat, width, height, depth, border, imageSize, data);
	CHECK_GL_ERROR_ASSERT("glCompressedTexImage3D");
}

void GL_APIENTRY glCompressedTexSubImage3D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const void* data)
{
	using PFN_glCompressedTexSubImage3D = void(GL_APIENTRY*)(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const void* data);
	static PFN_glCompressedTexSubImage3D compressedTexSubImage3DPtr = gl::internal::library().getProcAddress<PFN_glCompressedTexSubImage3D>("glCompressedTexSubImage3D");
	compressedTexSubImage3DPtr(target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, data);
	CHECK_GL_ERROR_ASSERT("glCompressedTexSubImage3D");
}

void GL_APIENTRY glCopyBufferSubData(GLenum readTarget, GLenum writeTarget, GLintptr readOffset, GLintptr writeOffset, GLsizeiptr size)
{
	using PFN_glCopyBufferSubData = void(GL_APIENTRY*)(GLenum readTarget, GLenum writeTarget, GLintptr readOffset, GLintptr writeOffset, GLsizeiptr size);
	static PFN_glCopyBufferSubData copyBufferSubDataPtr = gl::internal::library().getProcAddress<PFN_glCopyBufferSubData>("glCopyBufferSubData");
	copyBufferSubDataPtr(readTarget, writeTarget, readOffset, writeOffset, size);
	CHECK_GL_ERROR_ASSERT("glCopyBufferSubData");
}

void GL_APIENTRY glCopyTexSubImage3D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height)
{
	using PFN_glCopyTexSubImage3D = void(GL_APIENTRY*)(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height);
	static PFN_glCopyTexSubImage3D copyTexSubImage3DPtr = gl::internal::library().getProcAddress<PFN_glCopyTexSubImage3D>("glCopyTexSubImage3D");
	copyTexSubImage3DPtr(target, level, xoffset, yoffset, zoffset, x, y, width, height);
	CHECK_GL_ERROR_ASSERT("glCopyTexSubImage3D");
}

void GL_APIENTRY glDeleteQueries(GLsizei n, const GLuint* ids)
{
	using PFN_glDeleteQueries = void(GL_APIENTRY*)(GLsizei n, const GLuint* ids);
	static PFN_glDeleteQueries deleteQueriesPtr = gl::internal::library().getProcAddress<PFN_glDeleteQueries>("glDeleteQueries");
	deleteQueriesPtr(n, ids);
	CHECK_GL_ERROR_ASSERT("glDeleteQueries");
}

void GL_APIENTRY glDeleteSamplers(GLsizei count, const GLuint* samplers)
{
	using PFN_glDeleteSamplers = void(GL_APIENTRY*)(GLsizei count, const GLuint* samplers);
	static PFN_glDeleteSamplers deleteSamplersPtr = gl::internal::library().getProcAddress<PFN_glDeleteSamplers>("glDeleteSamplers");
	deleteSamplersPtr(count, samplers);
	CHECK_GL_ERROR_ASSERT("glDeleteSamplers");
}

void GL_APIENTRY glDeleteSync(GLsync sync)
{
	using PFN_glDeleteSync = void(GL_APIENTRY*)(GLsync sync);
	static PFN_glDeleteSync deleteSyncPtr = gl::internal::library().getProcAddress<PFN_glDeleteSync>("glDeleteSync");
	deleteSyncPtr(sync);
	CHECK_GL_ERROR_ASSERT("glDeleteSync");
}

void GL_APIENTRY glDeleteTransformFeedbacks(GLsizei n, const GLuint* ids)
{
	using PFN_glDeleteTransformFeedbacks = void(GL_APIENTRY*)(GLsizei n, const GLuint* ids);
	static PFN_glDeleteTransformFeedbacks deleteTransformFeedbacksPtr = gl::internal::library().getProcAddress<PFN_glDeleteTransformFeedbacks>("glDeleteTransformFeedbacks");
	deleteTransformFeedbacksPtr(n, ids);
	CHECK_GL_ERROR_ASSERT("glDeleteTransformFeedbacks");
}

void GL_APIENTRY glDeleteVertexArrays(GLsizei n, const GLuint* arrays)
{
	using PFN_glDeleteVertexArrays = void(GL_APIENTRY*)(GLsizei n, const GLuint* arrays);
	static PFN_glDeleteVertexArrays deleteVertexArraysPtr = gl::internal::library().getProcAddress<PFN_glDeleteVertexArrays>("glDeleteVertexArrays");
	deleteVertexArraysPtr(n, arrays);
	CHECK_GL_ERROR_ASSERT("glDeleteVertexArrays");
}

void GL_APIENTRY glDrawArraysInstanced(GLenum mode, GLint first, GLsizei count, GLsizei instancecount)
{
	using PFN_glDrawArraysInstanced = void(GL_APIENTRY*)(GLenum mode, GLint first, GLsizei count, GLsizei instancecount);
	static PFN_glDrawArraysInstanced drawArraysInstancedPtr = gl::internal::library().getProcAddress<PFN_glDrawArraysInstanced>("glDrawArraysInstanced");
	drawArraysInstancedPtr(mode, first, count, instancecount);
	CHECK_GL_ERROR_ASSERT("glDrawArraysInstanced");
}

void GL_APIENTRY glDrawBuffers(GLsizei n, const GLenum* bufs)
{
	using PFN_glDrawBuffers = void(GL_APIENTRY*)(GLsizei n, const GLenum* bufs);
	static PFN_glDrawBuffers drawBuffersPtr = gl::internal::library().getProcAddress<PFN_glDrawBuffers>("glDrawBuffers");
	drawBuffersPtr(n, bufs);
	CHECK_GL_ERROR_ASSERT("glDrawBuffers");
}

void GL_APIENTRY glDrawElementsInstanced(GLenum mode, GLsizei count, GLenum type, const void* indices, GLsizei instancecount)
{
	using PFN_glDrawElementsInstanced = void(GL_APIENTRY*)(GLenum mode, GLsizei count, GLenum type, const void* indices, GLsizei instancecount);
	static PFN_glDrawElementsInstanced drawElementsInstancedPtr = gl::internal::library().getProcAddress<PFN_glDrawElementsInstanced>("glDrawElementsInstanced");
	drawElementsInstancedPtr(mode, count, type, indices, instancecount);
	CHECK_GL_ERROR_ASSERT("glDrawElementsInstanced");
}

void GL_APIENTRY glDrawRangeElements(GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const void* indices)
{
	using PFN_glDrawRangeElements = void(GL_APIENTRY*)(GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const void* indices);
	static PFN_glDrawRangeElements drawRangeElementsPtr = gl::internal::library().getProcAddress<PFN_glDrawRangeElements>("glDrawRangeElements");
	drawRangeElementsPtr(mode, start, end, count, type, indices);
	CHECK_GL_ERROR_ASSERT("glDrawRangeElements");
}

void GL_APIENTRY glEndQuery(GLenum target)
{
	using PFN_glEndQuery = void(GL_APIENTRY*)(GLenum target);
	static PFN_glEndQuery endQueryPtr = gl::internal::library().getProcAddress<PFN_glEndQuery>("glEndQuery");
	endQueryPtr(target);
	CHECK_GL_ERROR_ASSERT("glEndQuery");
}

void GL_APIENTRY glEndTransformFeedback()
{
	using PFN_glEndTransformFeedback = void(GL_APIENTRY*)();
	static PFN_glEndTransformFeedback endTransformFeedbackPtr = gl::internal::library().getProcAddress<PFN_glEndTransformFeedback>("glEndTransformFeedback");
	endTransformFeedbackPtr();
	CHECK_GL_ERROR_ASSERT("glEndTransformFeedback");
}

GLsync GL_APIENTRY glFenceSync(GLenum condition, GLbitfield flags)
{
	using PFN_glFenceSync = GLsync(GL_APIENTRY*)(GLenum condition, GLbitfield flags);
	static PFN_glFenceSync fenceSyncPtr = gl::internal::library().getProcAddress<PFN_glFenceSync>("glFenceSync");
	auto result = fenceSyncPtr(condition, flags);
	CHECK_GL_ERROR_ASSERT("glFenceSync");
	return result;
}

void GL_APIENTRY glFlushMappedBufferRange(GLenum target, GLintptr offset, GLsizeiptr length)
{
	using PFN_glFlushMappedBufferRange = void(GL_APIENTRY*)(GLenum target, GLintptr offset, GLsizeiptr length);
	static PFN_glFlushMappedBufferRange flushMappedBufferRangePtr = gl::internal::library().getProcAddress<PFN_glFlushMappedBufferRange>("glFlushMappedBufferRange");
	flushMappedBufferRangePtr(target, offset, length);
	CHECK_GL_ERROR_ASSERT("glFlushMappedBufferRange");
}

void GL_APIENTRY glFramebufferTextureLayer(GLenum target, GLenum attachment, GLuint texture, GLint level, GLint layer)
{
	using PFN_glFramebufferTextureLayer = void(GL_APIENTRY*)(GLenum target, GLenum attachment, GLuint texture, GLint level, GLint layer);
	static PFN_glFramebufferTextureLayer framebufferTextureLayerPtr = gl::internal::library().getProcAddress<PFN_glFramebufferTextureLayer>("glFramebufferTextureLayer");
	framebufferTextureLayerPtr(target, attachment, texture, level, layer);
	CHECK_GL_ERROR_ASSERT("glFramebufferTextureLayer");
}

void GL_APIENTRY glGenQueries(GLsizei n, GLuint* ids)
{
	using PFN_glGenQueries = void(GL_APIENTRY*)(GLsizei n, GLuint * ids);
	static PFN_glGenQueries genQueriesPtr = gl::internal::library().getProcAddress<PFN_glGenQueries>("glGenQueries");
	genQueriesPtr(n, ids);
	CHECK_GL_ERROR_ASSERT("glGenQueries");
}

void GL_APIENTRY glGenSamplers(GLsizei count, GLuint* samplers)
{
	using PFN_glGenSamplers = void(GL_APIENTRY*)(GLsizei count, GLuint * samplers);
	static PFN_glGenSamplers genSamplersPtr = gl::internal::library().getProcAddress<PFN_glGenSamplers>("glGenSamplers");
	genSamplersPtr(count, samplers);
	CHECK_GL_ERROR_ASSERT("glGenSamplers");
}

void GL_APIENTRY glGenTransformFeedbacks(GLsizei n, GLuint* ids)
{
	using PFN_glGenTransformFeedbacks = void(GL_APIENTRY*)(GLsizei n, GLuint * ids);
	static PFN_glGenTransformFeedbacks genTransformFeedbacksPtr = gl::internal::library().getProcAddress<PFN_glGenTransformFeedbacks>("glGenTransformFeedbacks");
	genTransformFeedbacksPtr(n, ids);
	CHECK_GL_ERROR_ASSERT("glGenTransformFeedbacks");
}

void GL_APIENTRY glGenVertexArrays(GLsizei n, GLuint* arrays)
{
	using PFN_glGenVertexArrays = void(GL_APIENTRY*)(GLsizei n, GLuint * arrays);
	static PFN_glGenVertexArrays genVertexArraysPtr = gl::internal::library().getProcAddress<PFN_glGenVertexArrays>("glGenVertexArrays");
	genVertexArraysPtr(n, arrays);
	CHECK_GL_ERROR_ASSERT("glGenVertexArrays");
}

void GL_APIENTRY glGetActiveUniformBlockName(GLuint program, GLuint uniformBlockIndex, GLsizei bufSize, GLsizei* length, GLchar* uniformBlockName)
{
	using PFN_glGetActiveUniformBlockName = void(GL_APIENTRY*)(GLuint program, GLuint uniformBlockIndex, GLsizei bufSize, GLsizei * length, GLchar * uniformBlockName);
	static PFN_glGetActiveUniformBlockName getActiveUniformBlockNamePtr = gl::internal::library().getProcAddress<PFN_glGetActiveUniformBlockName>("glGetActiveUniformBlockName");
	getActiveUniformBlockNamePtr(program, uniformBlockIndex, bufSize, length, uniformBlockName);
	CHECK_GL_ERROR_ASSERT("glGetActiveUniformBlockName");
}

void GL_APIENTRY glGetActiveUniformBlockiv(GLuint program, GLuint uniformBlockIndex, GLenum pname, GLint* params)
{
	using PFN_glGetActiveUniformBlockiv = void(GL_APIENTRY*)(GLuint program, GLuint uniformBlockIndex, GLenum pname, GLint * params);
	static PFN_glGetActiveUniformBlockiv getActiveUniformBlockivPtr = gl::internal::library().getProcAddress<PFN_glGetActiveUniformBlockiv>("glGetActiveUniformBlockiv");
	getActiveUniformBlockivPtr(program, uniformBlockIndex, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetActiveUniformBlockiv");
}

void GL_APIENTRY glGetActiveUniformsiv(GLuint program, GLsizei uniformCount, const GLuint* uniformIndices, GLenum pname, GLint* params)
{
	using PFN_glGetActiveUniformsiv = void(GL_APIENTRY*)(GLuint program, GLsizei uniformCount, const GLuint* uniformIndices, GLenum pname, GLint* params);
	static PFN_glGetActiveUniformsiv getActiveUniformsivPtr = gl::internal::library().getProcAddress<PFN_glGetActiveUniformsiv>("glGetActiveUniformsiv");
	getActiveUniformsivPtr(program, uniformCount, uniformIndices, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetActiveUniformsiv");
}

void GL_APIENTRY glGetBufferParameteri64v(GLenum target, GLenum pname, GLint64* params)
{
	using PFN_glGetBufferParameteri64v = void(GL_APIENTRY*)(GLenum target, GLenum pname, GLint64 * params);
	static PFN_glGetBufferParameteri64v getBufferParameteri64vPtr = gl::internal::library().getProcAddress<PFN_glGetBufferParameteri64v>("glGetBufferParameteri64v");
	getBufferParameteri64vPtr(target, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetBufferParameteri64v");
}

void GL_APIENTRY glGetBufferPointerv(GLenum target, GLenum pname, void** params)
{
	using PFN_glGetBufferPointerv = void(GL_APIENTRY*)(GLenum target, GLenum pname, void** params);
	static PFN_glGetBufferPointerv getBufferPointervPtr = gl::internal::library().getProcAddress<PFN_glGetBufferPointerv>("glGetBufferPointerv");
	getBufferPointervPtr(target, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetBufferPointerv");
}

GLint GL_APIENTRY glGetFragDataLocation(GLuint program, const GLchar* name)
{
	using PFN_glGetFragDataLocation = GLint(GL_APIENTRY*)(GLuint program, const GLchar* name);
	static PFN_glGetFragDataLocation getFragDataLocationPtr = gl::internal::library().getProcAddress<PFN_glGetFragDataLocation>("glGetFragDataLocation");
	auto result = getFragDataLocationPtr(program, name);
	CHECK_GL_ERROR_ASSERT("glGetFragDataLocation");
	return result;
}

void GL_APIENTRY glGetInteger64i_v(GLenum target, GLuint index, GLint64* data)
{
	using PFN_glGetInteger64i_v = void(GL_APIENTRY*)(GLenum target, GLuint index, GLint64 * data);
	static PFN_glGetInteger64i_v getInteger64i_vPtr = gl::internal::library().getProcAddress<PFN_glGetInteger64i_v>("glGetInteger64i_v");
	getInteger64i_vPtr(target, index, data);
	CHECK_GL_ERROR_ASSERT("glGetInteger64i_v");
}

void GL_APIENTRY glGetInteger64v(GLenum pname, GLint64* data)
{
	using PFN_glGetInteger64v = void(GL_APIENTRY*)(GLenum pname, GLint64 * data);
	static PFN_glGetInteger64v getInteger64vPtr = gl::internal::library().getProcAddress<PFN_glGetInteger64v>("glGetInteger64v");
	getInteger64vPtr(pname, data);
	CHECK_GL_ERROR_ASSERT("glGetInteger64v");
}

void GL_APIENTRY glGetIntegeri_v(GLenum target, GLuint index, GLint* data)
{
	using PFN_glGetIntegeri_v = void(GL_APIENTRY*)(GLenum target, GLuint index, GLint * data);
	static PFN_glGetIntegeri_v getIntegeri_vPtr = gl::internal::library().getProcAddress<PFN_glGetIntegeri_v>("glGetIntegeri_v");
	getIntegeri_vPtr(target, index, data);
	CHECK_GL_ERROR_ASSERT("glGetIntegeri_v");
}

void GL_APIENTRY glGetInternalformativ(GLenum target, GLenum internalformat, GLenum pname, GLsizei bufSize, GLint* params)
{
	using PFN_glGetInternalformativ = void(GL_APIENTRY*)(GLenum target, GLenum internalformat, GLenum pname, GLsizei bufSize, GLint * params);
	static PFN_glGetInternalformativ getInternalformativPtr = gl::internal::library().getProcAddress<PFN_glGetInternalformativ>("glGetInternalformativ");
	getInternalformativPtr(target, internalformat, pname, bufSize, params);
	CHECK_GL_ERROR_ASSERT("glGetInternalformativ");
}

void GL_APIENTRY glGetProgramBinary(GLuint program, GLsizei bufSize, GLsizei* length, GLenum* binaryFormat, void* binary)
{
	using PFN_glGetProgramBinary = void(GL_APIENTRY*)(GLuint program, GLsizei bufSize, GLsizei * length, GLenum * binaryFormat, void* binary);
	static PFN_glGetProgramBinary getProgramBinaryPtr = gl::internal::library().getProcAddress<PFN_glGetProgramBinary>("glGetProgramBinary");
	getProgramBinaryPtr(program, bufSize, length, binaryFormat, binary);
	CHECK_GL_ERROR_ASSERT("glGetProgramBinary");
}

void GL_APIENTRY glGetQueryObjectuiv(GLuint id, GLenum pname, GLuint* params)
{
	using PFN_glGetQueryObjectuiv = void(GL_APIENTRY*)(GLuint id, GLenum pname, GLuint * params);
	static PFN_glGetQueryObjectuiv getQueryObjectuivPtr = gl::internal::library().getProcAddress<PFN_glGetQueryObjectuiv>("glGetQueryObjectuiv");
	getQueryObjectuivPtr(id, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetQueryObjectuiv");
}

void GL_APIENTRY glGetQueryiv(GLenum target, GLenum pname, GLint* params)
{
	using PFN_glGetQueryiv = void(GL_APIENTRY*)(GLenum target, GLenum pname, GLint * params);
	static PFN_glGetQueryiv getQueryivPtr = gl::internal::library().getProcAddress<PFN_glGetQueryiv>("glGetQueryiv");
	getQueryivPtr(target, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetQueryiv");
}

void GL_APIENTRY glGetSamplerParameterfv(GLuint sampler, GLenum pname, GLfloat* params)
{
	using PFN_glGetSamplerParameterfv = void(GL_APIENTRY*)(GLuint sampler, GLenum pname, GLfloat * params);
	static PFN_glGetSamplerParameterfv getSamplerParameterfvPtr = gl::internal::library().getProcAddress<PFN_glGetSamplerParameterfv>("glGetSamplerParameterfv");
	getSamplerParameterfvPtr(sampler, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetSamplerParameterfv");
}

void GL_APIENTRY glGetSamplerParameteriv(GLuint sampler, GLenum pname, GLint* params)
{
	using PFN_glGetSamplerParameteriv = void(GL_APIENTRY*)(GLuint sampler, GLenum pname, GLint * params);
	static PFN_glGetSamplerParameteriv getSamplerParameterivPtr = gl::internal::library().getProcAddress<PFN_glGetSamplerParameteriv>("glGetSamplerParameteriv");
	getSamplerParameterivPtr(sampler, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetSamplerParameteriv");
}

const GLubyte* GL_APIENTRY glGetStringi(GLenum name, GLuint index)
{
	using PFN_glGetStringi = const GLubyte*(GL_APIENTRY*) (GLenum name, GLuint index);
	static PFN_glGetStringi getStringiPtr = gl::internal::library().getProcAddress<PFN_glGetStringi>("glGetStringi");
	auto result = getStringiPtr(name, index);
	CHECK_GL_ERROR_ASSERT("glGetStringi");
	return result;
}

void GL_APIENTRY glGetSynciv(GLsync sync, GLenum pname, GLsizei bufSize, GLsizei* length, GLint* values)
{
	using PFN_glGetSynciv = void(GL_APIENTRY*)(GLsync sync, GLenum pname, GLsizei bufSize, GLsizei * length, GLint * values);
	static PFN_glGetSynciv getSyncivPtr = gl::internal::library().getProcAddress<PFN_glGetSynciv>("glGetSynciv");
	getSyncivPtr(sync, pname, bufSize, length, values);
	CHECK_GL_ERROR_ASSERT("glGetSynciv");
}

void GL_APIENTRY glGetTransformFeedbackVarying(GLuint program, GLuint index, GLsizei bufSize, GLsizei* length, GLsizei* size, GLenum* type, GLchar* name)
{
	using PFN_glGetTransformFeedbackVarying = void(GL_APIENTRY*)(GLuint program, GLuint index, GLsizei bufSize, GLsizei * length, GLsizei * size, GLenum * type, GLchar * name);
	static PFN_glGetTransformFeedbackVarying getTransformFeedbackVaryingPtr = gl::internal::library().getProcAddress<PFN_glGetTransformFeedbackVarying>("glGetTransformFeedbackVarying");
	getTransformFeedbackVaryingPtr(program, index, bufSize, length, size, type, name);
	CHECK_GL_ERROR_ASSERT("glGetTransformFeedbackVarying");
}

GLuint GL_APIENTRY glGetUniformBlockIndex(GLuint program, const GLchar* uniformBlockName)
{
	using PFN_glGetUniformBlockIndex = GLuint(GL_APIENTRY*)(GLuint program, const GLchar* uniformBlockName);
	static PFN_glGetUniformBlockIndex getUniformBlockIndexPtr = gl::internal::library().getProcAddress<PFN_glGetUniformBlockIndex>("glGetUniformBlockIndex");
	auto result = getUniformBlockIndexPtr(program, uniformBlockName);
	CHECK_GL_ERROR_ASSERT("glGetUniformBlockIndex");
	return result;
}

void GL_APIENTRY glGetUniformIndices(GLuint program, GLsizei uniformCount, const GLchar* const* uniformNames, GLuint* uniformIndices)
{
	using PFN_glGetUniformIndices = void(GL_APIENTRY*)(GLuint program, GLsizei uniformCount, const GLchar* const* uniformNames, GLuint* uniformIndices);
	static PFN_glGetUniformIndices getUniformIndicesPtr = gl::internal::library().getProcAddress<PFN_glGetUniformIndices>("glGetUniformIndices");
	getUniformIndicesPtr(program, uniformCount, uniformNames, uniformIndices);
	CHECK_GL_ERROR_ASSERT("glGetUniformIndices");
}

void GL_APIENTRY glGetUniformuiv(GLuint program, GLint location, GLuint* params)
{
	using PFN_glGetUniformuiv = void(GL_APIENTRY*)(GLuint program, GLint location, GLuint * params);
	static PFN_glGetUniformuiv getUniformuivPtr = gl::internal::library().getProcAddress<PFN_glGetUniformuiv>("glGetUniformuiv");
	getUniformuivPtr(program, location, params);
	CHECK_GL_ERROR_ASSERT("glGetUniformuiv");
}

void GL_APIENTRY glGetVertexAttribIiv(GLuint index, GLenum pname, GLint* params)
{
	using PFN_glGetVertexAttribIiv = void(GL_APIENTRY*)(GLuint index, GLenum pname, GLint * params);
	static PFN_glGetVertexAttribIiv getVertexAttribIivPtr = gl::internal::library().getProcAddress<PFN_glGetVertexAttribIiv>("glGetVertexAttribIiv");
	getVertexAttribIivPtr(index, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetVertexAttribIiv");
}

void GL_APIENTRY glGetVertexAttribIuiv(GLuint index, GLenum pname, GLuint* params)
{
	using PFN_glGetVertexAttribIuiv = void(GL_APIENTRY*)(GLuint index, GLenum pname, GLuint * params);
	static PFN_glGetVertexAttribIuiv getVertexAttribIuivPtr = gl::internal::library().getProcAddress<PFN_glGetVertexAttribIuiv>("glGetVertexAttribIuiv");
	getVertexAttribIuivPtr(index, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetVertexAttribIuiv");
}

void GL_APIENTRY glInvalidateFramebuffer(GLenum target, GLsizei numAttachments, const GLenum* attachments)
{
	using PFN_glInvalidateFramebuffer = void(GL_APIENTRY*)(GLenum target, GLsizei numAttachments, const GLenum* attachments);
	static PFN_glInvalidateFramebuffer invalidateFramebufferPtr = gl::internal::library().getProcAddress<PFN_glInvalidateFramebuffer>("glInvalidateFramebuffer");
	invalidateFramebufferPtr(target, numAttachments, attachments);
	CHECK_GL_ERROR_ASSERT("glInvalidateFramebuffer");
}

void GL_APIENTRY glInvalidateSubFramebuffer(GLenum target, GLsizei numAttachments, const GLenum* attachments, GLint x, GLint y, GLsizei width, GLsizei height)
{
	using PFN_glInvalidateSubFramebuffer = void(GL_APIENTRY*)(GLenum target, GLsizei numAttachments, const GLenum* attachments, GLint x, GLint y, GLsizei width, GLsizei height);
	static PFN_glInvalidateSubFramebuffer invalidateSubFramebufferPtr = gl::internal::library().getProcAddress<PFN_glInvalidateSubFramebuffer>("glInvalidateSubFramebuffer");
	invalidateSubFramebufferPtr(target, numAttachments, attachments, x, y, width, height);
	CHECK_GL_ERROR_ASSERT("glInvalidateSubFramebuffer");
}

GLboolean GL_APIENTRY glIsQuery(GLuint id)
{
	using PFN_glIsQuery = GLboolean(GL_APIENTRY*)(GLuint id);
	static PFN_glIsQuery isQueryPtr = gl::internal::library().getProcAddress<PFN_glIsQuery>("glIsQuery");
	auto result = isQueryPtr(id);
	CHECK_GL_ERROR_ASSERT("glIsQuery");
	return result;
}

GLboolean GL_APIENTRY glIsSampler(GLuint sampler)
{
	using PFN_glIsSampler = GLboolean(GL_APIENTRY*)(GLuint sampler);
	static PFN_glIsSampler isSamplerPtr = gl::internal::library().getProcAddress<PFN_glIsSampler>("glIsSampler");
	auto result = isSamplerPtr(sampler);
	CHECK_GL_ERROR_ASSERT("glIsSampler");
	return result;
}

GLboolean GL_APIENTRY glIsSync(GLsync sync)
{
	using PFN_glIsSync = GLboolean(GL_APIENTRY*)(GLsync sync);
	static PFN_glIsSync isSyncPtr = gl::internal::library().getProcAddress<PFN_glIsSync>("glIsSync");
	auto result = isSyncPtr(sync);
	CHECK_GL_ERROR_ASSERT("glIsSync");
	return result;
}

GLboolean GL_APIENTRY glIsTransformFeedback(GLuint id)
{
	using PFN_glIsTransformFeedback = GLboolean(GL_APIENTRY*)(GLuint id);
	static PFN_glIsTransformFeedback isTransformFeedbackPtr = gl::internal::library().getProcAddress<PFN_glIsTransformFeedback>("glIsTransformFeedback");
	auto result = isTransformFeedbackPtr(id);
	CHECK_GL_ERROR_ASSERT("glIsTransformFeedback");
	return result;
}

GLboolean GL_APIENTRY glIsVertexArray(GLuint array)
{
	using PFN_glIsVertexArray = GLboolean(GL_APIENTRY*)(GLuint array);
	static PFN_glIsVertexArray isVertexArrayPtr = gl::internal::library().getProcAddress<PFN_glIsVertexArray>("glIsVertexArray");
	auto result = isVertexArrayPtr(array);
	CHECK_GL_ERROR_ASSERT("glIsVertexArray");
	return result;
}

void* GL_APIENTRY glMapBufferRange(GLenum target, GLintptr offset, GLsizeiptr length, GLbitfield access)
{
	using PFN_glMapBufferRange = void*(GL_APIENTRY*) (GLenum target, GLintptr offset, GLsizeiptr length, GLbitfield access);
	static PFN_glMapBufferRange mapBufferRangePtr = gl::internal::library().getProcAddress<PFN_glMapBufferRange>("glMapBufferRange");
	auto result = mapBufferRangePtr(target, offset, length, access);
	CHECK_GL_ERROR_ASSERT("glMapBufferRange");
	return result;
}

void GL_APIENTRY glPauseTransformFeedback()
{
	using PFN_glPauseTransformFeedback = void(GL_APIENTRY*)();
	static PFN_glPauseTransformFeedback pauseTransformFeedbackPtr = gl::internal::library().getProcAddress<PFN_glPauseTransformFeedback>("glPauseTransformFeedback");
	pauseTransformFeedbackPtr();
	CHECK_GL_ERROR_ASSERT("glPauseTransformFeedback");
}

void GL_APIENTRY glProgramBinary(GLuint program, GLenum binaryFormat, const void* binary, GLsizei length)
{
	using PFN_glProgramBinary = void(GL_APIENTRY*)(GLuint program, GLenum binaryFormat, const void* binary, GLsizei length);
	static PFN_glProgramBinary programBinaryPtr = gl::internal::library().getProcAddress<PFN_glProgramBinary>("glProgramBinary");
	programBinaryPtr(program, binaryFormat, binary, length);
	CHECK_GL_ERROR_ASSERT("glProgramBinary");
}

void GL_APIENTRY glProgramParameteri(GLuint program, GLenum pname, GLint value)
{
	using PFN_glProgramParameteri = void(GL_APIENTRY*)(GLuint program, GLenum pname, GLint value);
	static PFN_glProgramParameteri programParameteriPtr = gl::internal::library().getProcAddress<PFN_glProgramParameteri>("glProgramParameteri");
	programParameteriPtr(program, pname, value);
	CHECK_GL_ERROR_ASSERT("glProgramParameteri");
}

void GL_APIENTRY glReadBuffer(GLenum src)
{
	using PFN_glReadBuffer = void(GL_APIENTRY*)(GLenum src);
	static PFN_glReadBuffer readBufferPtr = gl::internal::library().getProcAddress<PFN_glReadBuffer>("glReadBuffer");
	readBufferPtr(src);
	CHECK_GL_ERROR_ASSERT("glReadBuffer");
}

void GL_APIENTRY glRenderbufferStorageMultisample(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height)
{
	using PFN_glRenderbufferStorageMultisample = void(GL_APIENTRY*)(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height);
	static PFN_glRenderbufferStorageMultisample renderbufferStorageMultisamplePtr = gl::internal::library().getProcAddress<PFN_glRenderbufferStorageMultisample>("glRenderbufferStorageMultisample");
	renderbufferStorageMultisamplePtr(target, samples, internalformat, width, height);
	CHECK_GL_ERROR_ASSERT("glRenderbufferStorageMultisample");
}

void GL_APIENTRY glResumeTransformFeedback()
{
	using PFN_glResumeTransformFeedback = void(GL_APIENTRY*)();
	static PFN_glResumeTransformFeedback resumeTransformFeedbackPtr = gl::internal::library().getProcAddress<PFN_glResumeTransformFeedback>("glResumeTransformFeedback");
	resumeTransformFeedbackPtr();
	CHECK_GL_ERROR_ASSERT("glResumeTransformFeedback");
}

void GL_APIENTRY glSamplerParameterf(GLuint sampler, GLenum pname, GLfloat param)
{
	using PFN_glSamplerParameterf = void(GL_APIENTRY*)(GLuint sampler, GLenum pname, GLfloat param);
	static PFN_glSamplerParameterf samplerParameterfPtr = gl::internal::library().getProcAddress<PFN_glSamplerParameterf>("glSamplerParameterf");
	samplerParameterfPtr(sampler, pname, param);
	CHECK_GL_ERROR_ASSERT("glSamplerParameterf");
}

void GL_APIENTRY glSamplerParameterfv(GLuint sampler, GLenum pname, const GLfloat* param)
{
	using PFN_glSamplerParameterfv = void(GL_APIENTRY*)(GLuint sampler, GLenum pname, const GLfloat* param);
	static PFN_glSamplerParameterfv samplerParameterfvPtr = gl::internal::library().getProcAddress<PFN_glSamplerParameterfv>("glSamplerParameterfv");
	samplerParameterfvPtr(sampler, pname, param);
	CHECK_GL_ERROR_ASSERT("glSamplerParameterfv");
}

void GL_APIENTRY glSamplerParameteri(GLuint sampler, GLenum pname, GLint param)
{
	using PFN_glSamplerParameteri = void(GL_APIENTRY*)(GLuint sampler, GLenum pname, GLint param);
	static PFN_glSamplerParameteri samplerParameteriPtr = gl::internal::library().getProcAddress<PFN_glSamplerParameteri>("glSamplerParameteri");
	samplerParameteriPtr(sampler, pname, param);
	CHECK_GL_ERROR_ASSERT("glSamplerParameteri");
}

void GL_APIENTRY glSamplerParameteriv(GLuint sampler, GLenum pname, const GLint* param)
{
	using PFN_glSamplerParameteriv = void(GL_APIENTRY*)(GLuint sampler, GLenum pname, const GLint* param);
	static PFN_glSamplerParameteriv samplerParameterivPtr = gl::internal::library().getProcAddress<PFN_glSamplerParameteriv>("glSamplerParameteriv");
	samplerParameterivPtr(sampler, pname, param);
	CHECK_GL_ERROR_ASSERT("glSamplerParameteriv");
}

void GL_APIENTRY glTexImage3D(GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, const void* pixels)
{
	using PFN_glTexImage3D = void(GL_APIENTRY*)(GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, const void* pixels);
	static PFN_glTexImage3D texImage3DPtr = gl::internal::library().getProcAddress<PFN_glTexImage3D>("glTexImage3D");
	texImage3DPtr(target, level, internalformat, width, height, depth, border, format, type, pixels);
	CHECK_GL_ERROR_ASSERT("glTexImage3D");
}

void GL_APIENTRY glTexStorage2D(GLenum target, GLsizei levels, GLenum internalformat, GLsizei width, GLsizei height)
{
	using PFN_glTexStorage2D = void(GL_APIENTRY*)(GLenum target, GLsizei levels, GLenum internalformat, GLsizei width, GLsizei height);
	static PFN_glTexStorage2D texStorage2DPtr = gl::internal::library().getProcAddress<PFN_glTexStorage2D>("glTexStorage2D");
	texStorage2DPtr(target, levels, internalformat, width, height);
	CHECK_GL_ERROR_ASSERT("glTexStorage2D");
}

void GL_APIENTRY glTexStorage3D(GLenum target, GLsizei levels, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth)
{
	using PFN_glTexStorage3D = void(GL_APIENTRY*)(GLenum target, GLsizei levels, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth);
	static PFN_glTexStorage3D texStorage3DPtr = gl::internal::library().getProcAddress<PFN_glTexStorage3D>("glTexStorage3D");
	texStorage3DPtr(target, levels, internalformat, width, height, depth);
	CHECK_GL_ERROR_ASSERT("glTexStorage3D");
}

void GL_APIENTRY glTexSubImage3D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const void* pixels)
{
	using PFN_glTexSubImage3D = void(GL_APIENTRY*)(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const void* pixels);
	static PFN_glTexSubImage3D texSubImage3DPtr = gl::internal::library().getProcAddress<PFN_glTexSubImage3D>("glTexSubImage3D");
	texSubImage3DPtr(target, level, xoffset, yoffset, zoffset, width, height, depth, format, type, pixels);
	CHECK_GL_ERROR_ASSERT("glTexSubImage3D");
}

void GL_APIENTRY glTransformFeedbackVaryings(GLuint program, GLsizei count, const GLchar* const* varyings, GLenum bufferMode)
{
	using PFN_glTransformFeedbackVaryings = void(GL_APIENTRY*)(GLuint program, GLsizei count, const GLchar* const* varyings, GLenum bufferMode);
	static PFN_glTransformFeedbackVaryings transformFeedbackVaryingsPtr = gl::internal::library().getProcAddress<PFN_glTransformFeedbackVaryings>("glTransformFeedbackVaryings");
	transformFeedbackVaryingsPtr(program, count, varyings, bufferMode);
	CHECK_GL_ERROR_ASSERT("glTransformFeedbackVaryings");
}

void GL_APIENTRY glUniform1ui(GLint location, GLuint v0)
{
	using PFN_glUniform1ui = void(GL_APIENTRY*)(GLint location, GLuint v0);
	static PFN_glUniform1ui uniform1uiPtr = gl::internal::library().getProcAddress<PFN_glUniform1ui>("glUniform1ui");
	uniform1uiPtr(location, v0);
	CHECK_GL_ERROR_ASSERT("glUniform1ui");
}

void GL_APIENTRY glUniform1uiv(GLint location, GLsizei count, const GLuint* value)
{
	using PFN_glUniform1uiv = void(GL_APIENTRY*)(GLint location, GLsizei count, const GLuint* value);
	static PFN_glUniform1uiv uniform1uivPtr = gl::internal::library().getProcAddress<PFN_glUniform1uiv>("glUniform1uiv");
	uniform1uivPtr(location, count, value);
	CHECK_GL_ERROR_ASSERT("glUniform1uiv");
}

void GL_APIENTRY glUniform2ui(GLint location, GLuint v0, GLuint v1)
{
	using PFN_glUniform2ui = void(GL_APIENTRY*)(GLint location, GLuint v0, GLuint v1);
	static PFN_glUniform2ui uniform2uiPtr = gl::internal::library().getProcAddress<PFN_glUniform2ui>("glUniform2ui");
	uniform2uiPtr(location, v0, v1);
	CHECK_GL_ERROR_ASSERT("glUniform2ui");
}

void GL_APIENTRY glUniform2uiv(GLint location, GLsizei count, const GLuint* value)
{
	using PFN_glUniform2uiv = void(GL_APIENTRY*)(GLint location, GLsizei count, const GLuint* value);
	static PFN_glUniform2uiv uniform2uivPtr = gl::internal::library().getProcAddress<PFN_glUniform2uiv>("glUniform2uiv");
	uniform2uivPtr(location, count, value);
	CHECK_GL_ERROR_ASSERT("glUniform2uiv");
}

void GL_APIENTRY glUniform3ui(GLint location, GLuint v0, GLuint v1, GLuint v2)
{
	using PFN_glUniform3ui = void(GL_APIENTRY*)(GLint location, GLuint v0, GLuint v1, GLuint v2);
	static PFN_glUniform3ui uniform3uiPtr = gl::internal::library().getProcAddress<PFN_glUniform3ui>("glUniform3ui");
	uniform3uiPtr(location, v0, v1, v2);
	CHECK_GL_ERROR_ASSERT("glUniform3ui");
}

void GL_APIENTRY glUniform3uiv(GLint location, GLsizei count, const GLuint* value)
{
	using PFN_glUniform3uiv = void(GL_APIENTRY*)(GLint location, GLsizei count, const GLuint* value);
	static PFN_glUniform3uiv uniform3uivPtr = gl::internal::library().getProcAddress<PFN_glUniform3uiv>("glUniform3uiv");
	uniform3uivPtr(location, count, value);
	CHECK_GL_ERROR_ASSERT("glUniform3uiv");
}

void GL_APIENTRY glUniform4ui(GLint location, GLuint v0, GLuint v1, GLuint v2, GLuint v3)
{
	using PFN_glUniform4ui = void(GL_APIENTRY*)(GLint location, GLuint v0, GLuint v1, GLuint v2, GLuint v3);
	static PFN_glUniform4ui uniform4uiPtr = gl::internal::library().getProcAddress<PFN_glUniform4ui>("glUniform4ui");
	uniform4uiPtr(location, v0, v1, v2, v3);
	CHECK_GL_ERROR_ASSERT("glUniform4ui");
}

void GL_APIENTRY glUniform4uiv(GLint location, GLsizei count, const GLuint* value)
{
	using PFN_glUniform4uiv = void(GL_APIENTRY*)(GLint location, GLsizei count, const GLuint* value);
	static PFN_glUniform4uiv uniform4uivPtr = gl::internal::library().getProcAddress<PFN_glUniform4uiv>("glUniform4uiv");
	uniform4uivPtr(location, count, value);
	CHECK_GL_ERROR_ASSERT("glUniform4uiv");
}

void GL_APIENTRY glUniformBlockBinding(GLuint program, GLuint uniformBlockIndex, GLuint uniformBlockBinding)
{
	using PFN_glUniformBlockBinding = void(GL_APIENTRY*)(GLuint program, GLuint uniformBlockIndex, GLuint uniformBlockBinding);
	static PFN_glUniformBlockBinding uniformBlockBindingPtr = gl::internal::library().getProcAddress<PFN_glUniformBlockBinding>("glUniformBlockBinding");
	uniformBlockBindingPtr(program, uniformBlockIndex, uniformBlockBinding);
	CHECK_GL_ERROR_ASSERT("glUniformBlockBinding");
}

void GL_APIENTRY glUniformMatrix2x3fv(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glUniformMatrix2x3fv = void(GL_APIENTRY*)(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glUniformMatrix2x3fv uniformMatrix2x3fvPtr = gl::internal::library().getProcAddress<PFN_glUniformMatrix2x3fv>("glUniformMatrix2x3fv");
	uniformMatrix2x3fvPtr(location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glUniformMatrix2x3fv");
}

void GL_APIENTRY glUniformMatrix2x4fv(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glUniformMatrix2x4fv = void(GL_APIENTRY*)(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glUniformMatrix2x4fv uniformMatrix2x4fvPtr = gl::internal::library().getProcAddress<PFN_glUniformMatrix2x4fv>("glUniformMatrix2x4fv");
	uniformMatrix2x4fvPtr(location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glUniformMatrix2x4fv");
}

void GL_APIENTRY glUniformMatrix3x2fv(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glUniformMatrix3x2fv = void(GL_APIENTRY*)(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glUniformMatrix3x2fv uniformMatrix3x2fvPtr = gl::internal::library().getProcAddress<PFN_glUniformMatrix3x2fv>("glUniformMatrix3x2fv");
	uniformMatrix3x2fvPtr(location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glUniformMatrix3x2fv");
}

void GL_APIENTRY glUniformMatrix3x4fv(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glUniformMatrix3x4fv = void(GL_APIENTRY*)(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glUniformMatrix3x4fv uniformMatrix3x4fvPtr = gl::internal::library().getProcAddress<PFN_glUniformMatrix3x4fv>("glUniformMatrix3x4fv");
	uniformMatrix3x4fvPtr(location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glUniformMatrix3x4fv");
}

void GL_APIENTRY glUniformMatrix4x2fv(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glUniformMatrix4x2fv = void(GL_APIENTRY*)(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glUniformMatrix4x2fv uniformMatrix4x2fvPtr = gl::internal::library().getProcAddress<PFN_glUniformMatrix4x2fv>("glUniformMatrix4x2fv");
	uniformMatrix4x2fvPtr(location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glUniformMatrix4x2fv");
}

void GL_APIENTRY glUniformMatrix4x3fv(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glUniformMatrix4x3fv = void(GL_APIENTRY*)(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glUniformMatrix4x3fv uniformMatrix4x3fvPtr = gl::internal::library().getProcAddress<PFN_glUniformMatrix4x3fv>("glUniformMatrix4x3fv");
	uniformMatrix4x3fvPtr(location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glUniformMatrix4x3fv");
}

GLboolean GL_APIENTRY glUnmapBuffer(GLenum target)
{
	using PFN_glUnmapBuffer = GLboolean(GL_APIENTRY*)(GLenum target);
	static PFN_glUnmapBuffer unmapBufferPtr = gl::internal::library().getProcAddress<PFN_glUnmapBuffer>("glUnmapBuffer");
	auto result = unmapBufferPtr(target);
	CHECK_GL_ERROR_ASSERT("glUnmapBuffer");
	return result;
}

void GL_APIENTRY glVertexAttribDivisor(GLuint index, GLuint divisor)
{
	using PFN_glVertexAttribDivisor = void(GL_APIENTRY*)(GLuint index, GLuint divisor);
	static PFN_glVertexAttribDivisor vertexAttribDivisorPtr = gl::internal::library().getProcAddress<PFN_glVertexAttribDivisor>("glVertexAttribDivisor");
	vertexAttribDivisorPtr(index, divisor);
	CHECK_GL_ERROR_ASSERT("glVertexAttribDivisor");
}

void GL_APIENTRY glVertexAttribI4i(GLuint index, GLint x, GLint y, GLint z, GLint w)
{
	using PFN_glVertexAttribI4i = void(GL_APIENTRY*)(GLuint index, GLint x, GLint y, GLint z, GLint w);
	static PFN_glVertexAttribI4i vertexAttribI4iPtr = gl::internal::library().getProcAddress<PFN_glVertexAttribI4i>("glVertexAttribI4i");
	vertexAttribI4iPtr(index, x, y, z, w);
	CHECK_GL_ERROR_ASSERT("glVertexAttribI4i");
}

void GL_APIENTRY glVertexAttribI4iv(GLuint index, const GLint* v)
{
	using PFN_glVertexAttribI4iv = void(GL_APIENTRY*)(GLuint index, const GLint* v);
	static PFN_glVertexAttribI4iv vertexAttribI4ivPtr = gl::internal::library().getProcAddress<PFN_glVertexAttribI4iv>("glVertexAttribI4iv");
	vertexAttribI4ivPtr(index, v);
	CHECK_GL_ERROR_ASSERT("glVertexAttribI4iv");
}

void GL_APIENTRY glVertexAttribI4ui(GLuint index, GLuint x, GLuint y, GLuint z, GLuint w)
{
	using PFN_glVertexAttribI4ui = void(GL_APIENTRY*)(GLuint index, GLuint x, GLuint y, GLuint z, GLuint w);
	static PFN_glVertexAttribI4ui vertexAttribI4uiPtr = gl::internal::library().getProcAddress<PFN_glVertexAttribI4ui>("glVertexAttribI4ui");
	vertexAttribI4uiPtr(index, x, y, z, w);
	CHECK_GL_ERROR_ASSERT("glVertexAttribI4ui");
}

void GL_APIENTRY glVertexAttribI4uiv(GLuint index, const GLuint* v)
{
	using PFN_glVertexAttribI4uiv = void(GL_APIENTRY*)(GLuint index, const GLuint* v);
	static PFN_glVertexAttribI4uiv vertexAttribI4uivPtr = gl::internal::library().getProcAddress<PFN_glVertexAttribI4uiv>("glVertexAttribI4uiv");
	vertexAttribI4uivPtr(index, v);
	CHECK_GL_ERROR_ASSERT("glVertexAttribI4uiv");
}

void GL_APIENTRY glVertexAttribIPointer(GLuint index, GLint size, GLenum type, GLsizei stride, const void* pointer)
{
	using PFN_glVertexAttribIPointer = void(GL_APIENTRY*)(GLuint index, GLint size, GLenum type, GLsizei stride, const void* pointer);
	static PFN_glVertexAttribIPointer vertexAttribIPointerPtr = gl::internal::library().getProcAddress<PFN_glVertexAttribIPointer>("glVertexAttribIPointer");
	vertexAttribIPointerPtr(index, size, type, stride, pointer);
	CHECK_GL_ERROR_ASSERT("glVertexAttribIPointer");
}

void GL_APIENTRY glWaitSync(GLsync sync, GLbitfield flags, GLuint64 timeout)
{
	using PFN_glWaitSync = void(GL_APIENTRY*)(GLsync sync, GLbitfield flags, GLuint64 timeout);
	static PFN_glWaitSync waitSyncPtr = gl::internal::library().getProcAddress<PFN_glWaitSync>("glWaitSync");
	waitSyncPtr(sync, flags, timeout);
	CHECK_GL_ERROR_ASSERT("glWaitSync");
}

// GL_ES_VERSION_3_1
void GL_APIENTRY glActiveShaderProgram(GLuint pipeline, GLuint program)
{
	using PFN_glActiveShaderProgram = void(GL_APIENTRY*)(GLuint pipeline, GLuint program);
	static PFN_glActiveShaderProgram activeShaderProgramPtr = gl::internal::library().getProcAddress<PFN_glActiveShaderProgram>("glActiveShaderProgram");
	activeShaderProgramPtr(pipeline, program);
	CHECK_GL_ERROR_ASSERT("glActiveShaderProgram");
}

void GL_APIENTRY glBindImageTexture(GLuint unit, GLuint texture, GLint level, GLboolean layered, GLint layer, GLenum access, GLenum format)
{
	using PFN_glBindImageTexture = void(GL_APIENTRY*)(GLuint unit, GLuint texture, GLint level, GLboolean layered, GLint layer, GLenum access, GLenum format);
	static PFN_glBindImageTexture bindImageTexturePtr = gl::internal::library().getProcAddress<PFN_glBindImageTexture>("glBindImageTexture");
	bindImageTexturePtr(unit, texture, level, layered, layer, access, format);
	CHECK_GL_ERROR_ASSERT("glBindImageTexture");
}

void GL_APIENTRY glBindProgramPipeline(GLuint pipeline)
{
	using PFN_glBindProgramPipeline = void(GL_APIENTRY*)(GLuint pipeline);
	static PFN_glBindProgramPipeline bindProgramPipelinePtr = gl::internal::library().getProcAddress<PFN_glBindProgramPipeline>("glBindProgramPipeline");
	bindProgramPipelinePtr(pipeline);
	CHECK_GL_ERROR_ASSERT("glBindProgramPipeline");
}

void GL_APIENTRY glBindVertexBuffer(GLuint bindingindex, GLuint buffer, GLintptr offset, GLsizei stride)
{
	using PFN_glBindVertexBuffer = void(GL_APIENTRY*)(GLuint bindingindex, GLuint buffer, GLintptr offset, GLsizei stride);
	static PFN_glBindVertexBuffer bindVertexBufferPtr = gl::internal::library().getProcAddress<PFN_glBindVertexBuffer>("glBindVertexBuffer");
	bindVertexBufferPtr(bindingindex, buffer, offset, stride);
	CHECK_GL_ERROR_ASSERT("glBindVertexBuffer");
}

GLuint GL_APIENTRY glCreateShaderProgramv(GLenum type, GLsizei count, const GLchar* const* strings)
{
	using PFN_glCreateShaderProgramv = GLuint(GL_APIENTRY*)(GLenum type, GLsizei count, const GLchar* const* strings);
	static PFN_glCreateShaderProgramv createShaderProgramvPtr = gl::internal::library().getProcAddress<PFN_glCreateShaderProgramv>("glCreateShaderProgramv");
	auto result = createShaderProgramvPtr(type, count, strings);
	CHECK_GL_ERROR_ASSERT("glCreateShaderProgramv");
	return result;
}

void GL_APIENTRY glDeleteProgramPipelines(GLsizei n, const GLuint* pipelines)
{
	using PFN_glDeleteProgramPipelines = void(GL_APIENTRY*)(GLsizei n, const GLuint* pipelines);
	static PFN_glDeleteProgramPipelines deleteProgramPipelinesPtr = gl::internal::library().getProcAddress<PFN_glDeleteProgramPipelines>("glDeleteProgramPipelines");
	deleteProgramPipelinesPtr(n, pipelines);
	CHECK_GL_ERROR_ASSERT("glDeleteProgramPipelines");
}

void GL_APIENTRY glDispatchCompute(GLuint num_groups_x, GLuint num_groups_y, GLuint num_groups_z)
{
	using PFN_glDispatchCompute = void(GL_APIENTRY*)(GLuint num_groups_x, GLuint num_groups_y, GLuint num_groups_z);
	static PFN_glDispatchCompute dispatchComputePtr = gl::internal::library().getProcAddress<PFN_glDispatchCompute>("glDispatchCompute");
	dispatchComputePtr(num_groups_x, num_groups_y, num_groups_z);
	CHECK_GL_ERROR_ASSERT("glDispatchCompute");
}

void GL_APIENTRY glDispatchComputeIndirect(GLintptr indirect)
{
	using PFN_glDispatchComputeIndirect = void(GL_APIENTRY*)(GLintptr indirect);
	static PFN_glDispatchComputeIndirect dispatchComputeIndirectPtr = gl::internal::library().getProcAddress<PFN_glDispatchComputeIndirect>("glDispatchComputeIndirect");
	dispatchComputeIndirectPtr(indirect);
	CHECK_GL_ERROR_ASSERT("glDispatchComputeIndirect");
}

void GL_APIENTRY glDrawArraysIndirect(GLenum mode, const void* indirect)
{
	using PFN_glDrawArraysIndirect = void(GL_APIENTRY*)(GLenum mode, const void* indirect);
	static PFN_glDrawArraysIndirect drawArraysIndirectPtr = gl::internal::library().getProcAddress<PFN_glDrawArraysIndirect>("glDrawArraysIndirect");
	drawArraysIndirectPtr(mode, indirect);
	CHECK_GL_ERROR_ASSERT("glDrawArraysIndirect");
}

void GL_APIENTRY glDrawElementsIndirect(GLenum mode, GLenum type, const void* indirect)
{
	using PFN_glDrawElementsIndirect = void(GL_APIENTRY*)(GLenum mode, GLenum type, const void* indirect);
	static PFN_glDrawElementsIndirect drawElementsIndirectPtr = gl::internal::library().getProcAddress<PFN_glDrawElementsIndirect>("glDrawElementsIndirect");
	drawElementsIndirectPtr(mode, type, indirect);
	CHECK_GL_ERROR_ASSERT("glDrawElementsIndirect");
}

void GL_APIENTRY glFramebufferParameteri(GLenum target, GLenum pname, GLint param)
{
	using PFN_glFramebufferParameteri = void(GL_APIENTRY*)(GLenum target, GLenum pname, GLint param);
	static PFN_glFramebufferParameteri framebufferParameteriPtr = gl::internal::library().getProcAddress<PFN_glFramebufferParameteri>("glFramebufferParameteri");
	framebufferParameteriPtr(target, pname, param);
	CHECK_GL_ERROR_ASSERT("glFramebufferParameteri");
}

void GL_APIENTRY glGenProgramPipelines(GLsizei n, GLuint* pipelines)
{
	using PFN_glGenProgramPipelines = void(GL_APIENTRY*)(GLsizei n, GLuint * pipelines);
	static PFN_glGenProgramPipelines genProgramPipelinesPtr = gl::internal::library().getProcAddress<PFN_glGenProgramPipelines>("glGenProgramPipelines");
	genProgramPipelinesPtr(n, pipelines);
	CHECK_GL_ERROR_ASSERT("glGenProgramPipelines");
}

void GL_APIENTRY glGetBooleani_v(GLenum target, GLuint index, GLboolean* data)
{
	using PFN_glGetBooleani_v = void(GL_APIENTRY*)(GLenum target, GLuint index, GLboolean * data);
	static PFN_glGetBooleani_v getBooleani_vPtr = gl::internal::library().getProcAddress<PFN_glGetBooleani_v>("glGetBooleani_v");
	getBooleani_vPtr(target, index, data);
	CHECK_GL_ERROR_ASSERT("glGetBooleani_v");
}

void GL_APIENTRY glGetFramebufferParameteriv(GLenum target, GLenum pname, GLint* params)
{
	using PFN_glGetFramebufferParameteriv = void(GL_APIENTRY*)(GLenum target, GLenum pname, GLint * params);
	static PFN_glGetFramebufferParameteriv getFramebufferParameterivPtr = gl::internal::library().getProcAddress<PFN_glGetFramebufferParameteriv>("glGetFramebufferParameteriv");
	getFramebufferParameterivPtr(target, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetFramebufferParameteriv");
}

void GL_APIENTRY glGetMultisamplefv(GLenum pname, GLuint index, GLfloat* val)
{
	using PFN_glGetMultisamplefv = void(GL_APIENTRY*)(GLenum pname, GLuint index, GLfloat * val);
	static PFN_glGetMultisamplefv getMultisamplefvPtr = gl::internal::library().getProcAddress<PFN_glGetMultisamplefv>("glGetMultisamplefv");
	getMultisamplefvPtr(pname, index, val);
	CHECK_GL_ERROR_ASSERT("glGetMultisamplefv");
}

void GL_APIENTRY glGetProgramInterfaceiv(GLuint program, GLenum programInterface, GLenum pname, GLint* params)
{
	using PFN_glGetProgramInterfaceiv = void(GL_APIENTRY*)(GLuint program, GLenum programInterface, GLenum pname, GLint * params);
	static PFN_glGetProgramInterfaceiv getProgramInterfaceivPtr = gl::internal::library().getProcAddress<PFN_glGetProgramInterfaceiv>("glGetProgramInterfaceiv");
	getProgramInterfaceivPtr(program, programInterface, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetProgramInterfaceiv");
}

void GL_APIENTRY glGetProgramPipelineInfoLog(GLuint pipeline, GLsizei bufSize, GLsizei* length, GLchar* infoLog)
{
	using PFN_glGetProgramPipelineInfoLog = void(GL_APIENTRY*)(GLuint pipeline, GLsizei bufSize, GLsizei * length, GLchar * infoLog);
	static PFN_glGetProgramPipelineInfoLog getProgramPipelineInfoLogPtr = gl::internal::library().getProcAddress<PFN_glGetProgramPipelineInfoLog>("glGetProgramPipelineInfoLog");
	getProgramPipelineInfoLogPtr(pipeline, bufSize, length, infoLog);
	CHECK_GL_ERROR_ASSERT("glGetProgramPipelineInfoLog");
}

void GL_APIENTRY glGetProgramPipelineiv(GLuint pipeline, GLenum pname, GLint* params)
{
	using PFN_glGetProgramPipelineiv = void(GL_APIENTRY*)(GLuint pipeline, GLenum pname, GLint * params);
	static PFN_glGetProgramPipelineiv getProgramPipelineivPtr = gl::internal::library().getProcAddress<PFN_glGetProgramPipelineiv>("glGetProgramPipelineiv");
	getProgramPipelineivPtr(pipeline, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetProgramPipelineiv");
}

GLuint GL_APIENTRY glGetProgramResourceIndex(GLuint program, GLenum programInterface, const GLchar* name)
{
	using PFN_glGetProgramResourceIndex = GLuint(GL_APIENTRY*)(GLuint program, GLenum programInterface, const GLchar* name);
	static PFN_glGetProgramResourceIndex getProgramResourceIndexPtr = gl::internal::library().getProcAddress<PFN_glGetProgramResourceIndex>("glGetProgramResourceIndex");
	auto result = getProgramResourceIndexPtr(program, programInterface, name);
	CHECK_GL_ERROR_ASSERT("glGetProgramResourceIndex");
	return result;
}

GLint GL_APIENTRY glGetProgramResourceLocation(GLuint program, GLenum programInterface, const GLchar* name)
{
	using PFN_glGetProgramResourceLocation = GLint(GL_APIENTRY*)(GLuint program, GLenum programInterface, const GLchar* name);
	static PFN_glGetProgramResourceLocation getProgramResourceLocationPtr = gl::internal::library().getProcAddress<PFN_glGetProgramResourceLocation>("glGetProgramResourceLocation");
	auto result = getProgramResourceLocationPtr(program, programInterface, name);
	CHECK_GL_ERROR_ASSERT("glGetProgramResourceLocation");
	return result;
}

void GL_APIENTRY glGetProgramResourceName(GLuint program, GLenum programInterface, GLuint index, GLsizei bufSize, GLsizei* length, GLchar* name)
{
	using PFN_glGetProgramResourceName = void(GL_APIENTRY*)(GLuint program, GLenum programInterface, GLuint index, GLsizei bufSize, GLsizei * length, GLchar * name);
	static PFN_glGetProgramResourceName getProgramResourceNamePtr = gl::internal::library().getProcAddress<PFN_glGetProgramResourceName>("glGetProgramResourceName");
	getProgramResourceNamePtr(program, programInterface, index, bufSize, length, name);
	CHECK_GL_ERROR_ASSERT("glGetProgramResourceName");
}

void GL_APIENTRY glGetProgramResourceiv(GLuint program, GLenum programInterface, GLuint index, GLsizei propCount, const GLenum* props, GLsizei bufSize, GLsizei* length, GLint* params)
{
	using PFN_glGetProgramResourceiv = void(GL_APIENTRY*)(GLuint program, GLenum programInterface, GLuint index, GLsizei propCount, const GLenum* props, GLsizei bufSize, GLsizei* length, GLint* params);
	static PFN_glGetProgramResourceiv getProgramResourceivPtr = gl::internal::library().getProcAddress<PFN_glGetProgramResourceiv>("glGetProgramResourceiv");
	getProgramResourceivPtr(program, programInterface, index, propCount, props, bufSize, length, params);
	CHECK_GL_ERROR_ASSERT("glGetProgramResourceiv");
}

void GL_APIENTRY glGetTexLevelParameterfv(GLenum target, GLint level, GLenum pname, GLfloat* params)
{
	using PFN_glGetTexLevelParameterfv = void(GL_APIENTRY*)(GLenum target, GLint level, GLenum pname, GLfloat * params);
	static PFN_glGetTexLevelParameterfv getTexLevelParameterfvPtr = gl::internal::library().getProcAddress<PFN_glGetTexLevelParameterfv>("glGetTexLevelParameterfv");
	getTexLevelParameterfvPtr(target, level, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetTexLevelParameterfv");
}

void GL_APIENTRY glGetTexLevelParameteriv(GLenum target, GLint level, GLenum pname, GLint* params)
{
	using PFN_glGetTexLevelParameteriv = void(GL_APIENTRY*)(GLenum target, GLint level, GLenum pname, GLint * params);
	static PFN_glGetTexLevelParameteriv getTexLevelParameterivPtr = gl::internal::library().getProcAddress<PFN_glGetTexLevelParameteriv>("glGetTexLevelParameteriv");
	getTexLevelParameterivPtr(target, level, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetTexLevelParameteriv");
}

GLboolean GL_APIENTRY glIsProgramPipeline(GLuint pipeline)
{
	using PFN_glIsProgramPipeline = GLboolean(GL_APIENTRY*)(GLuint pipeline);
	static PFN_glIsProgramPipeline isProgramPipelinePtr = gl::internal::library().getProcAddress<PFN_glIsProgramPipeline>("glIsProgramPipeline");
	auto result = isProgramPipelinePtr(pipeline);
	CHECK_GL_ERROR_ASSERT("glIsProgramPipeline");
	return result;
}

void GL_APIENTRY glMemoryBarrier(GLbitfield barriers)
{
	using PFN_glMemoryBarrier = void(GL_APIENTRY*)(GLbitfield barriers);
	static PFN_glMemoryBarrier memoryBarrierPtr = gl::internal::library().getProcAddress<PFN_glMemoryBarrier>("glMemoryBarrier");
	memoryBarrierPtr(barriers);
	CHECK_GL_ERROR_ASSERT("glMemoryBarrier");
}

void GL_APIENTRY glMemoryBarrierByRegion(GLbitfield barriers)
{
	using PFN_glMemoryBarrierByRegion = void(GL_APIENTRY*)(GLbitfield barriers);
	static PFN_glMemoryBarrierByRegion memoryBarrierByRegionPtr = gl::internal::library().getProcAddress<PFN_glMemoryBarrierByRegion>("glMemoryBarrierByRegion");
	memoryBarrierByRegionPtr(barriers);
	CHECK_GL_ERROR_ASSERT("glMemoryBarrierByRegion");
}

void GL_APIENTRY glProgramUniform1f(GLuint program, GLint location, GLfloat v0)
{
	using PFN_glProgramUniform1f = void(GL_APIENTRY*)(GLuint program, GLint location, GLfloat v0);
	static PFN_glProgramUniform1f programUniform1fPtr = gl::internal::library().getProcAddress<PFN_glProgramUniform1f>("glProgramUniform1f");
	programUniform1fPtr(program, location, v0);
	CHECK_GL_ERROR_ASSERT("glProgramUniform1f");
}

void GL_APIENTRY glProgramUniform1fv(GLuint program, GLint location, GLsizei count, const GLfloat* value)
{
	using PFN_glProgramUniform1fv = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLfloat* value);
	static PFN_glProgramUniform1fv programUniform1fvPtr = gl::internal::library().getProcAddress<PFN_glProgramUniform1fv>("glProgramUniform1fv");
	programUniform1fvPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform1fv");
}

void GL_APIENTRY glProgramUniform1i(GLuint program, GLint location, GLint v0)
{
	using PFN_glProgramUniform1i = void(GL_APIENTRY*)(GLuint program, GLint location, GLint v0);
	static PFN_glProgramUniform1i programUniform1iPtr = gl::internal::library().getProcAddress<PFN_glProgramUniform1i>("glProgramUniform1i");
	programUniform1iPtr(program, location, v0);
	CHECK_GL_ERROR_ASSERT("glProgramUniform1i");
}

void GL_APIENTRY glProgramUniform1iv(GLuint program, GLint location, GLsizei count, const GLint* value)
{
	using PFN_glProgramUniform1iv = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLint* value);
	static PFN_glProgramUniform1iv programUniform1ivPtr = gl::internal::library().getProcAddress<PFN_glProgramUniform1iv>("glProgramUniform1iv");
	programUniform1ivPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform1iv");
}

void GL_APIENTRY glProgramUniform1ui(GLuint program, GLint location, GLuint v0)
{
	using PFN_glProgramUniform1ui = void(GL_APIENTRY*)(GLuint program, GLint location, GLuint v0);
	static PFN_glProgramUniform1ui programUniform1uiPtr = gl::internal::library().getProcAddress<PFN_glProgramUniform1ui>("glProgramUniform1ui");
	programUniform1uiPtr(program, location, v0);
	CHECK_GL_ERROR_ASSERT("glProgramUniform1ui");
}

void GL_APIENTRY glProgramUniform1uiv(GLuint program, GLint location, GLsizei count, const GLuint* value)
{
	using PFN_glProgramUniform1uiv = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLuint* value);
	static PFN_glProgramUniform1uiv programUniform1uivPtr = gl::internal::library().getProcAddress<PFN_glProgramUniform1uiv>("glProgramUniform1uiv");
	programUniform1uivPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform1uiv");
}

void GL_APIENTRY glProgramUniform2f(GLuint program, GLint location, GLfloat v0, GLfloat v1)
{
	using PFN_glProgramUniform2f = void(GL_APIENTRY*)(GLuint program, GLint location, GLfloat v0, GLfloat v1);
	static PFN_glProgramUniform2f programUniform2fPtr = gl::internal::library().getProcAddress<PFN_glProgramUniform2f>("glProgramUniform2f");
	programUniform2fPtr(program, location, v0, v1);
	CHECK_GL_ERROR_ASSERT("glProgramUniform2f");
}

void GL_APIENTRY glProgramUniform2fv(GLuint program, GLint location, GLsizei count, const GLfloat* value)
{
	using PFN_glProgramUniform2fv = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLfloat* value);
	static PFN_glProgramUniform2fv programUniform2fvPtr = gl::internal::library().getProcAddress<PFN_glProgramUniform2fv>("glProgramUniform2fv");
	programUniform2fvPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform2fv");
}

void GL_APIENTRY glProgramUniform2i(GLuint program, GLint location, GLint v0, GLint v1)
{
	using PFN_glProgramUniform2i = void(GL_APIENTRY*)(GLuint program, GLint location, GLint v0, GLint v1);
	static PFN_glProgramUniform2i programUniform2iPtr = gl::internal::library().getProcAddress<PFN_glProgramUniform2i>("glProgramUniform2i");
	programUniform2iPtr(program, location, v0, v1);
	CHECK_GL_ERROR_ASSERT("glProgramUniform2i");
}

void GL_APIENTRY glProgramUniform2iv(GLuint program, GLint location, GLsizei count, const GLint* value)
{
	using PFN_glProgramUniform2iv = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLint* value);
	static PFN_glProgramUniform2iv programUniform2ivPtr = gl::internal::library().getProcAddress<PFN_glProgramUniform2iv>("glProgramUniform2iv");
	programUniform2ivPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform2iv");
}

void GL_APIENTRY glProgramUniform2ui(GLuint program, GLint location, GLuint v0, GLuint v1)
{
	using PFN_glProgramUniform2ui = void(GL_APIENTRY*)(GLuint program, GLint location, GLuint v0, GLuint v1);
	static PFN_glProgramUniform2ui programUniform2uiPtr = gl::internal::library().getProcAddress<PFN_glProgramUniform2ui>("glProgramUniform2ui");
	programUniform2uiPtr(program, location, v0, v1);
	CHECK_GL_ERROR_ASSERT("glProgramUniform2ui");
}

void GL_APIENTRY glProgramUniform2uiv(GLuint program, GLint location, GLsizei count, const GLuint* value)
{
	using PFN_glProgramUniform2uiv = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLuint* value);
	static PFN_glProgramUniform2uiv programUniform2uivPtr = gl::internal::library().getProcAddress<PFN_glProgramUniform2uiv>("glProgramUniform2uiv");
	programUniform2uivPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform2uiv");
}

void GL_APIENTRY glProgramUniform3f(GLuint program, GLint location, GLfloat v0, GLfloat v1, GLfloat v2)
{
	using PFN_glProgramUniform3f = void(GL_APIENTRY*)(GLuint program, GLint location, GLfloat v0, GLfloat v1, GLfloat v2);
	static PFN_glProgramUniform3f programUniform3fPtr = gl::internal::library().getProcAddress<PFN_glProgramUniform3f>("glProgramUniform3f");
	programUniform3fPtr(program, location, v0, v1, v2);
	CHECK_GL_ERROR_ASSERT("glProgramUniform3f");
}

void GL_APIENTRY glProgramUniform3fv(GLuint program, GLint location, GLsizei count, const GLfloat* value)
{
	using PFN_glProgramUniform3fv = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLfloat* value);
	static PFN_glProgramUniform3fv programUniform3fvPtr = gl::internal::library().getProcAddress<PFN_glProgramUniform3fv>("glProgramUniform3fv");
	programUniform3fvPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform3fv");
}

void GL_APIENTRY glProgramUniform3i(GLuint program, GLint location, GLint v0, GLint v1, GLint v2)
{
	using PFN_glProgramUniform3i = void(GL_APIENTRY*)(GLuint program, GLint location, GLint v0, GLint v1, GLint v2);
	static PFN_glProgramUniform3i programUniform3iPtr = gl::internal::library().getProcAddress<PFN_glProgramUniform3i>("glProgramUniform3i");
	programUniform3iPtr(program, location, v0, v1, v2);
	CHECK_GL_ERROR_ASSERT("glProgramUniform3i");
}

void GL_APIENTRY glProgramUniform3iv(GLuint program, GLint location, GLsizei count, const GLint* value)
{
	using PFN_glProgramUniform3iv = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLint* value);
	static PFN_glProgramUniform3iv programUniform3ivPtr = gl::internal::library().getProcAddress<PFN_glProgramUniform3iv>("glProgramUniform3iv");
	programUniform3ivPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform3iv");
}

void GL_APIENTRY glProgramUniform3ui(GLuint program, GLint location, GLuint v0, GLuint v1, GLuint v2)
{
	using PFN_glProgramUniform3ui = void(GL_APIENTRY*)(GLuint program, GLint location, GLuint v0, GLuint v1, GLuint v2);
	static PFN_glProgramUniform3ui programUniform3uiPtr = gl::internal::library().getProcAddress<PFN_glProgramUniform3ui>("glProgramUniform3ui");
	programUniform3uiPtr(program, location, v0, v1, v2);
	CHECK_GL_ERROR_ASSERT("glProgramUniform3ui");
}

void GL_APIENTRY glProgramUniform3uiv(GLuint program, GLint location, GLsizei count, const GLuint* value)
{
	using PFN_glProgramUniform3uiv = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLuint* value);
	static PFN_glProgramUniform3uiv programUniform3uivPtr = gl::internal::library().getProcAddress<PFN_glProgramUniform3uiv>("glProgramUniform3uiv");
	programUniform3uivPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform3uiv");
}

void GL_APIENTRY glProgramUniform4f(GLuint program, GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3)
{
	using PFN_glProgramUniform4f = void(GL_APIENTRY*)(GLuint program, GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3);
	static PFN_glProgramUniform4f programUniform4fPtr = gl::internal::library().getProcAddress<PFN_glProgramUniform4f>("glProgramUniform4f");
	programUniform4fPtr(program, location, v0, v1, v2, v3);
	CHECK_GL_ERROR_ASSERT("glProgramUniform4f");
}

void GL_APIENTRY glProgramUniform4fv(GLuint program, GLint location, GLsizei count, const GLfloat* value)
{
	using PFN_glProgramUniform4fv = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLfloat* value);
	static PFN_glProgramUniform4fv programUniform4fvPtr = gl::internal::library().getProcAddress<PFN_glProgramUniform4fv>("glProgramUniform4fv");
	programUniform4fvPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform4fv");
}

void GL_APIENTRY glProgramUniform4i(GLuint program, GLint location, GLint v0, GLint v1, GLint v2, GLint v3)
{
	using PFN_glProgramUniform4i = void(GL_APIENTRY*)(GLuint program, GLint location, GLint v0, GLint v1, GLint v2, GLint v3);
	static PFN_glProgramUniform4i programUniform4iPtr = gl::internal::library().getProcAddress<PFN_glProgramUniform4i>("glProgramUniform4i");
	programUniform4iPtr(program, location, v0, v1, v2, v3);
	CHECK_GL_ERROR_ASSERT("glProgramUniform4i");
}

void GL_APIENTRY glProgramUniform4iv(GLuint program, GLint location, GLsizei count, const GLint* value)
{
	using PFN_glProgramUniform4iv = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLint* value);
	static PFN_glProgramUniform4iv programUniform4ivPtr = gl::internal::library().getProcAddress<PFN_glProgramUniform4iv>("glProgramUniform4iv");
	programUniform4ivPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform4iv");
}

void GL_APIENTRY glProgramUniform4ui(GLuint program, GLint location, GLuint v0, GLuint v1, GLuint v2, GLuint v3)
{
	using PFN_glProgramUniform4ui = void(GL_APIENTRY*)(GLuint program, GLint location, GLuint v0, GLuint v1, GLuint v2, GLuint v3);
	static PFN_glProgramUniform4ui programUniform4uiPtr = gl::internal::library().getProcAddress<PFN_glProgramUniform4ui>("glProgramUniform4ui");
	programUniform4uiPtr(program, location, v0, v1, v2, v3);
	CHECK_GL_ERROR_ASSERT("glProgramUniform4ui");
}

void GL_APIENTRY glProgramUniform4uiv(GLuint program, GLint location, GLsizei count, const GLuint* value)
{
	using PFN_glProgramUniform4uiv = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLuint* value);
	static PFN_glProgramUniform4uiv programUniform4uivPtr = gl::internal::library().getProcAddress<PFN_glProgramUniform4uiv>("glProgramUniform4uiv");
	programUniform4uivPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform4uiv");
}

void GL_APIENTRY glProgramUniformMatrix2fv(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glProgramUniformMatrix2fv = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glProgramUniformMatrix2fv programUniformMatrix2fvPtr = gl::internal::library().getProcAddress<PFN_glProgramUniformMatrix2fv>("glProgramUniformMatrix2fv");
	programUniformMatrix2fvPtr(program, location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniformMatrix2fv");
}

void GL_APIENTRY glProgramUniformMatrix2x3fv(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glProgramUniformMatrix2x3fv = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glProgramUniformMatrix2x3fv programUniformMatrix2x3fvPtr = gl::internal::library().getProcAddress<PFN_glProgramUniformMatrix2x3fv>("glProgramUniformMatrix2x3fv");
	programUniformMatrix2x3fvPtr(program, location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniformMatrix2x3fv");
}

void GL_APIENTRY glProgramUniformMatrix2x4fv(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glProgramUniformMatrix2x4fv = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glProgramUniformMatrix2x4fv programUniformMatrix2x4fvPtr = gl::internal::library().getProcAddress<PFN_glProgramUniformMatrix2x4fv>("glProgramUniformMatrix2x4fv");
	programUniformMatrix2x4fvPtr(program, location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniformMatrix2x4fv");
}

void GL_APIENTRY glProgramUniformMatrix3fv(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glProgramUniformMatrix3fv = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glProgramUniformMatrix3fv programUniformMatrix3fvPtr = gl::internal::library().getProcAddress<PFN_glProgramUniformMatrix3fv>("glProgramUniformMatrix3fv");
	programUniformMatrix3fvPtr(program, location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniformMatrix3fv");
}

void GL_APIENTRY glProgramUniformMatrix3x2fv(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glProgramUniformMatrix3x2fv = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glProgramUniformMatrix3x2fv programUniformMatrix3x2fvPtr = gl::internal::library().getProcAddress<PFN_glProgramUniformMatrix3x2fv>("glProgramUniformMatrix3x2fv");
	programUniformMatrix3x2fvPtr(program, location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniformMatrix3x2fv");
}

void GL_APIENTRY glProgramUniformMatrix3x4fv(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glProgramUniformMatrix3x4fv = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glProgramUniformMatrix3x4fv programUniformMatrix3x4fvPtr = gl::internal::library().getProcAddress<PFN_glProgramUniformMatrix3x4fv>("glProgramUniformMatrix3x4fv");
	programUniformMatrix3x4fvPtr(program, location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniformMatrix3x4fv");
}

void GL_APIENTRY glProgramUniformMatrix4fv(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glProgramUniformMatrix4fv = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glProgramUniformMatrix4fv programUniformMatrix4fvPtr = gl::internal::library().getProcAddress<PFN_glProgramUniformMatrix4fv>("glProgramUniformMatrix4fv");
	programUniformMatrix4fvPtr(program, location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniformMatrix4fv");
}

void GL_APIENTRY glProgramUniformMatrix4x2fv(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glProgramUniformMatrix4x2fv = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glProgramUniformMatrix4x2fv programUniformMatrix4x2fvPtr = gl::internal::library().getProcAddress<PFN_glProgramUniformMatrix4x2fv>("glProgramUniformMatrix4x2fv");
	programUniformMatrix4x2fvPtr(program, location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniformMatrix4x2fv");
}

void GL_APIENTRY glProgramUniformMatrix4x3fv(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glProgramUniformMatrix4x3fv = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glProgramUniformMatrix4x3fv programUniformMatrix4x3fvPtr = gl::internal::library().getProcAddress<PFN_glProgramUniformMatrix4x3fv>("glProgramUniformMatrix4x3fv");
	programUniformMatrix4x3fvPtr(program, location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniformMatrix4x3fv");
}

void GL_APIENTRY glSampleMaski(GLuint maskNumber, GLbitfield mask)
{
	using PFN_glSampleMaski = void(GL_APIENTRY*)(GLuint maskNumber, GLbitfield mask);
	static PFN_glSampleMaski sampleMaskiPtr = gl::internal::library().getProcAddress<PFN_glSampleMaski>("glSampleMaski");
	sampleMaskiPtr(maskNumber, mask);
	CHECK_GL_ERROR_ASSERT("glSampleMaski");
}

void GL_APIENTRY glTexStorage2DMultisample(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height, GLboolean fixedsamplelocations)
{
	using PFN_glTexStorage2DMultisample = void(GL_APIENTRY*)(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height, GLboolean fixedsamplelocations);
	static PFN_glTexStorage2DMultisample texStorage2DMultisamplePtr = gl::internal::library().getProcAddress<PFN_glTexStorage2DMultisample>("glTexStorage2DMultisample");
	texStorage2DMultisamplePtr(target, samples, internalformat, width, height, fixedsamplelocations);
	CHECK_GL_ERROR_ASSERT("glTexStorage2DMultisample");
}

void GL_APIENTRY glUseProgramStages(GLuint pipeline, GLbitfield stages, GLuint program)
{
	using PFN_glUseProgramStages = void(GL_APIENTRY*)(GLuint pipeline, GLbitfield stages, GLuint program);
	static PFN_glUseProgramStages useProgramStagesPtr = gl::internal::library().getProcAddress<PFN_glUseProgramStages>("glUseProgramStages");
	useProgramStagesPtr(pipeline, stages, program);
	CHECK_GL_ERROR_ASSERT("glUseProgramStages");
}

void GL_APIENTRY glValidateProgramPipeline(GLuint pipeline)
{
	using PFN_glValidateProgramPipeline = void(GL_APIENTRY*)(GLuint pipeline);
	static PFN_glValidateProgramPipeline validateProgramPipelinePtr = gl::internal::library().getProcAddress<PFN_glValidateProgramPipeline>("glValidateProgramPipeline");
	validateProgramPipelinePtr(pipeline);
	CHECK_GL_ERROR_ASSERT("glValidateProgramPipeline");
}

void GL_APIENTRY glVertexAttribBinding(GLuint attribindex, GLuint bindingindex)
{
	using PFN_glVertexAttribBinding = void(GL_APIENTRY*)(GLuint attribindex, GLuint bindingindex);
	static PFN_glVertexAttribBinding vertexAttribBindingPtr = gl::internal::library().getProcAddress<PFN_glVertexAttribBinding>("glVertexAttribBinding");
	vertexAttribBindingPtr(attribindex, bindingindex);
	CHECK_GL_ERROR_ASSERT("glVertexAttribBinding");
}

void GL_APIENTRY glVertexAttribFormat(GLuint attribindex, GLint size, GLenum type, GLboolean normalized, GLuint relativeoffset)
{
	using PFN_glVertexAttribFormat = void(GL_APIENTRY*)(GLuint attribindex, GLint size, GLenum type, GLboolean normalized, GLuint relativeoffset);
	static PFN_glVertexAttribFormat vertexAttribFormatPtr = gl::internal::library().getProcAddress<PFN_glVertexAttribFormat>("glVertexAttribFormat");
	vertexAttribFormatPtr(attribindex, size, type, normalized, relativeoffset);
	CHECK_GL_ERROR_ASSERT("glVertexAttribFormat");
}

void GL_APIENTRY glVertexAttribIFormat(GLuint attribindex, GLint size, GLenum type, GLuint relativeoffset)
{
	using PFN_glVertexAttribIFormat = void(GL_APIENTRY*)(GLuint attribindex, GLint size, GLenum type, GLuint relativeoffset);
	static PFN_glVertexAttribIFormat vertexAttribIFormatPtr = gl::internal::library().getProcAddress<PFN_glVertexAttribIFormat>("glVertexAttribIFormat");
	vertexAttribIFormatPtr(attribindex, size, type, relativeoffset);
	CHECK_GL_ERROR_ASSERT("glVertexAttribIFormat");
}

void GL_APIENTRY glVertexBindingDivisor(GLuint bindingindex, GLuint divisor)
{
	using PFN_glVertexBindingDivisor = void(GL_APIENTRY*)(GLuint bindingindex, GLuint divisor);
	static PFN_glVertexBindingDivisor vertexBindingDivisorPtr = gl::internal::library().getProcAddress<PFN_glVertexBindingDivisor>("glVertexBindingDivisor");
	vertexBindingDivisorPtr(bindingindex, divisor);
	CHECK_GL_ERROR_ASSERT("glVertexBindingDivisor");
}

// GL_ES_VERSION_3_2
void GL_APIENTRY glBlendBarrier()
{
	using PFN_glBlendBarrier = void(GL_APIENTRY*)();
	static PFN_glBlendBarrier blendBarrierPtr = gl::internal::library().getProcAddress<PFN_glBlendBarrier>("glBlendBarrier");
	blendBarrierPtr();
	CHECK_GL_ERROR_ASSERT("glBlendBarrier");
}

void GL_APIENTRY glBlendEquationSeparatei(GLuint buf, GLenum modeRGB, GLenum modeAlpha)
{
	using PFN_glBlendEquationSeparatei = void(GL_APIENTRY*)(GLuint buf, GLenum modeRGB, GLenum modeAlpha);
	static PFN_glBlendEquationSeparatei blendEquationSeparateiPtr = gl::internal::library().getProcAddress<PFN_glBlendEquationSeparatei>("glBlendEquationSeparatei");
	blendEquationSeparateiPtr(buf, modeRGB, modeAlpha);
	CHECK_GL_ERROR_ASSERT("glBlendEquationSeparatei");
}

void GL_APIENTRY glBlendEquationi(GLuint buf, GLenum mode)
{
	using PFN_glBlendEquationi = void(GL_APIENTRY*)(GLuint buf, GLenum mode);
	static PFN_glBlendEquationi blendEquationiPtr = gl::internal::library().getProcAddress<PFN_glBlendEquationi>("glBlendEquationi");
	blendEquationiPtr(buf, mode);
	CHECK_GL_ERROR_ASSERT("glBlendEquationi");
}

void GL_APIENTRY glBlendFuncSeparatei(GLuint buf, GLenum srcRGB, GLenum dstRGB, GLenum srcAlpha, GLenum dstAlpha)
{
	using PFN_glBlendFuncSeparatei = void(GL_APIENTRY*)(GLuint buf, GLenum srcRGB, GLenum dstRGB, GLenum srcAlpha, GLenum dstAlpha);
	static PFN_glBlendFuncSeparatei blendFuncSeparateiPtr = gl::internal::library().getProcAddress<PFN_glBlendFuncSeparatei>("glBlendFuncSeparatei");
	blendFuncSeparateiPtr(buf, srcRGB, dstRGB, srcAlpha, dstAlpha);
	CHECK_GL_ERROR_ASSERT("glBlendFuncSeparatei");
}

void GL_APIENTRY glBlendFunci(GLuint buf, GLenum src, GLenum dst)
{
	using PFN_glBlendFunci = void(GL_APIENTRY*)(GLuint buf, GLenum src, GLenum dst);
	static PFN_glBlendFunci blendFunciPtr = gl::internal::library().getProcAddress<PFN_glBlendFunci>("glBlendFunci");
	blendFunciPtr(buf, src, dst);
	CHECK_GL_ERROR_ASSERT("glBlendFunci");
}

void GL_APIENTRY glColorMaski(GLuint index, GLboolean r, GLboolean g, GLboolean b, GLboolean a)
{
	using PFN_glColorMaski = void(GL_APIENTRY*)(GLuint index, GLboolean r, GLboolean g, GLboolean b, GLboolean a);
	static PFN_glColorMaski colorMaskiPtr = gl::internal::library().getProcAddress<PFN_glColorMaski>("glColorMaski");
	colorMaskiPtr(index, r, g, b, a);
	CHECK_GL_ERROR_ASSERT("glColorMaski");
}

void GL_APIENTRY glCopyImageSubData(GLuint srcName, GLenum srcTarget, GLint srcLevel, GLint srcX, GLint srcY, GLint srcZ, GLuint dstName, GLenum dstTarget, GLint dstLevel, GLint dstX, GLint dstY, GLint dstZ, GLsizei srcWidth, GLsizei srcHeight, GLsizei srcDepth)
{
	using PFN_glCopyImageSubData = void(GL_APIENTRY*)(GLuint srcName, GLenum srcTarget, GLint srcLevel, GLint srcX, GLint srcY, GLint srcZ, GLuint dstName, GLenum dstTarget, GLint dstLevel, GLint dstX, GLint dstY, GLint dstZ, GLsizei srcWidth, GLsizei srcHeight, GLsizei srcDepth);
	static PFN_glCopyImageSubData copyImageSubDataPtr = gl::internal::library().getProcAddress<PFN_glCopyImageSubData>("glCopyImageSubData");
	copyImageSubDataPtr(srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth);
	CHECK_GL_ERROR_ASSERT("glCopyImageSubData");
}

void GL_APIENTRY glDebugMessageCallback(GLDEBUGPROC callback, const void* userParam)
{
	using PFN_glDebugMessageCallback = void(GL_APIENTRY*)(GLDEBUGPROC callback, const void* userParam);
	static PFN_glDebugMessageCallback debugMessageCallbackPtr = gl::internal::library().getProcAddress<PFN_glDebugMessageCallback>("glDebugMessageCallback");
	debugMessageCallbackPtr(callback, userParam);
	CHECK_GL_ERROR_ASSERT("glDebugMessageCallback");
}

void GL_APIENTRY glDebugMessageControl(GLenum source, GLenum type, GLenum severity, GLsizei count, const GLuint* ids, GLboolean enabled)
{
	using PFN_glDebugMessageControl = void(GL_APIENTRY*)(GLenum source, GLenum type, GLenum severity, GLsizei count, const GLuint* ids, GLboolean enabled);
	static PFN_glDebugMessageControl debugMessageControlPtr = gl::internal::library().getProcAddress<PFN_glDebugMessageControl>("glDebugMessageControl");
	debugMessageControlPtr(source, type, severity, count, ids, enabled);
	CHECK_GL_ERROR_ASSERT("glDebugMessageControl");
}

void GL_APIENTRY glDebugMessageInsert(GLenum source, GLenum type, GLuint id, GLenum severity, GLsizei length, const GLchar* buf)
{
	using PFN_glDebugMessageInsert = void(GL_APIENTRY*)(GLenum source, GLenum type, GLuint id, GLenum severity, GLsizei length, const GLchar* buf);
	static PFN_glDebugMessageInsert debugMessageInsertPtr = gl::internal::library().getProcAddress<PFN_glDebugMessageInsert>("glDebugMessageInsert");
	debugMessageInsertPtr(source, type, id, severity, length, buf);
	CHECK_GL_ERROR_ASSERT("glDebugMessageInsert");
}

void GL_APIENTRY glDisablei(GLenum target, GLuint index)
{
	using PFN_glDisablei = void(GL_APIENTRY*)(GLenum target, GLuint index);
	static PFN_glDisablei disableiPtr = gl::internal::library().getProcAddress<PFN_glDisablei>("glDisablei");
	disableiPtr(target, index);
	CHECK_GL_ERROR_ASSERT("glDisablei");
}

void GL_APIENTRY glDrawElementsBaseVertex(GLenum mode, GLsizei count, GLenum type, const void* indices, GLint basevertex)
{
	using PFN_glDrawElementsBaseVertex = void(GL_APIENTRY*)(GLenum mode, GLsizei count, GLenum type, const void* indices, GLint basevertex);
	static PFN_glDrawElementsBaseVertex drawElementsBaseVertexPtr = gl::internal::library().getProcAddress<PFN_glDrawElementsBaseVertex>("glDrawElementsBaseVertex");
	drawElementsBaseVertexPtr(mode, count, type, indices, basevertex);
	CHECK_GL_ERROR_ASSERT("glDrawElementsBaseVertex");
}

void GL_APIENTRY glDrawElementsInstancedBaseVertex(GLenum mode, GLsizei count, GLenum type, const void* indices, GLsizei instancecount, GLint basevertex)
{
	using PFN_glDrawElementsInstancedBaseVertex = void(GL_APIENTRY*)(GLenum mode, GLsizei count, GLenum type, const void* indices, GLsizei instancecount, GLint basevertex);
	static PFN_glDrawElementsInstancedBaseVertex drawElementsInstancedBaseVertexPtr = gl::internal::library().getProcAddress<PFN_glDrawElementsInstancedBaseVertex>("glDrawElementsInstancedBaseVertex");
	drawElementsInstancedBaseVertexPtr(mode, count, type, indices, instancecount, basevertex);
	CHECK_GL_ERROR_ASSERT("glDrawElementsInstancedBaseVertex");
}

void GL_APIENTRY glDrawRangeElementsBaseVertex(GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const void* indices, GLint basevertex)
{
	using PFN_glDrawRangeElementsBaseVertex = void(GL_APIENTRY*)(GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const void* indices, GLint basevertex);
	static PFN_glDrawRangeElementsBaseVertex drawRangeElementsBaseVertexPtr = gl::internal::library().getProcAddress<PFN_glDrawRangeElementsBaseVertex>("glDrawRangeElementsBaseVertex");
	drawRangeElementsBaseVertexPtr(mode, start, end, count, type, indices, basevertex);
	CHECK_GL_ERROR_ASSERT("glDrawRangeElementsBaseVertex");
}

void GL_APIENTRY glEnablei(GLenum target, GLuint index)
{
	using PFN_glEnablei = void(GL_APIENTRY*)(GLenum target, GLuint index);
	static PFN_glEnablei enableiPtr = gl::internal::library().getProcAddress<PFN_glEnablei>("glEnablei");
	enableiPtr(target, index);
	CHECK_GL_ERROR_ASSERT("glEnablei");
}

void GL_APIENTRY glFramebufferTexture(GLenum target, GLenum attachment, GLuint texture, GLint level)
{
	using PFN_glFramebufferTexture = void(GL_APIENTRY*)(GLenum target, GLenum attachment, GLuint texture, GLint level);
	static PFN_glFramebufferTexture framebufferTexturePtr = gl::internal::library().getProcAddress<PFN_glFramebufferTexture>("glFramebufferTexture");
	framebufferTexturePtr(target, attachment, texture, level);
	CHECK_GL_ERROR_ASSERT("glFramebufferTexture");
}

GLuint GL_APIENTRY glGetDebugMessageLog(GLuint count, GLsizei bufSize, GLenum* sources, GLenum* types, GLuint* ids, GLenum* severities, GLsizei* lengths, GLchar* messageLog)
{
	using PFN_glGetDebugMessageLog = GLuint(GL_APIENTRY*)(GLuint count, GLsizei bufSize, GLenum * sources, GLenum * types, GLuint * ids, GLenum * severities, GLsizei * lengths, GLchar * messageLog);
	static PFN_glGetDebugMessageLog getDebugMessageLogPtr = gl::internal::library().getProcAddress<PFN_glGetDebugMessageLog>("glGetDebugMessageLog");
	auto result = getDebugMessageLogPtr(count, bufSize, sources, types, ids, severities, lengths, messageLog);
	CHECK_GL_ERROR_ASSERT("glGetDebugMessageLog");
	return result;
}

GLenum GL_APIENTRY glGetGraphicsResetStatus()
{
	using PFN_glGetGraphicsResetStatus = GLenum(GL_APIENTRY*)();
	static PFN_glGetGraphicsResetStatus getGraphicsResetStatusPtr = gl::internal::library().getProcAddress<PFN_glGetGraphicsResetStatus>("glGetGraphicsResetStatus");
	auto result = getGraphicsResetStatusPtr();
	CHECK_GL_ERROR_ASSERT("glGetGraphicsResetStatus");
	return result;
}

void GL_APIENTRY glGetObjectLabel(GLenum identifier, GLuint name, GLsizei bufSize, GLsizei* length, GLchar* label)
{
	using PFN_glGetObjectLabel = void(GL_APIENTRY*)(GLenum identifier, GLuint name, GLsizei bufSize, GLsizei * length, GLchar * label);
	static PFN_glGetObjectLabel getObjectLabelPtr = gl::internal::library().getProcAddress<PFN_glGetObjectLabel>("glGetObjectLabel");
	getObjectLabelPtr(identifier, name, bufSize, length, label);
	CHECK_GL_ERROR_ASSERT("glGetObjectLabel");
}

void GL_APIENTRY glGetObjectPtrLabel(const void* ptr, GLsizei bufSize, GLsizei* length, GLchar* label)
{
	using PFN_glGetObjectPtrLabel = void(GL_APIENTRY*)(const void* ptr, GLsizei bufSize, GLsizei* length, GLchar* label);
	static PFN_glGetObjectPtrLabel getObjectPtrLabelPtr = gl::internal::library().getProcAddress<PFN_glGetObjectPtrLabel>("glGetObjectPtrLabel");
	getObjectPtrLabelPtr(ptr, bufSize, length, label);
	CHECK_GL_ERROR_ASSERT("glGetObjectPtrLabel");
}

void GL_APIENTRY glGetPointerv(GLenum pname, void** params)
{
	using PFN_glGetPointerv = void(GL_APIENTRY*)(GLenum pname, void** params);
	static PFN_glGetPointerv getPointervPtr = gl::internal::library().getProcAddress<PFN_glGetPointerv>("glGetPointerv");
	getPointervPtr(pname, params);
	CHECK_GL_ERROR_ASSERT("glGetPointerv");
}

void GL_APIENTRY glGetSamplerParameterIiv(GLuint sampler, GLenum pname, GLint* params)
{
	using PFN_glGetSamplerParameterIiv = void(GL_APIENTRY*)(GLuint sampler, GLenum pname, GLint * params);
	static PFN_glGetSamplerParameterIiv getSamplerParameterIivPtr = gl::internal::library().getProcAddress<PFN_glGetSamplerParameterIiv>("glGetSamplerParameterIiv");
	getSamplerParameterIivPtr(sampler, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetSamplerParameterIiv");
}

void GL_APIENTRY glGetSamplerParameterIuiv(GLuint sampler, GLenum pname, GLuint* params)
{
	using PFN_glGetSamplerParameterIuiv = void(GL_APIENTRY*)(GLuint sampler, GLenum pname, GLuint * params);
	static PFN_glGetSamplerParameterIuiv getSamplerParameterIuivPtr = gl::internal::library().getProcAddress<PFN_glGetSamplerParameterIuiv>("glGetSamplerParameterIuiv");
	getSamplerParameterIuivPtr(sampler, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetSamplerParameterIuiv");
}

void GL_APIENTRY glGetTexParameterIiv(GLenum target, GLenum pname, GLint* params)
{
	using PFN_glGetTexParameterIiv = void(GL_APIENTRY*)(GLenum target, GLenum pname, GLint * params);
	static PFN_glGetTexParameterIiv getTexParameterIivPtr = gl::internal::library().getProcAddress<PFN_glGetTexParameterIiv>("glGetTexParameterIiv");
	getTexParameterIivPtr(target, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetTexParameterIiv");
}

void GL_APIENTRY glGetTexParameterIuiv(GLenum target, GLenum pname, GLuint* params)
{
	using PFN_glGetTexParameterIuiv = void(GL_APIENTRY*)(GLenum target, GLenum pname, GLuint * params);
	static PFN_glGetTexParameterIuiv getTexParameterIuivPtr = gl::internal::library().getProcAddress<PFN_glGetTexParameterIuiv>("glGetTexParameterIuiv");
	getTexParameterIuivPtr(target, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetTexParameterIuiv");
}

void GL_APIENTRY glGetnUniformfv(GLuint program, GLint location, GLsizei bufSize, GLfloat* params)
{
	using PFN_glGetnUniformfv = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei bufSize, GLfloat * params);
	static PFN_glGetnUniformfv getnUniformfvPtr = gl::internal::library().getProcAddress<PFN_glGetnUniformfv>("glGetnUniformfv");
	getnUniformfvPtr(program, location, bufSize, params);
	CHECK_GL_ERROR_ASSERT("glGetnUniformfv");
}

void GL_APIENTRY glGetnUniformiv(GLuint program, GLint location, GLsizei bufSize, GLint* params)
{
	using PFN_glGetnUniformiv = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei bufSize, GLint * params);
	static PFN_glGetnUniformiv getnUniformivPtr = gl::internal::library().getProcAddress<PFN_glGetnUniformiv>("glGetnUniformiv");
	getnUniformivPtr(program, location, bufSize, params);
	CHECK_GL_ERROR_ASSERT("glGetnUniformiv");
}

void GL_APIENTRY glGetnUniformuiv(GLuint program, GLint location, GLsizei bufSize, GLuint* params)
{
	using PFN_glGetnUniformuiv = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei bufSize, GLuint * params);
	static PFN_glGetnUniformuiv getnUniformuivPtr = gl::internal::library().getProcAddress<PFN_glGetnUniformuiv>("glGetnUniformuiv");
	getnUniformuivPtr(program, location, bufSize, params);
	CHECK_GL_ERROR_ASSERT("glGetnUniformuiv");
}

GLboolean GL_APIENTRY glIsEnabledi(GLenum target, GLuint index)
{
	using PFN_glIsEnabledi = GLboolean(GL_APIENTRY*)(GLenum target, GLuint index);
	static PFN_glIsEnabledi isEnablediPtr = gl::internal::library().getProcAddress<PFN_glIsEnabledi>("glIsEnabledi");
	auto result = isEnablediPtr(target, index);
	CHECK_GL_ERROR_ASSERT("glIsEnabledi");
	return result;
}

void GL_APIENTRY glMinSampleShading(GLfloat value)
{
	using PFN_glMinSampleShading = void(GL_APIENTRY*)(GLfloat value);
	static PFN_glMinSampleShading minSampleShadingPtr = gl::internal::library().getProcAddress<PFN_glMinSampleShading>("glMinSampleShading");
	minSampleShadingPtr(value);
	CHECK_GL_ERROR_ASSERT("glMinSampleShading");
}

void GL_APIENTRY glObjectLabel(GLenum identifier, GLuint name, GLsizei length, const GLchar* label)
{
	using PFN_glObjectLabel = void(GL_APIENTRY*)(GLenum identifier, GLuint name, GLsizei length, const GLchar* label);
	static PFN_glObjectLabel objectLabelPtr = gl::internal::library().getProcAddress<PFN_glObjectLabel>("glObjectLabel");
	objectLabelPtr(identifier, name, length, label);
	CHECK_GL_ERROR_ASSERT("glObjectLabel");
}

void GL_APIENTRY glObjectPtrLabel(const void* ptr, GLsizei length, const GLchar* label)
{
	using PFN_glObjectPtrLabel = void(GL_APIENTRY*)(const void* ptr, GLsizei length, const GLchar* label);
	static PFN_glObjectPtrLabel objectPtrLabelPtr = gl::internal::library().getProcAddress<PFN_glObjectPtrLabel>("glObjectPtrLabel");
	objectPtrLabelPtr(ptr, length, label);
	CHECK_GL_ERROR_ASSERT("glObjectPtrLabel");
}

void GL_APIENTRY glPatchParameteri(GLenum pname, GLint value)
{
	using PFN_glPatchParameteri = void(GL_APIENTRY*)(GLenum pname, GLint value);
	static PFN_glPatchParameteri patchParameteriPtr = gl::internal::library().getProcAddress<PFN_glPatchParameteri>("glPatchParameteri");
	patchParameteriPtr(pname, value);
	CHECK_GL_ERROR_ASSERT("glPatchParameteri");
}

void GL_APIENTRY glPopDebugGroup()
{
	using PFN_glPopDebugGroup = void(GL_APIENTRY*)();
	static PFN_glPopDebugGroup popDebugGroupPtr = gl::internal::library().getProcAddress<PFN_glPopDebugGroup>("glPopDebugGroup");
	popDebugGroupPtr();
	CHECK_GL_ERROR_ASSERT("glPopDebugGroup");
}

void GL_APIENTRY glPrimitiveBoundingBox(GLfloat minX, GLfloat minY, GLfloat minZ, GLfloat minW, GLfloat maxX, GLfloat maxY, GLfloat maxZ, GLfloat maxW)
{
	using PFN_glPrimitiveBoundingBox = void(GL_APIENTRY*)(GLfloat minX, GLfloat minY, GLfloat minZ, GLfloat minW, GLfloat maxX, GLfloat maxY, GLfloat maxZ, GLfloat maxW);
	static PFN_glPrimitiveBoundingBox primitiveBoundingBoxPtr = gl::internal::library().getProcAddress<PFN_glPrimitiveBoundingBox>("glPrimitiveBoundingBox");
	primitiveBoundingBoxPtr(minX, minY, minZ, minW, maxX, maxY, maxZ, maxW);
	CHECK_GL_ERROR_ASSERT("glPrimitiveBoundingBox");
}

void GL_APIENTRY glPushDebugGroup(GLenum source, GLuint id, GLsizei length, const GLchar* message)
{
	using PFN_glPushDebugGroup = void(GL_APIENTRY*)(GLenum source, GLuint id, GLsizei length, const GLchar* message);
	static PFN_glPushDebugGroup pushDebugGroupPtr = gl::internal::library().getProcAddress<PFN_glPushDebugGroup>("glPushDebugGroup");
	pushDebugGroupPtr(source, id, length, message);
	CHECK_GL_ERROR_ASSERT("glPushDebugGroup");
}

void GL_APIENTRY glReadnPixels(GLint x, GLint y, GLsizei width, GLsizei height, GLenum format, GLenum type, GLsizei bufSize, void* data)
{
	using PFN_glReadnPixels = void(GL_APIENTRY*)(GLint x, GLint y, GLsizei width, GLsizei height, GLenum format, GLenum type, GLsizei bufSize, void* data);
	static PFN_glReadnPixels readnPixelsPtr = gl::internal::library().getProcAddress<PFN_glReadnPixels>("glReadnPixels");
	readnPixelsPtr(x, y, width, height, format, type, bufSize, data);
	CHECK_GL_ERROR_ASSERT("glReadnPixels");
}

void GL_APIENTRY glSamplerParameterIiv(GLuint sampler, GLenum pname, const GLint* param)
{
	using PFN_glSamplerParameterIiv = void(GL_APIENTRY*)(GLuint sampler, GLenum pname, const GLint* param);
	static PFN_glSamplerParameterIiv samplerParameterIivPtr = gl::internal::library().getProcAddress<PFN_glSamplerParameterIiv>("glSamplerParameterIiv");
	samplerParameterIivPtr(sampler, pname, param);
	CHECK_GL_ERROR_ASSERT("glSamplerParameterIiv");
}

void GL_APIENTRY glSamplerParameterIuiv(GLuint sampler, GLenum pname, const GLuint* param)
{
	using PFN_glSamplerParameterIuiv = void(GL_APIENTRY*)(GLuint sampler, GLenum pname, const GLuint* param);
	static PFN_glSamplerParameterIuiv samplerParameterIuivPtr = gl::internal::library().getProcAddress<PFN_glSamplerParameterIuiv>("glSamplerParameterIuiv");
	samplerParameterIuivPtr(sampler, pname, param);
	CHECK_GL_ERROR_ASSERT("glSamplerParameterIuiv");
}

void GL_APIENTRY glTexBuffer(GLenum target, GLenum internalformat, GLuint buffer)
{
	using PFN_glTexBuffer = void(GL_APIENTRY*)(GLenum target, GLenum internalformat, GLuint buffer);
	static PFN_glTexBuffer texBufferPtr = gl::internal::library().getProcAddress<PFN_glTexBuffer>("glTexBuffer");
	texBufferPtr(target, internalformat, buffer);
	CHECK_GL_ERROR_ASSERT("glTexBuffer");
}

void GL_APIENTRY glTexBufferRange(GLenum target, GLenum internalformat, GLuint buffer, GLintptr offset, GLsizeiptr size)
{
	using PFN_glTexBufferRange = void(GL_APIENTRY*)(GLenum target, GLenum internalformat, GLuint buffer, GLintptr offset, GLsizeiptr size);
	static PFN_glTexBufferRange texBufferRangePtr = gl::internal::library().getProcAddress<PFN_glTexBufferRange>("glTexBufferRange");
	texBufferRangePtr(target, internalformat, buffer, offset, size);
	CHECK_GL_ERROR_ASSERT("glTexBufferRange");
}

void GL_APIENTRY glTexParameterIiv(GLenum target, GLenum pname, const GLint* params)
{
	using PFN_glTexParameterIiv = void(GL_APIENTRY*)(GLenum target, GLenum pname, const GLint* params);
	static PFN_glTexParameterIiv texParameterIivPtr = gl::internal::library().getProcAddress<PFN_glTexParameterIiv>("glTexParameterIiv");
	texParameterIivPtr(target, pname, params);
	CHECK_GL_ERROR_ASSERT("glTexParameterIiv");
}

void GL_APIENTRY glTexParameterIuiv(GLenum target, GLenum pname, const GLuint* params)
{
	using PFN_glTexParameterIuiv = void(GL_APIENTRY*)(GLenum target, GLenum pname, const GLuint* params);
	static PFN_glTexParameterIuiv texParameterIuivPtr = gl::internal::library().getProcAddress<PFN_glTexParameterIuiv>("glTexParameterIuiv");
	texParameterIuivPtr(target, pname, params);
	CHECK_GL_ERROR_ASSERT("glTexParameterIuiv");
}

void GL_APIENTRY glTexStorage3DMultisample(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLboolean fixedsamplelocations)
{
	using PFN_glTexStorage3DMultisample = void(GL_APIENTRY*)(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLboolean fixedsamplelocations);
	static PFN_glTexStorage3DMultisample texStorage3DMultisamplePtr = gl::internal::library().getProcAddress<PFN_glTexStorage3DMultisample>("glTexStorage3DMultisample");
	texStorage3DMultisamplePtr(target, samples, internalformat, width, height, depth, fixedsamplelocations);
	CHECK_GL_ERROR_ASSERT("glTexStorage3DMultisample");
}

// GL_AMD_performance_monitor
void GL_APIENTRY glBeginPerfMonitorAMD(GLuint monitor)
{
	using PFN_glBeginPerfMonitorAMD = void(GL_APIENTRY*)(GLuint monitor);
	static PFN_glBeginPerfMonitorAMD beginPerfMonitorAMDPtr = reinterpret_cast<PFN_glBeginPerfMonitorAMD>(eglGetProcAddress("glBeginPerfMonitorAMD"));
	beginPerfMonitorAMDPtr(monitor);
	CHECK_GL_ERROR_ASSERT("glBeginPerfMonitorAMD");
}

void GL_APIENTRY glDeletePerfMonitorsAMD(GLsizei n, GLuint* monitors)
{
	using PFN_glDeletePerfMonitorsAMD = void(GL_APIENTRY*)(GLsizei n, GLuint * monitors);
	static PFN_glDeletePerfMonitorsAMD deletePerfMonitorsAMDPtr = reinterpret_cast<PFN_glDeletePerfMonitorsAMD>(eglGetProcAddress("glDeletePerfMonitorsAMD"));
	deletePerfMonitorsAMDPtr(n, monitors);
	CHECK_GL_ERROR_ASSERT("glDeletePerfMonitorsAMD");
}

void GL_APIENTRY glEndPerfMonitorAMD(GLuint monitor)
{
	using PFN_glEndPerfMonitorAMD = void(GL_APIENTRY*)(GLuint monitor);
	static PFN_glEndPerfMonitorAMD endPerfMonitorAMDPtr = reinterpret_cast<PFN_glEndPerfMonitorAMD>(eglGetProcAddress("glEndPerfMonitorAMD"));
	endPerfMonitorAMDPtr(monitor);
	CHECK_GL_ERROR_ASSERT("glEndPerfMonitorAMD");
}

void GL_APIENTRY glGenPerfMonitorsAMD(GLsizei n, GLuint* monitors)
{
	using PFN_glGenPerfMonitorsAMD = void(GL_APIENTRY*)(GLsizei n, GLuint * monitors);
	static PFN_glGenPerfMonitorsAMD genPerfMonitorsAMDPtr = reinterpret_cast<PFN_glGenPerfMonitorsAMD>(eglGetProcAddress("glGenPerfMonitorsAMD"));
	genPerfMonitorsAMDPtr(n, monitors);
	CHECK_GL_ERROR_ASSERT("glGenPerfMonitorsAMD");
}

void GL_APIENTRY glGetPerfMonitorCounterDataAMD(GLuint monitor, GLenum pname, GLsizei dataSize, GLuint* data, GLint* bytesWritten)
{
	using PFN_glGetPerfMonitorCounterDataAMD = void(GL_APIENTRY*)(GLuint monitor, GLenum pname, GLsizei dataSize, GLuint * data, GLint * bytesWritten);
	static PFN_glGetPerfMonitorCounterDataAMD getPerfMonitorCounterDataAMDPtr = reinterpret_cast<PFN_glGetPerfMonitorCounterDataAMD>(eglGetProcAddress("glGetPerfMonitorCounterDataAMD"));
	getPerfMonitorCounterDataAMDPtr(monitor, pname, dataSize, data, bytesWritten);
	CHECK_GL_ERROR_ASSERT("glGetPerfMonitorCounterDataAMD");
}

void GL_APIENTRY glGetPerfMonitorCounterInfoAMD(GLuint group, GLuint counter, GLenum pname, void* data)
{
	using PFN_glGetPerfMonitorCounterInfoAMD = void(GL_APIENTRY*)(GLuint group, GLuint counter, GLenum pname, void* data);
	static PFN_glGetPerfMonitorCounterInfoAMD getPerfMonitorCounterInfoAMDPtr = reinterpret_cast<PFN_glGetPerfMonitorCounterInfoAMD>(eglGetProcAddress("glGetPerfMonitorCounterInfoAMD"));
	getPerfMonitorCounterInfoAMDPtr(group, counter, pname, data);
	CHECK_GL_ERROR_ASSERT("glGetPerfMonitorCounterInfoAMD");
}

void GL_APIENTRY glGetPerfMonitorCounterStringAMD(GLuint group, GLuint counter, GLsizei bufSize, GLsizei* length, GLchar* counterString)
{
	using PFN_glGetPerfMonitorCounterStringAMD = void(GL_APIENTRY*)(GLuint group, GLuint counter, GLsizei bufSize, GLsizei * length, GLchar * counterString);
	static PFN_glGetPerfMonitorCounterStringAMD getPerfMonitorCounterStringAMDPtr = reinterpret_cast<PFN_glGetPerfMonitorCounterStringAMD>(eglGetProcAddress("glGetPerfMonitorCounterStringAMD"));
	getPerfMonitorCounterStringAMDPtr(group, counter, bufSize, length, counterString);
	CHECK_GL_ERROR_ASSERT("glGetPerfMonitorCounterStringAMD");
}

void GL_APIENTRY glGetPerfMonitorCountersAMD(GLuint group, GLint* numCounters, GLint* maxActiveCounters, GLsizei counterSize, GLuint* counters)
{
	using PFN_glGetPerfMonitorCountersAMD = void(GL_APIENTRY*)(GLuint group, GLint * numCounters, GLint * maxActiveCounters, GLsizei counterSize, GLuint * counters);
	static PFN_glGetPerfMonitorCountersAMD getPerfMonitorCountersAMDPtr = reinterpret_cast<PFN_glGetPerfMonitorCountersAMD>(eglGetProcAddress("glGetPerfMonitorCountersAMD"));
	getPerfMonitorCountersAMDPtr(group, numCounters, maxActiveCounters, counterSize, counters);
	CHECK_GL_ERROR_ASSERT("glGetPerfMonitorCountersAMD");
}

void GL_APIENTRY glGetPerfMonitorGroupStringAMD(GLuint group, GLsizei bufSize, GLsizei* length, GLchar* groupString)
{
	using PFN_glGetPerfMonitorGroupStringAMD = void(GL_APIENTRY*)(GLuint group, GLsizei bufSize, GLsizei * length, GLchar * groupString);
	static PFN_glGetPerfMonitorGroupStringAMD getPerfMonitorGroupStringAMDPtr = reinterpret_cast<PFN_glGetPerfMonitorGroupStringAMD>(eglGetProcAddress("glGetPerfMonitorGroupStringAMD"));
	getPerfMonitorGroupStringAMDPtr(group, bufSize, length, groupString);
	CHECK_GL_ERROR_ASSERT("glGetPerfMonitorGroupStringAMD");
}

void GL_APIENTRY glGetPerfMonitorGroupsAMD(GLint* numGroups, GLsizei groupsSize, GLuint* groups)
{
	using PFN_glGetPerfMonitorGroupsAMD = void(GL_APIENTRY*)(GLint * numGroups, GLsizei groupsSize, GLuint * groups);
	static PFN_glGetPerfMonitorGroupsAMD getPerfMonitorGroupsAMDPtr = reinterpret_cast<PFN_glGetPerfMonitorGroupsAMD>(eglGetProcAddress("glGetPerfMonitorGroupsAMD"));
	getPerfMonitorGroupsAMDPtr(numGroups, groupsSize, groups);
	CHECK_GL_ERROR_ASSERT("glGetPerfMonitorGroupsAMD");
}

void GL_APIENTRY glSelectPerfMonitorCountersAMD(GLuint monitor, GLboolean enable, GLuint group, GLint numCounters, GLuint* counterList)
{
	using PFN_glSelectPerfMonitorCountersAMD = void(GL_APIENTRY*)(GLuint monitor, GLboolean enable, GLuint group, GLint numCounters, GLuint * counterList);
	static PFN_glSelectPerfMonitorCountersAMD selectPerfMonitorCountersAMDPtr = reinterpret_cast<PFN_glSelectPerfMonitorCountersAMD>(eglGetProcAddress("glSelectPerfMonitorCountersAMD"));
	selectPerfMonitorCountersAMDPtr(monitor, enable, group, numCounters, counterList);
	CHECK_GL_ERROR_ASSERT("glSelectPerfMonitorCountersAMD");
}

// GL_ANGLE_framebuffer_blit
void GL_APIENTRY glBlitFramebufferANGLE(GLint srcX0, GLint srcY0, GLint srcX1, GLint srcY1, GLint dstX0, GLint dstY0, GLint dstX1, GLint dstY1, GLbitfield mask, GLenum filter)
{
	using PFN_glBlitFramebufferANGLE = void(GL_APIENTRY*)(GLint srcX0, GLint srcY0, GLint srcX1, GLint srcY1, GLint dstX0, GLint dstY0, GLint dstX1, GLint dstY1, GLbitfield mask, GLenum filter);
	static PFN_glBlitFramebufferANGLE blitFramebufferANGLEPtr = reinterpret_cast<PFN_glBlitFramebufferANGLE>(eglGetProcAddress("glBlitFramebufferANGLE"));
	blitFramebufferANGLEPtr(srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
	CHECK_GL_ERROR_ASSERT("glBlitFramebufferANGLE");
}

// GL_ANGLE_framebuffer_multisample
void GL_APIENTRY glRenderbufferStorageMultisampleANGLE(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height)
{
	using PFN_glRenderbufferStorageMultisampleANGLE = void(GL_APIENTRY*)(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height);
	static PFN_glRenderbufferStorageMultisampleANGLE renderbufferStorageMultisampleANGLEPtr = reinterpret_cast<PFN_glRenderbufferStorageMultisampleANGLE>(eglGetProcAddress("glRenderbufferStorageMultisampleANGLE"));
	renderbufferStorageMultisampleANGLEPtr(target, samples, internalformat, width, height);
	CHECK_GL_ERROR_ASSERT("glRenderbufferStorageMultisampleANGLE");
}

// GL_ANGLE_instanced_arrays
void GL_APIENTRY glDrawArraysInstancedANGLE(GLenum mode, GLint first, GLsizei count, GLsizei primcount)
{
	using PFN_glDrawArraysInstancedANGLE = void(GL_APIENTRY*)(GLenum mode, GLint first, GLsizei count, GLsizei primcount);
	static PFN_glDrawArraysInstancedANGLE drawArraysInstancedANGLEPtr = reinterpret_cast<PFN_glDrawArraysInstancedANGLE>(eglGetProcAddress("glDrawArraysInstancedANGLE"));
	drawArraysInstancedANGLEPtr(mode, first, count, primcount);
	CHECK_GL_ERROR_ASSERT("glDrawArraysInstancedANGLE");
}

void GL_APIENTRY glDrawElementsInstancedANGLE(GLenum mode, GLsizei count, GLenum type, const void* indices, GLsizei primcount)
{
	using PFN_glDrawElementsInstancedANGLE = void(GL_APIENTRY*)(GLenum mode, GLsizei count, GLenum type, const void* indices, GLsizei primcount);
	static PFN_glDrawElementsInstancedANGLE drawElementsInstancedANGLEPtr = reinterpret_cast<PFN_glDrawElementsInstancedANGLE>(eglGetProcAddress("glDrawElementsInstancedANGLE"));
	drawElementsInstancedANGLEPtr(mode, count, type, indices, primcount);
	CHECK_GL_ERROR_ASSERT("glDrawElementsInstancedANGLE");
}

void GL_APIENTRY glVertexAttribDivisorANGLE(GLuint index, GLuint divisor)
{
	using PFN_glVertexAttribDivisorANGLE = void(GL_APIENTRY*)(GLuint index, GLuint divisor);
	static PFN_glVertexAttribDivisorANGLE vertexAttribDivisorANGLEPtr = reinterpret_cast<PFN_glVertexAttribDivisorANGLE>(eglGetProcAddress("glVertexAttribDivisorANGLE"));
	vertexAttribDivisorANGLEPtr(index, divisor);
	CHECK_GL_ERROR_ASSERT("glVertexAttribDivisorANGLE");
}

// GL_ANGLE_translated_shader_source
void GL_APIENTRY glGetTranslatedShaderSourceANGLE(GLuint shader, GLsizei bufsize, GLsizei* length, GLchar* source)
{
	using PFN_glGetTranslatedShaderSourceANGLE = void(GL_APIENTRY*)(GLuint shader, GLsizei bufsize, GLsizei * length, GLchar * source);
	static PFN_glGetTranslatedShaderSourceANGLE getTranslatedShaderSourceANGLEPtr = reinterpret_cast<PFN_glGetTranslatedShaderSourceANGLE>(eglGetProcAddress("glGetTranslatedShaderSourceANGLE"));
	getTranslatedShaderSourceANGLEPtr(shader, bufsize, length, source);
	CHECK_GL_ERROR_ASSERT("glGetTranslatedShaderSourceANGLE");
}

// GL_APPLE_copy_texture_levels
void GL_APIENTRY glCopyTextureLevelsAPPLE(GLuint destinationTexture, GLuint sourceTexture, GLint sourceBaseLevel, GLsizei sourceLevelCount)
{
	using PFN_glCopyTextureLevelsAPPLE = void(GL_APIENTRY*)(GLuint destinationTexture, GLuint sourceTexture, GLint sourceBaseLevel, GLsizei sourceLevelCount);
	static PFN_glCopyTextureLevelsAPPLE copyTextureLevelsAPPLEPtr = reinterpret_cast<PFN_glCopyTextureLevelsAPPLE>(eglGetProcAddress("glCopyTextureLevelsAPPLE"));
	copyTextureLevelsAPPLEPtr(destinationTexture, sourceTexture, sourceBaseLevel, sourceLevelCount);
	CHECK_GL_ERROR_ASSERT("glCopyTextureLevelsAPPLE");
}

// GL_APPLE_framebuffer_multisample
void GL_APIENTRY glRenderbufferStorageMultisampleAPPLE(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height)
{
	using PFN_glRenderbufferStorageMultisampleAPPLE = void(GL_APIENTRY*)(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height);
	static PFN_glRenderbufferStorageMultisampleAPPLE renderbufferStorageMultisampleAPPLEPtr = reinterpret_cast<PFN_glRenderbufferStorageMultisampleAPPLE>(eglGetProcAddress("glRenderbufferStorageMultisampleAPPLE"));
	renderbufferStorageMultisampleAPPLEPtr(target, samples, internalformat, width, height);
	CHECK_GL_ERROR_ASSERT("glRenderbufferStorageMultisampleAPPLE");
}

void GL_APIENTRY glResolveMultisampleFramebufferAPPLE()
{
	using PFN_glResolveMultisampleFramebufferAPPLE = void(GL_APIENTRY*)();
	static PFN_glResolveMultisampleFramebufferAPPLE resolveMultisampleFramebufferAPPLEPtr = reinterpret_cast<PFN_glResolveMultisampleFramebufferAPPLE>(eglGetProcAddress("glResolveMultisampleFramebufferAPPLE"));
	resolveMultisampleFramebufferAPPLEPtr();
	CHECK_GL_ERROR_ASSERT("glResolveMultisampleFramebufferAPPLE");
}

// GL_APPLE_sync
GLenum GL_APIENTRY glClientWaitSyncAPPLE(GLsync sync, GLbitfield flags, GLuint64 timeout)
{
	using PFN_glClientWaitSyncAPPLE = GLenum(GL_APIENTRY*)(GLsync sync, GLbitfield flags, GLuint64 timeout);
	static PFN_glClientWaitSyncAPPLE clientWaitSyncAPPLEPtr = reinterpret_cast<PFN_glClientWaitSyncAPPLE>(eglGetProcAddress("glClientWaitSyncAPPLE"));
	auto result = clientWaitSyncAPPLEPtr(sync, flags, timeout);
	CHECK_GL_ERROR_ASSERT("glClientWaitSyncAPPLE");
	return result;
}

void GL_APIENTRY glDeleteSyncAPPLE(GLsync sync)
{
	using PFN_glDeleteSyncAPPLE = void(GL_APIENTRY*)(GLsync sync);
	static PFN_glDeleteSyncAPPLE deleteSyncAPPLEPtr = reinterpret_cast<PFN_glDeleteSyncAPPLE>(eglGetProcAddress("glDeleteSyncAPPLE"));
	deleteSyncAPPLEPtr(sync);
	CHECK_GL_ERROR_ASSERT("glDeleteSyncAPPLE");
}

GLsync GL_APIENTRY glFenceSyncAPPLE(GLenum condition, GLbitfield flags)
{
	using PFN_glFenceSyncAPPLE = GLsync(GL_APIENTRY*)(GLenum condition, GLbitfield flags);
	static PFN_glFenceSyncAPPLE fenceSyncAPPLEPtr = reinterpret_cast<PFN_glFenceSyncAPPLE>(eglGetProcAddress("glFenceSyncAPPLE"));
	auto result = fenceSyncAPPLEPtr(condition, flags);
	CHECK_GL_ERROR_ASSERT("glFenceSyncAPPLE");
	return result;
}

void GL_APIENTRY glGetInteger64vAPPLE(GLenum pname, GLint64* params)
{
	using PFN_glGetInteger64vAPPLE = void(GL_APIENTRY*)(GLenum pname, GLint64 * params);
	static PFN_glGetInteger64vAPPLE getInteger64vAPPLEPtr = reinterpret_cast<PFN_glGetInteger64vAPPLE>(eglGetProcAddress("glGetInteger64vAPPLE"));
	getInteger64vAPPLEPtr(pname, params);
	CHECK_GL_ERROR_ASSERT("glGetInteger64vAPPLE");
}

void GL_APIENTRY glGetSyncivAPPLE(GLsync sync, GLenum pname, GLsizei bufSize, GLsizei* length, GLint* values)
{
	using PFN_glGetSyncivAPPLE = void(GL_APIENTRY*)(GLsync sync, GLenum pname, GLsizei bufSize, GLsizei * length, GLint * values);
	static PFN_glGetSyncivAPPLE getSyncivAPPLEPtr = reinterpret_cast<PFN_glGetSyncivAPPLE>(eglGetProcAddress("glGetSyncivAPPLE"));
	getSyncivAPPLEPtr(sync, pname, bufSize, length, values);
	CHECK_GL_ERROR_ASSERT("glGetSyncivAPPLE");
}

GLboolean GL_APIENTRY glIsSyncAPPLE(GLsync sync)
{
	using PFN_glIsSyncAPPLE = GLboolean(GL_APIENTRY*)(GLsync sync);
	static PFN_glIsSyncAPPLE isSyncAPPLEPtr = reinterpret_cast<PFN_glIsSyncAPPLE>(eglGetProcAddress("glIsSyncAPPLE"));
	auto result = isSyncAPPLEPtr(sync);
	CHECK_GL_ERROR_ASSERT("glIsSyncAPPLE");
	return result;
}

void GL_APIENTRY glWaitSyncAPPLE(GLsync sync, GLbitfield flags, GLuint64 timeout)
{
	using PFN_glWaitSyncAPPLE = void(GL_APIENTRY*)(GLsync sync, GLbitfield flags, GLuint64 timeout);
	static PFN_glWaitSyncAPPLE waitSyncAPPLEPtr = reinterpret_cast<PFN_glWaitSyncAPPLE>(eglGetProcAddress("glWaitSyncAPPLE"));
	waitSyncAPPLEPtr(sync, flags, timeout);
	CHECK_GL_ERROR_ASSERT("glWaitSyncAPPLE");
}

// GL_EXT_base_instance
void GL_APIENTRY glDrawArraysInstancedBaseInstanceEXT(GLenum mode, GLint first, GLsizei count, GLsizei instancecount, GLuint baseinstance)
{
	using PFN_glDrawArraysInstancedBaseInstanceEXT = void(GL_APIENTRY*)(GLenum mode, GLint first, GLsizei count, GLsizei instancecount, GLuint baseinstance);
	static PFN_glDrawArraysInstancedBaseInstanceEXT drawArraysInstancedBaseInstanceEXTPtr = reinterpret_cast<PFN_glDrawArraysInstancedBaseInstanceEXT>(eglGetProcAddress("glDrawArraysInstancedBaseInstanceEXT"));
	drawArraysInstancedBaseInstanceEXTPtr(mode, first, count, instancecount, baseinstance);
	CHECK_GL_ERROR_ASSERT("glDrawArraysInstancedBaseInstanceEXT");
}

void GL_APIENTRY glDrawElementsInstancedBaseInstanceEXT(GLenum mode, GLsizei count, GLenum type, const void* indices, GLsizei instancecount, GLuint baseinstance)
{
	using PFN_glDrawElementsInstancedBaseInstanceEXT = void(GL_APIENTRY*)(GLenum mode, GLsizei count, GLenum type, const void* indices, GLsizei instancecount, GLuint baseinstance);
	static PFN_glDrawElementsInstancedBaseInstanceEXT drawElementsInstancedBaseInstanceEXTPtr = reinterpret_cast<PFN_glDrawElementsInstancedBaseInstanceEXT>(eglGetProcAddress("glDrawElementsInstancedBaseInstanceEXT"));
	drawElementsInstancedBaseInstanceEXTPtr(mode, count, type, indices, instancecount, baseinstance);
	CHECK_GL_ERROR_ASSERT("glDrawElementsInstancedBaseInstanceEXT");
}

void GL_APIENTRY glDrawElementsInstancedBaseVertexBaseInstanceEXT(GLenum mode, GLsizei count, GLenum type, const void* indices, GLsizei instancecount, GLint basevertex, GLuint baseinstance)
{
	using PFN_glDrawElementsInstancedBaseVertexBaseInstanceEXT = void(GL_APIENTRY*)(GLenum mode, GLsizei count, GLenum type, const void* indices, GLsizei instancecount, GLint basevertex, GLuint baseinstance);
	static PFN_glDrawElementsInstancedBaseVertexBaseInstanceEXT drawElementsInstancedBaseVertexBaseInstanceEXTPtr = reinterpret_cast<PFN_glDrawElementsInstancedBaseVertexBaseInstanceEXT>(eglGetProcAddress("glDrawElementsInstancedBaseVertexBaseInstanceEXT"));
	drawElementsInstancedBaseVertexBaseInstanceEXTPtr(mode, count, type, indices, instancecount, basevertex, baseinstance);
	CHECK_GL_ERROR_ASSERT("glDrawElementsInstancedBaseVertexBaseInstanceEXT");
}

// GL_EXT_blend_func_extended
void GL_APIENTRY glBindFragDataLocationEXT(GLuint program, GLuint color, const GLchar* name)
{
	using PFN_glBindFragDataLocationEXT = void(GL_APIENTRY*)(GLuint program, GLuint color, const GLchar* name);
	static PFN_glBindFragDataLocationEXT bindFragDataLocationEXTPtr = reinterpret_cast<PFN_glBindFragDataLocationEXT>(eglGetProcAddress("glBindFragDataLocationEXT"));
	bindFragDataLocationEXTPtr(program, color, name);
	CHECK_GL_ERROR_ASSERT("glBindFragDataLocationEXT");
}

void GL_APIENTRY glBindFragDataLocationIndexedEXT(GLuint program, GLuint colorNumber, GLuint index, const GLchar* name)
{
	using PFN_glBindFragDataLocationIndexedEXT = void(GL_APIENTRY*)(GLuint program, GLuint colorNumber, GLuint index, const GLchar* name);
	static PFN_glBindFragDataLocationIndexedEXT bindFragDataLocationIndexedEXTPtr = reinterpret_cast<PFN_glBindFragDataLocationIndexedEXT>(eglGetProcAddress("glBindFragDataLocationIndexedEXT"));
	bindFragDataLocationIndexedEXTPtr(program, colorNumber, index, name);
	CHECK_GL_ERROR_ASSERT("glBindFragDataLocationIndexedEXT");
}

GLint GL_APIENTRY glGetFragDataIndexEXT(GLuint program, const GLchar* name)
{
	using PFN_glGetFragDataIndexEXT = GLint(GL_APIENTRY*)(GLuint program, const GLchar* name);
	static PFN_glGetFragDataIndexEXT getFragDataIndexEXTPtr = reinterpret_cast<PFN_glGetFragDataIndexEXT>(eglGetProcAddress("glGetFragDataIndexEXT"));
	auto result = getFragDataIndexEXTPtr(program, name);
	CHECK_GL_ERROR_ASSERT("glGetFragDataIndexEXT");
	return result;
}

GLint GL_APIENTRY glGetProgramResourceLocationIndexEXT(GLuint program, GLenum programInterface, const GLchar* name)
{
	using PFN_glGetProgramResourceLocationIndexEXT = GLint(GL_APIENTRY*)(GLuint program, GLenum programInterface, const GLchar* name);
	static PFN_glGetProgramResourceLocationIndexEXT getProgramResourceLocationIndexEXTPtr = reinterpret_cast<PFN_glGetProgramResourceLocationIndexEXT>(eglGetProcAddress("glGetProgramResourceLocationIndexEXT"));
	auto result = getProgramResourceLocationIndexEXTPtr(program, programInterface, name);
	CHECK_GL_ERROR_ASSERT("glGetProgramResourceLocationIndexEXT");
	return result;
}

// GL_EXT_buffer_storage
void GL_APIENTRY glBufferStorageEXT(GLenum target, GLsizeiptr size, const void* data, GLbitfield flags)
{
	using PFN_glBufferStorageEXT = void(GL_APIENTRY*)(GLenum target, GLsizeiptr size, const void* data, GLbitfield flags);
	static PFN_glBufferStorageEXT bufferStorageEXTPtr = reinterpret_cast<PFN_glBufferStorageEXT>(eglGetProcAddress("glBufferStorageEXT"));
	bufferStorageEXTPtr(target, size, data, flags);
	CHECK_GL_ERROR_ASSERT("glBufferStorageEXT");
}

// GL_EXT_clear_texture
void GL_APIENTRY glClearTexImageEXT(GLuint texture, GLint level, GLenum format, GLenum type, const void* data)
{
	using PFN_glClearTexImageEXT = void(GL_APIENTRY*)(GLuint texture, GLint level, GLenum format, GLenum type, const void* data);
	static PFN_glClearTexImageEXT clearTexImageEXTPtr = reinterpret_cast<PFN_glClearTexImageEXT>(eglGetProcAddress("glClearTexImageEXT"));
	clearTexImageEXTPtr(texture, level, format, type, data);
	CHECK_GL_ERROR_ASSERT("glClearTexImageEXT");
}

void GL_APIENTRY glClearTexSubImageEXT(GLuint texture, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const void* data)
{
	using PFN_glClearTexSubImageEXT = void(GL_APIENTRY*)(GLuint texture, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const void* data);
	static PFN_glClearTexSubImageEXT clearTexSubImageEXTPtr = reinterpret_cast<PFN_glClearTexSubImageEXT>(eglGetProcAddress("glClearTexSubImageEXT"));
	clearTexSubImageEXTPtr(texture, level, xoffset, yoffset, zoffset, width, height, depth, format, type, data);
	CHECK_GL_ERROR_ASSERT("glClearTexSubImageEXT");
}

// GL_EXT_clip_control
void GL_APIENTRY glClipControlEXT(GLenum origin, GLenum depth)
{
	using PFN_glClipControlEXT = void(GL_APIENTRY*)(GLenum origin, GLenum depth);
	static PFN_glClipControlEXT clipControlEXTPtr = reinterpret_cast<PFN_glClipControlEXT>(eglGetProcAddress("glClipControlEXT"));
	clipControlEXTPtr(origin, depth);
	CHECK_GL_ERROR_ASSERT("glClipControlEXT");
}

// GL_EXT_copy_image
void GL_APIENTRY glCopyImageSubDataEXT(GLuint srcName, GLenum srcTarget, GLint srcLevel, GLint srcX, GLint srcY, GLint srcZ, GLuint dstName, GLenum dstTarget, GLint dstLevel, GLint dstX, GLint dstY, GLint dstZ, GLsizei srcWidth, GLsizei srcHeight, GLsizei srcDepth)
{
	using PFN_glCopyImageSubDataEXT = void(GL_APIENTRY*)(GLuint srcName, GLenum srcTarget, GLint srcLevel, GLint srcX, GLint srcY, GLint srcZ, GLuint dstName, GLenum dstTarget, GLint dstLevel, GLint dstX, GLint dstY, GLint dstZ, GLsizei srcWidth, GLsizei srcHeight, GLsizei srcDepth);
	static PFN_glCopyImageSubDataEXT copyImageSubDataEXTPtr = reinterpret_cast<PFN_glCopyImageSubDataEXT>(eglGetProcAddress("glCopyImageSubDataEXT"));
	copyImageSubDataEXTPtr(srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth);
	CHECK_GL_ERROR_ASSERT("glCopyImageSubDataEXT");
}

// GL_EXT_debug_label
void GL_APIENTRY glGetObjectLabelEXT(GLenum type, GLuint object, GLsizei bufSize, GLsizei* length, GLchar* label)
{
	using PFN_glGetObjectLabelEXT = void(GL_APIENTRY*)(GLenum type, GLuint object, GLsizei bufSize, GLsizei * length, GLchar * label);
	static PFN_glGetObjectLabelEXT getObjectLabelEXTPtr = reinterpret_cast<PFN_glGetObjectLabelEXT>(eglGetProcAddress("glGetObjectLabelEXT"));
	getObjectLabelEXTPtr(type, object, bufSize, length, label);
	CHECK_GL_ERROR_ASSERT("glGetObjectLabelEXT");
}

void GL_APIENTRY glLabelObjectEXT(GLenum type, GLuint object, GLsizei length, const GLchar* label)
{
	using PFN_glLabelObjectEXT = void(GL_APIENTRY*)(GLenum type, GLuint object, GLsizei length, const GLchar* label);
	static PFN_glLabelObjectEXT labelObjectEXTPtr = reinterpret_cast<PFN_glLabelObjectEXT>(eglGetProcAddress("glLabelObjectEXT"));
	labelObjectEXTPtr(type, object, length, label);
	CHECK_GL_ERROR_ASSERT("glLabelObjectEXT");
}

// GL_EXT_debug_marker
void GL_APIENTRY glInsertEventMarkerEXT(GLsizei length, const GLchar* marker)
{
	using PFN_glInsertEventMarkerEXT = void(GL_APIENTRY*)(GLsizei length, const GLchar* marker);
	static PFN_glInsertEventMarkerEXT insertEventMarkerEXTPtr = reinterpret_cast<PFN_glInsertEventMarkerEXT>(eglGetProcAddress("glInsertEventMarkerEXT"));
	insertEventMarkerEXTPtr(length, marker);
	CHECK_GL_ERROR_ASSERT("glInsertEventMarkerEXT");
}

void GL_APIENTRY glPopGroupMarkerEXT()
{
	using PFN_glPopGroupMarkerEXT = void(GL_APIENTRY*)();
	static PFN_glPopGroupMarkerEXT popGroupMarkerEXTPtr = reinterpret_cast<PFN_glPopGroupMarkerEXT>(eglGetProcAddress("glPopGroupMarkerEXT"));
	popGroupMarkerEXTPtr();
	CHECK_GL_ERROR_ASSERT("glPopGroupMarkerEXT");
}

void GL_APIENTRY glPushGroupMarkerEXT(GLsizei length, const GLchar* marker)
{
	using PFN_glPushGroupMarkerEXT = void(GL_APIENTRY*)(GLsizei length, const GLchar* marker);
	static PFN_glPushGroupMarkerEXT pushGroupMarkerEXTPtr = reinterpret_cast<PFN_glPushGroupMarkerEXT>(eglGetProcAddress("glPushGroupMarkerEXT"));
	pushGroupMarkerEXTPtr(length, marker);
	CHECK_GL_ERROR_ASSERT("glPushGroupMarkerEXT");
}

// GL_EXT_discard_framebuffer
void GL_APIENTRY glDiscardFramebufferEXT(GLenum target, GLsizei numAttachments, const GLenum* attachments)
{
	using PFN_glDiscardFramebufferEXT = void(GL_APIENTRY*)(GLenum target, GLsizei numAttachments, const GLenum* attachments);
	static PFN_glDiscardFramebufferEXT discardFramebufferEXTPtr = reinterpret_cast<PFN_glDiscardFramebufferEXT>(eglGetProcAddress("glDiscardFramebufferEXT"));
	discardFramebufferEXTPtr(target, numAttachments, attachments);
	CHECK_GL_ERROR_ASSERT("glDiscardFramebufferEXT");
}

// GL_EXT_disjoint_timer_query, GL_EXT_occlusion_query_boolean
void GL_APIENTRY glBeginQueryEXT(GLenum target, GLuint id)
{
	using PFN_glBeginQueryEXT = void(GL_APIENTRY*)(GLenum target, GLuint id);
	static PFN_glBeginQueryEXT beginQueryEXTPtr = reinterpret_cast<PFN_glBeginQueryEXT>(eglGetProcAddress("glBeginQueryEXT"));
	beginQueryEXTPtr(target, id);
	CHECK_GL_ERROR_ASSERT("glBeginQueryEXT");
}

void GL_APIENTRY glDeleteQueriesEXT(GLsizei n, const GLuint* ids)
{
	using PFN_glDeleteQueriesEXT = void(GL_APIENTRY*)(GLsizei n, const GLuint* ids);
	static PFN_glDeleteQueriesEXT deleteQueriesEXTPtr = reinterpret_cast<PFN_glDeleteQueriesEXT>(eglGetProcAddress("glDeleteQueriesEXT"));
	deleteQueriesEXTPtr(n, ids);
	CHECK_GL_ERROR_ASSERT("glDeleteQueriesEXT");
}

void GL_APIENTRY glEndQueryEXT(GLenum target)
{
	using PFN_glEndQueryEXT = void(GL_APIENTRY*)(GLenum target);
	static PFN_glEndQueryEXT endQueryEXTPtr = reinterpret_cast<PFN_glEndQueryEXT>(eglGetProcAddress("glEndQueryEXT"));
	endQueryEXTPtr(target);
	CHECK_GL_ERROR_ASSERT("glEndQueryEXT");
}

void GL_APIENTRY glGenQueriesEXT(GLsizei n, GLuint* ids)
{
	using PFN_glGenQueriesEXT = void(GL_APIENTRY*)(GLsizei n, GLuint * ids);
	static PFN_glGenQueriesEXT genQueriesEXTPtr = reinterpret_cast<PFN_glGenQueriesEXT>(eglGetProcAddress("glGenQueriesEXT"));
	genQueriesEXTPtr(n, ids);
	CHECK_GL_ERROR_ASSERT("glGenQueriesEXT");
}

void GL_APIENTRY glGetQueryObjectuivEXT(GLuint id, GLenum pname, GLuint* params)
{
	using PFN_glGetQueryObjectuivEXT = void(GL_APIENTRY*)(GLuint id, GLenum pname, GLuint * params);
	static PFN_glGetQueryObjectuivEXT getQueryObjectuivEXTPtr = reinterpret_cast<PFN_glGetQueryObjectuivEXT>(eglGetProcAddress("glGetQueryObjectuivEXT"));
	getQueryObjectuivEXTPtr(id, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetQueryObjectuivEXT");
}

void GL_APIENTRY glGetQueryivEXT(GLenum target, GLenum pname, GLint* params)
{
	using PFN_glGetQueryivEXT = void(GL_APIENTRY*)(GLenum target, GLenum pname, GLint * params);
	static PFN_glGetQueryivEXT getQueryivEXTPtr = reinterpret_cast<PFN_glGetQueryivEXT>(eglGetProcAddress("glGetQueryivEXT"));
	getQueryivEXTPtr(target, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetQueryivEXT");
}

GLboolean GL_APIENTRY glIsQueryEXT(GLuint id)
{
	using PFN_glIsQueryEXT = GLboolean(GL_APIENTRY*)(GLuint id);
	static PFN_glIsQueryEXT isQueryEXTPtr = reinterpret_cast<PFN_glIsQueryEXT>(eglGetProcAddress("glIsQueryEXT"));
	auto result = isQueryEXTPtr(id);
	CHECK_GL_ERROR_ASSERT("glIsQueryEXT");
	return result;
}

// GL_EXT_disjoint_timer_query
void GL_APIENTRY glGetQueryObjecti64vEXT(GLuint id, GLenum pname, GLint64* params)
{
	using PFN_glGetQueryObjecti64vEXT = void(GL_APIENTRY*)(GLuint id, GLenum pname, GLint64 * params);
	static PFN_glGetQueryObjecti64vEXT getQueryObjecti64vEXTPtr = reinterpret_cast<PFN_glGetQueryObjecti64vEXT>(eglGetProcAddress("glGetQueryObjecti64vEXT"));
	getQueryObjecti64vEXTPtr(id, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetQueryObjecti64vEXT");
}

void GL_APIENTRY glGetQueryObjectivEXT(GLuint id, GLenum pname, GLint* params)
{
	using PFN_glGetQueryObjectivEXT = void(GL_APIENTRY*)(GLuint id, GLenum pname, GLint * params);
	static PFN_glGetQueryObjectivEXT getQueryObjectivEXTPtr = reinterpret_cast<PFN_glGetQueryObjectivEXT>(eglGetProcAddress("glGetQueryObjectivEXT"));
	getQueryObjectivEXTPtr(id, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetQueryObjectivEXT");
}

void GL_APIENTRY glGetQueryObjectui64vEXT(GLuint id, GLenum pname, GLuint64* params)
{
	using PFN_glGetQueryObjectui64vEXT = void(GL_APIENTRY*)(GLuint id, GLenum pname, GLuint64 * params);
	static PFN_glGetQueryObjectui64vEXT getQueryObjectui64vEXTPtr = reinterpret_cast<PFN_glGetQueryObjectui64vEXT>(eglGetProcAddress("glGetQueryObjectui64vEXT"));
	getQueryObjectui64vEXTPtr(id, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetQueryObjectui64vEXT");
}

void GL_APIENTRY glQueryCounterEXT(GLuint id, GLenum target)
{
	using PFN_glQueryCounterEXT = void(GL_APIENTRY*)(GLuint id, GLenum target);
	static PFN_glQueryCounterEXT queryCounterEXTPtr = reinterpret_cast<PFN_glQueryCounterEXT>(eglGetProcAddress("glQueryCounterEXT"));
	queryCounterEXTPtr(id, target);
	CHECK_GL_ERROR_ASSERT("glQueryCounterEXT");
}

// GL_EXT_draw_buffers
void GL_APIENTRY glDrawBuffersEXT(GLsizei n, const GLenum* bufs)
{
	using PFN_glDrawBuffersEXT = void(GL_APIENTRY*)(GLsizei n, const GLenum* bufs);
	static PFN_glDrawBuffersEXT drawBuffersEXTPtr = reinterpret_cast<PFN_glDrawBuffersEXT>(eglGetProcAddress("glDrawBuffersEXT"));
	drawBuffersEXTPtr(n, bufs);
	CHECK_GL_ERROR_ASSERT("glDrawBuffersEXT");
}

// GL_EXT_draw_buffers_indexed
void GL_APIENTRY glBlendEquationSeparateiEXT(GLuint buf, GLenum modeRGB, GLenum modeAlpha)
{
	using PFN_glBlendEquationSeparateiEXT = void(GL_APIENTRY*)(GLuint buf, GLenum modeRGB, GLenum modeAlpha);
	static PFN_glBlendEquationSeparateiEXT blendEquationSeparateiEXTPtr = reinterpret_cast<PFN_glBlendEquationSeparateiEXT>(eglGetProcAddress("glBlendEquationSeparateiEXT"));
	blendEquationSeparateiEXTPtr(buf, modeRGB, modeAlpha);
	CHECK_GL_ERROR_ASSERT("glBlendEquationSeparateiEXT");
}

void GL_APIENTRY glBlendEquationiEXT(GLuint buf, GLenum mode)
{
	using PFN_glBlendEquationiEXT = void(GL_APIENTRY*)(GLuint buf, GLenum mode);
	static PFN_glBlendEquationiEXT blendEquationiEXTPtr = reinterpret_cast<PFN_glBlendEquationiEXT>(eglGetProcAddress("glBlendEquationiEXT"));
	blendEquationiEXTPtr(buf, mode);
	CHECK_GL_ERROR_ASSERT("glBlendEquationiEXT");
}

void GL_APIENTRY glBlendFuncSeparateiEXT(GLuint buf, GLenum srcRGB, GLenum dstRGB, GLenum srcAlpha, GLenum dstAlpha)
{
	using PFN_glBlendFuncSeparateiEXT = void(GL_APIENTRY*)(GLuint buf, GLenum srcRGB, GLenum dstRGB, GLenum srcAlpha, GLenum dstAlpha);
	static PFN_glBlendFuncSeparateiEXT blendFuncSeparateiEXTPtr = reinterpret_cast<PFN_glBlendFuncSeparateiEXT>(eglGetProcAddress("glBlendFuncSeparateiEXT"));
	blendFuncSeparateiEXTPtr(buf, srcRGB, dstRGB, srcAlpha, dstAlpha);
	CHECK_GL_ERROR_ASSERT("glBlendFuncSeparateiEXT");
}

void GL_APIENTRY glBlendFunciEXT(GLuint buf, GLenum src, GLenum dst)
{
	using PFN_glBlendFunciEXT = void(GL_APIENTRY*)(GLuint buf, GLenum src, GLenum dst);
	static PFN_glBlendFunciEXT blendFunciEXTPtr = reinterpret_cast<PFN_glBlendFunciEXT>(eglGetProcAddress("glBlendFunciEXT"));
	blendFunciEXTPtr(buf, src, dst);
	CHECK_GL_ERROR_ASSERT("glBlendFunciEXT");
}

void GL_APIENTRY glColorMaskiEXT(GLuint index, GLboolean r, GLboolean g, GLboolean b, GLboolean a)
{
	using PFN_glColorMaskiEXT = void(GL_APIENTRY*)(GLuint index, GLboolean r, GLboolean g, GLboolean b, GLboolean a);
	static PFN_glColorMaskiEXT colorMaskiEXTPtr = reinterpret_cast<PFN_glColorMaskiEXT>(eglGetProcAddress("glColorMaskiEXT"));
	colorMaskiEXTPtr(index, r, g, b, a);
	CHECK_GL_ERROR_ASSERT("glColorMaskiEXT");
}

void GL_APIENTRY glDisableiEXT(GLenum target, GLuint index)
{
	using PFN_glDisableiEXT = void(GL_APIENTRY*)(GLenum target, GLuint index);
	static PFN_glDisableiEXT disableiEXTPtr = reinterpret_cast<PFN_glDisableiEXT>(eglGetProcAddress("glDisableiEXT"));
	disableiEXTPtr(target, index);
	CHECK_GL_ERROR_ASSERT("glDisableiEXT");
}

void GL_APIENTRY glEnableiEXT(GLenum target, GLuint index)
{
	using PFN_glEnableiEXT = void(GL_APIENTRY*)(GLenum target, GLuint index);
	static PFN_glEnableiEXT enableiEXTPtr = reinterpret_cast<PFN_glEnableiEXT>(eglGetProcAddress("glEnableiEXT"));
	enableiEXTPtr(target, index);
	CHECK_GL_ERROR_ASSERT("glEnableiEXT");
}

GLboolean GL_APIENTRY glIsEnablediEXT(GLenum target, GLuint index)
{
	using PFN_glIsEnablediEXT = GLboolean(GL_APIENTRY*)(GLenum target, GLuint index);
	static PFN_glIsEnablediEXT isEnablediEXTPtr = reinterpret_cast<PFN_glIsEnablediEXT>(eglGetProcAddress("glIsEnablediEXT"));
	auto result = isEnablediEXTPtr(target, index);
	CHECK_GL_ERROR_ASSERT("glIsEnablediEXT");
	return result;
}

// GL_EXT_draw_elements_base_vertex, GL_OES_draw_elements_base_vertex
void GL_APIENTRY glMultiDrawElementsBaseVertexEXT(GLenum mode, const GLsizei* count, GLenum type, const void* const* indices, GLsizei primcount, const GLint* basevertex)
{
	using PFN_glMultiDrawElementsBaseVertexEXT = void(GL_APIENTRY*)(GLenum mode, const GLsizei* count, GLenum type, const void* const* indices, GLsizei primcount, const GLint* basevertex);
	static PFN_glMultiDrawElementsBaseVertexEXT multiDrawElementsBaseVertexEXTPtr = reinterpret_cast<PFN_glMultiDrawElementsBaseVertexEXT>(eglGetProcAddress("glMultiDrawElementsBaseVertexEXT"));
	multiDrawElementsBaseVertexEXTPtr(mode, count, type, indices, primcount, basevertex);
	CHECK_GL_ERROR_ASSERT("glMultiDrawElementsBaseVertexEXT");
}

// GL_EXT_draw_elements_base_vertex
void GL_APIENTRY glDrawElementsBaseVertexEXT(GLenum mode, GLsizei count, GLenum type, const void* indices, GLint basevertex)
{
	using PFN_glDrawElementsBaseVertexEXT = void(GL_APIENTRY*)(GLenum mode, GLsizei count, GLenum type, const void* indices, GLint basevertex);
	static PFN_glDrawElementsBaseVertexEXT drawElementsBaseVertexEXTPtr = reinterpret_cast<PFN_glDrawElementsBaseVertexEXT>(eglGetProcAddress("glDrawElementsBaseVertexEXT"));
	drawElementsBaseVertexEXTPtr(mode, count, type, indices, basevertex);
	CHECK_GL_ERROR_ASSERT("glDrawElementsBaseVertexEXT");
}

void GL_APIENTRY glDrawElementsInstancedBaseVertexEXT(GLenum mode, GLsizei count, GLenum type, const void* indices, GLsizei instancecount, GLint basevertex)
{
	using PFN_glDrawElementsInstancedBaseVertexEXT = void(GL_APIENTRY*)(GLenum mode, GLsizei count, GLenum type, const void* indices, GLsizei instancecount, GLint basevertex);
	static PFN_glDrawElementsInstancedBaseVertexEXT drawElementsInstancedBaseVertexEXTPtr = reinterpret_cast<PFN_glDrawElementsInstancedBaseVertexEXT>(eglGetProcAddress("glDrawElementsInstancedBaseVertexEXT"));
	drawElementsInstancedBaseVertexEXTPtr(mode, count, type, indices, instancecount, basevertex);
	CHECK_GL_ERROR_ASSERT("glDrawElementsInstancedBaseVertexEXT");
}

void GL_APIENTRY glDrawRangeElementsBaseVertexEXT(GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const void* indices, GLint basevertex)
{
	using PFN_glDrawRangeElementsBaseVertexEXT = void(GL_APIENTRY*)(GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const void* indices, GLint basevertex);
	static PFN_glDrawRangeElementsBaseVertexEXT drawRangeElementsBaseVertexEXTPtr = reinterpret_cast<PFN_glDrawRangeElementsBaseVertexEXT>(eglGetProcAddress("glDrawRangeElementsBaseVertexEXT"));
	drawRangeElementsBaseVertexEXTPtr(mode, start, end, count, type, indices, basevertex);
	CHECK_GL_ERROR_ASSERT("glDrawRangeElementsBaseVertexEXT");
}

// GL_EXT_draw_transform_feedback
void GL_APIENTRY glDrawTransformFeedbackEXT(GLenum mode, GLuint id)
{
	using PFN_glDrawTransformFeedbackEXT = void(GL_APIENTRY*)(GLenum mode, GLuint id);
	static PFN_glDrawTransformFeedbackEXT drawTransformFeedbackEXTPtr = reinterpret_cast<PFN_glDrawTransformFeedbackEXT>(eglGetProcAddress("glDrawTransformFeedbackEXT"));
	drawTransformFeedbackEXTPtr(mode, id);
	CHECK_GL_ERROR_ASSERT("glDrawTransformFeedbackEXT");
}

void GL_APIENTRY glDrawTransformFeedbackInstancedEXT(GLenum mode, GLuint id, GLsizei instancecount)
{
	using PFN_glDrawTransformFeedbackInstancedEXT = void(GL_APIENTRY*)(GLenum mode, GLuint id, GLsizei instancecount);
	static PFN_glDrawTransformFeedbackInstancedEXT drawTransformFeedbackInstancedEXTPtr = reinterpret_cast<PFN_glDrawTransformFeedbackInstancedEXT>(eglGetProcAddress("glDrawTransformFeedbackInstancedEXT"));
	drawTransformFeedbackInstancedEXTPtr(mode, id, instancecount);
	CHECK_GL_ERROR_ASSERT("glDrawTransformFeedbackInstancedEXT");
}

// GL_EXT_external_buffer
void GL_APIENTRY glBufferStorageExternalEXT(GLenum target, GLintptr offset, GLsizeiptr size, GLeglClientBufferEXT clientBuffer, GLbitfield flags)
{
	using PFN_glBufferStorageExternalEXT = void(GL_APIENTRY*)(GLenum target, GLintptr offset, GLsizeiptr size, GLeglClientBufferEXT clientBuffer, GLbitfield flags);
	static PFN_glBufferStorageExternalEXT bufferStorageExternalEXTPtr = reinterpret_cast<PFN_glBufferStorageExternalEXT>(eglGetProcAddress("glBufferStorageExternalEXT"));
	bufferStorageExternalEXTPtr(target, offset, size, clientBuffer, flags);
	CHECK_GL_ERROR_ASSERT("glBufferStorageExternalEXT");
}

void GL_APIENTRY glNamedBufferStorageExternalEXT(GLuint buffer, GLintptr offset, GLsizeiptr size, GLeglClientBufferEXT clientBuffer, GLbitfield flags)
{
	using PFN_glNamedBufferStorageExternalEXT = void(GL_APIENTRY*)(GLuint buffer, GLintptr offset, GLsizeiptr size, GLeglClientBufferEXT clientBuffer, GLbitfield flags);
	static PFN_glNamedBufferStorageExternalEXT namedBufferStorageExternalEXTPtr = reinterpret_cast<PFN_glNamedBufferStorageExternalEXT>(eglGetProcAddress("glNamedBufferStorageExternalEXT"));
	namedBufferStorageExternalEXTPtr(buffer, offset, size, clientBuffer, flags);
	CHECK_GL_ERROR_ASSERT("glNamedBufferStorageExternalEXT");
}

// GL_EXT_geometry_shader
void GL_APIENTRY glFramebufferTextureEXT(GLenum target, GLenum attachment, GLuint texture, GLint level)
{
	using PFN_glFramebufferTextureEXT = void(GL_APIENTRY*)(GLenum target, GLenum attachment, GLuint texture, GLint level);
	static PFN_glFramebufferTextureEXT framebufferTextureEXTPtr = reinterpret_cast<PFN_glFramebufferTextureEXT>(eglGetProcAddress("glFramebufferTextureEXT"));
	framebufferTextureEXTPtr(target, attachment, texture, level);
	CHECK_GL_ERROR_ASSERT("glFramebufferTextureEXT");
}

// GL_EXT_instanced_arrays, GL_EXT_draw_instanced
void GL_APIENTRY glDrawArraysInstancedEXT(GLenum mode, GLint start, GLsizei count, GLsizei primcount)
{
	using PFN_glDrawArraysInstancedEXT = void(GL_APIENTRY*)(GLenum mode, GLint start, GLsizei count, GLsizei primcount);
	static PFN_glDrawArraysInstancedEXT drawArraysInstancedEXTPtr = reinterpret_cast<PFN_glDrawArraysInstancedEXT>(eglGetProcAddress("glDrawArraysInstancedEXT"));
	drawArraysInstancedEXTPtr(mode, start, count, primcount);
	CHECK_GL_ERROR_ASSERT("glDrawArraysInstancedEXT");
}

void GL_APIENTRY glDrawElementsInstancedEXT(GLenum mode, GLsizei count, GLenum type, const void* indices, GLsizei primcount)
{
	using PFN_glDrawElementsInstancedEXT = void(GL_APIENTRY*)(GLenum mode, GLsizei count, GLenum type, const void* indices, GLsizei primcount);
	static PFN_glDrawElementsInstancedEXT drawElementsInstancedEXTPtr = reinterpret_cast<PFN_glDrawElementsInstancedEXT>(eglGetProcAddress("glDrawElementsInstancedEXT"));
	drawElementsInstancedEXTPtr(mode, count, type, indices, primcount);
	CHECK_GL_ERROR_ASSERT("glDrawElementsInstancedEXT");
}

// GL_EXT_instanced_arrays
void GL_APIENTRY glVertexAttribDivisorEXT(GLuint index, GLuint divisor)
{
	using PFN_glVertexAttribDivisorEXT = void(GL_APIENTRY*)(GLuint index, GLuint divisor);
	static PFN_glVertexAttribDivisorEXT vertexAttribDivisorEXTPtr = reinterpret_cast<PFN_glVertexAttribDivisorEXT>(eglGetProcAddress("glVertexAttribDivisorEXT"));
	vertexAttribDivisorEXTPtr(index, divisor);
	CHECK_GL_ERROR_ASSERT("glVertexAttribDivisorEXT");
}

// GL_EXT_map_buffer_range
void GL_APIENTRY glFlushMappedBufferRangeEXT(GLenum target, GLintptr offset, GLsizeiptr length)
{
	using PFN_glFlushMappedBufferRangeEXT = void(GL_APIENTRY*)(GLenum target, GLintptr offset, GLsizeiptr length);
	static PFN_glFlushMappedBufferRangeEXT flushMappedBufferRangeEXTPtr = reinterpret_cast<PFN_glFlushMappedBufferRangeEXT>(eglGetProcAddress("glFlushMappedBufferRangeEXT"));
	flushMappedBufferRangeEXTPtr(target, offset, length);
	CHECK_GL_ERROR_ASSERT("glFlushMappedBufferRangeEXT");
}

void* GL_APIENTRY glMapBufferRangeEXT(GLenum target, GLintptr offset, GLsizeiptr length, GLbitfield access)
{
	using PFN_glMapBufferRangeEXT = void*(GL_APIENTRY*) (GLenum target, GLintptr offset, GLsizeiptr length, GLbitfield access);
	static PFN_glMapBufferRangeEXT mapBufferRangeEXTPtr = reinterpret_cast<PFN_glMapBufferRangeEXT>(eglGetProcAddress("glMapBufferRangeEXT"));
	auto result = mapBufferRangeEXTPtr(target, offset, length, access);
	CHECK_GL_ERROR_ASSERT("glMapBufferRangeEXT");
	return result;
}

// GL_EXT_memory_object, GL_EXT_semaphore
void GL_APIENTRY glGetUnsignedBytei_vEXT(GLenum target, GLuint index, GLubyte* data)
{
	using PFN_glGetUnsignedBytei_vEXT = void(GL_APIENTRY*)(GLenum target, GLuint index, GLubyte * data);
	static PFN_glGetUnsignedBytei_vEXT getUnsignedBytei_vEXTPtr = reinterpret_cast<PFN_glGetUnsignedBytei_vEXT>(eglGetProcAddress("glGetUnsignedBytei_vEXT"));
	getUnsignedBytei_vEXTPtr(target, index, data);
	CHECK_GL_ERROR_ASSERT("glGetUnsignedBytei_vEXT");
}

void GL_APIENTRY glGetUnsignedBytevEXT(GLenum pname, GLubyte* data)
{
	using PFN_glGetUnsignedBytevEXT = void(GL_APIENTRY*)(GLenum pname, GLubyte * data);
	static PFN_glGetUnsignedBytevEXT getUnsignedBytevEXTPtr = reinterpret_cast<PFN_glGetUnsignedBytevEXT>(eglGetProcAddress("glGetUnsignedBytevEXT"));
	getUnsignedBytevEXTPtr(pname, data);
	CHECK_GL_ERROR_ASSERT("glGetUnsignedBytevEXT");
}

// GL_EXT_memory_object
void GL_APIENTRY glBufferStorageMemEXT(GLenum target, GLsizeiptr size, GLuint memory, GLuint64 offset)
{
	using PFN_glBufferStorageMemEXT = void(GL_APIENTRY*)(GLenum target, GLsizeiptr size, GLuint memory, GLuint64 offset);
	static PFN_glBufferStorageMemEXT bufferStorageMemEXTPtr = reinterpret_cast<PFN_glBufferStorageMemEXT>(eglGetProcAddress("glBufferStorageMemEXT"));
	bufferStorageMemEXTPtr(target, size, memory, offset);
	CHECK_GL_ERROR_ASSERT("glBufferStorageMemEXT");
}

void GL_APIENTRY glCreateMemoryObjectsEXT(GLsizei n, GLuint* memoryObjects)
{
	using PFN_glCreateMemoryObjectsEXT = void(GL_APIENTRY*)(GLsizei n, GLuint * memoryObjects);
	static PFN_glCreateMemoryObjectsEXT createMemoryObjectsEXTPtr = reinterpret_cast<PFN_glCreateMemoryObjectsEXT>(eglGetProcAddress("glCreateMemoryObjectsEXT"));
	createMemoryObjectsEXTPtr(n, memoryObjects);
	CHECK_GL_ERROR_ASSERT("glCreateMemoryObjectsEXT");
}

void GL_APIENTRY glDeleteMemoryObjectsEXT(GLsizei n, const GLuint* memoryObjects)
{
	using PFN_glDeleteMemoryObjectsEXT = void(GL_APIENTRY*)(GLsizei n, const GLuint* memoryObjects);
	static PFN_glDeleteMemoryObjectsEXT deleteMemoryObjectsEXTPtr = reinterpret_cast<PFN_glDeleteMemoryObjectsEXT>(eglGetProcAddress("glDeleteMemoryObjectsEXT"));
	deleteMemoryObjectsEXTPtr(n, memoryObjects);
	CHECK_GL_ERROR_ASSERT("glDeleteMemoryObjectsEXT");
}

void GL_APIENTRY glGetMemoryObjectParameterivEXT(GLuint memoryObject, GLenum pname, GLint* params)
{
	using PFN_glGetMemoryObjectParameterivEXT = void(GL_APIENTRY*)(GLuint memoryObject, GLenum pname, GLint * params);
	static PFN_glGetMemoryObjectParameterivEXT getMemoryObjectParameterivEXTPtr = reinterpret_cast<PFN_glGetMemoryObjectParameterivEXT>(eglGetProcAddress("glGetMemoryObjectParameterivEXT"));
	getMemoryObjectParameterivEXTPtr(memoryObject, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetMemoryObjectParameterivEXT");
}

GLboolean GL_APIENTRY glIsMemoryObjectEXT(GLuint memoryObject)
{
	using PFN_glIsMemoryObjectEXT = GLboolean(GL_APIENTRY*)(GLuint memoryObject);
	static PFN_glIsMemoryObjectEXT isMemoryObjectEXTPtr = reinterpret_cast<PFN_glIsMemoryObjectEXT>(eglGetProcAddress("glIsMemoryObjectEXT"));
	auto result = isMemoryObjectEXTPtr(memoryObject);
	CHECK_GL_ERROR_ASSERT("glIsMemoryObjectEXT");
	return result;
}

void GL_APIENTRY glMemoryObjectParameterivEXT(GLuint memoryObject, GLenum pname, const GLint* params)
{
	using PFN_glMemoryObjectParameterivEXT = void(GL_APIENTRY*)(GLuint memoryObject, GLenum pname, const GLint* params);
	static PFN_glMemoryObjectParameterivEXT memoryObjectParameterivEXTPtr = reinterpret_cast<PFN_glMemoryObjectParameterivEXT>(eglGetProcAddress("glMemoryObjectParameterivEXT"));
	memoryObjectParameterivEXTPtr(memoryObject, pname, params);
	CHECK_GL_ERROR_ASSERT("glMemoryObjectParameterivEXT");
}

void GL_APIENTRY glNamedBufferStorageMemEXT(GLuint buffer, GLsizeiptr size, GLuint memory, GLuint64 offset)
{
	using PFN_glNamedBufferStorageMemEXT = void(GL_APIENTRY*)(GLuint buffer, GLsizeiptr size, GLuint memory, GLuint64 offset);
	static PFN_glNamedBufferStorageMemEXT namedBufferStorageMemEXTPtr = reinterpret_cast<PFN_glNamedBufferStorageMemEXT>(eglGetProcAddress("glNamedBufferStorageMemEXT"));
	namedBufferStorageMemEXTPtr(buffer, size, memory, offset);
	CHECK_GL_ERROR_ASSERT("glNamedBufferStorageMemEXT");
}

void GL_APIENTRY glTexStorageMem2DEXT(GLenum target, GLsizei levels, GLenum internalFormat, GLsizei width, GLsizei height, GLuint memory, GLuint64 offset)
{
	using PFN_glTexStorageMem2DEXT = void(GL_APIENTRY*)(GLenum target, GLsizei levels, GLenum internalFormat, GLsizei width, GLsizei height, GLuint memory, GLuint64 offset);
	static PFN_glTexStorageMem2DEXT texStorageMem2DEXTPtr = reinterpret_cast<PFN_glTexStorageMem2DEXT>(eglGetProcAddress("glTexStorageMem2DEXT"));
	texStorageMem2DEXTPtr(target, levels, internalFormat, width, height, memory, offset);
	CHECK_GL_ERROR_ASSERT("glTexStorageMem2DEXT");
}

void GL_APIENTRY glTexStorageMem2DMultisampleEXT(GLenum target, GLsizei samples, GLenum internalFormat, GLsizei width, GLsizei height, GLboolean fixedSampleLocations, GLuint memory, GLuint64 offset)
{
	using PFN_glTexStorageMem2DMultisampleEXT = void(GL_APIENTRY*)(GLenum target, GLsizei samples, GLenum internalFormat, GLsizei width, GLsizei height, GLboolean fixedSampleLocations, GLuint memory, GLuint64 offset);
	static PFN_glTexStorageMem2DMultisampleEXT texStorageMem2DMultisampleEXTPtr = reinterpret_cast<PFN_glTexStorageMem2DMultisampleEXT>(eglGetProcAddress("glTexStorageMem2DMultisampleEXT"));
	texStorageMem2DMultisampleEXTPtr(target, samples, internalFormat, width, height, fixedSampleLocations, memory, offset);
	CHECK_GL_ERROR_ASSERT("glTexStorageMem2DMultisampleEXT");
}

void GL_APIENTRY glTexStorageMem3DEXT(GLenum target, GLsizei levels, GLenum internalFormat, GLsizei width, GLsizei height, GLsizei depth, GLuint memory, GLuint64 offset)
{
	using PFN_glTexStorageMem3DEXT = void(GL_APIENTRY*)(GLenum target, GLsizei levels, GLenum internalFormat, GLsizei width, GLsizei height, GLsizei depth, GLuint memory, GLuint64 offset);
	static PFN_glTexStorageMem3DEXT texStorageMem3DEXTPtr = reinterpret_cast<PFN_glTexStorageMem3DEXT>(eglGetProcAddress("glTexStorageMem3DEXT"));
	texStorageMem3DEXTPtr(target, levels, internalFormat, width, height, depth, memory, offset);
	CHECK_GL_ERROR_ASSERT("glTexStorageMem3DEXT");
}

void GL_APIENTRY glTexStorageMem3DMultisampleEXT(GLenum target, GLsizei samples, GLenum internalFormat, GLsizei width, GLsizei height, GLsizei depth, GLboolean fixedSampleLocations, GLuint memory, GLuint64 offset)
{
	using PFN_glTexStorageMem3DMultisampleEXT = void(GL_APIENTRY*)(GLenum target, GLsizei samples, GLenum internalFormat, GLsizei width, GLsizei height, GLsizei depth, GLboolean fixedSampleLocations, GLuint memory, GLuint64 offset);
	static PFN_glTexStorageMem3DMultisampleEXT texStorageMem3DMultisampleEXTPtr = reinterpret_cast<PFN_glTexStorageMem3DMultisampleEXT>(eglGetProcAddress("glTexStorageMem3DMultisampleEXT"));
	texStorageMem3DMultisampleEXTPtr(target, samples, internalFormat, width, height, depth, fixedSampleLocations, memory, offset);
	CHECK_GL_ERROR_ASSERT("glTexStorageMem3DMultisampleEXT");
}

void GL_APIENTRY glTextureStorageMem2DEXT(GLuint texture, GLsizei levels, GLenum internalFormat, GLsizei width, GLsizei height, GLuint memory, GLuint64 offset)
{
	using PFN_glTextureStorageMem2DEXT = void(GL_APIENTRY*)(GLuint texture, GLsizei levels, GLenum internalFormat, GLsizei width, GLsizei height, GLuint memory, GLuint64 offset);
	static PFN_glTextureStorageMem2DEXT textureStorageMem2DEXTPtr = reinterpret_cast<PFN_glTextureStorageMem2DEXT>(eglGetProcAddress("glTextureStorageMem2DEXT"));
	textureStorageMem2DEXTPtr(texture, levels, internalFormat, width, height, memory, offset);
	CHECK_GL_ERROR_ASSERT("glTextureStorageMem2DEXT");
}

void GL_APIENTRY glTextureStorageMem2DMultisampleEXT(GLuint texture, GLsizei samples, GLenum internalFormat, GLsizei width, GLsizei height, GLboolean fixedSampleLocations, GLuint memory, GLuint64 offset)
{
	using PFN_glTextureStorageMem2DMultisampleEXT = void(GL_APIENTRY*)(GLuint texture, GLsizei samples, GLenum internalFormat, GLsizei width, GLsizei height, GLboolean fixedSampleLocations, GLuint memory, GLuint64 offset);
	static PFN_glTextureStorageMem2DMultisampleEXT textureStorageMem2DMultisampleEXTPtr = reinterpret_cast<PFN_glTextureStorageMem2DMultisampleEXT>(eglGetProcAddress("glTextureStorageMem2DMultisampleEXT"));
	textureStorageMem2DMultisampleEXTPtr(texture, samples, internalFormat, width, height, fixedSampleLocations, memory, offset);
	CHECK_GL_ERROR_ASSERT("glTextureStorageMem2DMultisampleEXT");
}

void GL_APIENTRY glTextureStorageMem3DEXT(GLuint texture, GLsizei levels, GLenum internalFormat, GLsizei width, GLsizei height, GLsizei depth, GLuint memory, GLuint64 offset)
{
	using PFN_glTextureStorageMem3DEXT = void(GL_APIENTRY*)(GLuint texture, GLsizei levels, GLenum internalFormat, GLsizei width, GLsizei height, GLsizei depth, GLuint memory, GLuint64 offset);
	static PFN_glTextureStorageMem3DEXT textureStorageMem3DEXTPtr = reinterpret_cast<PFN_glTextureStorageMem3DEXT>(eglGetProcAddress("glTextureStorageMem3DEXT"));
	textureStorageMem3DEXTPtr(texture, levels, internalFormat, width, height, depth, memory, offset);
	CHECK_GL_ERROR_ASSERT("glTextureStorageMem3DEXT");
}

void GL_APIENTRY glTextureStorageMem3DMultisampleEXT(GLuint texture, GLsizei samples, GLenum internalFormat, GLsizei width, GLsizei height, GLsizei depth, GLboolean fixedSampleLocations, GLuint memory, GLuint64 offset)
{
	using PFN_glTextureStorageMem3DMultisampleEXT = void(GL_APIENTRY*)(GLuint texture, GLsizei samples, GLenum internalFormat, GLsizei width, GLsizei height, GLsizei depth, GLboolean fixedSampleLocations, GLuint memory, GLuint64 offset);
	static PFN_glTextureStorageMem3DMultisampleEXT textureStorageMem3DMultisampleEXTPtr = reinterpret_cast<PFN_glTextureStorageMem3DMultisampleEXT>(eglGetProcAddress("glTextureStorageMem3DMultisampleEXT"));
	textureStorageMem3DMultisampleEXTPtr(texture, samples, internalFormat, width, height, depth, fixedSampleLocations, memory, offset);
	CHECK_GL_ERROR_ASSERT("glTextureStorageMem3DMultisampleEXT");
}

// GL_EXT_memory_object_fd
void GL_APIENTRY glImportMemoryFdEXT(GLuint memory, GLuint64 size, GLenum handleType, GLint fd)
{
	using PFN_glImportMemoryFdEXT = void(GL_APIENTRY*)(GLuint memory, GLuint64 size, GLenum handleType, GLint fd);
	static PFN_glImportMemoryFdEXT importMemoryFdEXTPtr = reinterpret_cast<PFN_glImportMemoryFdEXT>(eglGetProcAddress("glImportMemoryFdEXT"));
	importMemoryFdEXTPtr(memory, size, handleType, fd);
	CHECK_GL_ERROR_ASSERT("glImportMemoryFdEXT");
}

// GL_EXT_memory_object_win32
void GL_APIENTRY glImportMemoryWin32HandleEXT(GLuint memory, GLuint64 size, GLenum handleType, void* handle)
{
	using PFN_glImportMemoryWin32HandleEXT = void(GL_APIENTRY*)(GLuint memory, GLuint64 size, GLenum handleType, void* handle);
	static PFN_glImportMemoryWin32HandleEXT importMemoryWin32HandleEXTPtr = reinterpret_cast<PFN_glImportMemoryWin32HandleEXT>(eglGetProcAddress("glImportMemoryWin32HandleEXT"));
	importMemoryWin32HandleEXTPtr(memory, size, handleType, handle);
	CHECK_GL_ERROR_ASSERT("glImportMemoryWin32HandleEXT");
}

void GL_APIENTRY glImportMemoryWin32NameEXT(GLuint memory, GLuint64 size, GLenum handleType, const void* name)
{
	using PFN_glImportMemoryWin32NameEXT = void(GL_APIENTRY*)(GLuint memory, GLuint64 size, GLenum handleType, const void* name);
	static PFN_glImportMemoryWin32NameEXT importMemoryWin32NameEXTPtr = reinterpret_cast<PFN_glImportMemoryWin32NameEXT>(eglGetProcAddress("glImportMemoryWin32NameEXT"));
	importMemoryWin32NameEXTPtr(memory, size, handleType, name);
	CHECK_GL_ERROR_ASSERT("glImportMemoryWin32NameEXT");
}

// GL_EXT_multi_draw_arrays
void GL_APIENTRY glMultiDrawArraysEXT(GLenum mode, const GLint* first, const GLsizei* count, GLsizei primcount)
{
	using PFN_glMultiDrawArraysEXT = void(GL_APIENTRY*)(GLenum mode, const GLint* first, const GLsizei* count, GLsizei primcount);
	static PFN_glMultiDrawArraysEXT multiDrawArraysEXTPtr = reinterpret_cast<PFN_glMultiDrawArraysEXT>(eglGetProcAddress("glMultiDrawArraysEXT"));
	multiDrawArraysEXTPtr(mode, first, count, primcount);
	CHECK_GL_ERROR_ASSERT("glMultiDrawArraysEXT");
}

void GL_APIENTRY glMultiDrawElementsEXT(GLenum mode, const GLsizei* count, GLenum type, const void* const* indices, GLsizei primcount)
{
	using PFN_glMultiDrawElementsEXT = void(GL_APIENTRY*)(GLenum mode, const GLsizei* count, GLenum type, const void* const* indices, GLsizei primcount);
	static PFN_glMultiDrawElementsEXT multiDrawElementsEXTPtr = reinterpret_cast<PFN_glMultiDrawElementsEXT>(eglGetProcAddress("glMultiDrawElementsEXT"));
	multiDrawElementsEXTPtr(mode, count, type, indices, primcount);
	CHECK_GL_ERROR_ASSERT("glMultiDrawElementsEXT");
}

// GL_EXT_multi_draw_indirect
void GL_APIENTRY glMultiDrawArraysIndirectEXT(GLenum mode, const void* indirect, GLsizei drawcount, GLsizei stride)
{
	using PFN_glMultiDrawArraysIndirectEXT = void(GL_APIENTRY*)(GLenum mode, const void* indirect, GLsizei drawcount, GLsizei stride);
	static PFN_glMultiDrawArraysIndirectEXT multiDrawArraysIndirectEXTPtr = reinterpret_cast<PFN_glMultiDrawArraysIndirectEXT>(eglGetProcAddress("glMultiDrawArraysIndirectEXT"));
	multiDrawArraysIndirectEXTPtr(mode, indirect, drawcount, stride);
	CHECK_GL_ERROR_ASSERT("glMultiDrawArraysIndirectEXT");
}

void GL_APIENTRY glMultiDrawElementsIndirectEXT(GLenum mode, GLenum type, const void* indirect, GLsizei drawcount, GLsizei stride)
{
	using PFN_glMultiDrawElementsIndirectEXT = void(GL_APIENTRY*)(GLenum mode, GLenum type, const void* indirect, GLsizei drawcount, GLsizei stride);
	static PFN_glMultiDrawElementsIndirectEXT multiDrawElementsIndirectEXTPtr = reinterpret_cast<PFN_glMultiDrawElementsIndirectEXT>(eglGetProcAddress("glMultiDrawElementsIndirectEXT"));
	multiDrawElementsIndirectEXTPtr(mode, type, indirect, drawcount, stride);
	CHECK_GL_ERROR_ASSERT("glMultiDrawElementsIndirectEXT");
}

// GL_EXT_multisampled_render_to_texture
void GL_APIENTRY glFramebufferTexture2DMultisampleEXT(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLsizei samples)
{
	using PFN_glFramebufferTexture2DMultisampleEXT = void(GL_APIENTRY*)(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLsizei samples);
	static PFN_glFramebufferTexture2DMultisampleEXT framebufferTexture2DMultisampleEXTPtr = reinterpret_cast<PFN_glFramebufferTexture2DMultisampleEXT>(eglGetProcAddress("glFramebufferTexture2DMultisampleEXT"));
	framebufferTexture2DMultisampleEXTPtr(target, attachment, textarget, texture, level, samples);
	CHECK_GL_ERROR_ASSERT("glFramebufferTexture2DMultisampleEXT");
}

void GL_APIENTRY glRenderbufferStorageMultisampleEXT(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height)
{
	using PFN_glRenderbufferStorageMultisampleEXT = void(GL_APIENTRY*)(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height);
	static PFN_glRenderbufferStorageMultisampleEXT renderbufferStorageMultisampleEXTPtr = reinterpret_cast<PFN_glRenderbufferStorageMultisampleEXT>(eglGetProcAddress("glRenderbufferStorageMultisampleEXT"));
	renderbufferStorageMultisampleEXTPtr(target, samples, internalformat, width, height);
	CHECK_GL_ERROR_ASSERT("glRenderbufferStorageMultisampleEXT");
}

// GL_EXT_multiview_draw_buffers
void GL_APIENTRY glDrawBuffersIndexedEXT(GLint n, const GLenum* location, const GLint* indices)
{
	using PFN_glDrawBuffersIndexedEXT = void(GL_APIENTRY*)(GLint n, const GLenum* location, const GLint* indices);
	static PFN_glDrawBuffersIndexedEXT drawBuffersIndexedEXTPtr = reinterpret_cast<PFN_glDrawBuffersIndexedEXT>(eglGetProcAddress("glDrawBuffersIndexedEXT"));
	drawBuffersIndexedEXTPtr(n, location, indices);
	CHECK_GL_ERROR_ASSERT("glDrawBuffersIndexedEXT");
}

void GL_APIENTRY glGetIntegeri_vEXT(GLenum target, GLuint index, GLint* data)
{
	using PFN_glGetIntegeri_vEXT = void(GL_APIENTRY*)(GLenum target, GLuint index, GLint * data);
	static PFN_glGetIntegeri_vEXT getIntegeri_vEXTPtr = reinterpret_cast<PFN_glGetIntegeri_vEXT>(eglGetProcAddress("glGetIntegeri_vEXT"));
	getIntegeri_vEXTPtr(target, index, data);
	CHECK_GL_ERROR_ASSERT("glGetIntegeri_vEXT");
}

void GL_APIENTRY glReadBufferIndexedEXT(GLenum src, GLint index)
{
	using PFN_glReadBufferIndexedEXT = void(GL_APIENTRY*)(GLenum src, GLint index);
	static PFN_glReadBufferIndexedEXT readBufferIndexedEXTPtr = reinterpret_cast<PFN_glReadBufferIndexedEXT>(eglGetProcAddress("glReadBufferIndexedEXT"));
	readBufferIndexedEXTPtr(src, index);
	CHECK_GL_ERROR_ASSERT("glReadBufferIndexedEXT");
}

// GL_EXT_polygon_offset_clamp
void GL_APIENTRY glPolygonOffsetClampEXT(GLfloat factor, GLfloat units, GLfloat clamp)
{
	using PFN_glPolygonOffsetClampEXT = void(GL_APIENTRY*)(GLfloat factor, GLfloat units, GLfloat clamp);
	static PFN_glPolygonOffsetClampEXT polygonOffsetClampEXTPtr = reinterpret_cast<PFN_glPolygonOffsetClampEXT>(eglGetProcAddress("glPolygonOffsetClampEXT"));
	polygonOffsetClampEXTPtr(factor, units, clamp);
	CHECK_GL_ERROR_ASSERT("glPolygonOffsetClampEXT");
}

// GL_EXT_primitive_bounding_box
void GL_APIENTRY glPrimitiveBoundingBoxEXT(GLfloat minX, GLfloat minY, GLfloat minZ, GLfloat minW, GLfloat maxX, GLfloat maxY, GLfloat maxZ, GLfloat maxW)
{
	using PFN_glPrimitiveBoundingBoxEXT = void(GL_APIENTRY*)(GLfloat minX, GLfloat minY, GLfloat minZ, GLfloat minW, GLfloat maxX, GLfloat maxY, GLfloat maxZ, GLfloat maxW);
	static PFN_glPrimitiveBoundingBoxEXT primitiveBoundingBoxEXTPtr = reinterpret_cast<PFN_glPrimitiveBoundingBoxEXT>(eglGetProcAddress("glPrimitiveBoundingBoxEXT"));
	primitiveBoundingBoxEXTPtr(minX, minY, minZ, minW, maxX, maxY, maxZ, maxW);
	CHECK_GL_ERROR_ASSERT("glPrimitiveBoundingBoxEXT");
}

// GL_EXT_robustness
GLenum GL_APIENTRY glGetGraphicsResetStatusEXT()
{
	using PFN_glGetGraphicsResetStatusEXT = GLenum(GL_APIENTRY*)();
	static PFN_glGetGraphicsResetStatusEXT getGraphicsResetStatusEXTPtr = reinterpret_cast<PFN_glGetGraphicsResetStatusEXT>(eglGetProcAddress("glGetGraphicsResetStatusEXT"));
	auto result = getGraphicsResetStatusEXTPtr();
	CHECK_GL_ERROR_ASSERT("glGetGraphicsResetStatusEXT");
	return result;
}

void GL_APIENTRY glGetnUniformfvEXT(GLuint program, GLint location, GLsizei bufSize, GLfloat* params)
{
	using PFN_glGetnUniformfvEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei bufSize, GLfloat * params);
	static PFN_glGetnUniformfvEXT getnUniformfvEXTPtr = reinterpret_cast<PFN_glGetnUniformfvEXT>(eglGetProcAddress("glGetnUniformfvEXT"));
	getnUniformfvEXTPtr(program, location, bufSize, params);
	CHECK_GL_ERROR_ASSERT("glGetnUniformfvEXT");
}

void GL_APIENTRY glGetnUniformivEXT(GLuint program, GLint location, GLsizei bufSize, GLint* params)
{
	using PFN_glGetnUniformivEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei bufSize, GLint * params);
	static PFN_glGetnUniformivEXT getnUniformivEXTPtr = reinterpret_cast<PFN_glGetnUniformivEXT>(eglGetProcAddress("glGetnUniformivEXT"));
	getnUniformivEXTPtr(program, location, bufSize, params);
	CHECK_GL_ERROR_ASSERT("glGetnUniformivEXT");
}

void GL_APIENTRY glReadnPixelsEXT(GLint x, GLint y, GLsizei width, GLsizei height, GLenum format, GLenum type, GLsizei bufSize, void* data)
{
	using PFN_glReadnPixelsEXT = void(GL_APIENTRY*)(GLint x, GLint y, GLsizei width, GLsizei height, GLenum format, GLenum type, GLsizei bufSize, void* data);
	static PFN_glReadnPixelsEXT readnPixelsEXTPtr = reinterpret_cast<PFN_glReadnPixelsEXT>(eglGetProcAddress("glReadnPixelsEXT"));
	readnPixelsEXTPtr(x, y, width, height, format, type, bufSize, data);
	CHECK_GL_ERROR_ASSERT("glReadnPixelsEXT");
}

// GL_EXT_semaphore
void GL_APIENTRY glDeleteSemaphoresEXT(GLsizei n, const GLuint* semaphores)
{
	using PFN_glDeleteSemaphoresEXT = void(GL_APIENTRY*)(GLsizei n, const GLuint* semaphores);
	static PFN_glDeleteSemaphoresEXT deleteSemaphoresEXTPtr = reinterpret_cast<PFN_glDeleteSemaphoresEXT>(eglGetProcAddress("glDeleteSemaphoresEXT"));
	deleteSemaphoresEXTPtr(n, semaphores);
	CHECK_GL_ERROR_ASSERT("glDeleteSemaphoresEXT");
}

void GL_APIENTRY glGenSemaphoresEXT(GLsizei n, GLuint* semaphores)
{
	using PFN_glGenSemaphoresEXT = void(GL_APIENTRY*)(GLsizei n, GLuint * semaphores);
	static PFN_glGenSemaphoresEXT genSemaphoresEXTPtr = reinterpret_cast<PFN_glGenSemaphoresEXT>(eglGetProcAddress("glGenSemaphoresEXT"));
	genSemaphoresEXTPtr(n, semaphores);
	CHECK_GL_ERROR_ASSERT("glGenSemaphoresEXT");
}

void GL_APIENTRY glGetSemaphoreParameterui64vEXT(GLuint semaphore, GLenum pname, GLuint64* params)
{
	using PFN_glGetSemaphoreParameterui64vEXT = void(GL_APIENTRY*)(GLuint semaphore, GLenum pname, GLuint64 * params);
	static PFN_glGetSemaphoreParameterui64vEXT getSemaphoreParameterui64vEXTPtr = reinterpret_cast<PFN_glGetSemaphoreParameterui64vEXT>(eglGetProcAddress("glGetSemaphoreParameterui64vEXT"));
	getSemaphoreParameterui64vEXTPtr(semaphore, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetSemaphoreParameterui64vEXT");
}

GLboolean GL_APIENTRY glIsSemaphoreEXT(GLuint semaphore)
{
	using PFN_glIsSemaphoreEXT = GLboolean(GL_APIENTRY*)(GLuint semaphore);
	static PFN_glIsSemaphoreEXT isSemaphoreEXTPtr = reinterpret_cast<PFN_glIsSemaphoreEXT>(eglGetProcAddress("glIsSemaphoreEXT"));
	auto result = isSemaphoreEXTPtr(semaphore);
	CHECK_GL_ERROR_ASSERT("glIsSemaphoreEXT");
	return result;
}

void GL_APIENTRY glSemaphoreParameterui64vEXT(GLuint semaphore, GLenum pname, const GLuint64* params)
{
	using PFN_glSemaphoreParameterui64vEXT = void(GL_APIENTRY*)(GLuint semaphore, GLenum pname, const GLuint64* params);
	static PFN_glSemaphoreParameterui64vEXT semaphoreParameterui64vEXTPtr = reinterpret_cast<PFN_glSemaphoreParameterui64vEXT>(eglGetProcAddress("glSemaphoreParameterui64vEXT"));
	semaphoreParameterui64vEXTPtr(semaphore, pname, params);
	CHECK_GL_ERROR_ASSERT("glSemaphoreParameterui64vEXT");
}

void GL_APIENTRY glSignalSemaphoreEXT(GLuint semaphore, GLuint numBufferBarriers, const GLuint* buffers, GLuint numTextureBarriers, const GLuint* textures, const GLenum* dstLayouts)
{
	using PFN_glSignalSemaphoreEXT = void(GL_APIENTRY*)(GLuint semaphore, GLuint numBufferBarriers, const GLuint* buffers, GLuint numTextureBarriers, const GLuint* textures, const GLenum* dstLayouts);
	static PFN_glSignalSemaphoreEXT signalSemaphoreEXTPtr = reinterpret_cast<PFN_glSignalSemaphoreEXT>(eglGetProcAddress("glSignalSemaphoreEXT"));
	signalSemaphoreEXTPtr(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, dstLayouts);
	CHECK_GL_ERROR_ASSERT("glSignalSemaphoreEXT");
}

void GL_APIENTRY glWaitSemaphoreEXT(GLuint semaphore, GLuint numBufferBarriers, const GLuint* buffers, GLuint numTextureBarriers, const GLuint* textures, const GLenum* srcLayouts)
{
	using PFN_glWaitSemaphoreEXT = void(GL_APIENTRY*)(GLuint semaphore, GLuint numBufferBarriers, const GLuint* buffers, GLuint numTextureBarriers, const GLuint* textures, const GLenum* srcLayouts);
	static PFN_glWaitSemaphoreEXT waitSemaphoreEXTPtr = reinterpret_cast<PFN_glWaitSemaphoreEXT>(eglGetProcAddress("glWaitSemaphoreEXT"));
	waitSemaphoreEXTPtr(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, srcLayouts);
	CHECK_GL_ERROR_ASSERT("glWaitSemaphoreEXT");
}

// GL_EXT_semaphore_fd
void GL_APIENTRY glImportSemaphoreFdEXT(GLuint semaphore, GLenum handleType, GLint fd)
{
	using PFN_glImportSemaphoreFdEXT = void(GL_APIENTRY*)(GLuint semaphore, GLenum handleType, GLint fd);
	static PFN_glImportSemaphoreFdEXT importSemaphoreFdEXTPtr = reinterpret_cast<PFN_glImportSemaphoreFdEXT>(eglGetProcAddress("glImportSemaphoreFdEXT"));
	importSemaphoreFdEXTPtr(semaphore, handleType, fd);
	CHECK_GL_ERROR_ASSERT("glImportSemaphoreFdEXT");
}

// GL_EXT_semaphore_win32
void GL_APIENTRY glImportSemaphoreWin32HandleEXT(GLuint semaphore, GLenum handleType, void* handle)
{
	using PFN_glImportSemaphoreWin32HandleEXT = void(GL_APIENTRY*)(GLuint semaphore, GLenum handleType, void* handle);
	static PFN_glImportSemaphoreWin32HandleEXT importSemaphoreWin32HandleEXTPtr = reinterpret_cast<PFN_glImportSemaphoreWin32HandleEXT>(eglGetProcAddress("glImportSemaphoreWin32HandleEXT"));
	importSemaphoreWin32HandleEXTPtr(semaphore, handleType, handle);
	CHECK_GL_ERROR_ASSERT("glImportSemaphoreWin32HandleEXT");
}

void GL_APIENTRY glImportSemaphoreWin32NameEXT(GLuint semaphore, GLenum handleType, const void* name)
{
	using PFN_glImportSemaphoreWin32NameEXT = void(GL_APIENTRY*)(GLuint semaphore, GLenum handleType, const void* name);
	static PFN_glImportSemaphoreWin32NameEXT importSemaphoreWin32NameEXTPtr = reinterpret_cast<PFN_glImportSemaphoreWin32NameEXT>(eglGetProcAddress("glImportSemaphoreWin32NameEXT"));
	importSemaphoreWin32NameEXTPtr(semaphore, handleType, name);
	CHECK_GL_ERROR_ASSERT("glImportSemaphoreWin32NameEXT");
}

// GL_EXT_separate_shader_objects
void GL_APIENTRY glActiveShaderProgramEXT(GLuint pipeline, GLuint program)
{
	using PFN_glActiveShaderProgramEXT = void(GL_APIENTRY*)(GLuint pipeline, GLuint program);
	static PFN_glActiveShaderProgramEXT activeShaderProgramEXTPtr = reinterpret_cast<PFN_glActiveShaderProgramEXT>(eglGetProcAddress("glActiveShaderProgramEXT"));
	activeShaderProgramEXTPtr(pipeline, program);
	CHECK_GL_ERROR_ASSERT("glActiveShaderProgramEXT");
}

void GL_APIENTRY glBindProgramPipelineEXT(GLuint pipeline)
{
	using PFN_glBindProgramPipelineEXT = void(GL_APIENTRY*)(GLuint pipeline);
	static PFN_glBindProgramPipelineEXT bindProgramPipelineEXTPtr = reinterpret_cast<PFN_glBindProgramPipelineEXT>(eglGetProcAddress("glBindProgramPipelineEXT"));
	bindProgramPipelineEXTPtr(pipeline);
	CHECK_GL_ERROR_ASSERT("glBindProgramPipelineEXT");
}

GLuint GL_APIENTRY glCreateShaderProgramvEXT(GLenum type, GLsizei count, const GLchar** strings)
{
	using PFN_glCreateShaderProgramvEXT = GLuint(GL_APIENTRY*)(GLenum type, GLsizei count, const GLchar** strings);
	static PFN_glCreateShaderProgramvEXT createShaderProgramvEXTPtr = reinterpret_cast<PFN_glCreateShaderProgramvEXT>(eglGetProcAddress("glCreateShaderProgramvEXT"));
	auto result = createShaderProgramvEXTPtr(type, count, strings);
	CHECK_GL_ERROR_ASSERT("glCreateShaderProgramvEXT");
	return result;
}

void GL_APIENTRY glDeleteProgramPipelinesEXT(GLsizei n, const GLuint* pipelines)
{
	using PFN_glDeleteProgramPipelinesEXT = void(GL_APIENTRY*)(GLsizei n, const GLuint* pipelines);
	static PFN_glDeleteProgramPipelinesEXT deleteProgramPipelinesEXTPtr = reinterpret_cast<PFN_glDeleteProgramPipelinesEXT>(eglGetProcAddress("glDeleteProgramPipelinesEXT"));
	deleteProgramPipelinesEXTPtr(n, pipelines);
	CHECK_GL_ERROR_ASSERT("glDeleteProgramPipelinesEXT");
}

void GL_APIENTRY glGenProgramPipelinesEXT(GLsizei n, GLuint* pipelines)
{
	using PFN_glGenProgramPipelinesEXT = void(GL_APIENTRY*)(GLsizei n, GLuint * pipelines);
	static PFN_glGenProgramPipelinesEXT genProgramPipelinesEXTPtr = reinterpret_cast<PFN_glGenProgramPipelinesEXT>(eglGetProcAddress("glGenProgramPipelinesEXT"));
	genProgramPipelinesEXTPtr(n, pipelines);
	CHECK_GL_ERROR_ASSERT("glGenProgramPipelinesEXT");
}

void GL_APIENTRY glGetProgramPipelineInfoLogEXT(GLuint pipeline, GLsizei bufSize, GLsizei* length, GLchar* infoLog)
{
	using PFN_glGetProgramPipelineInfoLogEXT = void(GL_APIENTRY*)(GLuint pipeline, GLsizei bufSize, GLsizei * length, GLchar * infoLog);
	static PFN_glGetProgramPipelineInfoLogEXT getProgramPipelineInfoLogEXTPtr = reinterpret_cast<PFN_glGetProgramPipelineInfoLogEXT>(eglGetProcAddress("glGetProgramPipelineInfoLogEXT"));
	getProgramPipelineInfoLogEXTPtr(pipeline, bufSize, length, infoLog);
	CHECK_GL_ERROR_ASSERT("glGetProgramPipelineInfoLogEXT");
}

void GL_APIENTRY glGetProgramPipelineivEXT(GLuint pipeline, GLenum pname, GLint* params)
{
	using PFN_glGetProgramPipelineivEXT = void(GL_APIENTRY*)(GLuint pipeline, GLenum pname, GLint * params);
	static PFN_glGetProgramPipelineivEXT getProgramPipelineivEXTPtr = reinterpret_cast<PFN_glGetProgramPipelineivEXT>(eglGetProcAddress("glGetProgramPipelineivEXT"));
	getProgramPipelineivEXTPtr(pipeline, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetProgramPipelineivEXT");
}

GLboolean GL_APIENTRY glIsProgramPipelineEXT(GLuint pipeline)
{
	using PFN_glIsProgramPipelineEXT = GLboolean(GL_APIENTRY*)(GLuint pipeline);
	static PFN_glIsProgramPipelineEXT isProgramPipelineEXTPtr = reinterpret_cast<PFN_glIsProgramPipelineEXT>(eglGetProcAddress("glIsProgramPipelineEXT"));
	auto result = isProgramPipelineEXTPtr(pipeline);
	CHECK_GL_ERROR_ASSERT("glIsProgramPipelineEXT");
	return result;
}

void GL_APIENTRY glProgramParameteriEXT(GLuint program, GLenum pname, GLint value)
{
	using PFN_glProgramParameteriEXT = void(GL_APIENTRY*)(GLuint program, GLenum pname, GLint value);
	static PFN_glProgramParameteriEXT programParameteriEXTPtr = reinterpret_cast<PFN_glProgramParameteriEXT>(eglGetProcAddress("glProgramParameteriEXT"));
	programParameteriEXTPtr(program, pname, value);
	CHECK_GL_ERROR_ASSERT("glProgramParameteriEXT");
}

void GL_APIENTRY glProgramUniform1fEXT(GLuint program, GLint location, GLfloat v0)
{
	using PFN_glProgramUniform1fEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLfloat v0);
	static PFN_glProgramUniform1fEXT programUniform1fEXTPtr = reinterpret_cast<PFN_glProgramUniform1fEXT>(eglGetProcAddress("glProgramUniform1fEXT"));
	programUniform1fEXTPtr(program, location, v0);
	CHECK_GL_ERROR_ASSERT("glProgramUniform1fEXT");
}

void GL_APIENTRY glProgramUniform1fvEXT(GLuint program, GLint location, GLsizei count, const GLfloat* value)
{
	using PFN_glProgramUniform1fvEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLfloat* value);
	static PFN_glProgramUniform1fvEXT programUniform1fvEXTPtr = reinterpret_cast<PFN_glProgramUniform1fvEXT>(eglGetProcAddress("glProgramUniform1fvEXT"));
	programUniform1fvEXTPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform1fvEXT");
}

void GL_APIENTRY glProgramUniform1iEXT(GLuint program, GLint location, GLint v0)
{
	using PFN_glProgramUniform1iEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLint v0);
	static PFN_glProgramUniform1iEXT programUniform1iEXTPtr = reinterpret_cast<PFN_glProgramUniform1iEXT>(eglGetProcAddress("glProgramUniform1iEXT"));
	programUniform1iEXTPtr(program, location, v0);
	CHECK_GL_ERROR_ASSERT("glProgramUniform1iEXT");
}

void GL_APIENTRY glProgramUniform1ivEXT(GLuint program, GLint location, GLsizei count, const GLint* value)
{
	using PFN_glProgramUniform1ivEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLint* value);
	static PFN_glProgramUniform1ivEXT programUniform1ivEXTPtr = reinterpret_cast<PFN_glProgramUniform1ivEXT>(eglGetProcAddress("glProgramUniform1ivEXT"));
	programUniform1ivEXTPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform1ivEXT");
}

void GL_APIENTRY glProgramUniform1uiEXT(GLuint program, GLint location, GLuint v0)
{
	using PFN_glProgramUniform1uiEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLuint v0);
	static PFN_glProgramUniform1uiEXT programUniform1uiEXTPtr = reinterpret_cast<PFN_glProgramUniform1uiEXT>(eglGetProcAddress("glProgramUniform1uiEXT"));
	programUniform1uiEXTPtr(program, location, v0);
	CHECK_GL_ERROR_ASSERT("glProgramUniform1uiEXT");
}

void GL_APIENTRY glProgramUniform1uivEXT(GLuint program, GLint location, GLsizei count, const GLuint* value)
{
	using PFN_glProgramUniform1uivEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLuint* value);
	static PFN_glProgramUniform1uivEXT programUniform1uivEXTPtr = reinterpret_cast<PFN_glProgramUniform1uivEXT>(eglGetProcAddress("glProgramUniform1uivEXT"));
	programUniform1uivEXTPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform1uivEXT");
}

void GL_APIENTRY glProgramUniform2fEXT(GLuint program, GLint location, GLfloat v0, GLfloat v1)
{
	using PFN_glProgramUniform2fEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLfloat v0, GLfloat v1);
	static PFN_glProgramUniform2fEXT programUniform2fEXTPtr = reinterpret_cast<PFN_glProgramUniform2fEXT>(eglGetProcAddress("glProgramUniform2fEXT"));
	programUniform2fEXTPtr(program, location, v0, v1);
	CHECK_GL_ERROR_ASSERT("glProgramUniform2fEXT");
}

void GL_APIENTRY glProgramUniform2fvEXT(GLuint program, GLint location, GLsizei count, const GLfloat* value)
{
	using PFN_glProgramUniform2fvEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLfloat* value);
	static PFN_glProgramUniform2fvEXT programUniform2fvEXTPtr = reinterpret_cast<PFN_glProgramUniform2fvEXT>(eglGetProcAddress("glProgramUniform2fvEXT"));
	programUniform2fvEXTPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform2fvEXT");
}

void GL_APIENTRY glProgramUniform2iEXT(GLuint program, GLint location, GLint v0, GLint v1)
{
	using PFN_glProgramUniform2iEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLint v0, GLint v1);
	static PFN_glProgramUniform2iEXT programUniform2iEXTPtr = reinterpret_cast<PFN_glProgramUniform2iEXT>(eglGetProcAddress("glProgramUniform2iEXT"));
	programUniform2iEXTPtr(program, location, v0, v1);
	CHECK_GL_ERROR_ASSERT("glProgramUniform2iEXT");
}

void GL_APIENTRY glProgramUniform2ivEXT(GLuint program, GLint location, GLsizei count, const GLint* value)
{
	using PFN_glProgramUniform2ivEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLint* value);
	static PFN_glProgramUniform2ivEXT programUniform2ivEXTPtr = reinterpret_cast<PFN_glProgramUniform2ivEXT>(eglGetProcAddress("glProgramUniform2ivEXT"));
	programUniform2ivEXTPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform2ivEXT");
}

void GL_APIENTRY glProgramUniform2uiEXT(GLuint program, GLint location, GLuint v0, GLuint v1)
{
	using PFN_glProgramUniform2uiEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLuint v0, GLuint v1);
	static PFN_glProgramUniform2uiEXT programUniform2uiEXTPtr = reinterpret_cast<PFN_glProgramUniform2uiEXT>(eglGetProcAddress("glProgramUniform2uiEXT"));
	programUniform2uiEXTPtr(program, location, v0, v1);
	CHECK_GL_ERROR_ASSERT("glProgramUniform2uiEXT");
}

void GL_APIENTRY glProgramUniform2uivEXT(GLuint program, GLint location, GLsizei count, const GLuint* value)
{
	using PFN_glProgramUniform2uivEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLuint* value);
	static PFN_glProgramUniform2uivEXT programUniform2uivEXTPtr = reinterpret_cast<PFN_glProgramUniform2uivEXT>(eglGetProcAddress("glProgramUniform2uivEXT"));
	programUniform2uivEXTPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform2uivEXT");
}

void GL_APIENTRY glProgramUniform3fEXT(GLuint program, GLint location, GLfloat v0, GLfloat v1, GLfloat v2)
{
	using PFN_glProgramUniform3fEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLfloat v0, GLfloat v1, GLfloat v2);
	static PFN_glProgramUniform3fEXT programUniform3fEXTPtr = reinterpret_cast<PFN_glProgramUniform3fEXT>(eglGetProcAddress("glProgramUniform3fEXT"));
	programUniform3fEXTPtr(program, location, v0, v1, v2);
	CHECK_GL_ERROR_ASSERT("glProgramUniform3fEXT");
}

void GL_APIENTRY glProgramUniform3fvEXT(GLuint program, GLint location, GLsizei count, const GLfloat* value)
{
	using PFN_glProgramUniform3fvEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLfloat* value);
	static PFN_glProgramUniform3fvEXT programUniform3fvEXTPtr = reinterpret_cast<PFN_glProgramUniform3fvEXT>(eglGetProcAddress("glProgramUniform3fvEXT"));
	programUniform3fvEXTPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform3fvEXT");
}

void GL_APIENTRY glProgramUniform3iEXT(GLuint program, GLint location, GLint v0, GLint v1, GLint v2)
{
	using PFN_glProgramUniform3iEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLint v0, GLint v1, GLint v2);
	static PFN_glProgramUniform3iEXT programUniform3iEXTPtr = reinterpret_cast<PFN_glProgramUniform3iEXT>(eglGetProcAddress("glProgramUniform3iEXT"));
	programUniform3iEXTPtr(program, location, v0, v1, v2);
	CHECK_GL_ERROR_ASSERT("glProgramUniform3iEXT");
}

void GL_APIENTRY glProgramUniform3ivEXT(GLuint program, GLint location, GLsizei count, const GLint* value)
{
	using PFN_glProgramUniform3ivEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLint* value);
	static PFN_glProgramUniform3ivEXT programUniform3ivEXTPtr = reinterpret_cast<PFN_glProgramUniform3ivEXT>(eglGetProcAddress("glProgramUniform3ivEXT"));
	programUniform3ivEXTPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform3ivEXT");
}

void GL_APIENTRY glProgramUniform3uiEXT(GLuint program, GLint location, GLuint v0, GLuint v1, GLuint v2)
{
	using PFN_glProgramUniform3uiEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLuint v0, GLuint v1, GLuint v2);
	static PFN_glProgramUniform3uiEXT programUniform3uiEXTPtr = reinterpret_cast<PFN_glProgramUniform3uiEXT>(eglGetProcAddress("glProgramUniform3uiEXT"));
	programUniform3uiEXTPtr(program, location, v0, v1, v2);
	CHECK_GL_ERROR_ASSERT("glProgramUniform3uiEXT");
}

void GL_APIENTRY glProgramUniform3uivEXT(GLuint program, GLint location, GLsizei count, const GLuint* value)
{
	using PFN_glProgramUniform3uivEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLuint* value);
	static PFN_glProgramUniform3uivEXT programUniform3uivEXTPtr = reinterpret_cast<PFN_glProgramUniform3uivEXT>(eglGetProcAddress("glProgramUniform3uivEXT"));
	programUniform3uivEXTPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform3uivEXT");
}

void GL_APIENTRY glProgramUniform4fEXT(GLuint program, GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3)
{
	using PFN_glProgramUniform4fEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3);
	static PFN_glProgramUniform4fEXT programUniform4fEXTPtr = reinterpret_cast<PFN_glProgramUniform4fEXT>(eglGetProcAddress("glProgramUniform4fEXT"));
	programUniform4fEXTPtr(program, location, v0, v1, v2, v3);
	CHECK_GL_ERROR_ASSERT("glProgramUniform4fEXT");
}

void GL_APIENTRY glProgramUniform4fvEXT(GLuint program, GLint location, GLsizei count, const GLfloat* value)
{
	using PFN_glProgramUniform4fvEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLfloat* value);
	static PFN_glProgramUniform4fvEXT programUniform4fvEXTPtr = reinterpret_cast<PFN_glProgramUniform4fvEXT>(eglGetProcAddress("glProgramUniform4fvEXT"));
	programUniform4fvEXTPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform4fvEXT");
}

void GL_APIENTRY glProgramUniform4iEXT(GLuint program, GLint location, GLint v0, GLint v1, GLint v2, GLint v3)
{
	using PFN_glProgramUniform4iEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLint v0, GLint v1, GLint v2, GLint v3);
	static PFN_glProgramUniform4iEXT programUniform4iEXTPtr = reinterpret_cast<PFN_glProgramUniform4iEXT>(eglGetProcAddress("glProgramUniform4iEXT"));
	programUniform4iEXTPtr(program, location, v0, v1, v2, v3);
	CHECK_GL_ERROR_ASSERT("glProgramUniform4iEXT");
}

void GL_APIENTRY glProgramUniform4ivEXT(GLuint program, GLint location, GLsizei count, const GLint* value)
{
	using PFN_glProgramUniform4ivEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLint* value);
	static PFN_glProgramUniform4ivEXT programUniform4ivEXTPtr = reinterpret_cast<PFN_glProgramUniform4ivEXT>(eglGetProcAddress("glProgramUniform4ivEXT"));
	programUniform4ivEXTPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform4ivEXT");
}

void GL_APIENTRY glProgramUniform4uiEXT(GLuint program, GLint location, GLuint v0, GLuint v1, GLuint v2, GLuint v3)
{
	using PFN_glProgramUniform4uiEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLuint v0, GLuint v1, GLuint v2, GLuint v3);
	static PFN_glProgramUniform4uiEXT programUniform4uiEXTPtr = reinterpret_cast<PFN_glProgramUniform4uiEXT>(eglGetProcAddress("glProgramUniform4uiEXT"));
	programUniform4uiEXTPtr(program, location, v0, v1, v2, v3);
	CHECK_GL_ERROR_ASSERT("glProgramUniform4uiEXT");
}

void GL_APIENTRY glProgramUniform4uivEXT(GLuint program, GLint location, GLsizei count, const GLuint* value)
{
	using PFN_glProgramUniform4uivEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLuint* value);
	static PFN_glProgramUniform4uivEXT programUniform4uivEXTPtr = reinterpret_cast<PFN_glProgramUniform4uivEXT>(eglGetProcAddress("glProgramUniform4uivEXT"));
	programUniform4uivEXTPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform4uivEXT");
}

void GL_APIENTRY glProgramUniformMatrix2fvEXT(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glProgramUniformMatrix2fvEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glProgramUniformMatrix2fvEXT programUniformMatrix2fvEXTPtr = reinterpret_cast<PFN_glProgramUniformMatrix2fvEXT>(eglGetProcAddress("glProgramUniformMatrix2fvEXT"));
	programUniformMatrix2fvEXTPtr(program, location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniformMatrix2fvEXT");
}

void GL_APIENTRY glProgramUniformMatrix2x3fvEXT(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glProgramUniformMatrix2x3fvEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glProgramUniformMatrix2x3fvEXT programUniformMatrix2x3fvEXTPtr = reinterpret_cast<PFN_glProgramUniformMatrix2x3fvEXT>(eglGetProcAddress("glProgramUniformMatrix2x3fvEXT"));
	programUniformMatrix2x3fvEXTPtr(program, location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniformMatrix2x3fvEXT");
}

void GL_APIENTRY glProgramUniformMatrix2x4fvEXT(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glProgramUniformMatrix2x4fvEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glProgramUniformMatrix2x4fvEXT programUniformMatrix2x4fvEXTPtr = reinterpret_cast<PFN_glProgramUniformMatrix2x4fvEXT>(eglGetProcAddress("glProgramUniformMatrix2x4fvEXT"));
	programUniformMatrix2x4fvEXTPtr(program, location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniformMatrix2x4fvEXT");
}

void GL_APIENTRY glProgramUniformMatrix3fvEXT(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glProgramUniformMatrix3fvEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glProgramUniformMatrix3fvEXT programUniformMatrix3fvEXTPtr = reinterpret_cast<PFN_glProgramUniformMatrix3fvEXT>(eglGetProcAddress("glProgramUniformMatrix3fvEXT"));
	programUniformMatrix3fvEXTPtr(program, location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniformMatrix3fvEXT");
}

void GL_APIENTRY glProgramUniformMatrix3x2fvEXT(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glProgramUniformMatrix3x2fvEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glProgramUniformMatrix3x2fvEXT programUniformMatrix3x2fvEXTPtr = reinterpret_cast<PFN_glProgramUniformMatrix3x2fvEXT>(eglGetProcAddress("glProgramUniformMatrix3x2fvEXT"));
	programUniformMatrix3x2fvEXTPtr(program, location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniformMatrix3x2fvEXT");
}

void GL_APIENTRY glProgramUniformMatrix3x4fvEXT(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glProgramUniformMatrix3x4fvEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glProgramUniformMatrix3x4fvEXT programUniformMatrix3x4fvEXTPtr = reinterpret_cast<PFN_glProgramUniformMatrix3x4fvEXT>(eglGetProcAddress("glProgramUniformMatrix3x4fvEXT"));
	programUniformMatrix3x4fvEXTPtr(program, location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniformMatrix3x4fvEXT");
}

void GL_APIENTRY glProgramUniformMatrix4fvEXT(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glProgramUniformMatrix4fvEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glProgramUniformMatrix4fvEXT programUniformMatrix4fvEXTPtr = reinterpret_cast<PFN_glProgramUniformMatrix4fvEXT>(eglGetProcAddress("glProgramUniformMatrix4fvEXT"));
	programUniformMatrix4fvEXTPtr(program, location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniformMatrix4fvEXT");
}

void GL_APIENTRY glProgramUniformMatrix4x2fvEXT(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glProgramUniformMatrix4x2fvEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glProgramUniformMatrix4x2fvEXT programUniformMatrix4x2fvEXTPtr = reinterpret_cast<PFN_glProgramUniformMatrix4x2fvEXT>(eglGetProcAddress("glProgramUniformMatrix4x2fvEXT"));
	programUniformMatrix4x2fvEXTPtr(program, location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniformMatrix4x2fvEXT");
}

void GL_APIENTRY glProgramUniformMatrix4x3fvEXT(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glProgramUniformMatrix4x3fvEXT = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glProgramUniformMatrix4x3fvEXT programUniformMatrix4x3fvEXTPtr = reinterpret_cast<PFN_glProgramUniformMatrix4x3fvEXT>(eglGetProcAddress("glProgramUniformMatrix4x3fvEXT"));
	programUniformMatrix4x3fvEXTPtr(program, location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniformMatrix4x3fvEXT");
}

void GL_APIENTRY glUseProgramStagesEXT(GLuint pipeline, GLbitfield stages, GLuint program)
{
	using PFN_glUseProgramStagesEXT = void(GL_APIENTRY*)(GLuint pipeline, GLbitfield stages, GLuint program);
	static PFN_glUseProgramStagesEXT useProgramStagesEXTPtr = reinterpret_cast<PFN_glUseProgramStagesEXT>(eglGetProcAddress("glUseProgramStagesEXT"));
	useProgramStagesEXTPtr(pipeline, stages, program);
	CHECK_GL_ERROR_ASSERT("glUseProgramStagesEXT");
}

void GL_APIENTRY glValidateProgramPipelineEXT(GLuint pipeline)
{
	using PFN_glValidateProgramPipelineEXT = void(GL_APIENTRY*)(GLuint pipeline);
	static PFN_glValidateProgramPipelineEXT validateProgramPipelineEXTPtr = reinterpret_cast<PFN_glValidateProgramPipelineEXT>(eglGetProcAddress("glValidateProgramPipelineEXT"));
	validateProgramPipelineEXTPtr(pipeline);
	CHECK_GL_ERROR_ASSERT("glValidateProgramPipelineEXT");
}

// GL_EXT_shader_pixel_local_storage2
void GL_APIENTRY glClearPixelLocalStorageuiEXT(GLsizei offset, GLsizei n, const GLuint* values)
{
	using PFN_glClearPixelLocalStorageuiEXT = void(GL_APIENTRY*)(GLsizei offset, GLsizei n, const GLuint* values);
	static PFN_glClearPixelLocalStorageuiEXT clearPixelLocalStorageuiEXTPtr = reinterpret_cast<PFN_glClearPixelLocalStorageuiEXT>(eglGetProcAddress("glClearPixelLocalStorageuiEXT"));
	clearPixelLocalStorageuiEXTPtr(offset, n, values);
	CHECK_GL_ERROR_ASSERT("glClearPixelLocalStorageuiEXT");
}

void GL_APIENTRY glFramebufferPixelLocalStorageSizeEXT(GLuint target, GLsizei size)
{
	using PFN_glFramebufferPixelLocalStorageSizeEXT = void(GL_APIENTRY*)(GLuint target, GLsizei size);
	static PFN_glFramebufferPixelLocalStorageSizeEXT framebufferPixelLocalStorageSizeEXTPtr = reinterpret_cast<PFN_glFramebufferPixelLocalStorageSizeEXT>(eglGetProcAddress("glFramebufferPixelLocalStorageSizeEXT"));
	framebufferPixelLocalStorageSizeEXTPtr(target, size);
	CHECK_GL_ERROR_ASSERT("glFramebufferPixelLocalStorageSizeEXT");
}

GLsizei GL_APIENTRY glGetFramebufferPixelLocalStorageSizeEXT(GLuint target)
{
	using PFN_glGetFramebufferPixelLocalStorageSizeEXT = GLsizei(GL_APIENTRY*)(GLuint target);
	static PFN_glGetFramebufferPixelLocalStorageSizeEXT getFramebufferPixelLocalStorageSizeEXTPtr = reinterpret_cast<PFN_glGetFramebufferPixelLocalStorageSizeEXT>(eglGetProcAddress("glGetFramebufferPixelLocalStorageSizeEXT"));
	auto result = getFramebufferPixelLocalStorageSizeEXTPtr(target);
	CHECK_GL_ERROR_ASSERT("glGetFramebufferPixelLocalStorageSizeEXT");
	return result;
}

// GL_EXT_sparse_texture
void GL_APIENTRY glTexPageCommitmentEXT(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLboolean commit)
{
	using PFN_glTexPageCommitmentEXT = void(GL_APIENTRY*)(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLboolean commit);
	static PFN_glTexPageCommitmentEXT texPageCommitmentEXTPtr = reinterpret_cast<PFN_glTexPageCommitmentEXT>(eglGetProcAddress("glTexPageCommitmentEXT"));
	texPageCommitmentEXTPtr(target, level, xoffset, yoffset, zoffset, width, height, depth, commit);
	CHECK_GL_ERROR_ASSERT("glTexPageCommitmentEXT");
}

// GL_EXT_tessellation_shader
void GL_APIENTRY glPatchParameteriEXT(GLenum pname, GLint value)
{
	using PFN_glPatchParameteriEXT = void(GL_APIENTRY*)(GLenum pname, GLint value);
	static PFN_glPatchParameteriEXT patchParameteriEXTPtr = reinterpret_cast<PFN_glPatchParameteriEXT>(eglGetProcAddress("glPatchParameteriEXT"));
	patchParameteriEXTPtr(pname, value);
	CHECK_GL_ERROR_ASSERT("glPatchParameteriEXT");
}

// GL_EXT_texture_border_clamp
void GL_APIENTRY glGetSamplerParameterIivEXT(GLuint sampler, GLenum pname, GLint* params)
{
	using PFN_glGetSamplerParameterIivEXT = void(GL_APIENTRY*)(GLuint sampler, GLenum pname, GLint * params);
	static PFN_glGetSamplerParameterIivEXT getSamplerParameterIivEXTPtr = reinterpret_cast<PFN_glGetSamplerParameterIivEXT>(eglGetProcAddress("glGetSamplerParameterIivEXT"));
	getSamplerParameterIivEXTPtr(sampler, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetSamplerParameterIivEXT");
}

void GL_APIENTRY glGetSamplerParameterIuivEXT(GLuint sampler, GLenum pname, GLuint* params)
{
	using PFN_glGetSamplerParameterIuivEXT = void(GL_APIENTRY*)(GLuint sampler, GLenum pname, GLuint * params);
	static PFN_glGetSamplerParameterIuivEXT getSamplerParameterIuivEXTPtr = reinterpret_cast<PFN_glGetSamplerParameterIuivEXT>(eglGetProcAddress("glGetSamplerParameterIuivEXT"));
	getSamplerParameterIuivEXTPtr(sampler, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetSamplerParameterIuivEXT");
}

void GL_APIENTRY glGetTexParameterIivEXT(GLenum target, GLenum pname, GLint* params)
{
	using PFN_glGetTexParameterIivEXT = void(GL_APIENTRY*)(GLenum target, GLenum pname, GLint * params);
	static PFN_glGetTexParameterIivEXT getTexParameterIivEXTPtr = reinterpret_cast<PFN_glGetTexParameterIivEXT>(eglGetProcAddress("glGetTexParameterIivEXT"));
	getTexParameterIivEXTPtr(target, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetTexParameterIivEXT");
}

void GL_APIENTRY glGetTexParameterIuivEXT(GLenum target, GLenum pname, GLuint* params)
{
	using PFN_glGetTexParameterIuivEXT = void(GL_APIENTRY*)(GLenum target, GLenum pname, GLuint * params);
	static PFN_glGetTexParameterIuivEXT getTexParameterIuivEXTPtr = reinterpret_cast<PFN_glGetTexParameterIuivEXT>(eglGetProcAddress("glGetTexParameterIuivEXT"));
	getTexParameterIuivEXTPtr(target, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetTexParameterIuivEXT");
}

void GL_APIENTRY glSamplerParameterIivEXT(GLuint sampler, GLenum pname, const GLint* param)
{
	using PFN_glSamplerParameterIivEXT = void(GL_APIENTRY*)(GLuint sampler, GLenum pname, const GLint* param);
	static PFN_glSamplerParameterIivEXT samplerParameterIivEXTPtr = reinterpret_cast<PFN_glSamplerParameterIivEXT>(eglGetProcAddress("glSamplerParameterIivEXT"));
	samplerParameterIivEXTPtr(sampler, pname, param);
	CHECK_GL_ERROR_ASSERT("glSamplerParameterIivEXT");
}

void GL_APIENTRY glSamplerParameterIuivEXT(GLuint sampler, GLenum pname, const GLuint* param)
{
	using PFN_glSamplerParameterIuivEXT = void(GL_APIENTRY*)(GLuint sampler, GLenum pname, const GLuint* param);
	static PFN_glSamplerParameterIuivEXT samplerParameterIuivEXTPtr = reinterpret_cast<PFN_glSamplerParameterIuivEXT>(eglGetProcAddress("glSamplerParameterIuivEXT"));
	samplerParameterIuivEXTPtr(sampler, pname, param);
	CHECK_GL_ERROR_ASSERT("glSamplerParameterIuivEXT");
}

void GL_APIENTRY glTexParameterIivEXT(GLenum target, GLenum pname, const GLint* params)
{
	using PFN_glTexParameterIivEXT = void(GL_APIENTRY*)(GLenum target, GLenum pname, const GLint* params);
	static PFN_glTexParameterIivEXT texParameterIivEXTPtr = reinterpret_cast<PFN_glTexParameterIivEXT>(eglGetProcAddress("glTexParameterIivEXT"));
	texParameterIivEXTPtr(target, pname, params);
	CHECK_GL_ERROR_ASSERT("glTexParameterIivEXT");
}

void GL_APIENTRY glTexParameterIuivEXT(GLenum target, GLenum pname, const GLuint* params)
{
	using PFN_glTexParameterIuivEXT = void(GL_APIENTRY*)(GLenum target, GLenum pname, const GLuint* params);
	static PFN_glTexParameterIuivEXT texParameterIuivEXTPtr = reinterpret_cast<PFN_glTexParameterIuivEXT>(eglGetProcAddress("glTexParameterIuivEXT"));
	texParameterIuivEXTPtr(target, pname, params);
	CHECK_GL_ERROR_ASSERT("glTexParameterIuivEXT");
}

// GL_EXT_texture_buffer
void GL_APIENTRY glTexBufferEXT(GLenum target, GLenum internalformat, GLuint buffer)
{
	using PFN_glTexBufferEXT = void(GL_APIENTRY*)(GLenum target, GLenum internalformat, GLuint buffer);
	static PFN_glTexBufferEXT texBufferEXTPtr = reinterpret_cast<PFN_glTexBufferEXT>(eglGetProcAddress("glTexBufferEXT"));
	texBufferEXTPtr(target, internalformat, buffer);
	CHECK_GL_ERROR_ASSERT("glTexBufferEXT");
}

void GL_APIENTRY glTexBufferRangeEXT(GLenum target, GLenum internalformat, GLuint buffer, GLintptr offset, GLsizeiptr size)
{
	using PFN_glTexBufferRangeEXT = void(GL_APIENTRY*)(GLenum target, GLenum internalformat, GLuint buffer, GLintptr offset, GLsizeiptr size);
	static PFN_glTexBufferRangeEXT texBufferRangeEXTPtr = reinterpret_cast<PFN_glTexBufferRangeEXT>(eglGetProcAddress("glTexBufferRangeEXT"));
	texBufferRangeEXTPtr(target, internalformat, buffer, offset, size);
	CHECK_GL_ERROR_ASSERT("glTexBufferRangeEXT");
}

// GL_EXT_texture_storage
void GL_APIENTRY glTexStorage1DEXT(GLenum target, GLsizei levels, GLenum internalformat, GLsizei width)
{
	using PFN_glTexStorage1DEXT = void(GL_APIENTRY*)(GLenum target, GLsizei levels, GLenum internalformat, GLsizei width);
	static PFN_glTexStorage1DEXT texStorage1DEXTPtr = reinterpret_cast<PFN_glTexStorage1DEXT>(eglGetProcAddress("glTexStorage1DEXT"));
	texStorage1DEXTPtr(target, levels, internalformat, width);
	CHECK_GL_ERROR_ASSERT("glTexStorage1DEXT");
}

void GL_APIENTRY glTexStorage2DEXT(GLenum target, GLsizei levels, GLenum internalformat, GLsizei width, GLsizei height)
{
	using PFN_glTexStorage2DEXT = void(GL_APIENTRY*)(GLenum target, GLsizei levels, GLenum internalformat, GLsizei width, GLsizei height);
	static PFN_glTexStorage2DEXT texStorage2DEXTPtr = reinterpret_cast<PFN_glTexStorage2DEXT>(eglGetProcAddress("glTexStorage2DEXT"));
	texStorage2DEXTPtr(target, levels, internalformat, width, height);
	CHECK_GL_ERROR_ASSERT("glTexStorage2DEXT");
}

void GL_APIENTRY glTexStorage3DEXT(GLenum target, GLsizei levels, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth)
{
	using PFN_glTexStorage3DEXT = void(GL_APIENTRY*)(GLenum target, GLsizei levels, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth);
	static PFN_glTexStorage3DEXT texStorage3DEXTPtr = reinterpret_cast<PFN_glTexStorage3DEXT>(eglGetProcAddress("glTexStorage3DEXT"));
	texStorage3DEXTPtr(target, levels, internalformat, width, height, depth);
	CHECK_GL_ERROR_ASSERT("glTexStorage3DEXT");
}

void GL_APIENTRY glTextureStorage1DEXT(GLuint texture, GLenum target, GLsizei levels, GLenum internalformat, GLsizei width)
{
	using PFN_glTextureStorage1DEXT = void(GL_APIENTRY*)(GLuint texture, GLenum target, GLsizei levels, GLenum internalformat, GLsizei width);
	static PFN_glTextureStorage1DEXT textureStorage1DEXTPtr = reinterpret_cast<PFN_glTextureStorage1DEXT>(eglGetProcAddress("glTextureStorage1DEXT"));
	textureStorage1DEXTPtr(texture, target, levels, internalformat, width);
	CHECK_GL_ERROR_ASSERT("glTextureStorage1DEXT");
}

void GL_APIENTRY glTextureStorage2DEXT(GLuint texture, GLenum target, GLsizei levels, GLenum internalformat, GLsizei width, GLsizei height)
{
	using PFN_glTextureStorage2DEXT = void(GL_APIENTRY*)(GLuint texture, GLenum target, GLsizei levels, GLenum internalformat, GLsizei width, GLsizei height);
	static PFN_glTextureStorage2DEXT textureStorage2DEXTPtr = reinterpret_cast<PFN_glTextureStorage2DEXT>(eglGetProcAddress("glTextureStorage2DEXT"));
	textureStorage2DEXTPtr(texture, target, levels, internalformat, width, height);
	CHECK_GL_ERROR_ASSERT("glTextureStorage2DEXT");
}

void GL_APIENTRY glTextureStorage3DEXT(GLuint texture, GLenum target, GLsizei levels, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth)
{
	using PFN_glTextureStorage3DEXT = void(GL_APIENTRY*)(GLuint texture, GLenum target, GLsizei levels, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth);
	static PFN_glTextureStorage3DEXT textureStorage3DEXTPtr = reinterpret_cast<PFN_glTextureStorage3DEXT>(eglGetProcAddress("glTextureStorage3DEXT"));
	textureStorage3DEXTPtr(texture, target, levels, internalformat, width, height, depth);
	CHECK_GL_ERROR_ASSERT("glTextureStorage3DEXT");
}

// GL_EXT_texture_view
void GL_APIENTRY glTextureViewEXT(GLuint texture, GLenum target, GLuint origtexture, GLenum internalformat, GLuint minlevel, GLuint numlevels, GLuint minlayer, GLuint numlayers)
{
	using PFN_glTextureViewEXT = void(GL_APIENTRY*)(GLuint texture, GLenum target, GLuint origtexture, GLenum internalformat, GLuint minlevel, GLuint numlevels, GLuint minlayer, GLuint numlayers);
	static PFN_glTextureViewEXT textureViewEXTPtr = reinterpret_cast<PFN_glTextureViewEXT>(eglGetProcAddress("glTextureViewEXT"));
	textureViewEXTPtr(texture, target, origtexture, internalformat, minlevel, numlevels, minlayer, numlayers);
	CHECK_GL_ERROR_ASSERT("glTextureViewEXT");
}

// GL_EXT_win32_keyed_mutex
GLboolean GL_APIENTRY glAcquireKeyedMutexWin32EXT(GLuint memory, GLuint64 key, GLuint timeout)
{
	using PFN_glAcquireKeyedMutexWin32EXT = GLboolean(GL_APIENTRY*)(GLuint memory, GLuint64 key, GLuint timeout);
	static PFN_glAcquireKeyedMutexWin32EXT acquireKeyedMutexWin32EXTPtr = reinterpret_cast<PFN_glAcquireKeyedMutexWin32EXT>(eglGetProcAddress("glAcquireKeyedMutexWin32EXT"));
	auto result = acquireKeyedMutexWin32EXTPtr(memory, key, timeout);
	CHECK_GL_ERROR_ASSERT("glAcquireKeyedMutexWin32EXT");
	return result;
}

GLboolean GL_APIENTRY glReleaseKeyedMutexWin32EXT(GLuint memory, GLuint64 key)
{
	using PFN_glReleaseKeyedMutexWin32EXT = GLboolean(GL_APIENTRY*)(GLuint memory, GLuint64 key);
	static PFN_glReleaseKeyedMutexWin32EXT releaseKeyedMutexWin32EXTPtr = reinterpret_cast<PFN_glReleaseKeyedMutexWin32EXT>(eglGetProcAddress("glReleaseKeyedMutexWin32EXT"));
	auto result = releaseKeyedMutexWin32EXTPtr(memory, key);
	CHECK_GL_ERROR_ASSERT("glReleaseKeyedMutexWin32EXT");
	return result;
}

// GL_EXT_window_rectangles
void GL_APIENTRY glWindowRectanglesEXT(GLenum mode, GLsizei count, const GLint* box)
{
	using PFN_glWindowRectanglesEXT = void(GL_APIENTRY*)(GLenum mode, GLsizei count, const GLint* box);
	static PFN_glWindowRectanglesEXT windowRectanglesEXTPtr = reinterpret_cast<PFN_glWindowRectanglesEXT>(eglGetProcAddress("glWindowRectanglesEXT"));
	windowRectanglesEXTPtr(mode, count, box);
	CHECK_GL_ERROR_ASSERT("glWindowRectanglesEXT");
}

// GL_IMG_bindless_texture
GLuint64 GL_APIENTRY glGetTextureHandleIMG(GLuint texture)
{
	using PFN_glGetTextureHandleIMG = GLuint64(GL_APIENTRY*)(GLuint texture);
	static PFN_glGetTextureHandleIMG getTextureHandleIMGPtr = reinterpret_cast<PFN_glGetTextureHandleIMG>(eglGetProcAddress("glGetTextureHandleIMG"));
	auto result = getTextureHandleIMGPtr(texture);
	CHECK_GL_ERROR_ASSERT("glGetTextureHandleIMG");
	return result;
}

GLuint64 GL_APIENTRY glGetTextureSamplerHandleIMG(GLuint texture, GLuint sampler)
{
	using PFN_glGetTextureSamplerHandleIMG = GLuint64(GL_APIENTRY*)(GLuint texture, GLuint sampler);
	static PFN_glGetTextureSamplerHandleIMG getTextureSamplerHandleIMGPtr = reinterpret_cast<PFN_glGetTextureSamplerHandleIMG>(eglGetProcAddress("glGetTextureSamplerHandleIMG"));
	auto result = getTextureSamplerHandleIMGPtr(texture, sampler);
	CHECK_GL_ERROR_ASSERT("glGetTextureSamplerHandleIMG");
	return result;
}

void GL_APIENTRY glProgramUniformHandleui64IMG(GLuint program, GLint location, GLuint64 value)
{
	using PFN_glProgramUniformHandleui64IMG = void(GL_APIENTRY*)(GLuint program, GLint location, GLuint64 value);
	static PFN_glProgramUniformHandleui64IMG programUniformHandleui64IMGPtr = reinterpret_cast<PFN_glProgramUniformHandleui64IMG>(eglGetProcAddress("glProgramUniformHandleui64IMG"));
	programUniformHandleui64IMGPtr(program, location, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniformHandleui64IMG");
}

void GL_APIENTRY glProgramUniformHandleui64vIMG(GLuint program, GLint location, GLsizei count, const GLuint64* values)
{
	using PFN_glProgramUniformHandleui64vIMG = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLuint64* values);
	static PFN_glProgramUniformHandleui64vIMG programUniformHandleui64vIMGPtr = reinterpret_cast<PFN_glProgramUniformHandleui64vIMG>(eglGetProcAddress("glProgramUniformHandleui64vIMG"));
	programUniformHandleui64vIMGPtr(program, location, count, values);
	CHECK_GL_ERROR_ASSERT("glProgramUniformHandleui64vIMG");
}

void GL_APIENTRY glUniformHandleui64IMG(GLint location, GLuint64 value)
{
	using PFN_glUniformHandleui64IMG = void(GL_APIENTRY*)(GLint location, GLuint64 value);
	static PFN_glUniformHandleui64IMG uniformHandleui64IMGPtr = reinterpret_cast<PFN_glUniformHandleui64IMG>(eglGetProcAddress("glUniformHandleui64IMG"));
	uniformHandleui64IMGPtr(location, value);
	CHECK_GL_ERROR_ASSERT("glUniformHandleui64IMG");
}

void GL_APIENTRY glUniformHandleui64vIMG(GLint location, GLsizei count, const GLuint64* value)
{
	using PFN_glUniformHandleui64vIMG = void(GL_APIENTRY*)(GLint location, GLsizei count, const GLuint64* value);
	static PFN_glUniformHandleui64vIMG uniformHandleui64vIMGPtr = reinterpret_cast<PFN_glUniformHandleui64vIMG>(eglGetProcAddress("glUniformHandleui64vIMG"));
	uniformHandleui64vIMGPtr(location, count, value);
	CHECK_GL_ERROR_ASSERT("glUniformHandleui64vIMG");
}

// GL_IMG_framebuffer_downsample
void GL_APIENTRY glFramebufferTexture2DDownsampleIMG(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLint xscale, GLint yscale)
{
	using PFN_glFramebufferTexture2DDownsampleIMG = void(GL_APIENTRY*)(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLint xscale, GLint yscale);
	static PFN_glFramebufferTexture2DDownsampleIMG framebufferTexture2DDownsampleIMGPtr = reinterpret_cast<PFN_glFramebufferTexture2DDownsampleIMG>(eglGetProcAddress("glFramebufferTexture2DDownsampleIMG"));
	framebufferTexture2DDownsampleIMGPtr(target, attachment, textarget, texture, level, xscale, yscale);
	CHECK_GL_ERROR_ASSERT("glFramebufferTexture2DDownsampleIMG");
}

void GL_APIENTRY glFramebufferTextureLayerDownsampleIMG(GLenum target, GLenum attachment, GLuint texture, GLint level, GLint layer, GLint xscale, GLint yscale)
{
	using PFN_glFramebufferTextureLayerDownsampleIMG = void(GL_APIENTRY*)(GLenum target, GLenum attachment, GLuint texture, GLint level, GLint layer, GLint xscale, GLint yscale);
	static PFN_glFramebufferTextureLayerDownsampleIMG framebufferTextureLayerDownsampleIMGPtr = reinterpret_cast<PFN_glFramebufferTextureLayerDownsampleIMG>(eglGetProcAddress("glFramebufferTextureLayerDownsampleIMG"));
	framebufferTextureLayerDownsampleIMGPtr(target, attachment, texture, level, layer, xscale, yscale);
	CHECK_GL_ERROR_ASSERT("glFramebufferTextureLayerDownsampleIMG");
}

// GL_IMG_multisampled_render_to_texture
void GL_APIENTRY glFramebufferTexture2DMultisampleIMG(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLsizei samples)
{
	using PFN_glFramebufferTexture2DMultisampleIMG = void(GL_APIENTRY*)(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLsizei samples);
	static PFN_glFramebufferTexture2DMultisampleIMG framebufferTexture2DMultisampleIMGPtr = reinterpret_cast<PFN_glFramebufferTexture2DMultisampleIMG>(eglGetProcAddress("glFramebufferTexture2DMultisampleIMG"));
	framebufferTexture2DMultisampleIMGPtr(target, attachment, textarget, texture, level, samples);
	CHECK_GL_ERROR_ASSERT("glFramebufferTexture2DMultisampleIMG");
}

void GL_APIENTRY glRenderbufferStorageMultisampleIMG(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height)
{
	using PFN_glRenderbufferStorageMultisampleIMG = void(GL_APIENTRY*)(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height);
	static PFN_glRenderbufferStorageMultisampleIMG renderbufferStorageMultisampleIMGPtr = reinterpret_cast<PFN_glRenderbufferStorageMultisampleIMG>(eglGetProcAddress("glRenderbufferStorageMultisampleIMG"));
	renderbufferStorageMultisampleIMGPtr(target, samples, internalformat, width, height);
	CHECK_GL_ERROR_ASSERT("glRenderbufferStorageMultisampleIMG");
}

// GL_INTEL_framebuffer_CMAA
void GL_APIENTRY glApplyFramebufferAttachmentCMAAINTEL()
{
	using PFN_glApplyFramebufferAttachmentCMAAINTEL = void(GL_APIENTRY*)();
	static PFN_glApplyFramebufferAttachmentCMAAINTEL applyFramebufferAttachmentCMAAINTELPtr = reinterpret_cast<PFN_glApplyFramebufferAttachmentCMAAINTEL>(eglGetProcAddress("glApplyFramebufferAttachmentCMAAINTEL"));
	applyFramebufferAttachmentCMAAINTELPtr();
	CHECK_GL_ERROR_ASSERT("glApplyFramebufferAttachmentCMAAINTEL");
}

// GL_INTEL_performance_query
void GL_APIENTRY glBeginPerfQueryINTEL(GLuint queryHandle)
{
	using PFN_glBeginPerfQueryINTEL = void(GL_APIENTRY*)(GLuint queryHandle);
	static PFN_glBeginPerfQueryINTEL beginPerfQueryINTELPtr = reinterpret_cast<PFN_glBeginPerfQueryINTEL>(eglGetProcAddress("glBeginPerfQueryINTEL"));
	beginPerfQueryINTELPtr(queryHandle);
	CHECK_GL_ERROR_ASSERT("glBeginPerfQueryINTEL");
}

void GL_APIENTRY glCreatePerfQueryINTEL(GLuint queryId, GLuint* queryHandle)
{
	using PFN_glCreatePerfQueryINTEL = void(GL_APIENTRY*)(GLuint queryId, GLuint * queryHandle);
	static PFN_glCreatePerfQueryINTEL createPerfQueryINTELPtr = reinterpret_cast<PFN_glCreatePerfQueryINTEL>(eglGetProcAddress("glCreatePerfQueryINTEL"));
	createPerfQueryINTELPtr(queryId, queryHandle);
	CHECK_GL_ERROR_ASSERT("glCreatePerfQueryINTEL");
}

void GL_APIENTRY glDeletePerfQueryINTEL(GLuint queryHandle)
{
	using PFN_glDeletePerfQueryINTEL = void(GL_APIENTRY*)(GLuint queryHandle);
	static PFN_glDeletePerfQueryINTEL deletePerfQueryINTELPtr = reinterpret_cast<PFN_glDeletePerfQueryINTEL>(eglGetProcAddress("glDeletePerfQueryINTEL"));
	deletePerfQueryINTELPtr(queryHandle);
	CHECK_GL_ERROR_ASSERT("glDeletePerfQueryINTEL");
}

void GL_APIENTRY glEndPerfQueryINTEL(GLuint queryHandle)
{
	using PFN_glEndPerfQueryINTEL = void(GL_APIENTRY*)(GLuint queryHandle);
	static PFN_glEndPerfQueryINTEL endPerfQueryINTELPtr = reinterpret_cast<PFN_glEndPerfQueryINTEL>(eglGetProcAddress("glEndPerfQueryINTEL"));
	endPerfQueryINTELPtr(queryHandle);
	CHECK_GL_ERROR_ASSERT("glEndPerfQueryINTEL");
}

void GL_APIENTRY glGetFirstPerfQueryIdINTEL(GLuint* queryId)
{
	using PFN_glGetFirstPerfQueryIdINTEL = void(GL_APIENTRY*)(GLuint * queryId);
	static PFN_glGetFirstPerfQueryIdINTEL getFirstPerfQueryIdINTELPtr = reinterpret_cast<PFN_glGetFirstPerfQueryIdINTEL>(eglGetProcAddress("glGetFirstPerfQueryIdINTEL"));
	getFirstPerfQueryIdINTELPtr(queryId);
	CHECK_GL_ERROR_ASSERT("glGetFirstPerfQueryIdINTEL");
}

void GL_APIENTRY glGetNextPerfQueryIdINTEL(GLuint queryId, GLuint* nextQueryId)
{
	using PFN_glGetNextPerfQueryIdINTEL = void(GL_APIENTRY*)(GLuint queryId, GLuint * nextQueryId);
	static PFN_glGetNextPerfQueryIdINTEL getNextPerfQueryIdINTELPtr = reinterpret_cast<PFN_glGetNextPerfQueryIdINTEL>(eglGetProcAddress("glGetNextPerfQueryIdINTEL"));
	getNextPerfQueryIdINTELPtr(queryId, nextQueryId);
	CHECK_GL_ERROR_ASSERT("glGetNextPerfQueryIdINTEL");
}

void GL_APIENTRY glGetPerfCounterInfoINTEL(GLuint queryId, GLuint counterId, GLuint counterNameLength, GLchar* counterName, GLuint counterDescLength, GLchar* counterDesc, GLuint* counterOffset, GLuint* counterDataSize, GLuint* counterTypeEnum, GLuint* counterDataTypeEnum, GLuint64* rawCounterMaxValue)
{
	using PFN_glGetPerfCounterInfoINTEL = void(GL_APIENTRY*)(GLuint queryId, GLuint counterId, GLuint counterNameLength, GLchar * counterName, GLuint counterDescLength, GLchar * counterDesc, GLuint * counterOffset, GLuint * counterDataSize, GLuint * counterTypeEnum, GLuint * counterDataTypeEnum, GLuint64 * rawCounterMaxValue);
	static PFN_glGetPerfCounterInfoINTEL getPerfCounterInfoINTELPtr = reinterpret_cast<PFN_glGetPerfCounterInfoINTEL>(eglGetProcAddress("glGetPerfCounterInfoINTEL"));
	getPerfCounterInfoINTELPtr(queryId, counterId, counterNameLength, counterName, counterDescLength, counterDesc, counterOffset, counterDataSize, counterTypeEnum, counterDataTypeEnum, rawCounterMaxValue);
	CHECK_GL_ERROR_ASSERT("glGetPerfCounterInfoINTEL");
}

void GL_APIENTRY glGetPerfQueryDataINTEL(GLuint queryHandle, GLuint flags, GLsizei dataSize, void* data, GLuint* bytesWritten)
{
	using PFN_glGetPerfQueryDataINTEL = void(GL_APIENTRY*)(GLuint queryHandle, GLuint flags, GLsizei dataSize, void* data, GLuint* bytesWritten);
	static PFN_glGetPerfQueryDataINTEL getPerfQueryDataINTELPtr = reinterpret_cast<PFN_glGetPerfQueryDataINTEL>(eglGetProcAddress("glGetPerfQueryDataINTEL"));
	getPerfQueryDataINTELPtr(queryHandle, flags, dataSize, data, bytesWritten);
	CHECK_GL_ERROR_ASSERT("glGetPerfQueryDataINTEL");
}

void GL_APIENTRY glGetPerfQueryIdByNameINTEL(GLchar* queryName, GLuint* queryId)
{
	using PFN_glGetPerfQueryIdByNameINTEL = void(GL_APIENTRY*)(GLchar * queryName, GLuint * queryId);
	static PFN_glGetPerfQueryIdByNameINTEL getPerfQueryIdByNameINTELPtr = reinterpret_cast<PFN_glGetPerfQueryIdByNameINTEL>(eglGetProcAddress("glGetPerfQueryIdByNameINTEL"));
	getPerfQueryIdByNameINTELPtr(queryName, queryId);
	CHECK_GL_ERROR_ASSERT("glGetPerfQueryIdByNameINTEL");
}

void GL_APIENTRY glGetPerfQueryInfoINTEL(GLuint queryId, GLuint queryNameLength, GLchar* queryName, GLuint* dataSize, GLuint* noCounters, GLuint* noInstances, GLuint* capsMask)
{
	using PFN_glGetPerfQueryInfoINTEL = void(GL_APIENTRY*)(GLuint queryId, GLuint queryNameLength, GLchar * queryName, GLuint * dataSize, GLuint * noCounters, GLuint * noInstances, GLuint * capsMask);
	static PFN_glGetPerfQueryInfoINTEL getPerfQueryInfoINTELPtr = reinterpret_cast<PFN_glGetPerfQueryInfoINTEL>(eglGetProcAddress("glGetPerfQueryInfoINTEL"));
	getPerfQueryInfoINTELPtr(queryId, queryNameLength, queryName, dataSize, noCounters, noInstances, capsMask);
	CHECK_GL_ERROR_ASSERT("glGetPerfQueryInfoINTEL");
}

// GL_KHR_blend_equation_advanced
void GL_APIENTRY glBlendBarrierKHR()
{
	using PFN_glBlendBarrierKHR = void(GL_APIENTRY*)();
	static PFN_glBlendBarrierKHR blendBarrierKHRPtr = reinterpret_cast<PFN_glBlendBarrierKHR>(eglGetProcAddress("glBlendBarrierKHR"));
	blendBarrierKHRPtr();
	CHECK_GL_ERROR_ASSERT("glBlendBarrierKHR");
}

// GL_KHR_debug
void GL_APIENTRY glDebugMessageCallbackKHR(GLDEBUGPROCKHR callback, const void* userParam)
{
	using PFN_glDebugMessageCallbackKHR = void(GL_APIENTRY*)(GLDEBUGPROCKHR callback, const void* userParam);
	static PFN_glDebugMessageCallbackKHR debugMessageCallbackKHRPtr = reinterpret_cast<PFN_glDebugMessageCallbackKHR>(eglGetProcAddress("glDebugMessageCallbackKHR"));
	debugMessageCallbackKHRPtr(callback, userParam);
	CHECK_GL_ERROR_ASSERT("glDebugMessageCallbackKHR");
}

void GL_APIENTRY glDebugMessageControlKHR(GLenum source, GLenum type, GLenum severity, GLsizei count, const GLuint* ids, GLboolean enabled)
{
	using PFN_glDebugMessageControlKHR = void(GL_APIENTRY*)(GLenum source, GLenum type, GLenum severity, GLsizei count, const GLuint* ids, GLboolean enabled);
	static PFN_glDebugMessageControlKHR debugMessageControlKHRPtr = reinterpret_cast<PFN_glDebugMessageControlKHR>(eglGetProcAddress("glDebugMessageControlKHR"));
	debugMessageControlKHRPtr(source, type, severity, count, ids, enabled);
	CHECK_GL_ERROR_ASSERT("glDebugMessageControlKHR");
}

void GL_APIENTRY glDebugMessageInsertKHR(GLenum source, GLenum type, GLuint id, GLenum severity, GLsizei length, const GLchar* buf)
{
	using PFN_glDebugMessageInsertKHR = void(GL_APIENTRY*)(GLenum source, GLenum type, GLuint id, GLenum severity, GLsizei length, const GLchar* buf);
	static PFN_glDebugMessageInsertKHR debugMessageInsertKHRPtr = reinterpret_cast<PFN_glDebugMessageInsertKHR>(eglGetProcAddress("glDebugMessageInsertKHR"));
	debugMessageInsertKHRPtr(source, type, id, severity, length, buf);
	CHECK_GL_ERROR_ASSERT("glDebugMessageInsertKHR");
}

GLuint GL_APIENTRY glGetDebugMessageLogKHR(GLuint count, GLsizei bufSize, GLenum* sources, GLenum* types, GLuint* ids, GLenum* severities, GLsizei* lengths, GLchar* messageLog)
{
	using PFN_glGetDebugMessageLogKHR = GLuint(GL_APIENTRY*)(GLuint count, GLsizei bufSize, GLenum * sources, GLenum * types, GLuint * ids, GLenum * severities, GLsizei * lengths, GLchar * messageLog);
	static PFN_glGetDebugMessageLogKHR getDebugMessageLogKHRPtr = reinterpret_cast<PFN_glGetDebugMessageLogKHR>(eglGetProcAddress("glGetDebugMessageLogKHR"));
	auto result = getDebugMessageLogKHRPtr(count, bufSize, sources, types, ids, severities, lengths, messageLog);
	CHECK_GL_ERROR_ASSERT("glGetDebugMessageLogKHR");
	return result;
}

void GL_APIENTRY glGetObjectLabelKHR(GLenum identifier, GLuint name, GLsizei bufSize, GLsizei* length, GLchar* label)
{
	using PFN_glGetObjectLabelKHR = void(GL_APIENTRY*)(GLenum identifier, GLuint name, GLsizei bufSize, GLsizei * length, GLchar * label);
	static PFN_glGetObjectLabelKHR getObjectLabelKHRPtr = reinterpret_cast<PFN_glGetObjectLabelKHR>(eglGetProcAddress("glGetObjectLabelKHR"));
	getObjectLabelKHRPtr(identifier, name, bufSize, length, label);
	CHECK_GL_ERROR_ASSERT("glGetObjectLabelKHR");
}

void GL_APIENTRY glGetObjectPtrLabelKHR(const void* ptr, GLsizei bufSize, GLsizei* length, GLchar* label)
{
	using PFN_glGetObjectPtrLabelKHR = void(GL_APIENTRY*)(const void* ptr, GLsizei bufSize, GLsizei* length, GLchar* label);
	static PFN_glGetObjectPtrLabelKHR getObjectPtrLabelKHRPtr = reinterpret_cast<PFN_glGetObjectPtrLabelKHR>(eglGetProcAddress("glGetObjectPtrLabelKHR"));
	getObjectPtrLabelKHRPtr(ptr, bufSize, length, label);
	CHECK_GL_ERROR_ASSERT("glGetObjectPtrLabelKHR");
}

void GL_APIENTRY glGetPointervKHR(GLenum pname, void** params)
{
	using PFN_glGetPointervKHR = void(GL_APIENTRY*)(GLenum pname, void** params);
	static PFN_glGetPointervKHR getPointervKHRPtr = reinterpret_cast<PFN_glGetPointervKHR>(eglGetProcAddress("glGetPointervKHR"));
	getPointervKHRPtr(pname, params);
	CHECK_GL_ERROR_ASSERT("glGetPointervKHR");
}

void GL_APIENTRY glObjectLabelKHR(GLenum identifier, GLuint name, GLsizei length, const GLchar* label)
{
	using PFN_glObjectLabelKHR = void(GL_APIENTRY*)(GLenum identifier, GLuint name, GLsizei length, const GLchar* label);
	static PFN_glObjectLabelKHR objectLabelKHRPtr = reinterpret_cast<PFN_glObjectLabelKHR>(eglGetProcAddress("glObjectLabelKHR"));
	objectLabelKHRPtr(identifier, name, length, label);
	CHECK_GL_ERROR_ASSERT("glObjectLabelKHR");
}

void GL_APIENTRY glObjectPtrLabelKHR(const void* ptr, GLsizei length, const GLchar* label)
{
	using PFN_glObjectPtrLabelKHR = void(GL_APIENTRY*)(const void* ptr, GLsizei length, const GLchar* label);
	static PFN_glObjectPtrLabelKHR objectPtrLabelKHRPtr = reinterpret_cast<PFN_glObjectPtrLabelKHR>(eglGetProcAddress("glObjectPtrLabelKHR"));
	objectPtrLabelKHRPtr(ptr, length, label);
	CHECK_GL_ERROR_ASSERT("glObjectPtrLabelKHR");
}

void GL_APIENTRY glPopDebugGroupKHR()
{
	using PFN_glPopDebugGroupKHR = void(GL_APIENTRY*)();
	static PFN_glPopDebugGroupKHR popDebugGroupKHRPtr = reinterpret_cast<PFN_glPopDebugGroupKHR>(eglGetProcAddress("glPopDebugGroupKHR"));
	popDebugGroupKHRPtr();
	CHECK_GL_ERROR_ASSERT("glPopDebugGroupKHR");
}

void GL_APIENTRY glPushDebugGroupKHR(GLenum source, GLuint id, GLsizei length, const GLchar* message)
{
	using PFN_glPushDebugGroupKHR = void(GL_APIENTRY*)(GLenum source, GLuint id, GLsizei length, const GLchar* message);
	static PFN_glPushDebugGroupKHR pushDebugGroupKHRPtr = reinterpret_cast<PFN_glPushDebugGroupKHR>(eglGetProcAddress("glPushDebugGroupKHR"));
	pushDebugGroupKHRPtr(source, id, length, message);
	CHECK_GL_ERROR_ASSERT("glPushDebugGroupKHR");
}

// GL_KHR_parallel_shader_compile
void GL_APIENTRY glMaxShaderCompilerThreadsKHR(GLuint count)
{
	using PFN_glMaxShaderCompilerThreadsKHR = void(GL_APIENTRY*)(GLuint count);
	static PFN_glMaxShaderCompilerThreadsKHR maxShaderCompilerThreadsKHRPtr = reinterpret_cast<PFN_glMaxShaderCompilerThreadsKHR>(eglGetProcAddress("glMaxShaderCompilerThreadsKHR"));
	maxShaderCompilerThreadsKHRPtr(count);
	CHECK_GL_ERROR_ASSERT("glMaxShaderCompilerThreadsKHR");
}

// GL_KHR_robustness
GLenum GL_APIENTRY glGetGraphicsResetStatusKHR()
{
	using PFN_glGetGraphicsResetStatusKHR = GLenum(GL_APIENTRY*)();
	static PFN_glGetGraphicsResetStatusKHR getGraphicsResetStatusKHRPtr = reinterpret_cast<PFN_glGetGraphicsResetStatusKHR>(eglGetProcAddress("glGetGraphicsResetStatusKHR"));
	auto result = getGraphicsResetStatusKHRPtr();
	CHECK_GL_ERROR_ASSERT("glGetGraphicsResetStatusKHR");
	return result;
}

void GL_APIENTRY glGetnUniformfvKHR(GLuint program, GLint location, GLsizei bufSize, GLfloat* params)
{
	using PFN_glGetnUniformfvKHR = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei bufSize, GLfloat * params);
	static PFN_glGetnUniformfvKHR getnUniformfvKHRPtr = reinterpret_cast<PFN_glGetnUniformfvKHR>(eglGetProcAddress("glGetnUniformfvKHR"));
	getnUniformfvKHRPtr(program, location, bufSize, params);
	CHECK_GL_ERROR_ASSERT("glGetnUniformfvKHR");
}

void GL_APIENTRY glGetnUniformivKHR(GLuint program, GLint location, GLsizei bufSize, GLint* params)
{
	using PFN_glGetnUniformivKHR = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei bufSize, GLint * params);
	static PFN_glGetnUniformivKHR getnUniformivKHRPtr = reinterpret_cast<PFN_glGetnUniformivKHR>(eglGetProcAddress("glGetnUniformivKHR"));
	getnUniformivKHRPtr(program, location, bufSize, params);
	CHECK_GL_ERROR_ASSERT("glGetnUniformivKHR");
}

void GL_APIENTRY glGetnUniformuivKHR(GLuint program, GLint location, GLsizei bufSize, GLuint* params)
{
	using PFN_glGetnUniformuivKHR = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei bufSize, GLuint * params);
	static PFN_glGetnUniformuivKHR getnUniformuivKHRPtr = reinterpret_cast<PFN_glGetnUniformuivKHR>(eglGetProcAddress("glGetnUniformuivKHR"));
	getnUniformuivKHRPtr(program, location, bufSize, params);
	CHECK_GL_ERROR_ASSERT("glGetnUniformuivKHR");
}

void GL_APIENTRY glReadnPixelsKHR(GLint x, GLint y, GLsizei width, GLsizei height, GLenum format, GLenum type, GLsizei bufSize, void* data)
{
	using PFN_glReadnPixelsKHR = void(GL_APIENTRY*)(GLint x, GLint y, GLsizei width, GLsizei height, GLenum format, GLenum type, GLsizei bufSize, void* data);
	static PFN_glReadnPixelsKHR readnPixelsKHRPtr = reinterpret_cast<PFN_glReadnPixelsKHR>(eglGetProcAddress("glReadnPixelsKHR"));
	readnPixelsKHRPtr(x, y, width, height, format, type, bufSize, data);
	CHECK_GL_ERROR_ASSERT("glReadnPixelsKHR");
}

// GL_NV_bindless_texture
GLuint64 GL_APIENTRY glGetImageHandleNV(GLuint texture, GLint level, GLboolean layered, GLint layer, GLenum format)
{
	using PFN_glGetImageHandleNV = GLuint64(GL_APIENTRY*)(GLuint texture, GLint level, GLboolean layered, GLint layer, GLenum format);
	static PFN_glGetImageHandleNV getImageHandleNVPtr = reinterpret_cast<PFN_glGetImageHandleNV>(eglGetProcAddress("glGetImageHandleNV"));
	auto result = getImageHandleNVPtr(texture, level, layered, layer, format);
	CHECK_GL_ERROR_ASSERT("glGetImageHandleNV");
	return result;
}

GLuint64 GL_APIENTRY glGetTextureHandleNV(GLuint texture)
{
	using PFN_glGetTextureHandleNV = GLuint64(GL_APIENTRY*)(GLuint texture);
	static PFN_glGetTextureHandleNV getTextureHandleNVPtr = reinterpret_cast<PFN_glGetTextureHandleNV>(eglGetProcAddress("glGetTextureHandleNV"));
	auto result = getTextureHandleNVPtr(texture);
	CHECK_GL_ERROR_ASSERT("glGetTextureHandleNV");
	return result;
}

GLuint64 GL_APIENTRY glGetTextureSamplerHandleNV(GLuint texture, GLuint sampler)
{
	using PFN_glGetTextureSamplerHandleNV = GLuint64(GL_APIENTRY*)(GLuint texture, GLuint sampler);
	static PFN_glGetTextureSamplerHandleNV getTextureSamplerHandleNVPtr = reinterpret_cast<PFN_glGetTextureSamplerHandleNV>(eglGetProcAddress("glGetTextureSamplerHandleNV"));
	auto result = getTextureSamplerHandleNVPtr(texture, sampler);
	CHECK_GL_ERROR_ASSERT("glGetTextureSamplerHandleNV");
	return result;
}

GLboolean GL_APIENTRY glIsImageHandleResidentNV(GLuint64 handle)
{
	using PFN_glIsImageHandleResidentNV = GLboolean(GL_APIENTRY*)(GLuint64 handle);
	static PFN_glIsImageHandleResidentNV isImageHandleResidentNVPtr = reinterpret_cast<PFN_glIsImageHandleResidentNV>(eglGetProcAddress("glIsImageHandleResidentNV"));
	auto result = isImageHandleResidentNVPtr(handle);
	CHECK_GL_ERROR_ASSERT("glIsImageHandleResidentNV");
	return result;
}

GLboolean GL_APIENTRY glIsTextureHandleResidentNV(GLuint64 handle)
{
	using PFN_glIsTextureHandleResidentNV = GLboolean(GL_APIENTRY*)(GLuint64 handle);
	static PFN_glIsTextureHandleResidentNV isTextureHandleResidentNVPtr = reinterpret_cast<PFN_glIsTextureHandleResidentNV>(eglGetProcAddress("glIsTextureHandleResidentNV"));
	auto result = isTextureHandleResidentNVPtr(handle);
	CHECK_GL_ERROR_ASSERT("glIsTextureHandleResidentNV");
	return result;
}

void GL_APIENTRY glMakeImageHandleNonResidentNV(GLuint64 handle)
{
	using PFN_glMakeImageHandleNonResidentNV = void(GL_APIENTRY*)(GLuint64 handle);
	static PFN_glMakeImageHandleNonResidentNV makeImageHandleNonResidentNVPtr = reinterpret_cast<PFN_glMakeImageHandleNonResidentNV>(eglGetProcAddress("glMakeImageHandleNonResidentNV"));
	makeImageHandleNonResidentNVPtr(handle);
	CHECK_GL_ERROR_ASSERT("glMakeImageHandleNonResidentNV");
}

void GL_APIENTRY glMakeImageHandleResidentNV(GLuint64 handle, GLenum access)
{
	using PFN_glMakeImageHandleResidentNV = void(GL_APIENTRY*)(GLuint64 handle, GLenum access);
	static PFN_glMakeImageHandleResidentNV makeImageHandleResidentNVPtr = reinterpret_cast<PFN_glMakeImageHandleResidentNV>(eglGetProcAddress("glMakeImageHandleResidentNV"));
	makeImageHandleResidentNVPtr(handle, access);
	CHECK_GL_ERROR_ASSERT("glMakeImageHandleResidentNV");
}

void GL_APIENTRY glMakeTextureHandleNonResidentNV(GLuint64 handle)
{
	using PFN_glMakeTextureHandleNonResidentNV = void(GL_APIENTRY*)(GLuint64 handle);
	static PFN_glMakeTextureHandleNonResidentNV makeTextureHandleNonResidentNVPtr = reinterpret_cast<PFN_glMakeTextureHandleNonResidentNV>(eglGetProcAddress("glMakeTextureHandleNonResidentNV"));
	makeTextureHandleNonResidentNVPtr(handle);
	CHECK_GL_ERROR_ASSERT("glMakeTextureHandleNonResidentNV");
}

void GL_APIENTRY glMakeTextureHandleResidentNV(GLuint64 handle)
{
	using PFN_glMakeTextureHandleResidentNV = void(GL_APIENTRY*)(GLuint64 handle);
	static PFN_glMakeTextureHandleResidentNV makeTextureHandleResidentNVPtr = reinterpret_cast<PFN_glMakeTextureHandleResidentNV>(eglGetProcAddress("glMakeTextureHandleResidentNV"));
	makeTextureHandleResidentNVPtr(handle);
	CHECK_GL_ERROR_ASSERT("glMakeTextureHandleResidentNV");
}

void GL_APIENTRY glProgramUniformHandleui64NV(GLuint program, GLint location, GLuint64 value)
{
	using PFN_glProgramUniformHandleui64NV = void(GL_APIENTRY*)(GLuint program, GLint location, GLuint64 value);
	static PFN_glProgramUniformHandleui64NV programUniformHandleui64NVPtr = reinterpret_cast<PFN_glProgramUniformHandleui64NV>(eglGetProcAddress("glProgramUniformHandleui64NV"));
	programUniformHandleui64NVPtr(program, location, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniformHandleui64NV");
}

void GL_APIENTRY glProgramUniformHandleui64vNV(GLuint program, GLint location, GLsizei count, const GLuint64* values)
{
	using PFN_glProgramUniformHandleui64vNV = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLuint64* values);
	static PFN_glProgramUniformHandleui64vNV programUniformHandleui64vNVPtr = reinterpret_cast<PFN_glProgramUniformHandleui64vNV>(eglGetProcAddress("glProgramUniformHandleui64vNV"));
	programUniformHandleui64vNVPtr(program, location, count, values);
	CHECK_GL_ERROR_ASSERT("glProgramUniformHandleui64vNV");
}

void GL_APIENTRY glUniformHandleui64NV(GLint location, GLuint64 value)
{
	using PFN_glUniformHandleui64NV = void(GL_APIENTRY*)(GLint location, GLuint64 value);
	static PFN_glUniformHandleui64NV uniformHandleui64NVPtr = reinterpret_cast<PFN_glUniformHandleui64NV>(eglGetProcAddress("glUniformHandleui64NV"));
	uniformHandleui64NVPtr(location, value);
	CHECK_GL_ERROR_ASSERT("glUniformHandleui64NV");
}

void GL_APIENTRY glUniformHandleui64vNV(GLint location, GLsizei count, const GLuint64* value)
{
	using PFN_glUniformHandleui64vNV = void(GL_APIENTRY*)(GLint location, GLsizei count, const GLuint64* value);
	static PFN_glUniformHandleui64vNV uniformHandleui64vNVPtr = reinterpret_cast<PFN_glUniformHandleui64vNV>(eglGetProcAddress("glUniformHandleui64vNV"));
	uniformHandleui64vNVPtr(location, count, value);
	CHECK_GL_ERROR_ASSERT("glUniformHandleui64vNV");
}

// GL_NV_blend_equation_advanced
void GL_APIENTRY glBlendBarrierNV()
{
	using PFN_glBlendBarrierNV = void(GL_APIENTRY*)();
	static PFN_glBlendBarrierNV blendBarrierNVPtr = reinterpret_cast<PFN_glBlendBarrierNV>(eglGetProcAddress("glBlendBarrierNV"));
	blendBarrierNVPtr();
	CHECK_GL_ERROR_ASSERT("glBlendBarrierNV");
}

void GL_APIENTRY glBlendParameteriNV(GLenum pname, GLint value)
{
	using PFN_glBlendParameteriNV = void(GL_APIENTRY*)(GLenum pname, GLint value);
	static PFN_glBlendParameteriNV blendParameteriNVPtr = reinterpret_cast<PFN_glBlendParameteriNV>(eglGetProcAddress("glBlendParameteriNV"));
	blendParameteriNVPtr(pname, value);
	CHECK_GL_ERROR_ASSERT("glBlendParameteriNV");
}

// GL_NV_conditional_render
void GL_APIENTRY glBeginConditionalRenderNV(GLuint id, GLenum mode)
{
	using PFN_glBeginConditionalRenderNV = void(GL_APIENTRY*)(GLuint id, GLenum mode);
	static PFN_glBeginConditionalRenderNV beginConditionalRenderNVPtr = reinterpret_cast<PFN_glBeginConditionalRenderNV>(eglGetProcAddress("glBeginConditionalRenderNV"));
	beginConditionalRenderNVPtr(id, mode);
	CHECK_GL_ERROR_ASSERT("glBeginConditionalRenderNV");
}

void GL_APIENTRY glEndConditionalRenderNV()
{
	using PFN_glEndConditionalRenderNV = void(GL_APIENTRY*)();
	static PFN_glEndConditionalRenderNV endConditionalRenderNVPtr = reinterpret_cast<PFN_glEndConditionalRenderNV>(eglGetProcAddress("glEndConditionalRenderNV"));
	endConditionalRenderNVPtr();
	CHECK_GL_ERROR_ASSERT("glEndConditionalRenderNV");
}

// GL_NV_conservative_raster
void GL_APIENTRY glSubpixelPrecisionBiasNV(GLuint xbits, GLuint ybits)
{
	using PFN_glSubpixelPrecisionBiasNV = void(GL_APIENTRY*)(GLuint xbits, GLuint ybits);
	static PFN_glSubpixelPrecisionBiasNV subpixelPrecisionBiasNVPtr = reinterpret_cast<PFN_glSubpixelPrecisionBiasNV>(eglGetProcAddress("glSubpixelPrecisionBiasNV"));
	subpixelPrecisionBiasNVPtr(xbits, ybits);
	CHECK_GL_ERROR_ASSERT("glSubpixelPrecisionBiasNV");
}

// GL_NV_conservative_raster_pre_snap_triangles
void GL_APIENTRY glConservativeRasterParameteriNV(GLenum pname, GLint param)
{
	using PFN_glConservativeRasterParameteriNV = void(GL_APIENTRY*)(GLenum pname, GLint param);
	static PFN_glConservativeRasterParameteriNV conservativeRasterParameteriNVPtr = reinterpret_cast<PFN_glConservativeRasterParameteriNV>(eglGetProcAddress("glConservativeRasterParameteriNV"));
	conservativeRasterParameteriNVPtr(pname, param);
	CHECK_GL_ERROR_ASSERT("glConservativeRasterParameteriNV");
}

// GL_NV_copy_buffer
void GL_APIENTRY glCopyBufferSubDataNV(GLenum readTarget, GLenum writeTarget, GLintptr readOffset, GLintptr writeOffset, GLsizeiptr size)
{
	using PFN_glCopyBufferSubDataNV = void(GL_APIENTRY*)(GLenum readTarget, GLenum writeTarget, GLintptr readOffset, GLintptr writeOffset, GLsizeiptr size);
	static PFN_glCopyBufferSubDataNV copyBufferSubDataNVPtr = reinterpret_cast<PFN_glCopyBufferSubDataNV>(eglGetProcAddress("glCopyBufferSubDataNV"));
	copyBufferSubDataNVPtr(readTarget, writeTarget, readOffset, writeOffset, size);
	CHECK_GL_ERROR_ASSERT("glCopyBufferSubDataNV");
}

// GL_NV_coverage_sample
void GL_APIENTRY glCoverageMaskNV(GLboolean mask)
{
	using PFN_glCoverageMaskNV = void(GL_APIENTRY*)(GLboolean mask);
	static PFN_glCoverageMaskNV coverageMaskNVPtr = reinterpret_cast<PFN_glCoverageMaskNV>(eglGetProcAddress("glCoverageMaskNV"));
	coverageMaskNVPtr(mask);
	CHECK_GL_ERROR_ASSERT("glCoverageMaskNV");
}

void GL_APIENTRY glCoverageOperationNV(GLenum operation)
{
	using PFN_glCoverageOperationNV = void(GL_APIENTRY*)(GLenum operation);
	static PFN_glCoverageOperationNV coverageOperationNVPtr = reinterpret_cast<PFN_glCoverageOperationNV>(eglGetProcAddress("glCoverageOperationNV"));
	coverageOperationNVPtr(operation);
	CHECK_GL_ERROR_ASSERT("glCoverageOperationNV");
}

// GL_NV_draw_buffers
void GL_APIENTRY glDrawBuffersNV(GLsizei n, const GLenum* bufs)
{
	using PFN_glDrawBuffersNV = void(GL_APIENTRY*)(GLsizei n, const GLenum* bufs);
	static PFN_glDrawBuffersNV drawBuffersNVPtr = reinterpret_cast<PFN_glDrawBuffersNV>(eglGetProcAddress("glDrawBuffersNV"));
	drawBuffersNVPtr(n, bufs);
	CHECK_GL_ERROR_ASSERT("glDrawBuffersNV");
}

// GL_NV_draw_instanced
void GL_APIENTRY glDrawArraysInstancedNV(GLenum mode, GLint first, GLsizei count, GLsizei primcount)
{
	using PFN_glDrawArraysInstancedNV = void(GL_APIENTRY*)(GLenum mode, GLint first, GLsizei count, GLsizei primcount);
	static PFN_glDrawArraysInstancedNV drawArraysInstancedNVPtr = reinterpret_cast<PFN_glDrawArraysInstancedNV>(eglGetProcAddress("glDrawArraysInstancedNV"));
	drawArraysInstancedNVPtr(mode, first, count, primcount);
	CHECK_GL_ERROR_ASSERT("glDrawArraysInstancedNV");
}

void GL_APIENTRY glDrawElementsInstancedNV(GLenum mode, GLsizei count, GLenum type, const void* indices, GLsizei primcount)
{
	using PFN_glDrawElementsInstancedNV = void(GL_APIENTRY*)(GLenum mode, GLsizei count, GLenum type, const void* indices, GLsizei primcount);
	static PFN_glDrawElementsInstancedNV drawElementsInstancedNVPtr = reinterpret_cast<PFN_glDrawElementsInstancedNV>(eglGetProcAddress("glDrawElementsInstancedNV"));
	drawElementsInstancedNVPtr(mode, count, type, indices, primcount);
	CHECK_GL_ERROR_ASSERT("glDrawElementsInstancedNV");
}

// GL_NV_draw_vulkan_image
void GL_APIENTRY glDrawVkImageNV(GLuint64 vkImage, GLuint sampler, GLfloat x0, GLfloat y0, GLfloat x1, GLfloat y1, GLfloat z, GLfloat s0, GLfloat t0, GLfloat s1, GLfloat t1)
{
	using PFN_glDrawVkImageNV = void(GL_APIENTRY*)(GLuint64 vkImage, GLuint sampler, GLfloat x0, GLfloat y0, GLfloat x1, GLfloat y1, GLfloat z, GLfloat s0, GLfloat t0, GLfloat s1, GLfloat t1);
	static PFN_glDrawVkImageNV drawVkImageNVPtr = reinterpret_cast<PFN_glDrawVkImageNV>(eglGetProcAddress("glDrawVkImageNV"));
	drawVkImageNVPtr(vkImage, sampler, x0, y0, x1, y1, z, s0, t0, s1, t1);
	CHECK_GL_ERROR_ASSERT("glDrawVkImageNV");
}

GLVULKANPROCNV GL_APIENTRY glGetVkProcAddrNV(const GLchar* name)
{
	using PFN_glGetVkProcAddrNV = GLVULKANPROCNV(GL_APIENTRY*)(const GLchar* name);
	static PFN_glGetVkProcAddrNV getVkProcAddrNVPtr = reinterpret_cast<PFN_glGetVkProcAddrNV>(eglGetProcAddress("glGetVkProcAddrNV"));
	auto result = getVkProcAddrNVPtr(name);
	CHECK_GL_ERROR_ASSERT("glGetVkProcAddrNV");
	return result;
}

void GL_APIENTRY glSignalVkFenceNV(GLuint64 vkFence)
{
	using PFN_glSignalVkFenceNV = void(GL_APIENTRY*)(GLuint64 vkFence);
	static PFN_glSignalVkFenceNV signalVkFenceNVPtr = reinterpret_cast<PFN_glSignalVkFenceNV>(eglGetProcAddress("glSignalVkFenceNV"));
	signalVkFenceNVPtr(vkFence);
	CHECK_GL_ERROR_ASSERT("glSignalVkFenceNV");
}

void GL_APIENTRY glSignalVkSemaphoreNV(GLuint64 vkSemaphore)
{
	using PFN_glSignalVkSemaphoreNV = void(GL_APIENTRY*)(GLuint64 vkSemaphore);
	static PFN_glSignalVkSemaphoreNV signalVkSemaphoreNVPtr = reinterpret_cast<PFN_glSignalVkSemaphoreNV>(eglGetProcAddress("glSignalVkSemaphoreNV"));
	signalVkSemaphoreNVPtr(vkSemaphore);
	CHECK_GL_ERROR_ASSERT("glSignalVkSemaphoreNV");
}

void GL_APIENTRY glWaitVkSemaphoreNV(GLuint64 vkSemaphore)
{
	using PFN_glWaitVkSemaphoreNV = void(GL_APIENTRY*)(GLuint64 vkSemaphore);
	static PFN_glWaitVkSemaphoreNV waitVkSemaphoreNVPtr = reinterpret_cast<PFN_glWaitVkSemaphoreNV>(eglGetProcAddress("glWaitVkSemaphoreNV"));
	waitVkSemaphoreNVPtr(vkSemaphore);
	CHECK_GL_ERROR_ASSERT("glWaitVkSemaphoreNV");
}

// GL_NV_fence
void GL_APIENTRY glDeleteFencesNV(GLsizei n, const GLuint* fences)
{
	using PFN_glDeleteFencesNV = void(GL_APIENTRY*)(GLsizei n, const GLuint* fences);
	static PFN_glDeleteFencesNV deleteFencesNVPtr = reinterpret_cast<PFN_glDeleteFencesNV>(eglGetProcAddress("glDeleteFencesNV"));
	deleteFencesNVPtr(n, fences);
	CHECK_GL_ERROR_ASSERT("glDeleteFencesNV");
}

void GL_APIENTRY glFinishFenceNV(GLuint fence)
{
	using PFN_glFinishFenceNV = void(GL_APIENTRY*)(GLuint fence);
	static PFN_glFinishFenceNV finishFenceNVPtr = reinterpret_cast<PFN_glFinishFenceNV>(eglGetProcAddress("glFinishFenceNV"));
	finishFenceNVPtr(fence);
	CHECK_GL_ERROR_ASSERT("glFinishFenceNV");
}

void GL_APIENTRY glGenFencesNV(GLsizei n, GLuint* fences)
{
	using PFN_glGenFencesNV = void(GL_APIENTRY*)(GLsizei n, GLuint * fences);
	static PFN_glGenFencesNV genFencesNVPtr = reinterpret_cast<PFN_glGenFencesNV>(eglGetProcAddress("glGenFencesNV"));
	genFencesNVPtr(n, fences);
	CHECK_GL_ERROR_ASSERT("glGenFencesNV");
}

void GL_APIENTRY glGetFenceivNV(GLuint fence, GLenum pname, GLint* params)
{
	using PFN_glGetFenceivNV = void(GL_APIENTRY*)(GLuint fence, GLenum pname, GLint * params);
	static PFN_glGetFenceivNV getFenceivNVPtr = reinterpret_cast<PFN_glGetFenceivNV>(eglGetProcAddress("glGetFenceivNV"));
	getFenceivNVPtr(fence, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetFenceivNV");
}

GLboolean GL_APIENTRY glIsFenceNV(GLuint fence)
{
	using PFN_glIsFenceNV = GLboolean(GL_APIENTRY*)(GLuint fence);
	static PFN_glIsFenceNV isFenceNVPtr = reinterpret_cast<PFN_glIsFenceNV>(eglGetProcAddress("glIsFenceNV"));
	auto result = isFenceNVPtr(fence);
	CHECK_GL_ERROR_ASSERT("glIsFenceNV");
	return result;
}

void GL_APIENTRY glSetFenceNV(GLuint fence, GLenum condition)
{
	using PFN_glSetFenceNV = void(GL_APIENTRY*)(GLuint fence, GLenum condition);
	static PFN_glSetFenceNV setFenceNVPtr = reinterpret_cast<PFN_glSetFenceNV>(eglGetProcAddress("glSetFenceNV"));
	setFenceNVPtr(fence, condition);
	CHECK_GL_ERROR_ASSERT("glSetFenceNV");
}

GLboolean GL_APIENTRY glTestFenceNV(GLuint fence)
{
	using PFN_glTestFenceNV = GLboolean(GL_APIENTRY*)(GLuint fence);
	static PFN_glTestFenceNV testFenceNVPtr = reinterpret_cast<PFN_glTestFenceNV>(eglGetProcAddress("glTestFenceNV"));
	auto result = testFenceNVPtr(fence);
	CHECK_GL_ERROR_ASSERT("glTestFenceNV");
	return result;
}

// GL_NV_fragment_coverage_to_color
void GL_APIENTRY glFragmentCoverageColorNV(GLuint color)
{
	using PFN_glFragmentCoverageColorNV = void(GL_APIENTRY*)(GLuint color);
	static PFN_glFragmentCoverageColorNV fragmentCoverageColorNVPtr = reinterpret_cast<PFN_glFragmentCoverageColorNV>(eglGetProcAddress("glFragmentCoverageColorNV"));
	fragmentCoverageColorNVPtr(color);
	CHECK_GL_ERROR_ASSERT("glFragmentCoverageColorNV");
}

// GL_NV_framebuffer_blit
void GL_APIENTRY glBlitFramebufferNV(GLint srcX0, GLint srcY0, GLint srcX1, GLint srcY1, GLint dstX0, GLint dstY0, GLint dstX1, GLint dstY1, GLbitfield mask, GLenum filter)
{
	using PFN_glBlitFramebufferNV = void(GL_APIENTRY*)(GLint srcX0, GLint srcY0, GLint srcX1, GLint srcY1, GLint dstX0, GLint dstY0, GLint dstX1, GLint dstY1, GLbitfield mask, GLenum filter);
	static PFN_glBlitFramebufferNV blitFramebufferNVPtr = reinterpret_cast<PFN_glBlitFramebufferNV>(eglGetProcAddress("glBlitFramebufferNV"));
	blitFramebufferNVPtr(srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
	CHECK_GL_ERROR_ASSERT("glBlitFramebufferNV");
}

// GL_NV_framebuffer_mixed_samples, GL_EXT_raster_multisample, GL_EXT_texture_filter_minmax
void GL_APIENTRY glRasterSamplesEXT(GLuint samples, GLboolean fixedsamplelocations)
{
	using PFN_glRasterSamplesEXT = void(GL_APIENTRY*)(GLuint samples, GLboolean fixedsamplelocations);
	static PFN_glRasterSamplesEXT rasterSamplesEXTPtr = reinterpret_cast<PFN_glRasterSamplesEXT>(eglGetProcAddress("glRasterSamplesEXT"));
	rasterSamplesEXTPtr(samples, fixedsamplelocations);
	CHECK_GL_ERROR_ASSERT("glRasterSamplesEXT");
}

// GL_NV_framebuffer_mixed_samples
void GL_APIENTRY glCoverageModulationNV(GLenum components)
{
	using PFN_glCoverageModulationNV = void(GL_APIENTRY*)(GLenum components);
	static PFN_glCoverageModulationNV coverageModulationNVPtr = reinterpret_cast<PFN_glCoverageModulationNV>(eglGetProcAddress("glCoverageModulationNV"));
	coverageModulationNVPtr(components);
	CHECK_GL_ERROR_ASSERT("glCoverageModulationNV");
}

void GL_APIENTRY glCoverageModulationTableNV(GLsizei n, const GLfloat* v)
{
	using PFN_glCoverageModulationTableNV = void(GL_APIENTRY*)(GLsizei n, const GLfloat* v);
	static PFN_glCoverageModulationTableNV coverageModulationTableNVPtr = reinterpret_cast<PFN_glCoverageModulationTableNV>(eglGetProcAddress("glCoverageModulationTableNV"));
	coverageModulationTableNVPtr(n, v);
	CHECK_GL_ERROR_ASSERT("glCoverageModulationTableNV");
}

void GL_APIENTRY glGetCoverageModulationTableNV(GLsizei bufsize, GLfloat* v)
{
	using PFN_glGetCoverageModulationTableNV = void(GL_APIENTRY*)(GLsizei bufsize, GLfloat * v);
	static PFN_glGetCoverageModulationTableNV getCoverageModulationTableNVPtr = reinterpret_cast<PFN_glGetCoverageModulationTableNV>(eglGetProcAddress("glGetCoverageModulationTableNV"));
	getCoverageModulationTableNVPtr(bufsize, v);
	CHECK_GL_ERROR_ASSERT("glGetCoverageModulationTableNV");
}

// GL_NV_framebuffer_multisample
void GL_APIENTRY glRenderbufferStorageMultisampleNV(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height)
{
	using PFN_glRenderbufferStorageMultisampleNV = void(GL_APIENTRY*)(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height);
	static PFN_glRenderbufferStorageMultisampleNV renderbufferStorageMultisampleNVPtr = reinterpret_cast<PFN_glRenderbufferStorageMultisampleNV>(eglGetProcAddress("glRenderbufferStorageMultisampleNV"));
	renderbufferStorageMultisampleNVPtr(target, samples, internalformat, width, height);
	CHECK_GL_ERROR_ASSERT("glRenderbufferStorageMultisampleNV");
}

// GL_NV_gpu_shader5
void GL_APIENTRY glGetUniformi64vNV(GLuint program, GLint location, GLint64EXT* params)
{
	using PFN_glGetUniformi64vNV = void(GL_APIENTRY*)(GLuint program, GLint location, GLint64EXT * params);
	static PFN_glGetUniformi64vNV getUniformi64vNVPtr = reinterpret_cast<PFN_glGetUniformi64vNV>(eglGetProcAddress("glGetUniformi64vNV"));
	getUniformi64vNVPtr(program, location, params);
	CHECK_GL_ERROR_ASSERT("glGetUniformi64vNV");
}

void GL_APIENTRY glProgramUniform1i64NV(GLuint program, GLint location, GLint64EXT x)
{
	using PFN_glProgramUniform1i64NV = void(GL_APIENTRY*)(GLuint program, GLint location, GLint64EXT x);
	static PFN_glProgramUniform1i64NV programUniform1i64NVPtr = reinterpret_cast<PFN_glProgramUniform1i64NV>(eglGetProcAddress("glProgramUniform1i64NV"));
	programUniform1i64NVPtr(program, location, x);
	CHECK_GL_ERROR_ASSERT("glProgramUniform1i64NV");
}

void GL_APIENTRY glProgramUniform1i64vNV(GLuint program, GLint location, GLsizei count, const GLint64EXT* value)
{
	using PFN_glProgramUniform1i64vNV = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLint64EXT* value);
	static PFN_glProgramUniform1i64vNV programUniform1i64vNVPtr = reinterpret_cast<PFN_glProgramUniform1i64vNV>(eglGetProcAddress("glProgramUniform1i64vNV"));
	programUniform1i64vNVPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform1i64vNV");
}

void GL_APIENTRY glProgramUniform1ui64NV(GLuint program, GLint location, GLuint64EXT x)
{
	using PFN_glProgramUniform1ui64NV = void(GL_APIENTRY*)(GLuint program, GLint location, GLuint64EXT x);
	static PFN_glProgramUniform1ui64NV programUniform1ui64NVPtr = reinterpret_cast<PFN_glProgramUniform1ui64NV>(eglGetProcAddress("glProgramUniform1ui64NV"));
	programUniform1ui64NVPtr(program, location, x);
	CHECK_GL_ERROR_ASSERT("glProgramUniform1ui64NV");
}

void GL_APIENTRY glProgramUniform1ui64vNV(GLuint program, GLint location, GLsizei count, const GLuint64EXT* value)
{
	using PFN_glProgramUniform1ui64vNV = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLuint64EXT* value);
	static PFN_glProgramUniform1ui64vNV programUniform1ui64vNVPtr = reinterpret_cast<PFN_glProgramUniform1ui64vNV>(eglGetProcAddress("glProgramUniform1ui64vNV"));
	programUniform1ui64vNVPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform1ui64vNV");
}

void GL_APIENTRY glProgramUniform2i64NV(GLuint program, GLint location, GLint64EXT x, GLint64EXT y)
{
	using PFN_glProgramUniform2i64NV = void(GL_APIENTRY*)(GLuint program, GLint location, GLint64EXT x, GLint64EXT y);
	static PFN_glProgramUniform2i64NV programUniform2i64NVPtr = reinterpret_cast<PFN_glProgramUniform2i64NV>(eglGetProcAddress("glProgramUniform2i64NV"));
	programUniform2i64NVPtr(program, location, x, y);
	CHECK_GL_ERROR_ASSERT("glProgramUniform2i64NV");
}

void GL_APIENTRY glProgramUniform2i64vNV(GLuint program, GLint location, GLsizei count, const GLint64EXT* value)
{
	using PFN_glProgramUniform2i64vNV = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLint64EXT* value);
	static PFN_glProgramUniform2i64vNV programUniform2i64vNVPtr = reinterpret_cast<PFN_glProgramUniform2i64vNV>(eglGetProcAddress("glProgramUniform2i64vNV"));
	programUniform2i64vNVPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform2i64vNV");
}

void GL_APIENTRY glProgramUniform2ui64NV(GLuint program, GLint location, GLuint64EXT x, GLuint64EXT y)
{
	using PFN_glProgramUniform2ui64NV = void(GL_APIENTRY*)(GLuint program, GLint location, GLuint64EXT x, GLuint64EXT y);
	static PFN_glProgramUniform2ui64NV programUniform2ui64NVPtr = reinterpret_cast<PFN_glProgramUniform2ui64NV>(eglGetProcAddress("glProgramUniform2ui64NV"));
	programUniform2ui64NVPtr(program, location, x, y);
	CHECK_GL_ERROR_ASSERT("glProgramUniform2ui64NV");
}

void GL_APIENTRY glProgramUniform2ui64vNV(GLuint program, GLint location, GLsizei count, const GLuint64EXT* value)
{
	using PFN_glProgramUniform2ui64vNV = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLuint64EXT* value);
	static PFN_glProgramUniform2ui64vNV programUniform2ui64vNVPtr = reinterpret_cast<PFN_glProgramUniform2ui64vNV>(eglGetProcAddress("glProgramUniform2ui64vNV"));
	programUniform2ui64vNVPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform2ui64vNV");
}

void GL_APIENTRY glProgramUniform3i64NV(GLuint program, GLint location, GLint64EXT x, GLint64EXT y, GLint64EXT z)
{
	using PFN_glProgramUniform3i64NV = void(GL_APIENTRY*)(GLuint program, GLint location, GLint64EXT x, GLint64EXT y, GLint64EXT z);
	static PFN_glProgramUniform3i64NV programUniform3i64NVPtr = reinterpret_cast<PFN_glProgramUniform3i64NV>(eglGetProcAddress("glProgramUniform3i64NV"));
	programUniform3i64NVPtr(program, location, x, y, z);
	CHECK_GL_ERROR_ASSERT("glProgramUniform3i64NV");
}

void GL_APIENTRY glProgramUniform3i64vNV(GLuint program, GLint location, GLsizei count, const GLint64EXT* value)
{
	using PFN_glProgramUniform3i64vNV = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLint64EXT* value);
	static PFN_glProgramUniform3i64vNV programUniform3i64vNVPtr = reinterpret_cast<PFN_glProgramUniform3i64vNV>(eglGetProcAddress("glProgramUniform3i64vNV"));
	programUniform3i64vNVPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform3i64vNV");
}

void GL_APIENTRY glProgramUniform3ui64NV(GLuint program, GLint location, GLuint64EXT x, GLuint64EXT y, GLuint64EXT z)
{
	using PFN_glProgramUniform3ui64NV = void(GL_APIENTRY*)(GLuint program, GLint location, GLuint64EXT x, GLuint64EXT y, GLuint64EXT z);
	static PFN_glProgramUniform3ui64NV programUniform3ui64NVPtr = reinterpret_cast<PFN_glProgramUniform3ui64NV>(eglGetProcAddress("glProgramUniform3ui64NV"));
	programUniform3ui64NVPtr(program, location, x, y, z);
	CHECK_GL_ERROR_ASSERT("glProgramUniform3ui64NV");
}

void GL_APIENTRY glProgramUniform3ui64vNV(GLuint program, GLint location, GLsizei count, const GLuint64EXT* value)
{
	using PFN_glProgramUniform3ui64vNV = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLuint64EXT* value);
	static PFN_glProgramUniform3ui64vNV programUniform3ui64vNVPtr = reinterpret_cast<PFN_glProgramUniform3ui64vNV>(eglGetProcAddress("glProgramUniform3ui64vNV"));
	programUniform3ui64vNVPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform3ui64vNV");
}

void GL_APIENTRY glProgramUniform4i64NV(GLuint program, GLint location, GLint64EXT x, GLint64EXT y, GLint64EXT z, GLint64EXT w)
{
	using PFN_glProgramUniform4i64NV = void(GL_APIENTRY*)(GLuint program, GLint location, GLint64EXT x, GLint64EXT y, GLint64EXT z, GLint64EXT w);
	static PFN_glProgramUniform4i64NV programUniform4i64NVPtr = reinterpret_cast<PFN_glProgramUniform4i64NV>(eglGetProcAddress("glProgramUniform4i64NV"));
	programUniform4i64NVPtr(program, location, x, y, z, w);
	CHECK_GL_ERROR_ASSERT("glProgramUniform4i64NV");
}

void GL_APIENTRY glProgramUniform4i64vNV(GLuint program, GLint location, GLsizei count, const GLint64EXT* value)
{
	using PFN_glProgramUniform4i64vNV = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLint64EXT* value);
	static PFN_glProgramUniform4i64vNV programUniform4i64vNVPtr = reinterpret_cast<PFN_glProgramUniform4i64vNV>(eglGetProcAddress("glProgramUniform4i64vNV"));
	programUniform4i64vNVPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform4i64vNV");
}

void GL_APIENTRY glProgramUniform4ui64NV(GLuint program, GLint location, GLuint64EXT x, GLuint64EXT y, GLuint64EXT z, GLuint64EXT w)
{
	using PFN_glProgramUniform4ui64NV = void(GL_APIENTRY*)(GLuint program, GLint location, GLuint64EXT x, GLuint64EXT y, GLuint64EXT z, GLuint64EXT w);
	static PFN_glProgramUniform4ui64NV programUniform4ui64NVPtr = reinterpret_cast<PFN_glProgramUniform4ui64NV>(eglGetProcAddress("glProgramUniform4ui64NV"));
	programUniform4ui64NVPtr(program, location, x, y, z, w);
	CHECK_GL_ERROR_ASSERT("glProgramUniform4ui64NV");
}

void GL_APIENTRY glProgramUniform4ui64vNV(GLuint program, GLint location, GLsizei count, const GLuint64EXT* value)
{
	using PFN_glProgramUniform4ui64vNV = void(GL_APIENTRY*)(GLuint program, GLint location, GLsizei count, const GLuint64EXT* value);
	static PFN_glProgramUniform4ui64vNV programUniform4ui64vNVPtr = reinterpret_cast<PFN_glProgramUniform4ui64vNV>(eglGetProcAddress("glProgramUniform4ui64vNV"));
	programUniform4ui64vNVPtr(program, location, count, value);
	CHECK_GL_ERROR_ASSERT("glProgramUniform4ui64vNV");
}

void GL_APIENTRY glUniform1i64NV(GLint location, GLint64EXT x)
{
	using PFN_glUniform1i64NV = void(GL_APIENTRY*)(GLint location, GLint64EXT x);
	static PFN_glUniform1i64NV uniform1i64NVPtr = reinterpret_cast<PFN_glUniform1i64NV>(eglGetProcAddress("glUniform1i64NV"));
	uniform1i64NVPtr(location, x);
	CHECK_GL_ERROR_ASSERT("glUniform1i64NV");
}

void GL_APIENTRY glUniform1i64vNV(GLint location, GLsizei count, const GLint64EXT* value)
{
	using PFN_glUniform1i64vNV = void(GL_APIENTRY*)(GLint location, GLsizei count, const GLint64EXT* value);
	static PFN_glUniform1i64vNV uniform1i64vNVPtr = reinterpret_cast<PFN_glUniform1i64vNV>(eglGetProcAddress("glUniform1i64vNV"));
	uniform1i64vNVPtr(location, count, value);
	CHECK_GL_ERROR_ASSERT("glUniform1i64vNV");
}

void GL_APIENTRY glUniform1ui64NV(GLint location, GLuint64EXT x)
{
	using PFN_glUniform1ui64NV = void(GL_APIENTRY*)(GLint location, GLuint64EXT x);
	static PFN_glUniform1ui64NV uniform1ui64NVPtr = reinterpret_cast<PFN_glUniform1ui64NV>(eglGetProcAddress("glUniform1ui64NV"));
	uniform1ui64NVPtr(location, x);
	CHECK_GL_ERROR_ASSERT("glUniform1ui64NV");
}

void GL_APIENTRY glUniform1ui64vNV(GLint location, GLsizei count, const GLuint64EXT* value)
{
	using PFN_glUniform1ui64vNV = void(GL_APIENTRY*)(GLint location, GLsizei count, const GLuint64EXT* value);
	static PFN_glUniform1ui64vNV uniform1ui64vNVPtr = reinterpret_cast<PFN_glUniform1ui64vNV>(eglGetProcAddress("glUniform1ui64vNV"));
	uniform1ui64vNVPtr(location, count, value);
	CHECK_GL_ERROR_ASSERT("glUniform1ui64vNV");
}

void GL_APIENTRY glUniform2i64NV(GLint location, GLint64EXT x, GLint64EXT y)
{
	using PFN_glUniform2i64NV = void(GL_APIENTRY*)(GLint location, GLint64EXT x, GLint64EXT y);
	static PFN_glUniform2i64NV uniform2i64NVPtr = reinterpret_cast<PFN_glUniform2i64NV>(eglGetProcAddress("glUniform2i64NV"));
	uniform2i64NVPtr(location, x, y);
	CHECK_GL_ERROR_ASSERT("glUniform2i64NV");
}

void GL_APIENTRY glUniform2i64vNV(GLint location, GLsizei count, const GLint64EXT* value)
{
	using PFN_glUniform2i64vNV = void(GL_APIENTRY*)(GLint location, GLsizei count, const GLint64EXT* value);
	static PFN_glUniform2i64vNV uniform2i64vNVPtr = reinterpret_cast<PFN_glUniform2i64vNV>(eglGetProcAddress("glUniform2i64vNV"));
	uniform2i64vNVPtr(location, count, value);
	CHECK_GL_ERROR_ASSERT("glUniform2i64vNV");
}

void GL_APIENTRY glUniform2ui64NV(GLint location, GLuint64EXT x, GLuint64EXT y)
{
	using PFN_glUniform2ui64NV = void(GL_APIENTRY*)(GLint location, GLuint64EXT x, GLuint64EXT y);
	static PFN_glUniform2ui64NV uniform2ui64NVPtr = reinterpret_cast<PFN_glUniform2ui64NV>(eglGetProcAddress("glUniform2ui64NV"));
	uniform2ui64NVPtr(location, x, y);
	CHECK_GL_ERROR_ASSERT("glUniform2ui64NV");
}

void GL_APIENTRY glUniform2ui64vNV(GLint location, GLsizei count, const GLuint64EXT* value)
{
	using PFN_glUniform2ui64vNV = void(GL_APIENTRY*)(GLint location, GLsizei count, const GLuint64EXT* value);
	static PFN_glUniform2ui64vNV uniform2ui64vNVPtr = reinterpret_cast<PFN_glUniform2ui64vNV>(eglGetProcAddress("glUniform2ui64vNV"));
	uniform2ui64vNVPtr(location, count, value);
	CHECK_GL_ERROR_ASSERT("glUniform2ui64vNV");
}

void GL_APIENTRY glUniform3i64NV(GLint location, GLint64EXT x, GLint64EXT y, GLint64EXT z)
{
	using PFN_glUniform3i64NV = void(GL_APIENTRY*)(GLint location, GLint64EXT x, GLint64EXT y, GLint64EXT z);
	static PFN_glUniform3i64NV uniform3i64NVPtr = reinterpret_cast<PFN_glUniform3i64NV>(eglGetProcAddress("glUniform3i64NV"));
	uniform3i64NVPtr(location, x, y, z);
	CHECK_GL_ERROR_ASSERT("glUniform3i64NV");
}

void GL_APIENTRY glUniform3i64vNV(GLint location, GLsizei count, const GLint64EXT* value)
{
	using PFN_glUniform3i64vNV = void(GL_APIENTRY*)(GLint location, GLsizei count, const GLint64EXT* value);
	static PFN_glUniform3i64vNV uniform3i64vNVPtr = reinterpret_cast<PFN_glUniform3i64vNV>(eglGetProcAddress("glUniform3i64vNV"));
	uniform3i64vNVPtr(location, count, value);
	CHECK_GL_ERROR_ASSERT("glUniform3i64vNV");
}

void GL_APIENTRY glUniform3ui64NV(GLint location, GLuint64EXT x, GLuint64EXT y, GLuint64EXT z)
{
	using PFN_glUniform3ui64NV = void(GL_APIENTRY*)(GLint location, GLuint64EXT x, GLuint64EXT y, GLuint64EXT z);
	static PFN_glUniform3ui64NV uniform3ui64NVPtr = reinterpret_cast<PFN_glUniform3ui64NV>(eglGetProcAddress("glUniform3ui64NV"));
	uniform3ui64NVPtr(location, x, y, z);
	CHECK_GL_ERROR_ASSERT("glUniform3ui64NV");
}

void GL_APIENTRY glUniform3ui64vNV(GLint location, GLsizei count, const GLuint64EXT* value)
{
	using PFN_glUniform3ui64vNV = void(GL_APIENTRY*)(GLint location, GLsizei count, const GLuint64EXT* value);
	static PFN_glUniform3ui64vNV uniform3ui64vNVPtr = reinterpret_cast<PFN_glUniform3ui64vNV>(eglGetProcAddress("glUniform3ui64vNV"));
	uniform3ui64vNVPtr(location, count, value);
	CHECK_GL_ERROR_ASSERT("glUniform3ui64vNV");
}

void GL_APIENTRY glUniform4i64NV(GLint location, GLint64EXT x, GLint64EXT y, GLint64EXT z, GLint64EXT w)
{
	using PFN_glUniform4i64NV = void(GL_APIENTRY*)(GLint location, GLint64EXT x, GLint64EXT y, GLint64EXT z, GLint64EXT w);
	static PFN_glUniform4i64NV uniform4i64NVPtr = reinterpret_cast<PFN_glUniform4i64NV>(eglGetProcAddress("glUniform4i64NV"));
	uniform4i64NVPtr(location, x, y, z, w);
	CHECK_GL_ERROR_ASSERT("glUniform4i64NV");
}

void GL_APIENTRY glUniform4i64vNV(GLint location, GLsizei count, const GLint64EXT* value)
{
	using PFN_glUniform4i64vNV = void(GL_APIENTRY*)(GLint location, GLsizei count, const GLint64EXT* value);
	static PFN_glUniform4i64vNV uniform4i64vNVPtr = reinterpret_cast<PFN_glUniform4i64vNV>(eglGetProcAddress("glUniform4i64vNV"));
	uniform4i64vNVPtr(location, count, value);
	CHECK_GL_ERROR_ASSERT("glUniform4i64vNV");
}

void GL_APIENTRY glUniform4ui64NV(GLint location, GLuint64EXT x, GLuint64EXT y, GLuint64EXT z, GLuint64EXT w)
{
	using PFN_glUniform4ui64NV = void(GL_APIENTRY*)(GLint location, GLuint64EXT x, GLuint64EXT y, GLuint64EXT z, GLuint64EXT w);
	static PFN_glUniform4ui64NV uniform4ui64NVPtr = reinterpret_cast<PFN_glUniform4ui64NV>(eglGetProcAddress("glUniform4ui64NV"));
	uniform4ui64NVPtr(location, x, y, z, w);
	CHECK_GL_ERROR_ASSERT("glUniform4ui64NV");
}

void GL_APIENTRY glUniform4ui64vNV(GLint location, GLsizei count, const GLuint64EXT* value)
{
	using PFN_glUniform4ui64vNV = void(GL_APIENTRY*)(GLint location, GLsizei count, const GLuint64EXT* value);
	static PFN_glUniform4ui64vNV uniform4ui64vNVPtr = reinterpret_cast<PFN_glUniform4ui64vNV>(eglGetProcAddress("glUniform4ui64vNV"));
	uniform4ui64vNVPtr(location, count, value);
	CHECK_GL_ERROR_ASSERT("glUniform4ui64vNV");
}

// GL_NV_instanced_arrays
void GL_APIENTRY glVertexAttribDivisorNV(GLuint index, GLuint divisor)
{
	using PFN_glVertexAttribDivisorNV = void(GL_APIENTRY*)(GLuint index, GLuint divisor);
	static PFN_glVertexAttribDivisorNV vertexAttribDivisorNVPtr = reinterpret_cast<PFN_glVertexAttribDivisorNV>(eglGetProcAddress("glVertexAttribDivisorNV"));
	vertexAttribDivisorNVPtr(index, divisor);
	CHECK_GL_ERROR_ASSERT("glVertexAttribDivisorNV");
}

// GL_NV_internalformat_sample_query
void GL_APIENTRY glGetInternalformatSampleivNV(GLenum target, GLenum internalformat, GLsizei samples, GLenum pname, GLsizei bufSize, GLint* params)
{
	using PFN_glGetInternalformatSampleivNV = void(GL_APIENTRY*)(GLenum target, GLenum internalformat, GLsizei samples, GLenum pname, GLsizei bufSize, GLint * params);
	static PFN_glGetInternalformatSampleivNV getInternalformatSampleivNVPtr = reinterpret_cast<PFN_glGetInternalformatSampleivNV>(eglGetProcAddress("glGetInternalformatSampleivNV"));
	getInternalformatSampleivNVPtr(target, internalformat, samples, pname, bufSize, params);
	CHECK_GL_ERROR_ASSERT("glGetInternalformatSampleivNV");
}

// GL_NV_non_square_matrices
void GL_APIENTRY glUniformMatrix2x3fvNV(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glUniformMatrix2x3fvNV = void(GL_APIENTRY*)(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glUniformMatrix2x3fvNV uniformMatrix2x3fvNVPtr = reinterpret_cast<PFN_glUniformMatrix2x3fvNV>(eglGetProcAddress("glUniformMatrix2x3fvNV"));
	uniformMatrix2x3fvNVPtr(location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glUniformMatrix2x3fvNV");
}

void GL_APIENTRY glUniformMatrix2x4fvNV(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glUniformMatrix2x4fvNV = void(GL_APIENTRY*)(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glUniformMatrix2x4fvNV uniformMatrix2x4fvNVPtr = reinterpret_cast<PFN_glUniformMatrix2x4fvNV>(eglGetProcAddress("glUniformMatrix2x4fvNV"));
	uniformMatrix2x4fvNVPtr(location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glUniformMatrix2x4fvNV");
}

void GL_APIENTRY glUniformMatrix3x2fvNV(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glUniformMatrix3x2fvNV = void(GL_APIENTRY*)(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glUniformMatrix3x2fvNV uniformMatrix3x2fvNVPtr = reinterpret_cast<PFN_glUniformMatrix3x2fvNV>(eglGetProcAddress("glUniformMatrix3x2fvNV"));
	uniformMatrix3x2fvNVPtr(location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glUniformMatrix3x2fvNV");
}

void GL_APIENTRY glUniformMatrix3x4fvNV(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glUniformMatrix3x4fvNV = void(GL_APIENTRY*)(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glUniformMatrix3x4fvNV uniformMatrix3x4fvNVPtr = reinterpret_cast<PFN_glUniformMatrix3x4fvNV>(eglGetProcAddress("glUniformMatrix3x4fvNV"));
	uniformMatrix3x4fvNVPtr(location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glUniformMatrix3x4fvNV");
}

void GL_APIENTRY glUniformMatrix4x2fvNV(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glUniformMatrix4x2fvNV = void(GL_APIENTRY*)(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glUniformMatrix4x2fvNV uniformMatrix4x2fvNVPtr = reinterpret_cast<PFN_glUniformMatrix4x2fvNV>(eglGetProcAddress("glUniformMatrix4x2fvNV"));
	uniformMatrix4x2fvNVPtr(location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glUniformMatrix4x2fvNV");
}

void GL_APIENTRY glUniformMatrix4x3fvNV(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value)
{
	using PFN_glUniformMatrix4x3fvNV = void(GL_APIENTRY*)(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value);
	static PFN_glUniformMatrix4x3fvNV uniformMatrix4x3fvNVPtr = reinterpret_cast<PFN_glUniformMatrix4x3fvNV>(eglGetProcAddress("glUniformMatrix4x3fvNV"));
	uniformMatrix4x3fvNVPtr(location, count, transpose, value);
	CHECK_GL_ERROR_ASSERT("glUniformMatrix4x3fvNV");
}

// GL_NV_path_rendering
void GL_APIENTRY glCopyPathNV(GLuint resultPath, GLuint srcPath)
{
	using PFN_glCopyPathNV = void(GL_APIENTRY*)(GLuint resultPath, GLuint srcPath);
	static PFN_glCopyPathNV copyPathNVPtr = reinterpret_cast<PFN_glCopyPathNV>(eglGetProcAddress("glCopyPathNV"));
	copyPathNVPtr(resultPath, srcPath);
	CHECK_GL_ERROR_ASSERT("glCopyPathNV");
}

void GL_APIENTRY glCoverFillPathInstancedNV(GLsizei numPaths, GLenum pathNameType, const void* paths, GLuint pathBase, GLenum coverMode, GLenum transformType, const GLfloat* transformValues)
{
	using PFN_glCoverFillPathInstancedNV = void(GL_APIENTRY*)(GLsizei numPaths, GLenum pathNameType, const void* paths, GLuint pathBase, GLenum coverMode, GLenum transformType, const GLfloat* transformValues);
	static PFN_glCoverFillPathInstancedNV coverFillPathInstancedNVPtr = reinterpret_cast<PFN_glCoverFillPathInstancedNV>(eglGetProcAddress("glCoverFillPathInstancedNV"));
	coverFillPathInstancedNVPtr(numPaths, pathNameType, paths, pathBase, coverMode, transformType, transformValues);
	CHECK_GL_ERROR_ASSERT("glCoverFillPathInstancedNV");
}

void GL_APIENTRY glCoverFillPathNV(GLuint path, GLenum coverMode)
{
	using PFN_glCoverFillPathNV = void(GL_APIENTRY*)(GLuint path, GLenum coverMode);
	static PFN_glCoverFillPathNV coverFillPathNVPtr = reinterpret_cast<PFN_glCoverFillPathNV>(eglGetProcAddress("glCoverFillPathNV"));
	coverFillPathNVPtr(path, coverMode);
	CHECK_GL_ERROR_ASSERT("glCoverFillPathNV");
}

void GL_APIENTRY glCoverStrokePathInstancedNV(GLsizei numPaths, GLenum pathNameType, const void* paths, GLuint pathBase, GLenum coverMode, GLenum transformType, const GLfloat* transformValues)
{
	using PFN_glCoverStrokePathInstancedNV = void(GL_APIENTRY*)(GLsizei numPaths, GLenum pathNameType, const void* paths, GLuint pathBase, GLenum coverMode, GLenum transformType, const GLfloat* transformValues);
	static PFN_glCoverStrokePathInstancedNV coverStrokePathInstancedNVPtr = reinterpret_cast<PFN_glCoverStrokePathInstancedNV>(eglGetProcAddress("glCoverStrokePathInstancedNV"));
	coverStrokePathInstancedNVPtr(numPaths, pathNameType, paths, pathBase, coverMode, transformType, transformValues);
	CHECK_GL_ERROR_ASSERT("glCoverStrokePathInstancedNV");
}

void GL_APIENTRY glCoverStrokePathNV(GLuint path, GLenum coverMode)
{
	using PFN_glCoverStrokePathNV = void(GL_APIENTRY*)(GLuint path, GLenum coverMode);
	static PFN_glCoverStrokePathNV coverStrokePathNVPtr = reinterpret_cast<PFN_glCoverStrokePathNV>(eglGetProcAddress("glCoverStrokePathNV"));
	coverStrokePathNVPtr(path, coverMode);
	CHECK_GL_ERROR_ASSERT("glCoverStrokePathNV");
}

void GL_APIENTRY glDeletePathsNV(GLuint path, GLsizei range)
{
	using PFN_glDeletePathsNV = void(GL_APIENTRY*)(GLuint path, GLsizei range);
	static PFN_glDeletePathsNV deletePathsNVPtr = reinterpret_cast<PFN_glDeletePathsNV>(eglGetProcAddress("glDeletePathsNV"));
	deletePathsNVPtr(path, range);
	CHECK_GL_ERROR_ASSERT("glDeletePathsNV");
}

GLuint GL_APIENTRY glGenPathsNV(GLsizei range)
{
	using PFN_glGenPathsNV = GLuint(GL_APIENTRY*)(GLsizei range);
	static PFN_glGenPathsNV genPathsNVPtr = reinterpret_cast<PFN_glGenPathsNV>(eglGetProcAddress("glGenPathsNV"));
	auto result = genPathsNVPtr(range);
	CHECK_GL_ERROR_ASSERT("glGenPathsNV");
	return result;
}

void GL_APIENTRY glGetPathCommandsNV(GLuint path, GLubyte* commands)
{
	using PFN_glGetPathCommandsNV = void(GL_APIENTRY*)(GLuint path, GLubyte * commands);
	static PFN_glGetPathCommandsNV getPathCommandsNVPtr = reinterpret_cast<PFN_glGetPathCommandsNV>(eglGetProcAddress("glGetPathCommandsNV"));
	getPathCommandsNVPtr(path, commands);
	CHECK_GL_ERROR_ASSERT("glGetPathCommandsNV");
}

void GL_APIENTRY glGetPathCoordsNV(GLuint path, GLfloat* coords)
{
	using PFN_glGetPathCoordsNV = void(GL_APIENTRY*)(GLuint path, GLfloat * coords);
	static PFN_glGetPathCoordsNV getPathCoordsNVPtr = reinterpret_cast<PFN_glGetPathCoordsNV>(eglGetProcAddress("glGetPathCoordsNV"));
	getPathCoordsNVPtr(path, coords);
	CHECK_GL_ERROR_ASSERT("glGetPathCoordsNV");
}

void GL_APIENTRY glGetPathDashArrayNV(GLuint path, GLfloat* dashArray)
{
	using PFN_glGetPathDashArrayNV = void(GL_APIENTRY*)(GLuint path, GLfloat * dashArray);
	static PFN_glGetPathDashArrayNV getPathDashArrayNVPtr = reinterpret_cast<PFN_glGetPathDashArrayNV>(eglGetProcAddress("glGetPathDashArrayNV"));
	getPathDashArrayNVPtr(path, dashArray);
	CHECK_GL_ERROR_ASSERT("glGetPathDashArrayNV");
}

GLfloat GL_APIENTRY glGetPathLengthNV(GLuint path, GLsizei startSegment, GLsizei numSegments)
{
	using PFN_glGetPathLengthNV = GLfloat(GL_APIENTRY*)(GLuint path, GLsizei startSegment, GLsizei numSegments);
	static PFN_glGetPathLengthNV getPathLengthNVPtr = reinterpret_cast<PFN_glGetPathLengthNV>(eglGetProcAddress("glGetPathLengthNV"));
	auto result = getPathLengthNVPtr(path, startSegment, numSegments);
	CHECK_GL_ERROR_ASSERT("glGetPathLengthNV");
	return result;
}

void GL_APIENTRY glGetPathMetricRangeNV(GLbitfield metricQueryMask, GLuint firstPathName, GLsizei numPaths, GLsizei stride, GLfloat* metrics)
{
	using PFN_glGetPathMetricRangeNV = void(GL_APIENTRY*)(GLbitfield metricQueryMask, GLuint firstPathName, GLsizei numPaths, GLsizei stride, GLfloat * metrics);
	static PFN_glGetPathMetricRangeNV getPathMetricRangeNVPtr = reinterpret_cast<PFN_glGetPathMetricRangeNV>(eglGetProcAddress("glGetPathMetricRangeNV"));
	getPathMetricRangeNVPtr(metricQueryMask, firstPathName, numPaths, stride, metrics);
	CHECK_GL_ERROR_ASSERT("glGetPathMetricRangeNV");
}

void GL_APIENTRY glGetPathMetricsNV(GLbitfield metricQueryMask, GLsizei numPaths, GLenum pathNameType, const void* paths, GLuint pathBase, GLsizei stride, GLfloat* metrics)
{
	using PFN_glGetPathMetricsNV = void(GL_APIENTRY*)(GLbitfield metricQueryMask, GLsizei numPaths, GLenum pathNameType, const void* paths, GLuint pathBase, GLsizei stride, GLfloat* metrics);
	static PFN_glGetPathMetricsNV getPathMetricsNVPtr = reinterpret_cast<PFN_glGetPathMetricsNV>(eglGetProcAddress("glGetPathMetricsNV"));
	getPathMetricsNVPtr(metricQueryMask, numPaths, pathNameType, paths, pathBase, stride, metrics);
	CHECK_GL_ERROR_ASSERT("glGetPathMetricsNV");
}

void GL_APIENTRY glGetPathParameterfvNV(GLuint path, GLenum pname, GLfloat* value)
{
	using PFN_glGetPathParameterfvNV = void(GL_APIENTRY*)(GLuint path, GLenum pname, GLfloat * value);
	static PFN_glGetPathParameterfvNV getPathParameterfvNVPtr = reinterpret_cast<PFN_glGetPathParameterfvNV>(eglGetProcAddress("glGetPathParameterfvNV"));
	getPathParameterfvNVPtr(path, pname, value);
	CHECK_GL_ERROR_ASSERT("glGetPathParameterfvNV");
}

void GL_APIENTRY glGetPathParameterivNV(GLuint path, GLenum pname, GLint* value)
{
	using PFN_glGetPathParameterivNV = void(GL_APIENTRY*)(GLuint path, GLenum pname, GLint * value);
	static PFN_glGetPathParameterivNV getPathParameterivNVPtr = reinterpret_cast<PFN_glGetPathParameterivNV>(eglGetProcAddress("glGetPathParameterivNV"));
	getPathParameterivNVPtr(path, pname, value);
	CHECK_GL_ERROR_ASSERT("glGetPathParameterivNV");
}

void GL_APIENTRY glGetPathSpacingNV(GLenum pathListMode, GLsizei numPaths, GLenum pathNameType, const void* paths, GLuint pathBase, GLfloat advanceScale, GLfloat kerningScale, GLenum transformType, GLfloat* returnedSpacing)
{
	using PFN_glGetPathSpacingNV = void(GL_APIENTRY*)(GLenum pathListMode, GLsizei numPaths, GLenum pathNameType, const void* paths, GLuint pathBase, GLfloat advanceScale, GLfloat kerningScale, GLenum transformType, GLfloat* returnedSpacing);
	static PFN_glGetPathSpacingNV getPathSpacingNVPtr = reinterpret_cast<PFN_glGetPathSpacingNV>(eglGetProcAddress("glGetPathSpacingNV"));
	getPathSpacingNVPtr(pathListMode, numPaths, pathNameType, paths, pathBase, advanceScale, kerningScale, transformType, returnedSpacing);
	CHECK_GL_ERROR_ASSERT("glGetPathSpacingNV");
}

void GL_APIENTRY glGetProgramResourcefvNV(GLuint program, GLenum programInterface, GLuint index, GLsizei propCount, const GLenum* props, GLsizei bufSize, GLsizei* length, GLfloat* params)
{
	using PFN_glGetProgramResourcefvNV = void(GL_APIENTRY*)(GLuint program, GLenum programInterface, GLuint index, GLsizei propCount, const GLenum* props, GLsizei bufSize, GLsizei* length, GLfloat* params);
	static PFN_glGetProgramResourcefvNV getProgramResourcefvNVPtr = reinterpret_cast<PFN_glGetProgramResourcefvNV>(eglGetProcAddress("glGetProgramResourcefvNV"));
	getProgramResourcefvNVPtr(program, programInterface, index, propCount, props, bufSize, length, params);
	CHECK_GL_ERROR_ASSERT("glGetProgramResourcefvNV");
}

void GL_APIENTRY glInterpolatePathsNV(GLuint resultPath, GLuint pathA, GLuint pathB, GLfloat weight)
{
	using PFN_glInterpolatePathsNV = void(GL_APIENTRY*)(GLuint resultPath, GLuint pathA, GLuint pathB, GLfloat weight);
	static PFN_glInterpolatePathsNV interpolatePathsNVPtr = reinterpret_cast<PFN_glInterpolatePathsNV>(eglGetProcAddress("glInterpolatePathsNV"));
	interpolatePathsNVPtr(resultPath, pathA, pathB, weight);
	CHECK_GL_ERROR_ASSERT("glInterpolatePathsNV");
}

GLboolean GL_APIENTRY glIsPathNV(GLuint path)
{
	using PFN_glIsPathNV = GLboolean(GL_APIENTRY*)(GLuint path);
	static PFN_glIsPathNV isPathNVPtr = reinterpret_cast<PFN_glIsPathNV>(eglGetProcAddress("glIsPathNV"));
	auto result = isPathNVPtr(path);
	CHECK_GL_ERROR_ASSERT("glIsPathNV");
	return result;
}

GLboolean GL_APIENTRY glIsPointInFillPathNV(GLuint path, GLuint mask, GLfloat x, GLfloat y)
{
	using PFN_glIsPointInFillPathNV = GLboolean(GL_APIENTRY*)(GLuint path, GLuint mask, GLfloat x, GLfloat y);
	static PFN_glIsPointInFillPathNV isPointInFillPathNVPtr = reinterpret_cast<PFN_glIsPointInFillPathNV>(eglGetProcAddress("glIsPointInFillPathNV"));
	auto result = isPointInFillPathNVPtr(path, mask, x, y);
	CHECK_GL_ERROR_ASSERT("glIsPointInFillPathNV");
	return result;
}

GLboolean GL_APIENTRY glIsPointInStrokePathNV(GLuint path, GLfloat x, GLfloat y)
{
	using PFN_glIsPointInStrokePathNV = GLboolean(GL_APIENTRY*)(GLuint path, GLfloat x, GLfloat y);
	static PFN_glIsPointInStrokePathNV isPointInStrokePathNVPtr = reinterpret_cast<PFN_glIsPointInStrokePathNV>(eglGetProcAddress("glIsPointInStrokePathNV"));
	auto result = isPointInStrokePathNVPtr(path, x, y);
	CHECK_GL_ERROR_ASSERT("glIsPointInStrokePathNV");
	return result;
}

void GL_APIENTRY glMatrixFrustumEXT(GLenum mode, GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar)
{
	using PFN_glMatrixFrustumEXT = void(GL_APIENTRY*)(GLenum mode, GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar);
	static PFN_glMatrixFrustumEXT matrixFrustumEXTPtr = reinterpret_cast<PFN_glMatrixFrustumEXT>(eglGetProcAddress("glMatrixFrustumEXT"));
	matrixFrustumEXTPtr(mode, left, right, bottom, top, zNear, zFar);
	CHECK_GL_ERROR_ASSERT("glMatrixFrustumEXT");
}

void GL_APIENTRY glMatrixLoad3x2fNV(GLenum matrixMode, const GLfloat* m)
{
	using PFN_glMatrixLoad3x2fNV = void(GL_APIENTRY*)(GLenum matrixMode, const GLfloat* m);
	static PFN_glMatrixLoad3x2fNV matrixLoad3x2fNVPtr = reinterpret_cast<PFN_glMatrixLoad3x2fNV>(eglGetProcAddress("glMatrixLoad3x2fNV"));
	matrixLoad3x2fNVPtr(matrixMode, m);
	CHECK_GL_ERROR_ASSERT("glMatrixLoad3x2fNV");
}

void GL_APIENTRY glMatrixLoad3x3fNV(GLenum matrixMode, const GLfloat* m)
{
	using PFN_glMatrixLoad3x3fNV = void(GL_APIENTRY*)(GLenum matrixMode, const GLfloat* m);
	static PFN_glMatrixLoad3x3fNV matrixLoad3x3fNVPtr = reinterpret_cast<PFN_glMatrixLoad3x3fNV>(eglGetProcAddress("glMatrixLoad3x3fNV"));
	matrixLoad3x3fNVPtr(matrixMode, m);
	CHECK_GL_ERROR_ASSERT("glMatrixLoad3x3fNV");
}

void GL_APIENTRY glMatrixLoadIdentityEXT(GLenum mode)
{
	using PFN_glMatrixLoadIdentityEXT = void(GL_APIENTRY*)(GLenum mode);
	static PFN_glMatrixLoadIdentityEXT matrixLoadIdentityEXTPtr = reinterpret_cast<PFN_glMatrixLoadIdentityEXT>(eglGetProcAddress("glMatrixLoadIdentityEXT"));
	matrixLoadIdentityEXTPtr(mode);
	CHECK_GL_ERROR_ASSERT("glMatrixLoadIdentityEXT");
}

void GL_APIENTRY glMatrixLoadTranspose3x3fNV(GLenum matrixMode, const GLfloat* m)
{
	using PFN_glMatrixLoadTranspose3x3fNV = void(GL_APIENTRY*)(GLenum matrixMode, const GLfloat* m);
	static PFN_glMatrixLoadTranspose3x3fNV matrixLoadTranspose3x3fNVPtr = reinterpret_cast<PFN_glMatrixLoadTranspose3x3fNV>(eglGetProcAddress("glMatrixLoadTranspose3x3fNV"));
	matrixLoadTranspose3x3fNVPtr(matrixMode, m);
	CHECK_GL_ERROR_ASSERT("glMatrixLoadTranspose3x3fNV");
}

void GL_APIENTRY glMatrixLoadTransposedEXT(GLenum mode, const GLdouble* m)
{
	using PFN_glMatrixLoadTransposedEXT = void(GL_APIENTRY*)(GLenum mode, const GLdouble* m);
	static PFN_glMatrixLoadTransposedEXT matrixLoadTransposedEXTPtr = reinterpret_cast<PFN_glMatrixLoadTransposedEXT>(eglGetProcAddress("glMatrixLoadTransposedEXT"));
	matrixLoadTransposedEXTPtr(mode, m);
	CHECK_GL_ERROR_ASSERT("glMatrixLoadTransposedEXT");
}

void GL_APIENTRY glMatrixLoadTransposefEXT(GLenum mode, const GLfloat* m)
{
	using PFN_glMatrixLoadTransposefEXT = void(GL_APIENTRY*)(GLenum mode, const GLfloat* m);
	static PFN_glMatrixLoadTransposefEXT matrixLoadTransposefEXTPtr = reinterpret_cast<PFN_glMatrixLoadTransposefEXT>(eglGetProcAddress("glMatrixLoadTransposefEXT"));
	matrixLoadTransposefEXTPtr(mode, m);
	CHECK_GL_ERROR_ASSERT("glMatrixLoadTransposefEXT");
}

void GL_APIENTRY glMatrixLoaddEXT(GLenum mode, const GLdouble* m)
{
	using PFN_glMatrixLoaddEXT = void(GL_APIENTRY*)(GLenum mode, const GLdouble* m);
	static PFN_glMatrixLoaddEXT matrixLoaddEXTPtr = reinterpret_cast<PFN_glMatrixLoaddEXT>(eglGetProcAddress("glMatrixLoaddEXT"));
	matrixLoaddEXTPtr(mode, m);
	CHECK_GL_ERROR_ASSERT("glMatrixLoaddEXT");
}

void GL_APIENTRY glMatrixLoadfEXT(GLenum mode, const GLfloat* m)
{
	using PFN_glMatrixLoadfEXT = void(GL_APIENTRY*)(GLenum mode, const GLfloat* m);
	static PFN_glMatrixLoadfEXT matrixLoadfEXTPtr = reinterpret_cast<PFN_glMatrixLoadfEXT>(eglGetProcAddress("glMatrixLoadfEXT"));
	matrixLoadfEXTPtr(mode, m);
	CHECK_GL_ERROR_ASSERT("glMatrixLoadfEXT");
}

void GL_APIENTRY glMatrixMult3x2fNV(GLenum matrixMode, const GLfloat* m)
{
	using PFN_glMatrixMult3x2fNV = void(GL_APIENTRY*)(GLenum matrixMode, const GLfloat* m);
	static PFN_glMatrixMult3x2fNV matrixMult3x2fNVPtr = reinterpret_cast<PFN_glMatrixMult3x2fNV>(eglGetProcAddress("glMatrixMult3x2fNV"));
	matrixMult3x2fNVPtr(matrixMode, m);
	CHECK_GL_ERROR_ASSERT("glMatrixMult3x2fNV");
}

void GL_APIENTRY glMatrixMult3x3fNV(GLenum matrixMode, const GLfloat* m)
{
	using PFN_glMatrixMult3x3fNV = void(GL_APIENTRY*)(GLenum matrixMode, const GLfloat* m);
	static PFN_glMatrixMult3x3fNV matrixMult3x3fNVPtr = reinterpret_cast<PFN_glMatrixMult3x3fNV>(eglGetProcAddress("glMatrixMult3x3fNV"));
	matrixMult3x3fNVPtr(matrixMode, m);
	CHECK_GL_ERROR_ASSERT("glMatrixMult3x3fNV");
}

void GL_APIENTRY glMatrixMultTranspose3x3fNV(GLenum matrixMode, const GLfloat* m)
{
	using PFN_glMatrixMultTranspose3x3fNV = void(GL_APIENTRY*)(GLenum matrixMode, const GLfloat* m);
	static PFN_glMatrixMultTranspose3x3fNV matrixMultTranspose3x3fNVPtr = reinterpret_cast<PFN_glMatrixMultTranspose3x3fNV>(eglGetProcAddress("glMatrixMultTranspose3x3fNV"));
	matrixMultTranspose3x3fNVPtr(matrixMode, m);
	CHECK_GL_ERROR_ASSERT("glMatrixMultTranspose3x3fNV");
}

void GL_APIENTRY glMatrixMultTransposedEXT(GLenum mode, const GLdouble* m)
{
	using PFN_glMatrixMultTransposedEXT = void(GL_APIENTRY*)(GLenum mode, const GLdouble* m);
	static PFN_glMatrixMultTransposedEXT matrixMultTransposedEXTPtr = reinterpret_cast<PFN_glMatrixMultTransposedEXT>(eglGetProcAddress("glMatrixMultTransposedEXT"));
	matrixMultTransposedEXTPtr(mode, m);
	CHECK_GL_ERROR_ASSERT("glMatrixMultTransposedEXT");
}

void GL_APIENTRY glMatrixMultTransposefEXT(GLenum mode, const GLfloat* m)
{
	using PFN_glMatrixMultTransposefEXT = void(GL_APIENTRY*)(GLenum mode, const GLfloat* m);
	static PFN_glMatrixMultTransposefEXT matrixMultTransposefEXTPtr = reinterpret_cast<PFN_glMatrixMultTransposefEXT>(eglGetProcAddress("glMatrixMultTransposefEXT"));
	matrixMultTransposefEXTPtr(mode, m);
	CHECK_GL_ERROR_ASSERT("glMatrixMultTransposefEXT");
}

void GL_APIENTRY glMatrixMultdEXT(GLenum mode, const GLdouble* m)
{
	using PFN_glMatrixMultdEXT = void(GL_APIENTRY*)(GLenum mode, const GLdouble* m);
	static PFN_glMatrixMultdEXT matrixMultdEXTPtr = reinterpret_cast<PFN_glMatrixMultdEXT>(eglGetProcAddress("glMatrixMultdEXT"));
	matrixMultdEXTPtr(mode, m);
	CHECK_GL_ERROR_ASSERT("glMatrixMultdEXT");
}

void GL_APIENTRY glMatrixMultfEXT(GLenum mode, const GLfloat* m)
{
	using PFN_glMatrixMultfEXT = void(GL_APIENTRY*)(GLenum mode, const GLfloat* m);
	static PFN_glMatrixMultfEXT matrixMultfEXTPtr = reinterpret_cast<PFN_glMatrixMultfEXT>(eglGetProcAddress("glMatrixMultfEXT"));
	matrixMultfEXTPtr(mode, m);
	CHECK_GL_ERROR_ASSERT("glMatrixMultfEXT");
}

void GL_APIENTRY glMatrixOrthoEXT(GLenum mode, GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar)
{
	using PFN_glMatrixOrthoEXT = void(GL_APIENTRY*)(GLenum mode, GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar);
	static PFN_glMatrixOrthoEXT matrixOrthoEXTPtr = reinterpret_cast<PFN_glMatrixOrthoEXT>(eglGetProcAddress("glMatrixOrthoEXT"));
	matrixOrthoEXTPtr(mode, left, right, bottom, top, zNear, zFar);
	CHECK_GL_ERROR_ASSERT("glMatrixOrthoEXT");
}

void GL_APIENTRY glMatrixPopEXT(GLenum mode)
{
	using PFN_glMatrixPopEXT = void(GL_APIENTRY*)(GLenum mode);
	static PFN_glMatrixPopEXT matrixPopEXTPtr = reinterpret_cast<PFN_glMatrixPopEXT>(eglGetProcAddress("glMatrixPopEXT"));
	matrixPopEXTPtr(mode);
	CHECK_GL_ERROR_ASSERT("glMatrixPopEXT");
}

void GL_APIENTRY glMatrixPushEXT(GLenum mode)
{
	using PFN_glMatrixPushEXT = void(GL_APIENTRY*)(GLenum mode);
	static PFN_glMatrixPushEXT matrixPushEXTPtr = reinterpret_cast<PFN_glMatrixPushEXT>(eglGetProcAddress("glMatrixPushEXT"));
	matrixPushEXTPtr(mode);
	CHECK_GL_ERROR_ASSERT("glMatrixPushEXT");
}

void GL_APIENTRY glMatrixRotatedEXT(GLenum mode, GLdouble angle, GLdouble x, GLdouble y, GLdouble z)
{
	using PFN_glMatrixRotatedEXT = void(GL_APIENTRY*)(GLenum mode, GLdouble angle, GLdouble x, GLdouble y, GLdouble z);
	static PFN_glMatrixRotatedEXT matrixRotatedEXTPtr = reinterpret_cast<PFN_glMatrixRotatedEXT>(eglGetProcAddress("glMatrixRotatedEXT"));
	matrixRotatedEXTPtr(mode, angle, x, y, z);
	CHECK_GL_ERROR_ASSERT("glMatrixRotatedEXT");
}

void GL_APIENTRY glMatrixRotatefEXT(GLenum mode, GLfloat angle, GLfloat x, GLfloat y, GLfloat z)
{
	using PFN_glMatrixRotatefEXT = void(GL_APIENTRY*)(GLenum mode, GLfloat angle, GLfloat x, GLfloat y, GLfloat z);
	static PFN_glMatrixRotatefEXT matrixRotatefEXTPtr = reinterpret_cast<PFN_glMatrixRotatefEXT>(eglGetProcAddress("glMatrixRotatefEXT"));
	matrixRotatefEXTPtr(mode, angle, x, y, z);
	CHECK_GL_ERROR_ASSERT("glMatrixRotatefEXT");
}

void GL_APIENTRY glMatrixScaledEXT(GLenum mode, GLdouble x, GLdouble y, GLdouble z)
{
	using PFN_glMatrixScaledEXT = void(GL_APIENTRY*)(GLenum mode, GLdouble x, GLdouble y, GLdouble z);
	static PFN_glMatrixScaledEXT matrixScaledEXTPtr = reinterpret_cast<PFN_glMatrixScaledEXT>(eglGetProcAddress("glMatrixScaledEXT"));
	matrixScaledEXTPtr(mode, x, y, z);
	CHECK_GL_ERROR_ASSERT("glMatrixScaledEXT");
}

void GL_APIENTRY glMatrixScalefEXT(GLenum mode, GLfloat x, GLfloat y, GLfloat z)
{
	using PFN_glMatrixScalefEXT = void(GL_APIENTRY*)(GLenum mode, GLfloat x, GLfloat y, GLfloat z);
	static PFN_glMatrixScalefEXT matrixScalefEXTPtr = reinterpret_cast<PFN_glMatrixScalefEXT>(eglGetProcAddress("glMatrixScalefEXT"));
	matrixScalefEXTPtr(mode, x, y, z);
	CHECK_GL_ERROR_ASSERT("glMatrixScalefEXT");
}

void GL_APIENTRY glMatrixTranslatedEXT(GLenum mode, GLdouble x, GLdouble y, GLdouble z)
{
	using PFN_glMatrixTranslatedEXT = void(GL_APIENTRY*)(GLenum mode, GLdouble x, GLdouble y, GLdouble z);
	static PFN_glMatrixTranslatedEXT matrixTranslatedEXTPtr = reinterpret_cast<PFN_glMatrixTranslatedEXT>(eglGetProcAddress("glMatrixTranslatedEXT"));
	matrixTranslatedEXTPtr(mode, x, y, z);
	CHECK_GL_ERROR_ASSERT("glMatrixTranslatedEXT");
}

void GL_APIENTRY glMatrixTranslatefEXT(GLenum mode, GLfloat x, GLfloat y, GLfloat z)
{
	using PFN_glMatrixTranslatefEXT = void(GL_APIENTRY*)(GLenum mode, GLfloat x, GLfloat y, GLfloat z);
	static PFN_glMatrixTranslatefEXT matrixTranslatefEXTPtr = reinterpret_cast<PFN_glMatrixTranslatefEXT>(eglGetProcAddress("glMatrixTranslatefEXT"));
	matrixTranslatefEXTPtr(mode, x, y, z);
	CHECK_GL_ERROR_ASSERT("glMatrixTranslatefEXT");
}

void GL_APIENTRY glPathCommandsNV(GLuint path, GLsizei numCommands, const GLubyte* commands, GLsizei numCoords, GLenum coordType, const void* coords)
{
	using PFN_glPathCommandsNV = void(GL_APIENTRY*)(GLuint path, GLsizei numCommands, const GLubyte* commands, GLsizei numCoords, GLenum coordType, const void* coords);
	static PFN_glPathCommandsNV pathCommandsNVPtr = reinterpret_cast<PFN_glPathCommandsNV>(eglGetProcAddress("glPathCommandsNV"));
	pathCommandsNVPtr(path, numCommands, commands, numCoords, coordType, coords);
	CHECK_GL_ERROR_ASSERT("glPathCommandsNV");
}

void GL_APIENTRY glPathCoordsNV(GLuint path, GLsizei numCoords, GLenum coordType, const void* coords)
{
	using PFN_glPathCoordsNV = void(GL_APIENTRY*)(GLuint path, GLsizei numCoords, GLenum coordType, const void* coords);
	static PFN_glPathCoordsNV pathCoordsNVPtr = reinterpret_cast<PFN_glPathCoordsNV>(eglGetProcAddress("glPathCoordsNV"));
	pathCoordsNVPtr(path, numCoords, coordType, coords);
	CHECK_GL_ERROR_ASSERT("glPathCoordsNV");
}

void GL_APIENTRY glPathCoverDepthFuncNV(GLenum func)
{
	using PFN_glPathCoverDepthFuncNV = void(GL_APIENTRY*)(GLenum func);
	static PFN_glPathCoverDepthFuncNV pathCoverDepthFuncNVPtr = reinterpret_cast<PFN_glPathCoverDepthFuncNV>(eglGetProcAddress("glPathCoverDepthFuncNV"));
	pathCoverDepthFuncNVPtr(func);
	CHECK_GL_ERROR_ASSERT("glPathCoverDepthFuncNV");
}

void GL_APIENTRY glPathDashArrayNV(GLuint path, GLsizei dashCount, const GLfloat* dashArray)
{
	using PFN_glPathDashArrayNV = void(GL_APIENTRY*)(GLuint path, GLsizei dashCount, const GLfloat* dashArray);
	static PFN_glPathDashArrayNV pathDashArrayNVPtr = reinterpret_cast<PFN_glPathDashArrayNV>(eglGetProcAddress("glPathDashArrayNV"));
	pathDashArrayNVPtr(path, dashCount, dashArray);
	CHECK_GL_ERROR_ASSERT("glPathDashArrayNV");
}

GLenum GL_APIENTRY glPathGlyphIndexArrayNV(GLuint firstPathName, GLenum fontTarget, const void* fontName, GLbitfield fontStyle, GLuint firstGlyphIndex, GLsizei numGlyphs, GLuint pathParameterTemplate, GLfloat emScale)
{
	using PFN_glPathGlyphIndexArrayNV = GLenum(GL_APIENTRY*)(GLuint firstPathName, GLenum fontTarget, const void* fontName, GLbitfield fontStyle, GLuint firstGlyphIndex, GLsizei numGlyphs, GLuint pathParameterTemplate, GLfloat emScale);
	static PFN_glPathGlyphIndexArrayNV pathGlyphIndexArrayNVPtr = reinterpret_cast<PFN_glPathGlyphIndexArrayNV>(eglGetProcAddress("glPathGlyphIndexArrayNV"));
	auto result = pathGlyphIndexArrayNVPtr(firstPathName, fontTarget, fontName, fontStyle, firstGlyphIndex, numGlyphs, pathParameterTemplate, emScale);
	CHECK_GL_ERROR_ASSERT("glPathGlyphIndexArrayNV");
	return result;
}

GLenum GL_APIENTRY glPathGlyphIndexRangeNV(GLenum fontTarget, const void* fontName, GLbitfield fontStyle, GLuint pathParameterTemplate, GLfloat emScale, GLuint baseAndCount[2])
{
	using PFN_glPathGlyphIndexRangeNV = GLenum(GL_APIENTRY*)(GLenum fontTarget, const void* fontName, GLbitfield fontStyle, GLuint pathParameterTemplate, GLfloat emScale, GLuint baseAndCount[2]);
	static PFN_glPathGlyphIndexRangeNV pathGlyphIndexRangeNVPtr = reinterpret_cast<PFN_glPathGlyphIndexRangeNV>(eglGetProcAddress("glPathGlyphIndexRangeNV"));
	auto result = pathGlyphIndexRangeNVPtr(fontTarget, fontName, fontStyle, pathParameterTemplate, emScale, baseAndCount);
	CHECK_GL_ERROR_ASSERT("glPathGlyphIndexRangeNV");
	return result;
}

void GL_APIENTRY glPathGlyphRangeNV(GLuint firstPathName, GLenum fontTarget, const void* fontName, GLbitfield fontStyle, GLuint firstGlyph, GLsizei numGlyphs, GLenum handleMissingGlyphs, GLuint pathParameterTemplate, GLfloat emScale)
{
	using PFN_glPathGlyphRangeNV = void(GL_APIENTRY*)(GLuint firstPathName, GLenum fontTarget, const void* fontName, GLbitfield fontStyle, GLuint firstGlyph, GLsizei numGlyphs, GLenum handleMissingGlyphs, GLuint pathParameterTemplate, GLfloat emScale);
	static PFN_glPathGlyphRangeNV pathGlyphRangeNVPtr = reinterpret_cast<PFN_glPathGlyphRangeNV>(eglGetProcAddress("glPathGlyphRangeNV"));
	pathGlyphRangeNVPtr(firstPathName, fontTarget, fontName, fontStyle, firstGlyph, numGlyphs, handleMissingGlyphs, pathParameterTemplate, emScale);
	CHECK_GL_ERROR_ASSERT("glPathGlyphRangeNV");
}

void GL_APIENTRY glPathGlyphsNV(GLuint firstPathName, GLenum fontTarget, const void* fontName, GLbitfield fontStyle, GLsizei numGlyphs, GLenum type, const void* charcodes, GLenum handleMissingGlyphs, GLuint pathParameterTemplate, GLfloat emScale)
{
	using PFN_glPathGlyphsNV = void(GL_APIENTRY*)(GLuint firstPathName, GLenum fontTarget, const void* fontName, GLbitfield fontStyle, GLsizei numGlyphs, GLenum type, const void* charcodes, GLenum handleMissingGlyphs, GLuint pathParameterTemplate, GLfloat emScale);
	static PFN_glPathGlyphsNV pathGlyphsNVPtr = reinterpret_cast<PFN_glPathGlyphsNV>(eglGetProcAddress("glPathGlyphsNV"));
	pathGlyphsNVPtr(firstPathName, fontTarget, fontName, fontStyle, numGlyphs, type, charcodes, handleMissingGlyphs, pathParameterTemplate, emScale);
	CHECK_GL_ERROR_ASSERT("glPathGlyphsNV");
}

GLenum GL_APIENTRY glPathMemoryGlyphIndexArrayNV(GLuint firstPathName, GLenum fontTarget, GLsizeiptr fontSize, const void* fontData, GLsizei faceIndex, GLuint firstGlyphIndex, GLsizei numGlyphs, GLuint pathParameterTemplate, GLfloat emScale)
{
	using PFN_glPathMemoryGlyphIndexArrayNV = GLenum(GL_APIENTRY*)(GLuint firstPathName, GLenum fontTarget, GLsizeiptr fontSize, const void* fontData, GLsizei faceIndex, GLuint firstGlyphIndex, GLsizei numGlyphs, GLuint pathParameterTemplate, GLfloat emScale);
	static PFN_glPathMemoryGlyphIndexArrayNV pathMemoryGlyphIndexArrayNVPtr = reinterpret_cast<PFN_glPathMemoryGlyphIndexArrayNV>(eglGetProcAddress("glPathMemoryGlyphIndexArrayNV"));
	auto result = pathMemoryGlyphIndexArrayNVPtr(firstPathName, fontTarget, fontSize, fontData, faceIndex, firstGlyphIndex, numGlyphs, pathParameterTemplate, emScale);
	CHECK_GL_ERROR_ASSERT("glPathMemoryGlyphIndexArrayNV");
	return result;
}

void GL_APIENTRY glPathParameterfNV(GLuint path, GLenum pname, GLfloat value)
{
	using PFN_glPathParameterfNV = void(GL_APIENTRY*)(GLuint path, GLenum pname, GLfloat value);
	static PFN_glPathParameterfNV pathParameterfNVPtr = reinterpret_cast<PFN_glPathParameterfNV>(eglGetProcAddress("glPathParameterfNV"));
	pathParameterfNVPtr(path, pname, value);
	CHECK_GL_ERROR_ASSERT("glPathParameterfNV");
}

void GL_APIENTRY glPathParameterfvNV(GLuint path, GLenum pname, const GLfloat* value)
{
	using PFN_glPathParameterfvNV = void(GL_APIENTRY*)(GLuint path, GLenum pname, const GLfloat* value);
	static PFN_glPathParameterfvNV pathParameterfvNVPtr = reinterpret_cast<PFN_glPathParameterfvNV>(eglGetProcAddress("glPathParameterfvNV"));
	pathParameterfvNVPtr(path, pname, value);
	CHECK_GL_ERROR_ASSERT("glPathParameterfvNV");
}

void GL_APIENTRY glPathParameteriNV(GLuint path, GLenum pname, GLint value)
{
	using PFN_glPathParameteriNV = void(GL_APIENTRY*)(GLuint path, GLenum pname, GLint value);
	static PFN_glPathParameteriNV pathParameteriNVPtr = reinterpret_cast<PFN_glPathParameteriNV>(eglGetProcAddress("glPathParameteriNV"));
	pathParameteriNVPtr(path, pname, value);
	CHECK_GL_ERROR_ASSERT("glPathParameteriNV");
}

void GL_APIENTRY glPathParameterivNV(GLuint path, GLenum pname, const GLint* value)
{
	using PFN_glPathParameterivNV = void(GL_APIENTRY*)(GLuint path, GLenum pname, const GLint* value);
	static PFN_glPathParameterivNV pathParameterivNVPtr = reinterpret_cast<PFN_glPathParameterivNV>(eglGetProcAddress("glPathParameterivNV"));
	pathParameterivNVPtr(path, pname, value);
	CHECK_GL_ERROR_ASSERT("glPathParameterivNV");
}

void GL_APIENTRY glPathStencilDepthOffsetNV(GLfloat factor, GLfloat units)
{
	using PFN_glPathStencilDepthOffsetNV = void(GL_APIENTRY*)(GLfloat factor, GLfloat units);
	static PFN_glPathStencilDepthOffsetNV pathStencilDepthOffsetNVPtr = reinterpret_cast<PFN_glPathStencilDepthOffsetNV>(eglGetProcAddress("glPathStencilDepthOffsetNV"));
	pathStencilDepthOffsetNVPtr(factor, units);
	CHECK_GL_ERROR_ASSERT("glPathStencilDepthOffsetNV");
}

void GL_APIENTRY glPathStencilFuncNV(GLenum func, GLint ref, GLuint mask)
{
	using PFN_glPathStencilFuncNV = void(GL_APIENTRY*)(GLenum func, GLint ref, GLuint mask);
	static PFN_glPathStencilFuncNV pathStencilFuncNVPtr = reinterpret_cast<PFN_glPathStencilFuncNV>(eglGetProcAddress("glPathStencilFuncNV"));
	pathStencilFuncNVPtr(func, ref, mask);
	CHECK_GL_ERROR_ASSERT("glPathStencilFuncNV");
}

void GL_APIENTRY glPathStringNV(GLuint path, GLenum format, GLsizei length, const void* pathString)
{
	using PFN_glPathStringNV = void(GL_APIENTRY*)(GLuint path, GLenum format, GLsizei length, const void* pathString);
	static PFN_glPathStringNV pathStringNVPtr = reinterpret_cast<PFN_glPathStringNV>(eglGetProcAddress("glPathStringNV"));
	pathStringNVPtr(path, format, length, pathString);
	CHECK_GL_ERROR_ASSERT("glPathStringNV");
}

void GL_APIENTRY glPathSubCommandsNV(GLuint path, GLsizei commandStart, GLsizei commandsToDelete, GLsizei numCommands, const GLubyte* commands, GLsizei numCoords, GLenum coordType, const void* coords)
{
	using PFN_glPathSubCommandsNV = void(GL_APIENTRY*)(GLuint path, GLsizei commandStart, GLsizei commandsToDelete, GLsizei numCommands, const GLubyte* commands, GLsizei numCoords, GLenum coordType, const void* coords);
	static PFN_glPathSubCommandsNV pathSubCommandsNVPtr = reinterpret_cast<PFN_glPathSubCommandsNV>(eglGetProcAddress("glPathSubCommandsNV"));
	pathSubCommandsNVPtr(path, commandStart, commandsToDelete, numCommands, commands, numCoords, coordType, coords);
	CHECK_GL_ERROR_ASSERT("glPathSubCommandsNV");
}

void GL_APIENTRY glPathSubCoordsNV(GLuint path, GLsizei coordStart, GLsizei numCoords, GLenum coordType, const void* coords)
{
	using PFN_glPathSubCoordsNV = void(GL_APIENTRY*)(GLuint path, GLsizei coordStart, GLsizei numCoords, GLenum coordType, const void* coords);
	static PFN_glPathSubCoordsNV pathSubCoordsNVPtr = reinterpret_cast<PFN_glPathSubCoordsNV>(eglGetProcAddress("glPathSubCoordsNV"));
	pathSubCoordsNVPtr(path, coordStart, numCoords, coordType, coords);
	CHECK_GL_ERROR_ASSERT("glPathSubCoordsNV");
}

GLboolean GL_APIENTRY glPointAlongPathNV(GLuint path, GLsizei startSegment, GLsizei numSegments, GLfloat distance, GLfloat* x, GLfloat* y, GLfloat* tangentX, GLfloat* tangentY)
{
	using PFN_glPointAlongPathNV = GLboolean(GL_APIENTRY*)(GLuint path, GLsizei startSegment, GLsizei numSegments, GLfloat distance, GLfloat * x, GLfloat * y, GLfloat * tangentX, GLfloat * tangentY);
	static PFN_glPointAlongPathNV pointAlongPathNVPtr = reinterpret_cast<PFN_glPointAlongPathNV>(eglGetProcAddress("glPointAlongPathNV"));
	auto result = pointAlongPathNVPtr(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
	CHECK_GL_ERROR_ASSERT("glPointAlongPathNV");
	return result;
}

void GL_APIENTRY glProgramPathFragmentInputGenNV(GLuint program, GLint location, GLenum genMode, GLint components, const GLfloat* coeffs)
{
	using PFN_glProgramPathFragmentInputGenNV = void(GL_APIENTRY*)(GLuint program, GLint location, GLenum genMode, GLint components, const GLfloat* coeffs);
	static PFN_glProgramPathFragmentInputGenNV programPathFragmentInputGenNVPtr = reinterpret_cast<PFN_glProgramPathFragmentInputGenNV>(eglGetProcAddress("glProgramPathFragmentInputGenNV"));
	programPathFragmentInputGenNVPtr(program, location, genMode, components, coeffs);
	CHECK_GL_ERROR_ASSERT("glProgramPathFragmentInputGenNV");
}

void GL_APIENTRY glStencilFillPathInstancedNV(GLsizei numPaths, GLenum pathNameType, const void* paths, GLuint pathBase, GLenum fillMode, GLuint mask, GLenum transformType, const GLfloat* transformValues)
{
	using PFN_glStencilFillPathInstancedNV = void(GL_APIENTRY*)(GLsizei numPaths, GLenum pathNameType, const void* paths, GLuint pathBase, GLenum fillMode, GLuint mask, GLenum transformType, const GLfloat* transformValues);
	static PFN_glStencilFillPathInstancedNV stencilFillPathInstancedNVPtr = reinterpret_cast<PFN_glStencilFillPathInstancedNV>(eglGetProcAddress("glStencilFillPathInstancedNV"));
	stencilFillPathInstancedNVPtr(numPaths, pathNameType, paths, pathBase, fillMode, mask, transformType, transformValues);
	CHECK_GL_ERROR_ASSERT("glStencilFillPathInstancedNV");
}

void GL_APIENTRY glStencilFillPathNV(GLuint path, GLenum fillMode, GLuint mask)
{
	using PFN_glStencilFillPathNV = void(GL_APIENTRY*)(GLuint path, GLenum fillMode, GLuint mask);
	static PFN_glStencilFillPathNV stencilFillPathNVPtr = reinterpret_cast<PFN_glStencilFillPathNV>(eglGetProcAddress("glStencilFillPathNV"));
	stencilFillPathNVPtr(path, fillMode, mask);
	CHECK_GL_ERROR_ASSERT("glStencilFillPathNV");
}

void GL_APIENTRY glStencilStrokePathInstancedNV(GLsizei numPaths, GLenum pathNameType, const void* paths, GLuint pathBase, GLint reference, GLuint mask, GLenum transformType, const GLfloat* transformValues)
{
	using PFN_glStencilStrokePathInstancedNV = void(GL_APIENTRY*)(GLsizei numPaths, GLenum pathNameType, const void* paths, GLuint pathBase, GLint reference, GLuint mask, GLenum transformType, const GLfloat* transformValues);
	static PFN_glStencilStrokePathInstancedNV stencilStrokePathInstancedNVPtr = reinterpret_cast<PFN_glStencilStrokePathInstancedNV>(eglGetProcAddress("glStencilStrokePathInstancedNV"));
	stencilStrokePathInstancedNVPtr(numPaths, pathNameType, paths, pathBase, reference, mask, transformType, transformValues);
	CHECK_GL_ERROR_ASSERT("glStencilStrokePathInstancedNV");
}

void GL_APIENTRY glStencilStrokePathNV(GLuint path, GLint reference, GLuint mask)
{
	using PFN_glStencilStrokePathNV = void(GL_APIENTRY*)(GLuint path, GLint reference, GLuint mask);
	static PFN_glStencilStrokePathNV stencilStrokePathNVPtr = reinterpret_cast<PFN_glStencilStrokePathNV>(eglGetProcAddress("glStencilStrokePathNV"));
	stencilStrokePathNVPtr(path, reference, mask);
	CHECK_GL_ERROR_ASSERT("glStencilStrokePathNV");
}

void GL_APIENTRY glStencilThenCoverFillPathInstancedNV(GLsizei numPaths, GLenum pathNameType, const void* paths, GLuint pathBase, GLenum fillMode, GLuint mask, GLenum coverMode, GLenum transformType, const GLfloat* transformValues)
{
	using PFN_glStencilThenCoverFillPathInstancedNV = void(GL_APIENTRY*)(GLsizei numPaths, GLenum pathNameType, const void* paths, GLuint pathBase, GLenum fillMode, GLuint mask, GLenum coverMode, GLenum transformType, const GLfloat* transformValues);
	static PFN_glStencilThenCoverFillPathInstancedNV stencilThenCoverFillPathInstancedNVPtr = reinterpret_cast<PFN_glStencilThenCoverFillPathInstancedNV>(eglGetProcAddress("glStencilThenCoverFillPathInstancedNV"));
	stencilThenCoverFillPathInstancedNVPtr(numPaths, pathNameType, paths, pathBase, fillMode, mask, coverMode, transformType, transformValues);
	CHECK_GL_ERROR_ASSERT("glStencilThenCoverFillPathInstancedNV");
}

void GL_APIENTRY glStencilThenCoverFillPathNV(GLuint path, GLenum fillMode, GLuint mask, GLenum coverMode)
{
	using PFN_glStencilThenCoverFillPathNV = void(GL_APIENTRY*)(GLuint path, GLenum fillMode, GLuint mask, GLenum coverMode);
	static PFN_glStencilThenCoverFillPathNV stencilThenCoverFillPathNVPtr = reinterpret_cast<PFN_glStencilThenCoverFillPathNV>(eglGetProcAddress("glStencilThenCoverFillPathNV"));
	stencilThenCoverFillPathNVPtr(path, fillMode, mask, coverMode);
	CHECK_GL_ERROR_ASSERT("glStencilThenCoverFillPathNV");
}

void GL_APIENTRY glStencilThenCoverStrokePathInstancedNV(GLsizei numPaths, GLenum pathNameType, const void* paths, GLuint pathBase, GLint reference, GLuint mask, GLenum coverMode, GLenum transformType, const GLfloat* transformValues)
{
	using PFN_glStencilThenCoverStrokePathInstancedNV = void(GL_APIENTRY*)(GLsizei numPaths, GLenum pathNameType, const void* paths, GLuint pathBase, GLint reference, GLuint mask, GLenum coverMode, GLenum transformType, const GLfloat* transformValues);
	static PFN_glStencilThenCoverStrokePathInstancedNV stencilThenCoverStrokePathInstancedNVPtr = reinterpret_cast<PFN_glStencilThenCoverStrokePathInstancedNV>(eglGetProcAddress("glStencilThenCoverStrokePathInstancedNV"));
	stencilThenCoverStrokePathInstancedNVPtr(numPaths, pathNameType, paths, pathBase, reference, mask, coverMode, transformType, transformValues);
	CHECK_GL_ERROR_ASSERT("glStencilThenCoverStrokePathInstancedNV");
}

void GL_APIENTRY glStencilThenCoverStrokePathNV(GLuint path, GLint reference, GLuint mask, GLenum coverMode)
{
	using PFN_glStencilThenCoverStrokePathNV = void(GL_APIENTRY*)(GLuint path, GLint reference, GLuint mask, GLenum coverMode);
	static PFN_glStencilThenCoverStrokePathNV stencilThenCoverStrokePathNVPtr = reinterpret_cast<PFN_glStencilThenCoverStrokePathNV>(eglGetProcAddress("glStencilThenCoverStrokePathNV"));
	stencilThenCoverStrokePathNVPtr(path, reference, mask, coverMode);
	CHECK_GL_ERROR_ASSERT("glStencilThenCoverStrokePathNV");
}

void GL_APIENTRY glTransformPathNV(GLuint resultPath, GLuint srcPath, GLenum transformType, const GLfloat* transformValues)
{
	using PFN_glTransformPathNV = void(GL_APIENTRY*)(GLuint resultPath, GLuint srcPath, GLenum transformType, const GLfloat* transformValues);
	static PFN_glTransformPathNV transformPathNVPtr = reinterpret_cast<PFN_glTransformPathNV>(eglGetProcAddress("glTransformPathNV"));
	transformPathNVPtr(resultPath, srcPath, transformType, transformValues);
	CHECK_GL_ERROR_ASSERT("glTransformPathNV");
}

void GL_APIENTRY glWeightPathsNV(GLuint resultPath, GLsizei numPaths, const GLuint* paths, const GLfloat* weights)
{
	using PFN_glWeightPathsNV = void(GL_APIENTRY*)(GLuint resultPath, GLsizei numPaths, const GLuint* paths, const GLfloat* weights);
	static PFN_glWeightPathsNV weightPathsNVPtr = reinterpret_cast<PFN_glWeightPathsNV>(eglGetProcAddress("glWeightPathsNV"));
	weightPathsNVPtr(resultPath, numPaths, paths, weights);
	CHECK_GL_ERROR_ASSERT("glWeightPathsNV");
}

// GL_NV_polygon_mode
void GL_APIENTRY glPolygonModeNV(GLenum face, GLenum mode)
{
	using PFN_glPolygonModeNV = void(GL_APIENTRY*)(GLenum face, GLenum mode);
	static PFN_glPolygonModeNV polygonModeNVPtr = reinterpret_cast<PFN_glPolygonModeNV>(eglGetProcAddress("glPolygonModeNV"));
	polygonModeNVPtr(face, mode);
	CHECK_GL_ERROR_ASSERT("glPolygonModeNV");
}

// GL_NV_read_buffer
void GL_APIENTRY glReadBufferNV(GLenum mode)
{
	using PFN_glReadBufferNV = void(GL_APIENTRY*)(GLenum mode);
	static PFN_glReadBufferNV readBufferNVPtr = reinterpret_cast<PFN_glReadBufferNV>(eglGetProcAddress("glReadBufferNV"));
	readBufferNVPtr(mode);
	CHECK_GL_ERROR_ASSERT("glReadBufferNV");
}

// GL_NV_sample_locations
void GL_APIENTRY glFramebufferSampleLocationsfvNV(GLenum target, GLuint start, GLsizei count, const GLfloat* v)
{
	using PFN_glFramebufferSampleLocationsfvNV = void(GL_APIENTRY*)(GLenum target, GLuint start, GLsizei count, const GLfloat* v);
	static PFN_glFramebufferSampleLocationsfvNV framebufferSampleLocationsfvNVPtr = reinterpret_cast<PFN_glFramebufferSampleLocationsfvNV>(eglGetProcAddress("glFramebufferSampleLocationsfvNV"));
	framebufferSampleLocationsfvNVPtr(target, start, count, v);
	CHECK_GL_ERROR_ASSERT("glFramebufferSampleLocationsfvNV");
}

void GL_APIENTRY glNamedFramebufferSampleLocationsfvNV(GLuint framebuffer, GLuint start, GLsizei count, const GLfloat* v)
{
	using PFN_glNamedFramebufferSampleLocationsfvNV = void(GL_APIENTRY*)(GLuint framebuffer, GLuint start, GLsizei count, const GLfloat* v);
	static PFN_glNamedFramebufferSampleLocationsfvNV namedFramebufferSampleLocationsfvNVPtr = reinterpret_cast<PFN_glNamedFramebufferSampleLocationsfvNV>(eglGetProcAddress("glNamedFramebufferSampleLocationsfvNV"));
	namedFramebufferSampleLocationsfvNVPtr(framebuffer, start, count, v);
	CHECK_GL_ERROR_ASSERT("glNamedFramebufferSampleLocationsfvNV");
}

void GL_APIENTRY glResolveDepthValuesNV()
{
	using PFN_glResolveDepthValuesNV = void(GL_APIENTRY*)();
	static PFN_glResolveDepthValuesNV resolveDepthValuesNVPtr = reinterpret_cast<PFN_glResolveDepthValuesNV>(eglGetProcAddress("glResolveDepthValuesNV"));
	resolveDepthValuesNVPtr();
	CHECK_GL_ERROR_ASSERT("glResolveDepthValuesNV");
}

// GL_NV_viewport_array
void GL_APIENTRY glDepthRangeArrayfvNV(GLuint first, GLsizei count, const GLfloat* v)
{
	using PFN_glDepthRangeArrayfvNV = void(GL_APIENTRY*)(GLuint first, GLsizei count, const GLfloat* v);
	static PFN_glDepthRangeArrayfvNV depthRangeArrayfvNVPtr = reinterpret_cast<PFN_glDepthRangeArrayfvNV>(eglGetProcAddress("glDepthRangeArrayfvNV"));
	depthRangeArrayfvNVPtr(first, count, v);
	CHECK_GL_ERROR_ASSERT("glDepthRangeArrayfvNV");
}

void GL_APIENTRY glDepthRangeIndexedfNV(GLuint index, GLfloat n, GLfloat f)
{
	using PFN_glDepthRangeIndexedfNV = void(GL_APIENTRY*)(GLuint index, GLfloat n, GLfloat f);
	static PFN_glDepthRangeIndexedfNV depthRangeIndexedfNVPtr = reinterpret_cast<PFN_glDepthRangeIndexedfNV>(eglGetProcAddress("glDepthRangeIndexedfNV"));
	depthRangeIndexedfNVPtr(index, n, f);
	CHECK_GL_ERROR_ASSERT("glDepthRangeIndexedfNV");
}

void GL_APIENTRY glDisableiNV(GLenum target, GLuint index)
{
	using PFN_glDisableiNV = void(GL_APIENTRY*)(GLenum target, GLuint index);
	static PFN_glDisableiNV disableiNVPtr = reinterpret_cast<PFN_glDisableiNV>(eglGetProcAddress("glDisableiNV"));
	disableiNVPtr(target, index);
	CHECK_GL_ERROR_ASSERT("glDisableiNV");
}

void GL_APIENTRY glEnableiNV(GLenum target, GLuint index)
{
	using PFN_glEnableiNV = void(GL_APIENTRY*)(GLenum target, GLuint index);
	static PFN_glEnableiNV enableiNVPtr = reinterpret_cast<PFN_glEnableiNV>(eglGetProcAddress("glEnableiNV"));
	enableiNVPtr(target, index);
	CHECK_GL_ERROR_ASSERT("glEnableiNV");
}

void GL_APIENTRY glGetFloati_vNV(GLenum target, GLuint index, GLfloat* data)
{
	using PFN_glGetFloati_vNV = void(GL_APIENTRY*)(GLenum target, GLuint index, GLfloat * data);
	static PFN_glGetFloati_vNV getFloati_vNVPtr = reinterpret_cast<PFN_glGetFloati_vNV>(eglGetProcAddress("glGetFloati_vNV"));
	getFloati_vNVPtr(target, index, data);
	CHECK_GL_ERROR_ASSERT("glGetFloati_vNV");
}

GLboolean GL_APIENTRY glIsEnablediNV(GLenum target, GLuint index)
{
	using PFN_glIsEnablediNV = GLboolean(GL_APIENTRY*)(GLenum target, GLuint index);
	static PFN_glIsEnablediNV isEnablediNVPtr = reinterpret_cast<PFN_glIsEnablediNV>(eglGetProcAddress("glIsEnablediNV"));
	auto result = isEnablediNVPtr(target, index);
	CHECK_GL_ERROR_ASSERT("glIsEnablediNV");
	return result;
}

void GL_APIENTRY glScissorArrayvNV(GLuint first, GLsizei count, const GLint* v)
{
	using PFN_glScissorArrayvNV = void(GL_APIENTRY*)(GLuint first, GLsizei count, const GLint* v);
	static PFN_glScissorArrayvNV scissorArrayvNVPtr = reinterpret_cast<PFN_glScissorArrayvNV>(eglGetProcAddress("glScissorArrayvNV"));
	scissorArrayvNVPtr(first, count, v);
	CHECK_GL_ERROR_ASSERT("glScissorArrayvNV");
}

void GL_APIENTRY glScissorIndexedNV(GLuint index, GLint left, GLint bottom, GLsizei width, GLsizei height)
{
	using PFN_glScissorIndexedNV = void(GL_APIENTRY*)(GLuint index, GLint left, GLint bottom, GLsizei width, GLsizei height);
	static PFN_glScissorIndexedNV scissorIndexedNVPtr = reinterpret_cast<PFN_glScissorIndexedNV>(eglGetProcAddress("glScissorIndexedNV"));
	scissorIndexedNVPtr(index, left, bottom, width, height);
	CHECK_GL_ERROR_ASSERT("glScissorIndexedNV");
}

void GL_APIENTRY glScissorIndexedvNV(GLuint index, const GLint* v)
{
	using PFN_glScissorIndexedvNV = void(GL_APIENTRY*)(GLuint index, const GLint* v);
	static PFN_glScissorIndexedvNV scissorIndexedvNVPtr = reinterpret_cast<PFN_glScissorIndexedvNV>(eglGetProcAddress("glScissorIndexedvNV"));
	scissorIndexedvNVPtr(index, v);
	CHECK_GL_ERROR_ASSERT("glScissorIndexedvNV");
}

void GL_APIENTRY glViewportArrayvNV(GLuint first, GLsizei count, const GLfloat* v)
{
	using PFN_glViewportArrayvNV = void(GL_APIENTRY*)(GLuint first, GLsizei count, const GLfloat* v);
	static PFN_glViewportArrayvNV viewportArrayvNVPtr = reinterpret_cast<PFN_glViewportArrayvNV>(eglGetProcAddress("glViewportArrayvNV"));
	viewportArrayvNVPtr(first, count, v);
	CHECK_GL_ERROR_ASSERT("glViewportArrayvNV");
}

void GL_APIENTRY glViewportIndexedfNV(GLuint index, GLfloat x, GLfloat y, GLfloat w, GLfloat h)
{
	using PFN_glViewportIndexedfNV = void(GL_APIENTRY*)(GLuint index, GLfloat x, GLfloat y, GLfloat w, GLfloat h);
	static PFN_glViewportIndexedfNV viewportIndexedfNVPtr = reinterpret_cast<PFN_glViewportIndexedfNV>(eglGetProcAddress("glViewportIndexedfNV"));
	viewportIndexedfNVPtr(index, x, y, w, h);
	CHECK_GL_ERROR_ASSERT("glViewportIndexedfNV");
}

void GL_APIENTRY glViewportIndexedfvNV(GLuint index, const GLfloat* v)
{
	using PFN_glViewportIndexedfvNV = void(GL_APIENTRY*)(GLuint index, const GLfloat* v);
	static PFN_glViewportIndexedfvNV viewportIndexedfvNVPtr = reinterpret_cast<PFN_glViewportIndexedfvNV>(eglGetProcAddress("glViewportIndexedfvNV"));
	viewportIndexedfvNVPtr(index, v);
	CHECK_GL_ERROR_ASSERT("glViewportIndexedfvNV");
}

// GL_NV_viewport_swizzle
void GL_APIENTRY glViewportSwizzleNV(GLuint index, GLenum swizzlex, GLenum swizzley, GLenum swizzlez, GLenum swizzlew)
{
	using PFN_glViewportSwizzleNV = void(GL_APIENTRY*)(GLuint index, GLenum swizzlex, GLenum swizzley, GLenum swizzlez, GLenum swizzlew);
	static PFN_glViewportSwizzleNV viewportSwizzleNVPtr = reinterpret_cast<PFN_glViewportSwizzleNV>(eglGetProcAddress("glViewportSwizzleNV"));
	viewportSwizzleNVPtr(index, swizzlex, swizzley, swizzlez, swizzlew);
	CHECK_GL_ERROR_ASSERT("glViewportSwizzleNV");
}

// GL_OES_EGL_image
void GL_APIENTRY glEGLImageTargetRenderbufferStorageOES(GLenum target, GLeglImageOES image)
{
	using PFN_glEGLImageTargetRenderbufferStorageOES = void(GL_APIENTRY*)(GLenum target, GLeglImageOES image);
	static PFN_glEGLImageTargetRenderbufferStorageOES eGLImageTargetRenderbufferStorageOESPtr = reinterpret_cast<PFN_glEGLImageTargetRenderbufferStorageOES>(eglGetProcAddress("glEGLImageTargetRenderbufferStorageOES"));
	eGLImageTargetRenderbufferStorageOESPtr(target, image);
	CHECK_GL_ERROR_ASSERT("glEGLImageTargetRenderbufferStorageOES");
}

void GL_APIENTRY glEGLImageTargetTexture2DOES(GLenum target, GLeglImageOES image)
{
	using PFN_glEGLImageTargetTexture2DOES = void(GL_APIENTRY*)(GLenum target, GLeglImageOES image);
	static PFN_glEGLImageTargetTexture2DOES eGLImageTargetTexture2DOESPtr = reinterpret_cast<PFN_glEGLImageTargetTexture2DOES>(eglGetProcAddress("glEGLImageTargetTexture2DOES"));
	eGLImageTargetTexture2DOESPtr(target, image);
	CHECK_GL_ERROR_ASSERT("glEGLImageTargetTexture2DOES");
}

// GL_OES_copy_image
void GL_APIENTRY glCopyImageSubDataOES(GLuint srcName, GLenum srcTarget, GLint srcLevel, GLint srcX, GLint srcY, GLint srcZ, GLuint dstName, GLenum dstTarget, GLint dstLevel, GLint dstX, GLint dstY, GLint dstZ, GLsizei srcWidth, GLsizei srcHeight, GLsizei srcDepth)
{
	using PFN_glCopyImageSubDataOES = void(GL_APIENTRY*)(GLuint srcName, GLenum srcTarget, GLint srcLevel, GLint srcX, GLint srcY, GLint srcZ, GLuint dstName, GLenum dstTarget, GLint dstLevel, GLint dstX, GLint dstY, GLint dstZ, GLsizei srcWidth, GLsizei srcHeight, GLsizei srcDepth);
	static PFN_glCopyImageSubDataOES copyImageSubDataOESPtr = reinterpret_cast<PFN_glCopyImageSubDataOES>(eglGetProcAddress("glCopyImageSubDataOES"));
	copyImageSubDataOESPtr(srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth);
	CHECK_GL_ERROR_ASSERT("glCopyImageSubDataOES");
}

// GL_OES_draw_buffers_indexed
void GL_APIENTRY glBlendEquationSeparateiOES(GLuint buf, GLenum modeRGB, GLenum modeAlpha)
{
	using PFN_glBlendEquationSeparateiOES = void(GL_APIENTRY*)(GLuint buf, GLenum modeRGB, GLenum modeAlpha);
	static PFN_glBlendEquationSeparateiOES blendEquationSeparateiOESPtr = reinterpret_cast<PFN_glBlendEquationSeparateiOES>(eglGetProcAddress("glBlendEquationSeparateiOES"));
	blendEquationSeparateiOESPtr(buf, modeRGB, modeAlpha);
	CHECK_GL_ERROR_ASSERT("glBlendEquationSeparateiOES");
}

void GL_APIENTRY glBlendEquationiOES(GLuint buf, GLenum mode)
{
	using PFN_glBlendEquationiOES = void(GL_APIENTRY*)(GLuint buf, GLenum mode);
	static PFN_glBlendEquationiOES blendEquationiOESPtr = reinterpret_cast<PFN_glBlendEquationiOES>(eglGetProcAddress("glBlendEquationiOES"));
	blendEquationiOESPtr(buf, mode);
	CHECK_GL_ERROR_ASSERT("glBlendEquationiOES");
}

void GL_APIENTRY glBlendFuncSeparateiOES(GLuint buf, GLenum srcRGB, GLenum dstRGB, GLenum srcAlpha, GLenum dstAlpha)
{
	using PFN_glBlendFuncSeparateiOES = void(GL_APIENTRY*)(GLuint buf, GLenum srcRGB, GLenum dstRGB, GLenum srcAlpha, GLenum dstAlpha);
	static PFN_glBlendFuncSeparateiOES blendFuncSeparateiOESPtr = reinterpret_cast<PFN_glBlendFuncSeparateiOES>(eglGetProcAddress("glBlendFuncSeparateiOES"));
	blendFuncSeparateiOESPtr(buf, srcRGB, dstRGB, srcAlpha, dstAlpha);
	CHECK_GL_ERROR_ASSERT("glBlendFuncSeparateiOES");
}

void GL_APIENTRY glBlendFunciOES(GLuint buf, GLenum src, GLenum dst)
{
	using PFN_glBlendFunciOES = void(GL_APIENTRY*)(GLuint buf, GLenum src, GLenum dst);
	static PFN_glBlendFunciOES blendFunciOESPtr = reinterpret_cast<PFN_glBlendFunciOES>(eglGetProcAddress("glBlendFunciOES"));
	blendFunciOESPtr(buf, src, dst);
	CHECK_GL_ERROR_ASSERT("glBlendFunciOES");
}

void GL_APIENTRY glColorMaskiOES(GLuint index, GLboolean r, GLboolean g, GLboolean b, GLboolean a)
{
	using PFN_glColorMaskiOES = void(GL_APIENTRY*)(GLuint index, GLboolean r, GLboolean g, GLboolean b, GLboolean a);
	static PFN_glColorMaskiOES colorMaskiOESPtr = reinterpret_cast<PFN_glColorMaskiOES>(eglGetProcAddress("glColorMaskiOES"));
	colorMaskiOESPtr(index, r, g, b, a);
	CHECK_GL_ERROR_ASSERT("glColorMaskiOES");
}

// GL_OES_draw_elements_base_vertex
void GL_APIENTRY glDrawElementsBaseVertexOES(GLenum mode, GLsizei count, GLenum type, const void* indices, GLint basevertex)
{
	using PFN_glDrawElementsBaseVertexOES = void(GL_APIENTRY*)(GLenum mode, GLsizei count, GLenum type, const void* indices, GLint basevertex);
	static PFN_glDrawElementsBaseVertexOES drawElementsBaseVertexOESPtr = reinterpret_cast<PFN_glDrawElementsBaseVertexOES>(eglGetProcAddress("glDrawElementsBaseVertexOES"));
	drawElementsBaseVertexOESPtr(mode, count, type, indices, basevertex);
	CHECK_GL_ERROR_ASSERT("glDrawElementsBaseVertexOES");
}

void GL_APIENTRY glDrawElementsInstancedBaseVertexOES(GLenum mode, GLsizei count, GLenum type, const void* indices, GLsizei instancecount, GLint basevertex)
{
	using PFN_glDrawElementsInstancedBaseVertexOES = void(GL_APIENTRY*)(GLenum mode, GLsizei count, GLenum type, const void* indices, GLsizei instancecount, GLint basevertex);
	static PFN_glDrawElementsInstancedBaseVertexOES drawElementsInstancedBaseVertexOESPtr = reinterpret_cast<PFN_glDrawElementsInstancedBaseVertexOES>(eglGetProcAddress("glDrawElementsInstancedBaseVertexOES"));
	drawElementsInstancedBaseVertexOESPtr(mode, count, type, indices, instancecount, basevertex);
	CHECK_GL_ERROR_ASSERT("glDrawElementsInstancedBaseVertexOES");
}

void GL_APIENTRY glDrawRangeElementsBaseVertexOES(GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const void* indices, GLint basevertex)
{
	using PFN_glDrawRangeElementsBaseVertexOES = void(GL_APIENTRY*)(GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const void* indices, GLint basevertex);
	static PFN_glDrawRangeElementsBaseVertexOES drawRangeElementsBaseVertexOESPtr = reinterpret_cast<PFN_glDrawRangeElementsBaseVertexOES>(eglGetProcAddress("glDrawRangeElementsBaseVertexOES"));
	drawRangeElementsBaseVertexOESPtr(mode, start, end, count, type, indices, basevertex);
	CHECK_GL_ERROR_ASSERT("glDrawRangeElementsBaseVertexOES");
}

// GL_OES_geometry_shader
void GL_APIENTRY glFramebufferTextureOES(GLenum target, GLenum attachment, GLuint texture, GLint level)
{
	using PFN_glFramebufferTextureOES = void(GL_APIENTRY*)(GLenum target, GLenum attachment, GLuint texture, GLint level);
	static PFN_glFramebufferTextureOES framebufferTextureOESPtr = reinterpret_cast<PFN_glFramebufferTextureOES>(eglGetProcAddress("glFramebufferTextureOES"));
	framebufferTextureOESPtr(target, attachment, texture, level);
	CHECK_GL_ERROR_ASSERT("glFramebufferTextureOES");
}

// GL_OES_get_program_binary
void GL_APIENTRY glGetProgramBinaryOES(GLuint program, GLsizei bufSize, GLsizei* length, GLenum* binaryFormat, void* binary)
{
	using PFN_glGetProgramBinaryOES = void(GL_APIENTRY*)(GLuint program, GLsizei bufSize, GLsizei * length, GLenum * binaryFormat, void* binary);
	static PFN_glGetProgramBinaryOES getProgramBinaryOESPtr = reinterpret_cast<PFN_glGetProgramBinaryOES>(eglGetProcAddress("glGetProgramBinaryOES"));
	getProgramBinaryOESPtr(program, bufSize, length, binaryFormat, binary);
	CHECK_GL_ERROR_ASSERT("glGetProgramBinaryOES");
}

void GL_APIENTRY glProgramBinaryOES(GLuint program, GLenum binaryFormat, const void* binary, GLint length)
{
	using PFN_glProgramBinaryOES = void(GL_APIENTRY*)(GLuint program, GLenum binaryFormat, const void* binary, GLint length);
	static PFN_glProgramBinaryOES programBinaryOESPtr = reinterpret_cast<PFN_glProgramBinaryOES>(eglGetProcAddress("glProgramBinaryOES"));
	programBinaryOESPtr(program, binaryFormat, binary, length);
	CHECK_GL_ERROR_ASSERT("glProgramBinaryOES");
}

// GL_OES_mapbuffer
void GL_APIENTRY glGetBufferPointervOES(GLenum target, GLenum pname, void** params)
{
	using PFN_glGetBufferPointervOES = void(GL_APIENTRY*)(GLenum target, GLenum pname, void** params);
	static PFN_glGetBufferPointervOES getBufferPointervOESPtr = reinterpret_cast<PFN_glGetBufferPointervOES>(eglGetProcAddress("glGetBufferPointervOES"));
	getBufferPointervOESPtr(target, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetBufferPointervOES");
}

void* GL_APIENTRY glMapBufferOES(GLenum target, GLenum access)
{
	using PFN_glMapBufferOES = void*(GL_APIENTRY*) (GLenum target, GLenum access);
	static PFN_glMapBufferOES mapBufferOESPtr = reinterpret_cast<PFN_glMapBufferOES>(eglGetProcAddress("glMapBufferOES"));
	auto result = mapBufferOESPtr(target, access);
	CHECK_GL_ERROR_ASSERT("glMapBufferOES");
	return result;
}

GLboolean GL_APIENTRY glUnmapBufferOES(GLenum target)
{
	using PFN_glUnmapBufferOES = GLboolean(GL_APIENTRY*)(GLenum target);
	static PFN_glUnmapBufferOES unmapBufferOESPtr = reinterpret_cast<PFN_glUnmapBufferOES>(eglGetProcAddress("glUnmapBufferOES"));
	auto result = unmapBufferOESPtr(target);
	CHECK_GL_ERROR_ASSERT("glUnmapBufferOES");
	return result;
}

// GL_OES_primitive_bounding_box
void GL_APIENTRY glPrimitiveBoundingBoxOES(GLfloat minX, GLfloat minY, GLfloat minZ, GLfloat minW, GLfloat maxX, GLfloat maxY, GLfloat maxZ, GLfloat maxW)
{
	using PFN_glPrimitiveBoundingBoxOES = void(GL_APIENTRY*)(GLfloat minX, GLfloat minY, GLfloat minZ, GLfloat minW, GLfloat maxX, GLfloat maxY, GLfloat maxZ, GLfloat maxW);
	static PFN_glPrimitiveBoundingBoxOES primitiveBoundingBoxOESPtr = reinterpret_cast<PFN_glPrimitiveBoundingBoxOES>(eglGetProcAddress("glPrimitiveBoundingBoxOES"));
	primitiveBoundingBoxOESPtr(minX, minY, minZ, minW, maxX, maxY, maxZ, maxW);
	CHECK_GL_ERROR_ASSERT("glPrimitiveBoundingBoxOES");
}

// GL_OES_sample_shading
void GL_APIENTRY glMinSampleShadingOES(GLfloat value)
{
	using PFN_glMinSampleShadingOES = void(GL_APIENTRY*)(GLfloat value);
	static PFN_glMinSampleShadingOES minSampleShadingOESPtr = reinterpret_cast<PFN_glMinSampleShadingOES>(eglGetProcAddress("glMinSampleShadingOES"));
	minSampleShadingOESPtr(value);
	CHECK_GL_ERROR_ASSERT("glMinSampleShadingOES");
}

// GL_OES_tessellation_shader
void GL_APIENTRY glPatchParameteriOES(GLenum pname, GLint value)
{
	using PFN_glPatchParameteriOES = void(GL_APIENTRY*)(GLenum pname, GLint value);
	static PFN_glPatchParameteriOES patchParameteriOESPtr = reinterpret_cast<PFN_glPatchParameteriOES>(eglGetProcAddress("glPatchParameteriOES"));
	patchParameteriOESPtr(pname, value);
	CHECK_GL_ERROR_ASSERT("glPatchParameteriOES");
}

// GL_OES_texture_3D
void GL_APIENTRY glCompressedTexImage3DOES(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, const void* data)
{
	using PFN_glCompressedTexImage3DOES = void(GL_APIENTRY*)(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, const void* data);
	static PFN_glCompressedTexImage3DOES compressedTexImage3DOESPtr = reinterpret_cast<PFN_glCompressedTexImage3DOES>(eglGetProcAddress("glCompressedTexImage3DOES"));
	compressedTexImage3DOESPtr(target, level, internalformat, width, height, depth, border, imageSize, data);
	CHECK_GL_ERROR_ASSERT("glCompressedTexImage3DOES");
}

void GL_APIENTRY glCompressedTexSubImage3DOES(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const void* data)
{
	using PFN_glCompressedTexSubImage3DOES = void(GL_APIENTRY*)(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const void* data);
	static PFN_glCompressedTexSubImage3DOES compressedTexSubImage3DOESPtr = reinterpret_cast<PFN_glCompressedTexSubImage3DOES>(eglGetProcAddress("glCompressedTexSubImage3DOES"));
	compressedTexSubImage3DOESPtr(target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, data);
	CHECK_GL_ERROR_ASSERT("glCompressedTexSubImage3DOES");
}

void GL_APIENTRY glCopyTexSubImage3DOES(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height)
{
	using PFN_glCopyTexSubImage3DOES = void(GL_APIENTRY*)(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height);
	static PFN_glCopyTexSubImage3DOES copyTexSubImage3DOESPtr = reinterpret_cast<PFN_glCopyTexSubImage3DOES>(eglGetProcAddress("glCopyTexSubImage3DOES"));
	copyTexSubImage3DOESPtr(target, level, xoffset, yoffset, zoffset, x, y, width, height);
	CHECK_GL_ERROR_ASSERT("glCopyTexSubImage3DOES");
}

void GL_APIENTRY glFramebufferTexture3DOES(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLint zoffset)
{
	using PFN_glFramebufferTexture3DOES = void(GL_APIENTRY*)(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLint zoffset);
	static PFN_glFramebufferTexture3DOES framebufferTexture3DOESPtr = reinterpret_cast<PFN_glFramebufferTexture3DOES>(eglGetProcAddress("glFramebufferTexture3DOES"));
	framebufferTexture3DOESPtr(target, attachment, textarget, texture, level, zoffset);
	CHECK_GL_ERROR_ASSERT("glFramebufferTexture3DOES");
}

void GL_APIENTRY glTexImage3DOES(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, const void* pixels)
{
	using PFN_glTexImage3DOES = void(GL_APIENTRY*)(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, const void* pixels);
	static PFN_glTexImage3DOES texImage3DOESPtr = reinterpret_cast<PFN_glTexImage3DOES>(eglGetProcAddress("glTexImage3DOES"));
	texImage3DOESPtr(target, level, internalformat, width, height, depth, border, format, type, pixels);
	CHECK_GL_ERROR_ASSERT("glTexImage3DOES");
}

void GL_APIENTRY glTexSubImage3DOES(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const void* pixels)
{
	using PFN_glTexSubImage3DOES = void(GL_APIENTRY*)(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const void* pixels);
	static PFN_glTexSubImage3DOES texSubImage3DOESPtr = reinterpret_cast<PFN_glTexSubImage3DOES>(eglGetProcAddress("glTexSubImage3DOES"));
	texSubImage3DOESPtr(target, level, xoffset, yoffset, zoffset, width, height, depth, format, type, pixels);
	CHECK_GL_ERROR_ASSERT("glTexSubImage3DOES");
}

// GL_OES_texture_border_clamp
void GL_APIENTRY glGetSamplerParameterIivOES(GLuint sampler, GLenum pname, GLint* params)
{
	using PFN_glGetSamplerParameterIivOES = void(GL_APIENTRY*)(GLuint sampler, GLenum pname, GLint * params);
	static PFN_glGetSamplerParameterIivOES getSamplerParameterIivOESPtr = reinterpret_cast<PFN_glGetSamplerParameterIivOES>(eglGetProcAddress("glGetSamplerParameterIivOES"));
	getSamplerParameterIivOESPtr(sampler, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetSamplerParameterIivOES");
}

void GL_APIENTRY glGetSamplerParameterIuivOES(GLuint sampler, GLenum pname, GLuint* params)
{
	using PFN_glGetSamplerParameterIuivOES = void(GL_APIENTRY*)(GLuint sampler, GLenum pname, GLuint * params);
	static PFN_glGetSamplerParameterIuivOES getSamplerParameterIuivOESPtr = reinterpret_cast<PFN_glGetSamplerParameterIuivOES>(eglGetProcAddress("glGetSamplerParameterIuivOES"));
	getSamplerParameterIuivOESPtr(sampler, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetSamplerParameterIuivOES");
}

void GL_APIENTRY glGetTexParameterIivOES(GLenum target, GLenum pname, GLint* params)
{
	using PFN_glGetTexParameterIivOES = void(GL_APIENTRY*)(GLenum target, GLenum pname, GLint * params);
	static PFN_glGetTexParameterIivOES getTexParameterIivOESPtr = reinterpret_cast<PFN_glGetTexParameterIivOES>(eglGetProcAddress("glGetTexParameterIivOES"));
	getTexParameterIivOESPtr(target, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetTexParameterIivOES");
}

void GL_APIENTRY glGetTexParameterIuivOES(GLenum target, GLenum pname, GLuint* params)
{
	using PFN_glGetTexParameterIuivOES = void(GL_APIENTRY*)(GLenum target, GLenum pname, GLuint * params);
	static PFN_glGetTexParameterIuivOES getTexParameterIuivOESPtr = reinterpret_cast<PFN_glGetTexParameterIuivOES>(eglGetProcAddress("glGetTexParameterIuivOES"));
	getTexParameterIuivOESPtr(target, pname, params);
	CHECK_GL_ERROR_ASSERT("glGetTexParameterIuivOES");
}

void GL_APIENTRY glSamplerParameterIivOES(GLuint sampler, GLenum pname, const GLint* param)
{
	using PFN_glSamplerParameterIivOES = void(GL_APIENTRY*)(GLuint sampler, GLenum pname, const GLint* param);
	static PFN_glSamplerParameterIivOES samplerParameterIivOESPtr = reinterpret_cast<PFN_glSamplerParameterIivOES>(eglGetProcAddress("glSamplerParameterIivOES"));
	samplerParameterIivOESPtr(sampler, pname, param);
	CHECK_GL_ERROR_ASSERT("glSamplerParameterIivOES");
}

void GL_APIENTRY glSamplerParameterIuivOES(GLuint sampler, GLenum pname, const GLuint* param)
{
	using PFN_glSamplerParameterIuivOES = void(GL_APIENTRY*)(GLuint sampler, GLenum pname, const GLuint* param);
	static PFN_glSamplerParameterIuivOES samplerParameterIuivOESPtr = reinterpret_cast<PFN_glSamplerParameterIuivOES>(eglGetProcAddress("glSamplerParameterIuivOES"));
	samplerParameterIuivOESPtr(sampler, pname, param);
	CHECK_GL_ERROR_ASSERT("glSamplerParameterIuivOES");
}

void GL_APIENTRY glTexParameterIivOES(GLenum target, GLenum pname, const GLint* params)
{
	using PFN_glTexParameterIivOES = void(GL_APIENTRY*)(GLenum target, GLenum pname, const GLint* params);
	static PFN_glTexParameterIivOES texParameterIivOESPtr = reinterpret_cast<PFN_glTexParameterIivOES>(eglGetProcAddress("glTexParameterIivOES"));
	texParameterIivOESPtr(target, pname, params);
	CHECK_GL_ERROR_ASSERT("glTexParameterIivOES");
}

void GL_APIENTRY glTexParameterIuivOES(GLenum target, GLenum pname, const GLuint* params)
{
	using PFN_glTexParameterIuivOES = void(GL_APIENTRY*)(GLenum target, GLenum pname, const GLuint* params);
	static PFN_glTexParameterIuivOES texParameterIuivOESPtr = reinterpret_cast<PFN_glTexParameterIuivOES>(eglGetProcAddress("glTexParameterIuivOES"));
	texParameterIuivOESPtr(target, pname, params);
	CHECK_GL_ERROR_ASSERT("glTexParameterIuivOES");
}

// GL_OES_texture_buffer
void GL_APIENTRY glTexBufferOES(GLenum target, GLenum internalformat, GLuint buffer)
{
	using PFN_glTexBufferOES = void(GL_APIENTRY*)(GLenum target, GLenum internalformat, GLuint buffer);
	static PFN_glTexBufferOES texBufferOESPtr = reinterpret_cast<PFN_glTexBufferOES>(eglGetProcAddress("glTexBufferOES"));
	texBufferOESPtr(target, internalformat, buffer);
	CHECK_GL_ERROR_ASSERT("glTexBufferOES");
}

void GL_APIENTRY glTexBufferRangeOES(GLenum target, GLenum internalformat, GLuint buffer, GLintptr offset, GLsizeiptr size)
{
	using PFN_glTexBufferRangeOES = void(GL_APIENTRY*)(GLenum target, GLenum internalformat, GLuint buffer, GLintptr offset, GLsizeiptr size);
	static PFN_glTexBufferRangeOES texBufferRangeOESPtr = reinterpret_cast<PFN_glTexBufferRangeOES>(eglGetProcAddress("glTexBufferRangeOES"));
	texBufferRangeOESPtr(target, internalformat, buffer, offset, size);
	CHECK_GL_ERROR_ASSERT("glTexBufferRangeOES");
}

// GL_OES_texture_storage_multisample_2d_array
void GL_APIENTRY glTexStorage3DMultisampleOES(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLboolean fixedsamplelocations)
{
	using PFN_glTexStorage3DMultisampleOES = void(GL_APIENTRY*)(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLboolean fixedsamplelocations);
	static PFN_glTexStorage3DMultisampleOES texStorage3DMultisampleOESPtr = reinterpret_cast<PFN_glTexStorage3DMultisampleOES>(eglGetProcAddress("glTexStorage3DMultisampleOES"));
	texStorage3DMultisampleOESPtr(target, samples, internalformat, width, height, depth, fixedsamplelocations);
	CHECK_GL_ERROR_ASSERT("glTexStorage3DMultisampleOES");
}

// GL_OES_texture_view
void GL_APIENTRY glTextureViewOES(GLuint texture, GLenum target, GLuint origtexture, GLenum internalformat, GLuint minlevel, GLuint numlevels, GLuint minlayer, GLuint numlayers)
{
	using PFN_glTextureViewOES = void(GL_APIENTRY*)(GLuint texture, GLenum target, GLuint origtexture, GLenum internalformat, GLuint minlevel, GLuint numlevels, GLuint minlayer, GLuint numlayers);
	static PFN_glTextureViewOES textureViewOESPtr = reinterpret_cast<PFN_glTextureViewOES>(eglGetProcAddress("glTextureViewOES"));
	textureViewOESPtr(texture, target, origtexture, internalformat, minlevel, numlevels, minlayer, numlayers);
	CHECK_GL_ERROR_ASSERT("glTextureViewOES");
}

// GL_OES_vertex_array_object
void GL_APIENTRY glBindVertexArrayOES(GLuint array)
{
	using PFN_glBindVertexArrayOES = void(GL_APIENTRY*)(GLuint array);
	static PFN_glBindVertexArrayOES bindVertexArrayOESPtr = reinterpret_cast<PFN_glBindVertexArrayOES>(eglGetProcAddress("glBindVertexArrayOES"));
	bindVertexArrayOESPtr(array);
	CHECK_GL_ERROR_ASSERT("glBindVertexArrayOES");
}

void GL_APIENTRY glDeleteVertexArraysOES(GLsizei n, const GLuint* arrays)
{
	using PFN_glDeleteVertexArraysOES = void(GL_APIENTRY*)(GLsizei n, const GLuint* arrays);
	static PFN_glDeleteVertexArraysOES deleteVertexArraysOESPtr = reinterpret_cast<PFN_glDeleteVertexArraysOES>(eglGetProcAddress("glDeleteVertexArraysOES"));
	deleteVertexArraysOESPtr(n, arrays);
	CHECK_GL_ERROR_ASSERT("glDeleteVertexArraysOES");
}

void GL_APIENTRY glGenVertexArraysOES(GLsizei n, GLuint* arrays)
{
	using PFN_glGenVertexArraysOES = void(GL_APIENTRY*)(GLsizei n, GLuint * arrays);
	static PFN_glGenVertexArraysOES genVertexArraysOESPtr = reinterpret_cast<PFN_glGenVertexArraysOES>(eglGetProcAddress("glGenVertexArraysOES"));
	genVertexArraysOESPtr(n, arrays);
	CHECK_GL_ERROR_ASSERT("glGenVertexArraysOES");
}

GLboolean GL_APIENTRY glIsVertexArrayOES(GLuint array)
{
	using PFN_glIsVertexArrayOES = GLboolean(GL_APIENTRY*)(GLuint array);
	static PFN_glIsVertexArrayOES isVertexArrayOESPtr = reinterpret_cast<PFN_glIsVertexArrayOES>(eglGetProcAddress("glIsVertexArrayOES"));
	auto result = isVertexArrayOESPtr(array);
	CHECK_GL_ERROR_ASSERT("glIsVertexArrayOES");
	return result;
}

// GL_OES_viewport_array, GL_OES_draw_buffers_indexed
void GL_APIENTRY glDisableiOES(GLenum target, GLuint index)
{
	using PFN_glDisableiOES = void(GL_APIENTRY*)(GLenum target, GLuint index);
	static PFN_glDisableiOES disableiOESPtr = reinterpret_cast<PFN_glDisableiOES>(eglGetProcAddress("glDisableiOES"));
	disableiOESPtr(target, index);
	CHECK_GL_ERROR_ASSERT("glDisableiOES");
}

void GL_APIENTRY glEnableiOES(GLenum target, GLuint index)
{
	using PFN_glEnableiOES = void(GL_APIENTRY*)(GLenum target, GLuint index);
	static PFN_glEnableiOES enableiOESPtr = reinterpret_cast<PFN_glEnableiOES>(eglGetProcAddress("glEnableiOES"));
	enableiOESPtr(target, index);
	CHECK_GL_ERROR_ASSERT("glEnableiOES");
}

GLboolean GL_APIENTRY glIsEnablediOES(GLenum target, GLuint index)
{
	using PFN_glIsEnablediOES = GLboolean(GL_APIENTRY*)(GLenum target, GLuint index);
	static PFN_glIsEnablediOES isEnablediOESPtr = reinterpret_cast<PFN_glIsEnablediOES>(eglGetProcAddress("glIsEnablediOES"));
	auto result = isEnablediOESPtr(target, index);
	CHECK_GL_ERROR_ASSERT("glIsEnablediOES");
	return result;
}

// GL_OES_viewport_array
void GL_APIENTRY glDepthRangeArrayfvOES(GLuint first, GLsizei count, const GLfloat* v)
{
	using PFN_glDepthRangeArrayfvOES = void(GL_APIENTRY*)(GLuint first, GLsizei count, const GLfloat* v);
	static PFN_glDepthRangeArrayfvOES depthRangeArrayfvOESPtr = reinterpret_cast<PFN_glDepthRangeArrayfvOES>(eglGetProcAddress("glDepthRangeArrayfvOES"));
	depthRangeArrayfvOESPtr(first, count, v);
	CHECK_GL_ERROR_ASSERT("glDepthRangeArrayfvOES");
}

void GL_APIENTRY glDepthRangeIndexedfOES(GLuint index, GLfloat n, GLfloat f)
{
	using PFN_glDepthRangeIndexedfOES = void(GL_APIENTRY*)(GLuint index, GLfloat n, GLfloat f);
	static PFN_glDepthRangeIndexedfOES depthRangeIndexedfOESPtr = reinterpret_cast<PFN_glDepthRangeIndexedfOES>(eglGetProcAddress("glDepthRangeIndexedfOES"));
	depthRangeIndexedfOESPtr(index, n, f);
	CHECK_GL_ERROR_ASSERT("glDepthRangeIndexedfOES");
}

void GL_APIENTRY glGetFloati_vOES(GLenum target, GLuint index, GLfloat* data)
{
	using PFN_glGetFloati_vOES = void(GL_APIENTRY*)(GLenum target, GLuint index, GLfloat * data);
	static PFN_glGetFloati_vOES getFloati_vOESPtr = reinterpret_cast<PFN_glGetFloati_vOES>(eglGetProcAddress("glGetFloati_vOES"));
	getFloati_vOESPtr(target, index, data);
	CHECK_GL_ERROR_ASSERT("glGetFloati_vOES");
}

void GL_APIENTRY glScissorArrayvOES(GLuint first, GLsizei count, const GLint* v)
{
	using PFN_glScissorArrayvOES = void(GL_APIENTRY*)(GLuint first, GLsizei count, const GLint* v);
	static PFN_glScissorArrayvOES scissorArrayvOESPtr = reinterpret_cast<PFN_glScissorArrayvOES>(eglGetProcAddress("glScissorArrayvOES"));
	scissorArrayvOESPtr(first, count, v);
	CHECK_GL_ERROR_ASSERT("glScissorArrayvOES");
}

void GL_APIENTRY glScissorIndexedOES(GLuint index, GLint left, GLint bottom, GLsizei width, GLsizei height)
{
	using PFN_glScissorIndexedOES = void(GL_APIENTRY*)(GLuint index, GLint left, GLint bottom, GLsizei width, GLsizei height);
	static PFN_glScissorIndexedOES scissorIndexedOESPtr = reinterpret_cast<PFN_glScissorIndexedOES>(eglGetProcAddress("glScissorIndexedOES"));
	scissorIndexedOESPtr(index, left, bottom, width, height);
	CHECK_GL_ERROR_ASSERT("glScissorIndexedOES");
}

void GL_APIENTRY glScissorIndexedvOES(GLuint index, const GLint* v)
{
	using PFN_glScissorIndexedvOES = void(GL_APIENTRY*)(GLuint index, const GLint* v);
	static PFN_glScissorIndexedvOES scissorIndexedvOESPtr = reinterpret_cast<PFN_glScissorIndexedvOES>(eglGetProcAddress("glScissorIndexedvOES"));
	scissorIndexedvOESPtr(index, v);
	CHECK_GL_ERROR_ASSERT("glScissorIndexedvOES");
}

void GL_APIENTRY glViewportArrayvOES(GLuint first, GLsizei count, const GLfloat* v)
{
	using PFN_glViewportArrayvOES = void(GL_APIENTRY*)(GLuint first, GLsizei count, const GLfloat* v);
	static PFN_glViewportArrayvOES viewportArrayvOESPtr = reinterpret_cast<PFN_glViewportArrayvOES>(eglGetProcAddress("glViewportArrayvOES"));
	viewportArrayvOESPtr(first, count, v);
	CHECK_GL_ERROR_ASSERT("glViewportArrayvOES");
}

void GL_APIENTRY glViewportIndexedfOES(GLuint index, GLfloat x, GLfloat y, GLfloat w, GLfloat h)
{
	using PFN_glViewportIndexedfOES = void(GL_APIENTRY*)(GLuint index, GLfloat x, GLfloat y, GLfloat w, GLfloat h);
	static PFN_glViewportIndexedfOES viewportIndexedfOESPtr = reinterpret_cast<PFN_glViewportIndexedfOES>(eglGetProcAddress("glViewportIndexedfOES"));
	viewportIndexedfOESPtr(index, x, y, w, h);
	CHECK_GL_ERROR_ASSERT("glViewportIndexedfOES");
}

void GL_APIENTRY glViewportIndexedfvOES(GLuint index, const GLfloat* v)
{
	using PFN_glViewportIndexedfvOES = void(GL_APIENTRY*)(GLuint index, const GLfloat* v);
	static PFN_glViewportIndexedfvOES viewportIndexedfvOESPtr = reinterpret_cast<PFN_glViewportIndexedfvOES>(eglGetProcAddress("glViewportIndexedfvOES"));
	viewportIndexedfvOESPtr(index, v);
	CHECK_GL_ERROR_ASSERT("glViewportIndexedfvOES");
}

// GL_OVR_multiview
void GL_APIENTRY glFramebufferTextureMultiviewOVR(GLenum target, GLenum attachment, GLuint texture, GLint level, GLint baseViewIndex, GLsizei numViews)
{
	using PFN_glFramebufferTextureMultiviewOVR = void(GL_APIENTRY*)(GLenum target, GLenum attachment, GLuint texture, GLint level, GLint baseViewIndex, GLsizei numViews);
	static PFN_glFramebufferTextureMultiviewOVR framebufferTextureMultiviewOVRPtr = reinterpret_cast<PFN_glFramebufferTextureMultiviewOVR>(eglGetProcAddress("glFramebufferTextureMultiviewOVR"));
	framebufferTextureMultiviewOVRPtr(target, attachment, texture, level, baseViewIndex, numViews);
	CHECK_GL_ERROR_ASSERT("glFramebufferTextureMultiviewOVR");
}

// GL_OVR_multiview_multisampled_render_to_texture
void GL_APIENTRY glFramebufferTextureMultisampleMultiviewOVR(GLenum target, GLenum attachment, GLuint texture, GLint level, GLsizei samples, GLint baseViewIndex, GLsizei numViews)
{
	using PFN_glFramebufferTextureMultisampleMultiviewOVR = void(GL_APIENTRY*)(GLenum target, GLenum attachment, GLuint texture, GLint level, GLsizei samples, GLint baseViewIndex, GLsizei numViews);
	static PFN_glFramebufferTextureMultisampleMultiviewOVR framebufferTextureMultisampleMultiviewOVRPtr = reinterpret_cast<PFN_glFramebufferTextureMultisampleMultiviewOVR>(eglGetProcAddress("glFramebufferTextureMultisampleMultiviewOVR"));
	framebufferTextureMultisampleMultiviewOVRPtr(target, attachment, texture, level, samples, baseViewIndex, numViews);
	CHECK_GL_ERROR_ASSERT("glFramebufferTextureMultisampleMultiviewOVR");
}

// GL_QCOM_alpha_test
void GL_APIENTRY glAlphaFuncQCOM(GLenum func, GLclampf ref)
{
	using PFN_glAlphaFuncQCOM = void(GL_APIENTRY*)(GLenum func, GLclampf ref);
	static PFN_glAlphaFuncQCOM alphaFuncQCOMPtr = reinterpret_cast<PFN_glAlphaFuncQCOM>(eglGetProcAddress("glAlphaFuncQCOM"));
	alphaFuncQCOMPtr(func, ref);
	CHECK_GL_ERROR_ASSERT("glAlphaFuncQCOM");
}

// GL_QCOM_driver_control
void GL_APIENTRY glDisableDriverControlQCOM(GLuint driverControl)
{
	using PFN_glDisableDriverControlQCOM = void(GL_APIENTRY*)(GLuint driverControl);
	static PFN_glDisableDriverControlQCOM disableDriverControlQCOMPtr = reinterpret_cast<PFN_glDisableDriverControlQCOM>(eglGetProcAddress("glDisableDriverControlQCOM"));
	disableDriverControlQCOMPtr(driverControl);
	CHECK_GL_ERROR_ASSERT("glDisableDriverControlQCOM");
}

void GL_APIENTRY glEnableDriverControlQCOM(GLuint driverControl)
{
	using PFN_glEnableDriverControlQCOM = void(GL_APIENTRY*)(GLuint driverControl);
	static PFN_glEnableDriverControlQCOM enableDriverControlQCOMPtr = reinterpret_cast<PFN_glEnableDriverControlQCOM>(eglGetProcAddress("glEnableDriverControlQCOM"));
	enableDriverControlQCOMPtr(driverControl);
	CHECK_GL_ERROR_ASSERT("glEnableDriverControlQCOM");
}

void GL_APIENTRY glGetDriverControlStringQCOM(GLuint driverControl, GLsizei bufSize, GLsizei* length, GLchar* driverControlString)
{
	using PFN_glGetDriverControlStringQCOM = void(GL_APIENTRY*)(GLuint driverControl, GLsizei bufSize, GLsizei * length, GLchar * driverControlString);
	static PFN_glGetDriverControlStringQCOM getDriverControlStringQCOMPtr = reinterpret_cast<PFN_glGetDriverControlStringQCOM>(eglGetProcAddress("glGetDriverControlStringQCOM"));
	getDriverControlStringQCOMPtr(driverControl, bufSize, length, driverControlString);
	CHECK_GL_ERROR_ASSERT("glGetDriverControlStringQCOM");
}

void GL_APIENTRY glGetDriverControlsQCOM(GLint* num, GLsizei size, GLuint* driverControls)
{
	using PFN_glGetDriverControlsQCOM = void(GL_APIENTRY*)(GLint * num, GLsizei size, GLuint * driverControls);
	static PFN_glGetDriverControlsQCOM getDriverControlsQCOMPtr = reinterpret_cast<PFN_glGetDriverControlsQCOM>(eglGetProcAddress("glGetDriverControlsQCOM"));
	getDriverControlsQCOMPtr(num, size, driverControls);
	CHECK_GL_ERROR_ASSERT("glGetDriverControlsQCOM");
}

// GL_QCOM_extended_get
void GL_APIENTRY glExtGetBufferPointervQCOM(GLenum target, void** params)
{
	using PFN_glExtGetBufferPointervQCOM = void(GL_APIENTRY*)(GLenum target, void** params);
	static PFN_glExtGetBufferPointervQCOM extGetBufferPointervQCOMPtr = reinterpret_cast<PFN_glExtGetBufferPointervQCOM>(eglGetProcAddress("glExtGetBufferPointervQCOM"));
	extGetBufferPointervQCOMPtr(target, params);
	CHECK_GL_ERROR_ASSERT("glExtGetBufferPointervQCOM");
}

void GL_APIENTRY glExtGetBuffersQCOM(GLuint* buffers, GLint maxBuffers, GLint* numBuffers)
{
	using PFN_glExtGetBuffersQCOM = void(GL_APIENTRY*)(GLuint * buffers, GLint maxBuffers, GLint * numBuffers);
	static PFN_glExtGetBuffersQCOM extGetBuffersQCOMPtr = reinterpret_cast<PFN_glExtGetBuffersQCOM>(eglGetProcAddress("glExtGetBuffersQCOM"));
	extGetBuffersQCOMPtr(buffers, maxBuffers, numBuffers);
	CHECK_GL_ERROR_ASSERT("glExtGetBuffersQCOM");
}

void GL_APIENTRY glExtGetFramebuffersQCOM(GLuint* framebuffers, GLint maxFramebuffers, GLint* numFramebuffers)
{
	using PFN_glExtGetFramebuffersQCOM = void(GL_APIENTRY*)(GLuint * framebuffers, GLint maxFramebuffers, GLint * numFramebuffers);
	static PFN_glExtGetFramebuffersQCOM extGetFramebuffersQCOMPtr = reinterpret_cast<PFN_glExtGetFramebuffersQCOM>(eglGetProcAddress("glExtGetFramebuffersQCOM"));
	extGetFramebuffersQCOMPtr(framebuffers, maxFramebuffers, numFramebuffers);
	CHECK_GL_ERROR_ASSERT("glExtGetFramebuffersQCOM");
}

void GL_APIENTRY glExtGetRenderbuffersQCOM(GLuint* renderbuffers, GLint maxRenderbuffers, GLint* numRenderbuffers)
{
	using PFN_glExtGetRenderbuffersQCOM = void(GL_APIENTRY*)(GLuint * renderbuffers, GLint maxRenderbuffers, GLint * numRenderbuffers);
	static PFN_glExtGetRenderbuffersQCOM extGetRenderbuffersQCOMPtr = reinterpret_cast<PFN_glExtGetRenderbuffersQCOM>(eglGetProcAddress("glExtGetRenderbuffersQCOM"));
	extGetRenderbuffersQCOMPtr(renderbuffers, maxRenderbuffers, numRenderbuffers);
	CHECK_GL_ERROR_ASSERT("glExtGetRenderbuffersQCOM");
}

void GL_APIENTRY glExtGetTexLevelParameterivQCOM(GLuint texture, GLenum face, GLint level, GLenum pname, GLint* params)
{
	using PFN_glExtGetTexLevelParameterivQCOM = void(GL_APIENTRY*)(GLuint texture, GLenum face, GLint level, GLenum pname, GLint * params);
	static PFN_glExtGetTexLevelParameterivQCOM extGetTexLevelParameterivQCOMPtr = reinterpret_cast<PFN_glExtGetTexLevelParameterivQCOM>(eglGetProcAddress("glExtGetTexLevelParameterivQCOM"));
	extGetTexLevelParameterivQCOMPtr(texture, face, level, pname, params);
	CHECK_GL_ERROR_ASSERT("glExtGetTexLevelParameterivQCOM");
}

void GL_APIENTRY glExtGetTexSubImageQCOM(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, void* texels)
{
	using PFN_glExtGetTexSubImageQCOM = void(GL_APIENTRY*)(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, void* texels);
	static PFN_glExtGetTexSubImageQCOM extGetTexSubImageQCOMPtr = reinterpret_cast<PFN_glExtGetTexSubImageQCOM>(eglGetProcAddress("glExtGetTexSubImageQCOM"));
	extGetTexSubImageQCOMPtr(target, level, xoffset, yoffset, zoffset, width, height, depth, format, type, texels);
	CHECK_GL_ERROR_ASSERT("glExtGetTexSubImageQCOM");
}

void GL_APIENTRY glExtGetTexturesQCOM(GLuint* textures, GLint maxTextures, GLint* numTextures)
{
	using PFN_glExtGetTexturesQCOM = void(GL_APIENTRY*)(GLuint * textures, GLint maxTextures, GLint * numTextures);
	static PFN_glExtGetTexturesQCOM extGetTexturesQCOMPtr = reinterpret_cast<PFN_glExtGetTexturesQCOM>(eglGetProcAddress("glExtGetTexturesQCOM"));
	extGetTexturesQCOMPtr(textures, maxTextures, numTextures);
	CHECK_GL_ERROR_ASSERT("glExtGetTexturesQCOM");
}

void GL_APIENTRY glExtTexObjectStateOverrideiQCOM(GLenum target, GLenum pname, GLint param)
{
	using PFN_glExtTexObjectStateOverrideiQCOM = void(GL_APIENTRY*)(GLenum target, GLenum pname, GLint param);
	static PFN_glExtTexObjectStateOverrideiQCOM extTexObjectStateOverrideiQCOMPtr = reinterpret_cast<PFN_glExtTexObjectStateOverrideiQCOM>(eglGetProcAddress("glExtTexObjectStateOverrideiQCOM"));
	extTexObjectStateOverrideiQCOMPtr(target, pname, param);
	CHECK_GL_ERROR_ASSERT("glExtTexObjectStateOverrideiQCOM");
}

// GL_QCOM_extended_get2
void GL_APIENTRY glExtGetProgramBinarySourceQCOM(GLuint program, GLenum shadertype, GLchar* source, GLint* length)
{
	using PFN_glExtGetProgramBinarySourceQCOM = void(GL_APIENTRY*)(GLuint program, GLenum shadertype, GLchar * source, GLint * length);
	static PFN_glExtGetProgramBinarySourceQCOM extGetProgramBinarySourceQCOMPtr = reinterpret_cast<PFN_glExtGetProgramBinarySourceQCOM>(eglGetProcAddress("glExtGetProgramBinarySourceQCOM"));
	extGetProgramBinarySourceQCOMPtr(program, shadertype, source, length);
	CHECK_GL_ERROR_ASSERT("glExtGetProgramBinarySourceQCOM");
}

void GL_APIENTRY glExtGetProgramsQCOM(GLuint* programs, GLint maxPrograms, GLint* numPrograms)
{
	using PFN_glExtGetProgramsQCOM = void(GL_APIENTRY*)(GLuint * programs, GLint maxPrograms, GLint * numPrograms);
	static PFN_glExtGetProgramsQCOM extGetProgramsQCOMPtr = reinterpret_cast<PFN_glExtGetProgramsQCOM>(eglGetProcAddress("glExtGetProgramsQCOM"));
	extGetProgramsQCOMPtr(programs, maxPrograms, numPrograms);
	CHECK_GL_ERROR_ASSERT("glExtGetProgramsQCOM");
}

void GL_APIENTRY glExtGetShadersQCOM(GLuint* shaders, GLint maxShaders, GLint* numShaders)
{
	using PFN_glExtGetShadersQCOM = void(GL_APIENTRY*)(GLuint * shaders, GLint maxShaders, GLint * numShaders);
	static PFN_glExtGetShadersQCOM extGetShadersQCOMPtr = reinterpret_cast<PFN_glExtGetShadersQCOM>(eglGetProcAddress("glExtGetShadersQCOM"));
	extGetShadersQCOMPtr(shaders, maxShaders, numShaders);
	CHECK_GL_ERROR_ASSERT("glExtGetShadersQCOM");
}

GLboolean GL_APIENTRY glExtIsProgramBinaryQCOM(GLuint program)
{
	using PFN_glExtIsProgramBinaryQCOM = GLboolean(GL_APIENTRY*)(GLuint program);
	static PFN_glExtIsProgramBinaryQCOM extIsProgramBinaryQCOMPtr = reinterpret_cast<PFN_glExtIsProgramBinaryQCOM>(eglGetProcAddress("glExtIsProgramBinaryQCOM"));
	auto result = extIsProgramBinaryQCOMPtr(program);
	CHECK_GL_ERROR_ASSERT("glExtIsProgramBinaryQCOM");
	return result;
}

// GL_QCOM_framebuffer_foveated
void GL_APIENTRY glFramebufferFoveationConfigQCOM(GLuint framebuffer, GLuint numLayers, GLuint focalPointsPerLayer, GLuint requestedFeatures, GLuint* providedFeatures)
{
	using PFN_glFramebufferFoveationConfigQCOM = void(GL_APIENTRY*)(GLuint framebuffer, GLuint numLayers, GLuint focalPointsPerLayer, GLuint requestedFeatures, GLuint * providedFeatures);
	static PFN_glFramebufferFoveationConfigQCOM framebufferFoveationConfigQCOMPtr = reinterpret_cast<PFN_glFramebufferFoveationConfigQCOM>(eglGetProcAddress("glFramebufferFoveationConfigQCOM"));
	framebufferFoveationConfigQCOMPtr(framebuffer, numLayers, focalPointsPerLayer, requestedFeatures, providedFeatures);
	CHECK_GL_ERROR_ASSERT("glFramebufferFoveationConfigQCOM");
}

void GL_APIENTRY glFramebufferFoveationParametersQCOM(GLuint framebuffer, GLuint layer, GLuint focalPoint, GLfloat focalX, GLfloat focalY, GLfloat gainX, GLfloat gainY, GLfloat foveaArea)
{
	using PFN_glFramebufferFoveationParametersQCOM = void(GL_APIENTRY*)(GLuint framebuffer, GLuint layer, GLuint focalPoint, GLfloat focalX, GLfloat focalY, GLfloat gainX, GLfloat gainY, GLfloat foveaArea);
	static PFN_glFramebufferFoveationParametersQCOM framebufferFoveationParametersQCOMPtr = reinterpret_cast<PFN_glFramebufferFoveationParametersQCOM>(eglGetProcAddress("glFramebufferFoveationParametersQCOM"));
	framebufferFoveationParametersQCOMPtr(framebuffer, layer, focalPoint, focalX, focalY, gainX, gainY, foveaArea);
	CHECK_GL_ERROR_ASSERT("glFramebufferFoveationParametersQCOM");
}

// GL_QCOM_shader_framebuffer_fetch_noncoherent
void GL_APIENTRY glFramebufferFetchBarrierQCOM()
{
	using PFN_glFramebufferFetchBarrierQCOM = void(GL_APIENTRY*)();
	static PFN_glFramebufferFetchBarrierQCOM framebufferFetchBarrierQCOMPtr = reinterpret_cast<PFN_glFramebufferFetchBarrierQCOM>(eglGetProcAddress("glFramebufferFetchBarrierQCOM"));
	framebufferFetchBarrierQCOMPtr();
	CHECK_GL_ERROR_ASSERT("glFramebufferFetchBarrierQCOM");
}

// GL_QCOM_texture_foveated
void GL_APIENTRY glTextureFoveationParametersQCOM(GLuint texture, GLuint layer, GLuint focalPoint, GLfloat focalX, GLfloat focalY, GLfloat gainX, GLfloat gainY, GLfloat foveaArea)
{
	using PFN_glTextureFoveationParametersQCOM = void(GL_APIENTRY*)(GLuint texture, GLuint layer, GLuint focalPoint, GLfloat focalX, GLfloat focalY, GLfloat gainX, GLfloat gainY, GLfloat foveaArea);
	static PFN_glTextureFoveationParametersQCOM textureFoveationParametersQCOMPtr = reinterpret_cast<PFN_glTextureFoveationParametersQCOM>(eglGetProcAddress("glTextureFoveationParametersQCOM"));
	textureFoveationParametersQCOMPtr(texture, layer, focalPoint, focalX, focalY, gainX, gainY, foveaArea);
	CHECK_GL_ERROR_ASSERT("glTextureFoveationParametersQCOM");
}

// GL_QCOM_tiled_rendering
void GL_APIENTRY glEndTilingQCOM(GLbitfield preserveMask)
{
	using PFN_glEndTilingQCOM = void(GL_APIENTRY*)(GLbitfield preserveMask);
	static PFN_glEndTilingQCOM endTilingQCOMPtr = reinterpret_cast<PFN_glEndTilingQCOM>(eglGetProcAddress("glEndTilingQCOM"));
	endTilingQCOMPtr(preserveMask);
	CHECK_GL_ERROR_ASSERT("glEndTilingQCOM");
}

void GL_APIENTRY glStartTilingQCOM(GLuint x, GLuint y, GLuint width, GLuint height, GLbitfield preserveMask)
{
	using PFN_glStartTilingQCOM = void(GL_APIENTRY*)(GLuint x, GLuint y, GLuint width, GLuint height, GLbitfield preserveMask);
	static PFN_glStartTilingQCOM startTilingQCOMPtr = reinterpret_cast<PFN_glStartTilingQCOM>(eglGetProcAddress("glStartTilingQCOM"));
	startTilingQCOMPtr(x, y, width, height, preserveMask);
	CHECK_GL_ERROR_ASSERT("glStartTilingQCOM");
}
